// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.app;

import android.support.v4.util.LogWriter;
import android.util.Log;
import java.io.FileDescriptor;
import java.io.PrintWriter;
import java.util.ArrayList;

final class BackStackRecord extends FragmentTransaction implements Runnable {
    final class Op {
        int cmd;
        int enterAnim;
        int exitAnim;
        Fragment fragment;
        Op next;
        int popEnterAnim;
        int popExitAnim;
        Op prev;
        ArrayList removed;

        Op() {
            super();
        }
    }

    boolean mAddToBackStack;
    boolean mAllowAddToBackStack;
    int mBreadCrumbShortTitleRes;
    CharSequence mBreadCrumbShortTitleText;
    int mBreadCrumbTitleRes;
    CharSequence mBreadCrumbTitleText;
    boolean mCommitted;
    int mEnterAnim;
    int mExitAnim;
    Op mHead;
    int mIndex;
    final FragmentManagerImpl mManager;
    String mName;
    int mNumOp;
    int mPopEnterAnim;
    int mPopExitAnim;
    Op mTail;
    int mTransition;
    int mTransitionStyle;

    public BackStackRecord(FragmentManagerImpl manager) {
        super();
        this.mAllowAddToBackStack = true;
        this.mIndex = -1;
        this.mManager = manager;
    }

    public FragmentTransaction add(int containerViewId, Fragment fragment, String tag) {
        this.doAddOp(containerViewId, fragment, tag, 1);
        return this;
    }

    void addOp(Op op) {
        if(this.mHead == null) {
            this.mTail = op;
            this.mHead = op;
        }
        else {
            op.prev = this.mTail;
            this.mTail.next = op;
            this.mTail = op;
        }

        op.enterAnim = this.mEnterAnim;
        op.exitAnim = this.mExitAnim;
        op.popEnterAnim = this.mPopEnterAnim;
        op.popExitAnim = this.mPopExitAnim;
        ++this.mNumOp;
    }

    public FragmentTransaction attach(Fragment fragment) {
        Op v0 = new Op();
        v0.cmd = 7;
        v0.fragment = fragment;
        this.addOp(v0);
        return this;
    }

    void bumpBackStackNesting(int amt) {
        if(this.mAddToBackStack) {
            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "Bump nesting in " + this + " by " + amt);
            }

            Op v1;
            for(v1 = this.mHead; v1 != null; v1 = v1.next) {
                if(v1.fragment != null) {
                    v1.fragment.mBackStackNesting += amt;
                    if(FragmentManagerImpl.DEBUG) {
                        Log.v("FragmentManager", "Bump nesting of " + v1.fragment + " to " + v1.fragment.mBackStackNesting);
                    }
                }

                if(v1.removed != null) {
                    int v0;
                    for(v0 = v1.removed.size() - 1; v0 >= 0; --v0) {
                        Object v2 = v1.removed.get(v0);
                        ((Fragment)v2).mBackStackNesting += amt;
                        if(FragmentManagerImpl.DEBUG) {
                            Log.v("FragmentManager", "Bump nesting of " + v2 + " to " + ((Fragment)v2).mBackStackNesting);
                        }
                    }
                }
            }
        }
    }

    public int commit() {
        return this.commitInternal(false);
    }

    int commitInternal(boolean allowStateLoss) {
        FileDescriptor v5 = null;
        if(this.mCommitted) {
            throw new IllegalStateException("commit already called");
        }

        if(FragmentManagerImpl.DEBUG) {
            Log.v("FragmentManager", "Commit: " + this);
            this.dump("  ", v5, new PrintWriter(new LogWriter("FragmentManager")), ((String[])v5));
        }

        this.mCommitted = true;
        if(this.mAddToBackStack) {
            this.mIndex = this.mManager.allocBackStackIndex(this);
        }
        else {
            this.mIndex = -1;
        }

        this.mManager.enqueueAction(((Runnable)this), allowStateLoss);
        return this.mIndex;
    }

    public FragmentTransaction detach(Fragment fragment) {
        Op v0 = new Op();
        v0.cmd = 6;
        v0.fragment = fragment;
        this.addOp(v0);
        return this;
    }

    private void doAddOp(int containerViewId, Fragment fragment, String tag, int opcmd) {
        fragment.mFragmentManager = this.mManager;
        if(tag != null) {
            if(fragment.mTag != null && !tag.equals(fragment.mTag)) {
                throw new IllegalStateException("Can\'t change tag of fragment " + fragment + ": was " + fragment.mTag + " now " + tag);
            }

            fragment.mTag = tag;
        }

        if(containerViewId != 0) {
            if(fragment.mFragmentId != 0 && fragment.mFragmentId != containerViewId) {
                throw new IllegalStateException("Can\'t change container ID of fragment " + fragment + ": was " + fragment.mFragmentId + " now " + containerViewId);
            }

            fragment.mFragmentId = containerViewId;
            fragment.mContainerId = containerViewId;
        }

        Op v0 = new Op();
        v0.cmd = opcmd;
        v0.fragment = fragment;
        this.addOp(v0);
    }

    public void dump(String prefix, FileDescriptor fd, PrintWriter writer, String[] args) {
        this.dump(prefix, writer, true);
    }

    public void dump(String prefix, PrintWriter writer, boolean full) {
        String v0;
        if(full) {
            writer.print(prefix);
            writer.print("mName=");
            writer.print(this.mName);
            writer.print(" mIndex=");
            writer.print(this.mIndex);
            writer.print(" mCommitted=");
            writer.println(this.mCommitted);
            if(this.mTransition != 0) {
                writer.print(prefix);
                writer.print("mTransition=#");
                writer.print(Integer.toHexString(this.mTransition));
                writer.print(" mTransitionStyle=#");
                writer.println(Integer.toHexString(this.mTransitionStyle));
            }

            if(this.mEnterAnim != 0 || this.mExitAnim != 0) {
                writer.print(prefix);
                writer.print("mEnterAnim=#");
                writer.print(Integer.toHexString(this.mEnterAnim));
                writer.print(" mExitAnim=#");
                writer.println(Integer.toHexString(this.mExitAnim));
            }

            if(this.mPopEnterAnim != 0 || this.mPopExitAnim != 0) {
                writer.print(prefix);
                writer.print("mPopEnterAnim=#");
                writer.print(Integer.toHexString(this.mPopEnterAnim));
                writer.print(" mPopExitAnim=#");
                writer.println(Integer.toHexString(this.mPopExitAnim));
            }

            if(this.mBreadCrumbTitleRes != 0 || this.mBreadCrumbTitleText != null) {
                writer.print(prefix);
                writer.print("mBreadCrumbTitleRes=#");
                writer.print(Integer.toHexString(this.mBreadCrumbTitleRes));
                writer.print(" mBreadCrumbTitleText=");
                writer.println(this.mBreadCrumbTitleText);
            }

            if(this.mBreadCrumbShortTitleRes == 0 && this.mBreadCrumbShortTitleText == null) {
                goto label_85;
            }

            writer.print(prefix);
            writer.print("mBreadCrumbShortTitleRes=#");
            writer.print(Integer.toHexString(this.mBreadCrumbShortTitleRes));
            writer.print(" mBreadCrumbShortTitleText=");
            writer.println(this.mBreadCrumbShortTitleText);
        }

    label_85:
        if(this.mHead != null) {
            writer.print(prefix);
            writer.println("Operations:");
            String v2 = prefix + "    ";
            Op v4 = this.mHead;
            int v3;
            for(v3 = 0; v4 != null; ++v3) {
                switch(v4.cmd) {
                    case 0: {
                        v0 = "NULL";
                        break;
                    }
                    case 1: {
                        v0 = "ADD";
                        break;
                    }
                    case 2: {
                        v0 = "REPLACE";
                        break;
                    }
                    case 3: {
                        v0 = "REMOVE";
                        break;
                    }
                    case 4: {
                        v0 = "HIDE";
                        break;
                    }
                    case 5: {
                        v0 = "SHOW";
                        break;
                    }
                    case 6: {
                        v0 = "DETACH";
                        break;
                    }
                    case 7: {
                        v0 = "ATTACH";
                        break;
                    }
                    default: {
                        v0 = "cmd=" + v4.cmd;
                        break;
                    }
                }

                writer.print(prefix);
                writer.print("  Op #");
                writer.print(v3);
                writer.print(": ");
                writer.print(v0);
                writer.print(" ");
                writer.println(v4.fragment);
                if(full) {
                    if(v4.enterAnim != 0 || v4.exitAnim != 0) {
                        writer.print(prefix);
                        writer.print("enterAnim=#");
                        writer.print(Integer.toHexString(v4.enterAnim));
                        writer.print(" exitAnim=#");
                        writer.println(Integer.toHexString(v4.exitAnim));
                    }

                    if(v4.popEnterAnim == 0 && v4.popExitAnim == 0) {
                        goto label_148;
                    }

                    writer.print(prefix);
                    writer.print("popEnterAnim=#");
                    writer.print(Integer.toHexString(v4.popEnterAnim));
                    writer.print(" popExitAnim=#");
                    writer.println(Integer.toHexString(v4.popExitAnim));
                }

            label_148:
                if(v4.removed != null && v4.removed.size() > 0) {
                    int v1;
                    for(v1 = 0; v1 < v4.removed.size(); ++v1) {
                        writer.print(v2);
                        if(v4.removed.size() == 1) {
                            writer.print("Removed: ");
                        }
                        else {
                            if(v1 == 0) {
                                writer.println("Removed:");
                            }

                            writer.print(v2);
                            writer.print("  #");
                            writer.print(v1);
                            writer.print(": ");
                        }

                        writer.println(v4.removed.get(v1));
                    }
                }

                v4 = v4.next;
            }
        }
    }

    public String getName() {
        return this.mName;
    }

    public void popFromBackStack(boolean doStateMove) {
        Fragment v0;
        FileDescriptor v10 = null;
        int v11 = -1;
        if(FragmentManagerImpl.DEBUG) {
            Log.v("FragmentManager", "popFromBackStack: " + this);
            this.dump("  ", v10, new PrintWriter(new LogWriter("FragmentManager")), ((String[])v10));
        }

        this.bumpBackStackNesting(v11);
        Op v4;
        for(v4 = this.mTail; v4 != null; v4 = v4.prev) {
            switch(v4.cmd) {
                case 1: {
                    v0 = v4.fragment;
                    v0.mNextAnim = v4.popExitAnim;
                    this.mManager.removeFragment(v0, FragmentManagerImpl.reverseTransit(this.mTransition), this.mTransitionStyle);
                    break;
                }
                case 2: {
                    v0 = v4.fragment;
                    if(v0 != null) {
                        v0.mNextAnim = v4.popExitAnim;
                        this.mManager.removeFragment(v0, FragmentManagerImpl.reverseTransit(this.mTransition), this.mTransitionStyle);
                    }

                    if(v4.removed == null) {
                        goto label_38;
                    }

                    int v1;
                    for(v1 = 0; v1 < v4.removed.size(); ++v1) {
                        Object v3 = v4.removed.get(v1);
                        ((Fragment)v3).mNextAnim = v4.popEnterAnim;
                        this.mManager.addFragment(((Fragment)v3), false);
                    }
                }
                case 3: {
                    v0 = v4.fragment;
                    v0.mNextAnim = v4.popEnterAnim;
                    this.mManager.addFragment(v0, false);
                    break;
                }
                case 4: {
                    v0 = v4.fragment;
                    v0.mNextAnim = v4.popEnterAnim;
                    this.mManager.showFragment(v0, FragmentManagerImpl.reverseTransit(this.mTransition), this.mTransitionStyle);
                    break;
                }
                case 5: {
                    v0 = v4.fragment;
                    v0.mNextAnim = v4.popExitAnim;
                    this.mManager.hideFragment(v0, FragmentManagerImpl.reverseTransit(this.mTransition), this.mTransitionStyle);
                    break;
                }
                case 6: {
                    v0 = v4.fragment;
                    v0.mNextAnim = v4.popEnterAnim;
                    this.mManager.attachFragment(v0, FragmentManagerImpl.reverseTransit(this.mTransition), this.mTransitionStyle);
                    break;
                }
                case 7: {
                    v0 = v4.fragment;
                    v0.mNextAnim = v4.popEnterAnim;
                    this.mManager.detachFragment(v0, FragmentManagerImpl.reverseTransit(this.mTransition), this.mTransitionStyle);
                    break;
                }
                default: {
                    throw new IllegalArgumentException("Unknown cmd: " + v4.cmd);
                }
            }

        label_38:
        }

        if(doStateMove) {
            this.mManager.moveToState(this.mManager.mCurState, FragmentManagerImpl.reverseTransit(this.mTransition), this.mTransitionStyle, true);
        }

        if(this.mIndex >= 0) {
            this.mManager.freeBackStackIndex(this.mIndex);
            this.mIndex = v11;
        }
    }

    public void run() {
        Object v0_1;
        Fragment v0;
        if(FragmentManagerImpl.DEBUG) {
            Log.v("FragmentManager", "Run: " + this);
        }

        if((this.mAddToBackStack) && this.mIndex < 0) {
            throw new IllegalStateException("addToBackStack() called after commit()");
        }

        this.bumpBackStackNesting(1);
        Op v3;
        for(v3 = this.mHead; v3 != null; v3 = v3.next) {
            switch(v3.cmd) {
                case 1: {
                    v0 = v3.fragment;
                    v0.mNextAnim = v3.enterAnim;
                    this.mManager.addFragment(v0, false);
                    break;
                }
                case 2: {
                    v0 = v3.fragment;
                    if(this.mManager.mAdded != null) {
                        int v1;
                        for(v1 = 0; v1 < this.mManager.mAdded.size(); ++v1) {
                            Object v2 = this.mManager.mAdded.get(v1);
                            if(FragmentManagerImpl.DEBUG) {
                                Log.v("FragmentManager", "OP_REPLACE: adding=" + v0 + " old=" + v2);
                            }

                            if(v0 == null || ((Fragment)v2).mContainerId == v0.mContainerId) {
                                if((((Fragment)v2)) == v0) {
                                    v0_1 = null;
                                    v3.fragment = ((Fragment)v0_1);
                                }
                                else {
                                    if(v3.removed == null) {
                                        v3.removed = new ArrayList();
                                    }

                                    v3.removed.add(v2);
                                    ((Fragment)v2).mNextAnim = v3.exitAnim;
                                    if(this.mAddToBackStack) {
                                        ++((Fragment)v2).mBackStackNesting;
                                        if(FragmentManagerImpl.DEBUG) {
                                            Log.v("FragmentManager", "Bump nesting of " + v2 + " to " + ((Fragment)v2).mBackStackNesting);
                                        }
                                    }

                                    this.mManager.removeFragment(((Fragment)v2), this.mTransition, this.mTransitionStyle);
                                }
                            }
                        }
                    }

                    if((((Fragment)v0_1)) == null) {
                        goto label_36;
                    }

                    ((Fragment)v0_1).mNextAnim = v3.enterAnim;
                    this.mManager.addFragment(((Fragment)v0_1), false);
                    break;
                }
                case 3: {
                    v0 = v3.fragment;
                    v0.mNextAnim = v3.exitAnim;
                    this.mManager.removeFragment(v0, this.mTransition, this.mTransitionStyle);
                    break;
                }
                case 4: {
                    v0 = v3.fragment;
                    v0.mNextAnim = v3.exitAnim;
                    this.mManager.hideFragment(v0, this.mTransition, this.mTransitionStyle);
                    break;
                }
                case 5: {
                    v0 = v3.fragment;
                    v0.mNextAnim = v3.enterAnim;
                    this.mManager.showFragment(v0, this.mTransition, this.mTransitionStyle);
                    break;
                }
                case 6: {
                    v0 = v3.fragment;
                    v0.mNextAnim = v3.exitAnim;
                    this.mManager.detachFragment(v0, this.mTransition, this.mTransitionStyle);
                    break;
                }
                case 7: {
                    v0 = v3.fragment;
                    v0.mNextAnim = v3.enterAnim;
                    this.mManager.attachFragment(v0, this.mTransition, this.mTransitionStyle);
                    break;
                }
                default: {
                    throw new IllegalArgumentException("Unknown cmd: " + v3.cmd);
                }
            }

        label_36:
        }

        this.mManager.moveToState(this.mManager.mCurState, this.mTransition, this.mTransitionStyle, true);
        if(this.mAddToBackStack) {
            this.mManager.addBackStackState(this);
        }
    }

    public String toString() {
        StringBuilder v0 = new StringBuilder(128);
        v0.append("BackStackEntry{");
        v0.append(Integer.toHexString(System.identityHashCode(this)));
        if(this.mIndex >= 0) {
            v0.append(" #");
            v0.append(this.mIndex);
        }

        if(this.mName != null) {
            v0.append(" ");
            v0.append(this.mName);
        }

        v0.append("}");
        return v0.toString();
    }
}

