// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.app;

import android.os.Parcel;
import android.os.Parcelable;
import android.os.Parcelable$Creator;
import android.text.TextUtils;
import android.util.Log;
import java.util.ArrayList;

final class BackStackState implements Parcelable {
    public static final Parcelable$Creator CREATOR;
    final int mBreadCrumbShortTitleRes;
    final CharSequence mBreadCrumbShortTitleText;
    final int mBreadCrumbTitleRes;
    final CharSequence mBreadCrumbTitleText;
    final int mIndex;
    final String mName;
    final int[] mOps;
    final int mTransition;
    final int mTransitionStyle;

    static  {
        BackStackState.CREATOR = new Parcelable$Creator() {
            public BackStackState createFromParcel(Parcel in) {
                return new BackStackState(in);
            }

            public Object createFromParcel(Parcel x0) {
                return this.createFromParcel(x0);
            }

            public BackStackState[] newArray(int size) {
                return new BackStackState[size];
            }

            public Object[] newArray(int x0) {
                return this.newArray(x0);
            }
        };
    }

    public BackStackState(Parcel in) {
        super();
        this.mOps = in.createIntArray();
        this.mTransition = in.readInt();
        this.mTransitionStyle = in.readInt();
        this.mName = in.readString();
        this.mIndex = in.readInt();
        this.mBreadCrumbTitleRes = in.readInt();
        this.mBreadCrumbTitleText = TextUtils.CHAR_SEQUENCE_CREATOR.createFromParcel(in);
        this.mBreadCrumbShortTitleRes = in.readInt();
        this.mBreadCrumbShortTitleText = TextUtils.CHAR_SEQUENCE_CREATOR.createFromParcel(in);
    }

    public BackStackState(FragmentManagerImpl fm, BackStackRecord bse) {
        int v6;
        super();
        int v2 = 0;
        Op v3;
        for(v3 = bse.mHead; v3 != null; v3 = v3.next) {
            if(v3.removed != null) {
                v2 += v3.removed.size();
            }
        }

        this.mOps = new int[bse.mNumOp * 7 + v2];
        if(!bse.mAddToBackStack) {
            throw new IllegalStateException("Not on back stack");
        }

        v3 = bse.mHead;
        int v5;
        for(v5 = 0; v3 != null; v5 = v4) {
            int v4 = v5 + 1;
            this.mOps[v5] = v3.cmd;
            int[] v7 = this.mOps;
            v5 = v4 + 1;
            if(v3.fragment != null) {
                v6 = v3.fragment.mIndex;
            }
            else {
                v6 = -1;
            }

            v7[v4] = v6;
            v4 = v5 + 1;
            this.mOps[v5] = v3.enterAnim;
            v5 = v4 + 1;
            this.mOps[v4] = v3.exitAnim;
            v4 = v5 + 1;
            this.mOps[v5] = v3.popEnterAnim;
            v5 = v4 + 1;
            this.mOps[v4] = v3.popExitAnim;
            if(v3.removed != null) {
                int v0 = v3.removed.size();
                this.mOps[v5] = v0;
                int v1 = 0;
                ++v5;
                while(v1 < v0) {
                    this.mOps[v5] = v3.removed.get(v1).mIndex;
                    ++v1;
                    ++v5;
                }

                v4 = v5;
            }
            else {
                v4 = v5 + 1;
                this.mOps[v5] = 0;
            }

            v3 = v3.next;
        }

        this.mTransition = bse.mTransition;
        this.mTransitionStyle = bse.mTransitionStyle;
        this.mName = bse.mName;
        this.mIndex = bse.mIndex;
        this.mBreadCrumbTitleRes = bse.mBreadCrumbTitleRes;
        this.mBreadCrumbTitleText = bse.mBreadCrumbTitleText;
        this.mBreadCrumbShortTitleRes = bse.mBreadCrumbShortTitleRes;
        this.mBreadCrumbShortTitleText = bse.mBreadCrumbShortTitleText;
    }

    public int describeContents() {
        return 0;
    }

    public BackStackRecord instantiate(FragmentManagerImpl fm) {
        BackStackRecord v1 = new BackStackRecord(fm);
        int v7 = 0;
        int v5;
        for(v5 = 0; v7 < this.mOps.length; ++v5) {
            Op v6 = new Op();
            int v8 = v7 + 1;
            v6.cmd = this.mOps[v7];
            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "Instantiate " + v1 + " op #" + v5 + " base fragment #" + this.mOps[v8]);
            }

            v7 = v8 + 1;
            int v3 = this.mOps[v8];
            if(v3 >= 0) {
                v6.fragment = fm.mActive.get(v3);
            }
            else {
                v6.fragment = null;
            }

            v8 = v7 + 1;
            v6.enterAnim = this.mOps[v7];
            v7 = v8 + 1;
            v6.exitAnim = this.mOps[v8];
            v8 = v7 + 1;
            v6.popEnterAnim = this.mOps[v7];
            v7 = v8 + 1;
            v6.popExitAnim = this.mOps[v8];
            v8 = v7 + 1;
            int v0 = this.mOps[v7];
            if(v0 > 0) {
                v6.removed = new ArrayList(v0);
                int v4 = 0;
                while(v4 < v0) {
                    if(FragmentManagerImpl.DEBUG) {
                        Log.v("FragmentManager", "Instantiate " + v1 + " set remove fragment #" + this.mOps[v8]);
                    }

                    v6.removed.add(fm.mActive.get(this.mOps[v8]));
                    ++v4;
                    ++v8;
                }
            }

            v7 = v8;
            v1.addOp(v6);
        }

        v1.mTransition = this.mTransition;
        v1.mTransitionStyle = this.mTransitionStyle;
        v1.mName = this.mName;
        v1.mIndex = this.mIndex;
        v1.mAddToBackStack = true;
        v1.mBreadCrumbTitleRes = this.mBreadCrumbTitleRes;
        v1.mBreadCrumbTitleText = this.mBreadCrumbTitleText;
        v1.mBreadCrumbShortTitleRes = this.mBreadCrumbShortTitleRes;
        v1.mBreadCrumbShortTitleText = this.mBreadCrumbShortTitleText;
        v1.bumpBackStackNesting(1);
        return v1;
    }

    public void writeToParcel(Parcel dest, int flags) {
        dest.writeIntArray(this.mOps);
        dest.writeInt(this.mTransition);
        dest.writeInt(this.mTransitionStyle);
        dest.writeString(this.mName);
        dest.writeInt(this.mIndex);
        dest.writeInt(this.mBreadCrumbTitleRes);
        TextUtils.writeToParcel(this.mBreadCrumbTitleText, dest, 0);
        dest.writeInt(this.mBreadCrumbShortTitleRes);
        TextUtils.writeToParcel(this.mBreadCrumbShortTitleText, dest, 0);
    }
}

