// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.app;

import android.content.Context;
import android.content.res.Configuration;
import android.os.Build$VERSION;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Parcelable;
import android.support.v4.util.DebugUtils;
import android.support.v4.util.LogWriter;
import android.util.Log;
import android.util.SparseArray;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.AlphaAnimation;
import android.view.animation.Animation;
import android.view.animation.Animation$AnimationListener;
import android.view.animation.AnimationSet;
import android.view.animation.AnimationUtils;
import android.view.animation.DecelerateInterpolator;
import android.view.animation.Interpolator;
import android.view.animation.ScaleAnimation;
import java.io.FileDescriptor;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;

final class FragmentManagerImpl extends FragmentManager {
    static final Interpolator ACCELERATE_CUBIC;
    static final Interpolator ACCELERATE_QUINT;
    static final Interpolator DECELERATE_CUBIC;
    static final Interpolator DECELERATE_QUINT;
    static final boolean HONEYCOMB;
    ArrayList mActive;
    FragmentActivity mActivity;
    ArrayList mAdded;
    ArrayList mAvailBackStackIndices;
    ArrayList mAvailIndices;
    ArrayList mBackStack;
    ArrayList mBackStackChangeListeners;
    ArrayList mBackStackIndices;
    FragmentContainer mContainer;
    ArrayList mCreatedMenus;
    int mCurState;
    boolean mDestroyed;
    Runnable mExecCommit;
    boolean mExecutingActions;
    boolean mHavePendingDeferredStart;
    boolean mNeedMenuInvalidate;
    String mNoTransactionsBecause;
    Fragment mParent;
    ArrayList mPendingActions;
    SparseArray mStateArray;
    Bundle mStateBundle;
    boolean mStateSaved;
    Runnable[] mTmpActions;

    static  {
        boolean v0 = false;
        float v4 = 2.5f;
        float v3 = 1.5f;
        FragmentManagerImpl.DEBUG = false;
        if(Build$VERSION.SDK_INT >= 11) {
            v0 = true;
        }

        FragmentManagerImpl.HONEYCOMB = v0;
        FragmentManagerImpl.DECELERATE_QUINT = new DecelerateInterpolator(v4);
        FragmentManagerImpl.DECELERATE_CUBIC = new DecelerateInterpolator(v3);
        FragmentManagerImpl.ACCELERATE_QUINT = new AccelerateInterpolator(v4);
        FragmentManagerImpl.ACCELERATE_CUBIC = new AccelerateInterpolator(v3);
    }

    FragmentManagerImpl() {
        super();
        this.mCurState = 0;
        this.mStateBundle = null;
        this.mStateArray = null;
        this.mExecCommit = new Runnable() {
            public void run() {
                FragmentManagerImpl.this.execPendingActions();
            }
        };
    }

    void addBackStackState(BackStackRecord state) {
        if(this.mBackStack == null) {
            this.mBackStack = new ArrayList();
        }

        this.mBackStack.add(state);
        this.reportBackStackChanged();
    }

    public void addFragment(Fragment fragment, boolean moveToStateNow) {
        if(this.mAdded == null) {
            this.mAdded = new ArrayList();
        }

        if(FragmentManagerImpl.DEBUG) {
            Log.v("FragmentManager", "add: " + fragment);
        }

        this.makeActive(fragment);
        if(!fragment.mDetached) {
            if(this.mAdded.contains(fragment)) {
                throw new IllegalStateException("Fragment already added: " + fragment);
            }
            else {
                this.mAdded.add(fragment);
                fragment.mAdded = true;
                fragment.mRemoving = false;
                if((fragment.mHasMenu) && (fragment.mMenuVisible)) {
                    this.mNeedMenuInvalidate = true;
                }

                if(!moveToStateNow) {
                    return;
                }

                this.moveToState(fragment);
            }
        }
    }

    public int allocBackStackIndex(BackStackRecord bse) {
        int v1;
        int v0;
        __monitor_enter(this);
        try {
            if(this.mAvailBackStackIndices == null || this.mAvailBackStackIndices.size() <= 0) {
                if(this.mBackStackIndices == null) {
                    this.mBackStackIndices = new ArrayList();
                }

                v0 = this.mBackStackIndices.size();
                if(FragmentManagerImpl.DEBUG) {
                    Log.v("FragmentManager", "Setting back stack index " + v0 + " to " + bse);
                }

                this.mBackStackIndices.add(bse);
                __monitor_exit(this);
                v1 = v0;
            }
            else {
                v0 = this.mAvailBackStackIndices.remove(this.mAvailBackStackIndices.size() - 1).intValue();
                if(FragmentManagerImpl.DEBUG) {
                    Log.v("FragmentManager", "Adding back stack index " + v0 + " with " + bse);
                }

                this.mBackStackIndices.set(v0, bse);
                __monitor_exit(this);
                v1 = v0;
            }

            return v1;
        label_53:
            __monitor_exit(this);
        }
        catch(Throwable v2) {
            goto label_53;
        }

        throw v2;
    }

    public void attachActivity(FragmentActivity activity, FragmentContainer container, Fragment parent) {
        if(this.mActivity != null) {
            throw new IllegalStateException("Already attached");
        }

        this.mActivity = activity;
        this.mContainer = container;
        this.mParent = parent;
    }

    public void attachFragment(Fragment fragment, int transition, int transitionStyle) {
        if(FragmentManagerImpl.DEBUG) {
            Log.v("FragmentManager", "attach: " + fragment);
        }

        if(fragment.mDetached) {
            fragment.mDetached = false;
            if(!fragment.mAdded) {
                if(this.mAdded == null) {
                    this.mAdded = new ArrayList();
                }

                if(this.mAdded.contains(fragment)) {
                    throw new IllegalStateException("Fragment already added: " + fragment);
                }

                if(FragmentManagerImpl.DEBUG) {
                    Log.v("FragmentManager", "add from attach: " + fragment);
                }

                this.mAdded.add(fragment);
                fragment.mAdded = true;
                if((fragment.mHasMenu) && (fragment.mMenuVisible)) {
                    this.mNeedMenuInvalidate = true;
                }

                this.moveToState(fragment, this.mCurState, transition, transitionStyle, false);
            }
        }
    }

    public FragmentTransaction beginTransaction() {
        return new BackStackRecord(this);
    }

    private void checkStateLoss() {
        if(this.mStateSaved) {
            throw new IllegalStateException("Can not perform this action after onSaveInstanceState");
        }

        if(this.mNoTransactionsBecause != null) {
            throw new IllegalStateException("Can not perform this action inside of " + this.mNoTransactionsBecause);
        }
    }

    public void detachFragment(Fragment fragment, int transition, int transitionStyle) {
        if(FragmentManagerImpl.DEBUG) {
            Log.v("FragmentManager", "detach: " + fragment);
        }

        if(!fragment.mDetached) {
            fragment.mDetached = true;
            if(fragment.mAdded) {
                if(this.mAdded != null) {
                    if(FragmentManagerImpl.DEBUG) {
                        Log.v("FragmentManager", "remove from detach: " + fragment);
                    }

                    this.mAdded.remove(fragment);
                }

                if((fragment.mHasMenu) && (fragment.mMenuVisible)) {
                    this.mNeedMenuInvalidate = true;
                }

                fragment.mAdded = false;
                this.moveToState(fragment, 1, transition, transitionStyle, false);
            }
        }
    }

    public void dispatchActivityCreated() {
        this.mStateSaved = false;
        this.moveToState(2, false);
    }

    public void dispatchConfigurationChanged(Configuration newConfig) {
        if(this.mAdded != null) {
            int v1;
            for(v1 = 0; v1 < this.mAdded.size(); ++v1) {
                Object v0 = this.mAdded.get(v1);
                if(v0 != null) {
                    ((Fragment)v0).performConfigurationChanged(newConfig);
                }
            }
        }
    }

    public boolean dispatchContextItemSelected(MenuItem item) {
        boolean v2;
        if(this.mAdded != null) {
            int v1 = 0;
            while(true) {
                if(v1 < this.mAdded.size()) {
                    Object v0 = this.mAdded.get(v1);
                    if(v0 != null && (((Fragment)v0).performContextItemSelected(item))) {
                        v2 = true;
                        break;
                    }

                    ++v1;
                    continue;
                }
                else {
                    goto label_15;
                }
            }
        }
        else {
        label_15:
            v2 = false;
        }

        return v2;
    }

    public void dispatchCreate() {
        this.mStateSaved = false;
        this.moveToState(1, false);
    }

    public boolean dispatchCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        Object v0;
        boolean v3 = false;
        ArrayList v2 = null;
        if(this.mAdded != null) {
            int v1;
            for(v1 = 0; v1 < this.mAdded.size(); ++v1) {
                v0 = this.mAdded.get(v1);
                if(v0 != null && (((Fragment)v0).performCreateOptionsMenu(menu, inflater))) {
                    v3 = true;
                    if(v2 == null) {
                        v2 = new ArrayList();
                    }

                    v2.add(v0);
                }
            }
        }

        if(this.mCreatedMenus != null) {
            for(v1 = 0; v1 < this.mCreatedMenus.size(); ++v1) {
                v0 = this.mCreatedMenus.get(v1);
                if(v2 == null || !v2.contains(v0)) {
                    ((Fragment)v0).onDestroyOptionsMenu();
                }
            }
        }

        this.mCreatedMenus = v2;
        return v3;
    }

    public void dispatchDestroy() {
        this.mDestroyed = true;
        this.execPendingActions();
        this.moveToState(0, false);
        this.mActivity = null;
        this.mContainer = null;
        this.mParent = null;
    }

    public void dispatchDestroyView() {
        this.moveToState(1, false);
    }

    public void dispatchLowMemory() {
        if(this.mAdded != null) {
            int v1;
            for(v1 = 0; v1 < this.mAdded.size(); ++v1) {
                Object v0 = this.mAdded.get(v1);
                if(v0 != null) {
                    ((Fragment)v0).performLowMemory();
                }
            }
        }
    }

    public boolean dispatchOptionsItemSelected(MenuItem item) {
        boolean v2;
        if(this.mAdded != null) {
            int v1 = 0;
            while(true) {
                if(v1 < this.mAdded.size()) {
                    Object v0 = this.mAdded.get(v1);
                    if(v0 != null && (((Fragment)v0).performOptionsItemSelected(item))) {
                        v2 = true;
                        break;
                    }

                    ++v1;
                    continue;
                }
                else {
                    goto label_15;
                }
            }
        }
        else {
        label_15:
            v2 = false;
        }

        return v2;
    }

    public void dispatchOptionsMenuClosed(Menu menu) {
        if(this.mAdded != null) {
            int v1;
            for(v1 = 0; v1 < this.mAdded.size(); ++v1) {
                Object v0 = this.mAdded.get(v1);
                if(v0 != null) {
                    ((Fragment)v0).performOptionsMenuClosed(menu);
                }
            }
        }
    }

    public void dispatchPause() {
        this.moveToState(4, false);
    }

    public boolean dispatchPrepareOptionsMenu(Menu menu) {
        boolean v2 = false;
        if(this.mAdded != null) {
            int v1;
            for(v1 = 0; v1 < this.mAdded.size(); ++v1) {
                Object v0 = this.mAdded.get(v1);
                if(v0 != null && (((Fragment)v0).performPrepareOptionsMenu(menu))) {
                    v2 = true;
                }
            }
        }

        return v2;
    }

    public void dispatchReallyStop() {
        this.moveToState(2, false);
    }

    public void dispatchResume() {
        this.mStateSaved = false;
        this.moveToState(5, false);
    }

    public void dispatchStart() {
        this.mStateSaved = false;
        this.moveToState(4, false);
    }

    public void dispatchStop() {
        this.mStateSaved = true;
        this.moveToState(3, false);
    }

    public void dump(String prefix, FileDescriptor fd, PrintWriter writer, String[] args) {
        Object v1;
        Object v2;
        int v0;
        String v4 = prefix + "    ";
        if(this.mActive != null) {
            v0 = this.mActive.size();
            if(v0 > 0) {
                writer.print(prefix);
                writer.print("Active Fragments in ");
                writer.print(Integer.toHexString(System.identityHashCode(this)));
                writer.println(":");
                int v3;
                for(v3 = 0; v3 < v0; ++v3) {
                    v2 = this.mActive.get(v3);
                    writer.print(prefix);
                    writer.print("  #");
                    writer.print(v3);
                    writer.print(": ");
                    writer.println(v2);
                    if(v2 != null) {
                        ((Fragment)v2).dump(v4, fd, writer, args);
                    }
                }
            }
        }

        if(this.mAdded != null) {
            v0 = this.mAdded.size();
            if(v0 > 0) {
                writer.print(prefix);
                writer.println("Added Fragments:");
                for(v3 = 0; v3 < v0; ++v3) {
                    v2 = this.mAdded.get(v3);
                    writer.print(prefix);
                    writer.print("  #");
                    writer.print(v3);
                    writer.print(": ");
                    writer.println(((Fragment)v2).toString());
                }
            }
        }

        if(this.mCreatedMenus != null) {
            v0 = this.mCreatedMenus.size();
            if(v0 > 0) {
                writer.print(prefix);
                writer.println("Fragments Created Menus:");
                for(v3 = 0; v3 < v0; ++v3) {
                    v2 = this.mCreatedMenus.get(v3);
                    writer.print(prefix);
                    writer.print("  #");
                    writer.print(v3);
                    writer.print(": ");
                    writer.println(((Fragment)v2).toString());
                }
            }
        }

        if(this.mBackStack != null) {
            v0 = this.mBackStack.size();
            if(v0 > 0) {
                writer.print(prefix);
                writer.println("Back Stack:");
                for(v3 = 0; v3 < v0; ++v3) {
                    v1 = this.mBackStack.get(v3);
                    writer.print(prefix);
                    writer.print("  #");
                    writer.print(v3);
                    writer.print(": ");
                    writer.println(((BackStackRecord)v1).toString());
                    ((BackStackRecord)v1).dump(v4, fd, writer, args);
                }
            }
        }

        __monitor_enter(this);
        try {
            if(this.mBackStackIndices != null) {
                v0 = this.mBackStackIndices.size();
                if(v0 > 0) {
                    writer.print(prefix);
                    writer.println("Back Stack Indices:");
                    for(v3 = 0; v3 < v0; ++v3) {
                        v1 = this.mBackStackIndices.get(v3);
                        writer.print(prefix);
                        writer.print("  #");
                        writer.print(v3);
                        writer.print(": ");
                        writer.println(v1);
                    }
                }
            }

            if(this.mAvailBackStackIndices != null && this.mAvailBackStackIndices.size() > 0) {
                writer.print(prefix);
                writer.print("mAvailBackStackIndices: ");
                writer.println(Arrays.toString(this.mAvailBackStackIndices.toArray()));
            }

            __monitor_exit(this);
        }
        catch(Throwable v6) {
            try {
            label_157:
                __monitor_exit(this);
            }
            catch(Throwable v6) {
                goto label_157;
            }

            throw v6;
        }

        if(this.mPendingActions != null) {
            v0 = this.mPendingActions.size();
            if(v0 > 0) {
                writer.print(prefix);
                writer.println("Pending Actions:");
                for(v3 = 0; v3 < v0; ++v3) {
                    Object v5 = this.mPendingActions.get(v3);
                    writer.print(prefix);
                    writer.print("  #");
                    writer.print(v3);
                    writer.print(": ");
                    writer.println(v5);
                }
            }
        }

        writer.print(prefix);
        writer.println("FragmentManager misc state:");
        writer.print(prefix);
        writer.print("  mActivity=");
        writer.println(this.mActivity);
        writer.print(prefix);
        writer.print("  mContainer=");
        writer.println(this.mContainer);
        if(this.mParent != null) {
            writer.print(prefix);
            writer.print("  mParent=");
            writer.println(this.mParent);
        }

        writer.print(prefix);
        writer.print("  mCurState=");
        writer.print(this.mCurState);
        writer.print(" mStateSaved=");
        writer.print(this.mStateSaved);
        writer.print(" mDestroyed=");
        writer.println(this.mDestroyed);
        if(this.mNeedMenuInvalidate) {
            writer.print(prefix);
            writer.print("  mNeedMenuInvalidate=");
            writer.println(this.mNeedMenuInvalidate);
        }

        if(this.mNoTransactionsBecause != null) {
            writer.print(prefix);
            writer.print("  mNoTransactionsBecause=");
            writer.println(this.mNoTransactionsBecause);
        }

        if(this.mAvailIndices != null && this.mAvailIndices.size() > 0) {
            writer.print(prefix);
            writer.print("  mAvailIndices: ");
            writer.println(Arrays.toString(this.mAvailIndices.toArray()));
        }
    }

    public void enqueueAction(Runnable action, boolean allowStateLoss) {
        if(!allowStateLoss) {
            this.checkStateLoss();
        }

        __monitor_enter(this);
        try {
            if(this.mActivity == null) {
                throw new IllegalStateException("Activity has been destroyed");
            }

            if(this.mPendingActions == null) {
                this.mPendingActions = new ArrayList();
            }

            this.mPendingActions.add(action);
            if(this.mPendingActions.size() == 1) {
                this.mActivity.mHandler.removeCallbacks(this.mExecCommit);
                this.mActivity.mHandler.post(this.mExecCommit);
            }

            __monitor_exit(this);
            return;
        label_9:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_9;
        }

        throw v0;
    }

    public boolean execPendingActions() {
        if(this.mExecutingActions) {
            throw new IllegalStateException("Recursive entry to executePendingTransactions");
        }

        if(Looper.myLooper() != this.mActivity.mHandler.getLooper()) {
            throw new IllegalStateException("Must be called from main thread of process");
        }

        boolean v0;
        for(v0 = false; true; v0 = true) {
            __monitor_enter(this);
            try {
                if(this.mPendingActions != null && this.mPendingActions.size() != 0) {
                    int v4 = this.mPendingActions.size();
                    if(this.mTmpActions == null || this.mTmpActions.length < v4) {
                        this.mTmpActions = new Runnable[v4];
                    }

                    this.mPendingActions.toArray(this.mTmpActions);
                    this.mPendingActions.clear();
                    this.mActivity.mHandler.removeCallbacks(this.mExecCommit);
                    __monitor_exit(this);
                    goto label_58;
                }

                goto label_21;
            }
            catch(Throwable v5) {
                goto label_71;
            }

        label_58:
            this.mExecutingActions = true;
            int v2;
            for(v2 = 0; v2 < v4; ++v2) {
                this.mTmpActions[v2].run();
                this.mTmpActions[v2] = null;
            }

            this.mExecutingActions = false;
        }

        try {
        label_21:
            __monitor_exit(this);
        }
        catch(Throwable v5) {
            try {
            label_71:
                __monitor_exit(this);
            }
            catch(Throwable v5) {
                goto label_71;
            }

            throw v5;
        }

        if(this.mHavePendingDeferredStart) {
            int v3 = 0;
            for(v2 = 0; v2 < this.mActive.size(); ++v2) {
                Object v1 = this.mActive.get(v2);
                if(v1 != null && ((Fragment)v1).mLoaderManager != null) {
                    v3 |= ((Fragment)v1).mLoaderManager.hasRunningLoaders();
                }
            }

            if(v3 != 0) {
                goto label_79;
            }

            this.mHavePendingDeferredStart = false;
            this.startPendingDeferredFragments();
        }

    label_79:
        return v0;
    }

    public boolean executePendingTransactions() {
        return this.execPendingActions();
    }

    public Fragment findFragmentById(int id) {
        Fragment v0_1;
        Object v0;
        int v1;
        if(this.mAdded != null) {
            v1 = this.mAdded.size() - 1;
            while(true) {
                if(v1 >= 0) {
                    v0 = this.mAdded.get(v1);
                    if(v0 != null && ((Fragment)v0).mFragmentId == id) {
                        break;
                    }

                    --v1;
                    continue;
                }
                else {
                    goto label_14;
                }
            }
        }
        else {
        label_14:
            if(this.mActive != null) {
                for(v1 = this.mActive.size() - 1; v1 >= 0; --v1) {
                    v0 = this.mActive.get(v1);
                    if(v0 != null && ((Fragment)v0).mFragmentId == id) {
                        goto label_11;
                    }
                }
            }

            v0_1 = null;
        }

    label_11:
        return v0_1;
    }

    public Fragment findFragmentByTag(String tag) {
        Object v0;
        int v1;
        Fragment v0_1;
        if(this.mAdded == null || tag == null) {
        label_16:
            if(this.mActive != null && tag != null) {
                for(v1 = this.mActive.size() - 1; v1 >= 0; --v1) {
                    v0 = this.mActive.get(v1);
                    if(v0 != null && (tag.equals(((Fragment)v0).mTag))) {
                        goto label_13;
                    }
                }
            }

            v0_1 = null;
        }
        else {
            v1 = this.mAdded.size() - 1;
            while(true) {
                if(v1 >= 0) {
                    v0 = this.mAdded.get(v1);
                    if(v0 != null && (tag.equals(((Fragment)v0).mTag))) {
                        break;
                    }

                    --v1;
                    continue;
                }
                else {
                    goto label_16;
                }
            }
        }

    label_13:
        return v0_1;
    }

    public void freeBackStackIndex(int index) {
        __monitor_enter(this);
        try {
            this.mBackStackIndices.set(index, null);
            if(this.mAvailBackStackIndices == null) {
                this.mAvailBackStackIndices = new ArrayList();
            }

            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "Freeing back stack index " + index);
            }

            this.mAvailBackStackIndices.add(Integer.valueOf(index));
            __monitor_exit(this);
            return;
        label_23:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_23;
        }

        throw v0;
    }

    public Fragment getFragment(Bundle bundle, String key) {
        Fragment v0;
        int v1 = bundle.getInt(key, -1);
        if(v1 == -1) {
            v0 = null;
        }
        else {
            if(v1 >= this.mActive.size()) {
                this.throwException(new IllegalStateException("Fragement no longer exists for key " + key + ": index " + v1));
            }

            Object v0_1 = this.mActive.get(v1);
            if(v0_1 != null) {
                goto label_4;
            }

            this.throwException(new IllegalStateException("Fragement no longer exists for key " + key + ": index " + v1));
        }

    label_4:
        return v0;
    }

    public void hideFragment(Fragment fragment, int transition, int transitionStyle) {
        if(FragmentManagerImpl.DEBUG) {
            Log.v("FragmentManager", "hide: " + fragment);
        }

        if(!fragment.mHidden) {
            fragment.mHidden = true;
            if(fragment.mView != null) {
                Animation v0 = this.loadAnimation(fragment, transition, true, transitionStyle);
                if(v0 != null) {
                    fragment.mView.startAnimation(v0);
                }

                fragment.mView.setVisibility(8);
            }

            if((fragment.mAdded) && (fragment.mHasMenu) && (fragment.mMenuVisible)) {
                this.mNeedMenuInvalidate = true;
            }

            fragment.onHiddenChanged(true);
        }
    }

    Animation loadAnimation(Fragment fragment, int transit, boolean enter, int transitionStyle) {
        float v8 = 0.975f;
        Animation v3 = null;
        float v6 = 1f;
        Animation v1 = fragment.onCreateAnimation(transit, enter, fragment.mNextAnim);
        if(v1 == null) {
            if(fragment.mNextAnim != 0) {
                Animation v0 = AnimationUtils.loadAnimation(this.mActivity, fragment.mNextAnim);
                if(v0 != null) {
                    v1 = v0;
                    goto label_7;
                }
            }

            if(transit != 0) {
                goto label_19;
            }

            v1 = v3;
            goto label_7;
        label_19:
            int v2 = FragmentManagerImpl.transitToStyleIndex(transit, enter);
            if(v2 >= 0) {
                goto label_23;
            }

            v1 = v3;
            goto label_7;
        label_23:
            switch(v2) {
                case 1: {
                    goto label_35;
                }
                case 2: {
                    goto label_39;
                }
                case 3: {
                    goto label_42;
                }
                case 4: {
                    goto label_45;
                }
                case 5: {
                    goto label_49;
                }
                case 6: {
                    goto label_52;
                }
            }

            if(transitionStyle == 0 && this.mActivity.getWindow() != null) {
                transitionStyle = this.mActivity.getWindow().getAttributes().windowAnimations;
            }

            if(transitionStyle != 0) {
                goto label_55;
            }

            v1 = v3;
            goto label_7;
        label_55:
            v1 = v3;
            goto label_7;
        label_39:
            v1 = FragmentManagerImpl.makeOpenCloseAnimation(this.mActivity, v6, v8, v6, 0f);
            goto label_7;
        label_49:
            v1 = FragmentManagerImpl.makeFadeAnimation(this.mActivity, 0f, v6);
            goto label_7;
        label_52:
            v1 = FragmentManagerImpl.makeFadeAnimation(this.mActivity, v6, 0f);
            goto label_7;
        label_35:
            v1 = FragmentManagerImpl.makeOpenCloseAnimation(this.mActivity, 1.125f, v6, 0f, v6);
            goto label_7;
        label_45:
            v1 = FragmentManagerImpl.makeOpenCloseAnimation(this.mActivity, v6, 1.075f, v6, 0f);
            goto label_7;
        label_42:
            v1 = FragmentManagerImpl.makeOpenCloseAnimation(this.mActivity, v8, v6, 0f, v6);
        }

    label_7:
        return v1;
    }

    void makeActive(Fragment f) {
        if(f.mIndex < 0) {
            if(this.mAvailIndices == null || this.mAvailIndices.size() <= 0) {
                if(this.mActive == null) {
                    this.mActive = new ArrayList();
                }

                f.setIndex(this.mActive.size(), this.mParent);
                this.mActive.add(f);
            }
            else {
                f.setIndex(this.mAvailIndices.remove(this.mAvailIndices.size() - 1).intValue(), this.mParent);
                this.mActive.set(f.mIndex, f);
            }

            if(!FragmentManagerImpl.DEBUG) {
                return;
            }

            Log.v("FragmentManager", "Allocated fragment index " + f);
        }
    }

    static Animation makeFadeAnimation(Context context, float start, float end) {
        AlphaAnimation v0 = new AlphaAnimation(start, end);
        v0.setInterpolator(FragmentManagerImpl.DECELERATE_CUBIC);
        v0.setDuration(220);
        return ((Animation)v0);
    }

    void makeInactive(Fragment f) {
        if(f.mIndex >= 0) {
            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "Freeing fragment index " + f);
            }

            this.mActive.set(f.mIndex, null);
            if(this.mAvailIndices == null) {
                this.mAvailIndices = new ArrayList();
            }

            this.mAvailIndices.add(Integer.valueOf(f.mIndex));
            this.mActivity.invalidateSupportFragment(f.mWho);
            f.initState();
        }
    }

    static Animation makeOpenCloseAnimation(Context context, float startScale, float endScale, float startAlpha, float endAlpha) {
        AnimationSet v10 = new AnimationSet(false);
        ScaleAnimation v0 = new ScaleAnimation(startScale, endScale, startScale, endScale, 1, 0.5f, 1, 0.5f);
        v0.setInterpolator(FragmentManagerImpl.DECELERATE_QUINT);
        v0.setDuration(220);
        v10.addAnimation(((Animation)v0));
        AlphaAnimation v9 = new AlphaAnimation(startAlpha, endAlpha);
        v9.setInterpolator(FragmentManagerImpl.DECELERATE_CUBIC);
        v9.setDuration(220);
        v10.addAnimation(((Animation)v9));
        return ((Animation)v10);
    }

    void moveToState(int newState, int transit, int transitStyle, boolean always) {
        if(this.mActivity == null && newState != 0) {
            throw new IllegalStateException("No activity");
        }

        if((always) || this.mCurState != newState) {
            this.mCurState = newState;
            if(this.mActive != null) {
                int v7 = 0;
                int v6;
                for(v6 = 0; v6 < this.mActive.size(); ++v6) {
                    Object v1 = this.mActive.get(v6);
                    if(v1 != null) {
                        this.moveToState(((Fragment)v1), newState, transit, transitStyle, false);
                        if(((Fragment)v1).mLoaderManager != null) {
                            v7 |= ((Fragment)v1).mLoaderManager.hasRunningLoaders();
                        }
                    }
                }

                if(v7 == 0) {
                    this.startPendingDeferredFragments();
                }

                if(!this.mNeedMenuInvalidate) {
                    return;
                }

                if(this.mActivity == null) {
                    return;
                }

                if(this.mCurState != 5) {
                    return;
                }

                this.mActivity.supportInvalidateOptionsMenu();
                this.mNeedMenuInvalidate = false;
            }
        }
    }

    void moveToState(Fragment f) {
        this.moveToState(f, this.mCurState, 0, 0, false);
    }

    void moveToState(Fragment f, int newState, int transit, int transitionStyle, boolean keepActive) {
        Animation v6;
        View v7_1;
        FragmentManagerImpl v0;
        if((!f.mAdded || (f.mDetached)) && newState > 1) {
            newState = 1;
        }

        if((f.mRemoving) && 1 > f.mState) {
            newState = f.mState;
        }

        if((f.mDeferStart) && f.mState < 4 && newState > 3) {
            newState = 3;
        }

        if(f.mState < newState) {
            if((f.mFromLayout) && !f.mInLayout) {
                return;
            }

            if(f.mAnimatingAway != null) {
                f.mAnimatingAway = null;
                this.moveToState(f, f.mStateAfterAnimating, 0, 0, true);
            }

            switch(f.mState) {
                case 0: {
                    goto label_42;
                }
                case 1: {
                    goto label_140;
                }
                case 2: 
                case 3: {
                    goto label_217;
                }
                case 4: {
                    goto label_229;
                }
            }

            goto label_40;
        label_42:
            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "moveto CREATED: " + f);
            }

            if(f.mSavedFragmentState != null) {
                f.mSavedViewState = f.mSavedFragmentState.getSparseParcelableArray("android:view_state");
                f.mTarget = this.getFragment(f.mSavedFragmentState, "android:target_state");
                if(f.mTarget != null) {
                    f.mTargetRequestCode = f.mSavedFragmentState.getInt("android:target_req_state", 0);
                }

                f.mUserVisibleHint = f.mSavedFragmentState.getBoolean("android:user_visible_hint", true);
                if(f.mUserVisibleHint) {
                    goto label_80;
                }

                f.mDeferStart = true;
                if(newState <= 3) {
                    goto label_80;
                }

                newState = 3;
            }

        label_80:
            f.mActivity = this.mActivity;
            f.mParentFragment = this.mParent;
            if(this.mParent != null) {
                v0 = this.mParent.mChildFragmentManager;
            }
            else {
                v0 = this.mActivity.mFragments;
            }

            f.mFragmentManager = v0;
            f.mCalled = false;
            f.onAttach(this.mActivity);
            if(!f.mCalled) {
                throw new SuperNotCalledException("Fragment " + f + " did not call through to super.onAttach()");
            }

            if(f.mParentFragment == null) {
                this.mActivity.onAttachFragment(f);
            }

            if(!f.mRetaining) {
                f.performCreate(f.mSavedFragmentState);
            }

            f.mRetaining = false;
            if(!f.mFromLayout) {
                goto label_140;
            }

            f.mView = f.performCreateView(f.getLayoutInflater(f.mSavedFragmentState), null, f.mSavedFragmentState);
            if(f.mView == null) {
                goto label_248;
            }

            f.mInnerView = f.mView;
            f.mView = NoSaveStateFrameLayout.wrap(f.mView);
            if(f.mHidden) {
                f.mView.setVisibility(8);
            }

            f.onViewCreated(f.mView, f.mSavedFragmentState);
            goto label_140;
        label_248:
            f.mInnerView = null;
        label_140:
            if(newState <= 1) {
                goto label_217;
            }

            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "moveto ACTIVITY_CREATED: " + f);
            }

            if(!f.mFromLayout) {
                ViewGroup v7 = null;
                if(f.mContainerId != 0) {
                    v7_1 = this.mContainer.findViewById(f.mContainerId);
                    if(v7_1 == null && !f.mRestored) {
                        this.throwException(new IllegalArgumentException("No view found for id 0x" + Integer.toHexString(f.mContainerId) + " (" + f.getResources().getResourceName(f.mContainerId) + ") for fragment " + f));
                    }
                }

                f.mContainer = ((ViewGroup)v7_1);
                f.mView = f.performCreateView(f.getLayoutInflater(f.mSavedFragmentState), ((ViewGroup)v7_1), f.mSavedFragmentState);
                if(f.mView == null) {
                    goto label_251;
                }

                f.mInnerView = f.mView;
                f.mView = NoSaveStateFrameLayout.wrap(f.mView);
                if(v7_1 != null) {
                    v6 = this.loadAnimation(f, transit, true, transitionStyle);
                    if(v6 != null) {
                        f.mView.startAnimation(v6);
                    }

                    ((ViewGroup)v7_1).addView(f.mView);
                }

                if(f.mHidden) {
                    f.mView.setVisibility(8);
                }

                f.onViewCreated(f.mView, f.mSavedFragmentState);
                goto label_209;
            label_251:
                f.mInnerView = null;
            }

        label_209:
            f.performActivityCreated(f.mSavedFragmentState);
            if(f.mView != null) {
                f.restoreViewState(f.mSavedFragmentState);
            }

            f.mSavedFragmentState = null;
        label_217:
            if(newState <= 3) {
                goto label_229;
            }

            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "moveto STARTED: " + f);
            }

            f.performStart();
        label_229:
            if(newState <= 4) {
                goto label_40;
            }

            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "moveto RESUMED: " + f);
            }

            f.mResumed = true;
            f.performResume();
            f.mSavedFragmentState = null;
            f.mSavedViewState = null;
            goto label_40;
        }
        else {
            if(f.mState <= newState) {
                goto label_40;
            }

            switch(f.mState) {
                case 1: {
                    goto label_259;
                }
                case 2: {
                    goto label_312;
                }
                case 3: {
                    goto label_300;
                }
                case 4: {
                    goto label_288;
                }
                case 5: {
                    goto label_274;
                }
            }

            goto label_40;
        label_274:
            if(newState >= 5) {
                goto label_288;
            }

            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "movefrom RESUMED: " + f);
            }

            f.performPause();
            f.mResumed = false;
        label_288:
            if(newState >= 4) {
                goto label_300;
            }

            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "movefrom STARTED: " + f);
            }

            f.performStop();
        label_300:
            if(newState >= 3) {
                goto label_312;
            }

            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "movefrom STOPPED: " + f);
            }

            f.performReallyStop();
        label_312:
            if(newState >= 2) {
                goto label_259;
            }

            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "movefrom ACTIVITY_CREATED: " + f);
            }

            if(f.mView != null && !this.mActivity.isFinishing() && f.mSavedViewState == null) {
                this.saveFragmentViewState(f);
            }

            f.performDestroyView();
            if(f.mView != null && f.mContainer != null) {
                v6 = null;
                if(this.mCurState > 0 && !this.mDestroyed) {
                    v6 = this.loadAnimation(f, transit, false, transitionStyle);
                }

                if(v6 != null) {
                    f.mAnimatingAway = f.mView;
                    f.mStateAfterAnimating = newState;
                    v6.setAnimationListener(new Animation$AnimationListener() {
                        public void onAnimationEnd(Animation animation) {
                            if(this.val$fragment.mAnimatingAway != null) {
                                this.val$fragment.mAnimatingAway = null;
                                FragmentManagerImpl.this.moveToState(this.val$fragment, this.val$fragment.mStateAfterAnimating, 0, 0, false);
                            }
                        }

                        public void onAnimationRepeat(Animation animation) {
                        }

                        public void onAnimationStart(Animation animation) {
                        }
                    });
                    f.mView.startAnimation(v6);
                }

                f.mContainer.removeView(f.mView);
            }

            f.mContainer = null;
            f.mView = null;
            f.mInnerView = null;
        label_259:
            if(newState >= 1) {
                goto label_40;
            }

            if((this.mDestroyed) && f.mAnimatingAway != null) {
                View v9 = f.mAnimatingAway;
                f.mAnimatingAway = null;
                v9.clearAnimation();
            }

            if(f.mAnimatingAway == null) {
                goto label_362;
            }

            f.mStateAfterAnimating = newState;
            newState = 1;
            goto label_40;
        label_362:
            if(FragmentManagerImpl.DEBUG) {
                Log.v("FragmentManager", "movefrom CREATED: " + f);
            }

            if(!f.mRetaining) {
                f.performDestroy();
            }

            f.mCalled = false;
            f.onDetach();
            if(!f.mCalled) {
                throw new SuperNotCalledException("Fragment " + f + " did not call through to super.onDetach()");
            }

            if(keepActive) {
                goto label_40;
            }

            if(f.mRetaining) {
                goto label_393;
            }

            this.makeInactive(f);
            goto label_40;
        label_393:
            f.mActivity = null;
            f.mFragmentManager = null;
        label_40:
            f.mState = newState;
        }
    }

    void moveToState(int newState, boolean always) {
        this.moveToState(newState, 0, 0, always);
    }

    public void noteStateNotSaved() {
        this.mStateSaved = false;
    }

    public void performPendingDeferredStart(Fragment f) {
        if(f.mDeferStart) {
            if(this.mExecutingActions) {
                this.mHavePendingDeferredStart = true;
            }
            else {
                f.mDeferStart = false;
                this.moveToState(f, this.mCurState, 0, 0, false);
            }
        }
    }

    public boolean popBackStackImmediate() {
        this.checkStateLoss();
        this.executePendingTransactions();
        return this.popBackStackState(this.mActivity.mHandler, null, -1, 0);
    }

    boolean popBackStackState(Handler handler, String name, int id, int flags) {
        boolean v7;
        Object v1;
        boolean v9 = false;
        if(this.mBackStack != null) {
            if(name != null || id >= 0 || (flags & 1) != 0) {
                int v3 = -1;
                if(name != null || id >= 0) {
                    for(v3 = this.mBackStack.size() - 1; v3 >= 0; --v3) {
                        v1 = this.mBackStack.get(v3);
                        if(name != null && (name.equals(((BackStackRecord)v1).getName()))) {
                            goto label_32;
                        }

                        if(id >= 0 && id == ((BackStackRecord)v1).mIndex) {
                            goto label_32;
                        }
                    }

                label_32:
                    if(v3 < 0) {
                        goto label_4;
                    }

                    if((flags & 1) == 0) {
                        goto label_53;
                    }

                    --v3;
                    while(v3 >= 0) {
                        v1 = this.mBackStack.get(v3);
                        if(name == null || !name.equals(((BackStackRecord)v1).getName())) {
                            if(id >= 0) {
                                if(id == ((BackStackRecord)v1).mIndex) {
                                    goto label_46;
                                }

                                break;
                            }
                            else {
                                break;
                            }
                        }

                    label_46:
                        --v3;
                    }
                }

            label_53:
                if(v3 == this.mBackStack.size() - 1) {
                    goto label_4;
                }

                ArrayList v5 = new ArrayList();
                int v2;
                for(v2 = this.mBackStack.size() - 1; v2 > v3; --v2) {
                    v5.add(this.mBackStack.remove(v2));
                }

                int v0 = v5.size() - 1;
                for(v2 = 0; v2 <= v0; ++v2) {
                    if(FragmentManagerImpl.DEBUG) {
                        Log.v("FragmentManager", "Popping back stack state: " + v5.get(v2));
                    }

                    Object v6 = v5.get(v2);
                    if(v2 == v0) {
                        v7 = true;
                    }
                    else {
                        v7 = false;
                    }

                    ((BackStackRecord)v6).popFromBackStack(v7);
                }

                this.reportBackStackChanged();
            }
            else {
                int v4 = this.mBackStack.size() - 1;
                if(v4 >= 0) {
                    this.mBackStack.remove(v4).popFromBackStack(true);
                    this.reportBackStackChanged();
                }
                else {
                    goto label_4;
                }
            }

            v9 = true;
        }

    label_4:
        return v9;
    }

    public void putFragment(Bundle bundle, String key, Fragment fragment) {
        if(fragment.mIndex < 0) {
            this.throwException(new IllegalStateException("Fragment " + fragment + " is not currently in the FragmentManager"));
        }

        bundle.putInt(key, fragment.mIndex);
    }

    public void removeFragment(Fragment fragment, int transition, int transitionStyle) {
        int v2;
        int v6;
        if(FragmentManagerImpl.DEBUG) {
            Log.v("FragmentManager", "remove: " + fragment + " nesting=" + fragment.mBackStackNesting);
        }

        if(!fragment.isInBackStack()) {
            v6 = 1;
        }
        else {
            v6 = 0;
        }

        if(!fragment.mDetached || v6 != 0) {
            if(this.mAdded != null) {
                this.mAdded.remove(fragment);
            }

            if((fragment.mHasMenu) && (fragment.mMenuVisible)) {
                this.mNeedMenuInvalidate = true;
            }

            fragment.mAdded = false;
            fragment.mRemoving = true;
            if(v6 != 0) {
                v2 = 0;
            }
            else {
                v2 = 1;
            }

            this.moveToState(fragment, v2, transition, transitionStyle, false);
        }
    }

    void reportBackStackChanged() {
        if(this.mBackStackChangeListeners != null) {
            int v0;
            for(v0 = 0; v0 < this.mBackStackChangeListeners.size(); ++v0) {
                this.mBackStackChangeListeners.get(v0).onBackStackChanged();
            }
        }
    }

    void restoreAllState(Parcelable state, ArrayList arg14) {
        FragmentState v3;
        Object v1;
        SparseArray v10 = null;
        if(state != null) {
            Parcelable v2 = state;
            if(((FragmentManagerState)v2).mActive != null) {
                if(arg14 != null) {
                    int v4;
                    for(v4 = 0; v4 < arg14.size(); ++v4) {
                        v1 = arg14.get(v4);
                        if(FragmentManagerImpl.DEBUG) {
                            Log.v("FragmentManager", "restoreAllState: re-attaching retained " + v1);
                        }

                        v3 = ((FragmentManagerState)v2).mActive[((Fragment)v1).mIndex];
                        v3.mInstance = ((Fragment)v1);
                        ((Fragment)v1).mSavedViewState = v10;
                        ((Fragment)v1).mBackStackNesting = 0;
                        ((Fragment)v1).mInLayout = false;
                        ((Fragment)v1).mAdded = false;
                        ((Fragment)v1).mTarget = ((Fragment)v10);
                        if(v3.mSavedFragmentState != null) {
                            v3.mSavedFragmentState.setClassLoader(this.mActivity.getClassLoader());
                            ((Fragment)v1).mSavedViewState = v3.mSavedFragmentState.getSparseParcelableArray("android:view_state");
                        }
                    }
                }

                this.mActive = new ArrayList(((FragmentManagerState)v2).mActive.length);
                if(this.mAvailIndices != null) {
                    this.mAvailIndices.clear();
                }

                for(v4 = 0; v4 < ((FragmentManagerState)v2).mActive.length; ++v4) {
                    v3 = ((FragmentManagerState)v2).mActive[v4];
                    if(v3 != null) {
                        Fragment v1_1 = v3.instantiate(this.mActivity, this.mParent);
                        if(FragmentManagerImpl.DEBUG) {
                            Log.v("FragmentManager", "restoreAllState: active #" + v4 + ": " + v1_1);
                        }

                        this.mActive.add(v1_1);
                        v3.mInstance = ((Fragment)v10);
                    }
                    else {
                        this.mActive.add(v10);
                        if(this.mAvailIndices == null) {
                            this.mAvailIndices = new ArrayList();
                        }

                        if(FragmentManagerImpl.DEBUG) {
                            Log.v("FragmentManager", "restoreAllState: avail #" + v4);
                        }

                        this.mAvailIndices.add(Integer.valueOf(v4));
                    }
                }

                if(arg14 != null) {
                    for(v4 = 0; v4 < arg14.size(); ++v4) {
                        v1 = arg14.get(v4);
                        if(((Fragment)v1).mTargetIndex >= 0) {
                            if(((Fragment)v1).mTargetIndex < this.mActive.size()) {
                                ((Fragment)v1).mTarget = this.mActive.get(((Fragment)v1).mTargetIndex);
                            }
                            else {
                                Log.w("FragmentManager", "Re-attaching retained fragment " + v1 + " target no longer exists: " + ((Fragment)v1).mTargetIndex);
                                ((Fragment)v1).mTarget = ((Fragment)v10);
                            }
                        }
                    }
                }

                if(((FragmentManagerState)v2).mAdded != null) {
                    this.mAdded = new ArrayList(((FragmentManagerState)v2).mAdded.length);
                    for(v4 = 0; v4 < ((FragmentManagerState)v2).mAdded.length; ++v4) {
                        v1 = this.mActive.get(((FragmentManagerState)v2).mAdded[v4]);
                        if(v1 == null) {
                            this.throwException(new IllegalStateException("No instantiated fragment for index #" + ((FragmentManagerState)v2).mAdded[v4]));
                        }

                        ((Fragment)v1).mAdded = true;
                        if(FragmentManagerImpl.DEBUG) {
                            Log.v("FragmentManager", "restoreAllState: added #" + v4 + ": " + v1);
                        }

                        if(this.mAdded.contains(v1)) {
                            throw new IllegalStateException("Already added!");
                        }

                        this.mAdded.add(v1);
                    }
                }
                else {
                    this.mAdded = ((ArrayList)v10);
                }

                if(((FragmentManagerState)v2).mBackStack == null) {
                    goto label_217;
                }

                this.mBackStack = new ArrayList(((FragmentManagerState)v2).mBackStack.length);
                for(v4 = 0; true; ++v4) {
                    if(v4 >= ((FragmentManagerState)v2).mBackStack.length) {
                        return;
                    }

                    BackStackRecord v0 = ((FragmentManagerState)v2).mBackStack[v4].instantiate(this);
                    if(FragmentManagerImpl.DEBUG) {
                        Log.v("FragmentManager", "restoreAllState: back stack #" + v4 + " (index " + v0.mIndex + "): " + v0);
                        v0.dump("  ", new PrintWriter(new LogWriter("FragmentManager")), false);
                    }

                    this.mBackStack.add(v0);
                    if(v0.mIndex >= 0) {
                        this.setBackStackIndex(v0.mIndex, v0);
                    }
                }

            label_217:
                this.mBackStack = ((ArrayList)v10);
            }
        }
    }

    ArrayList retainNonConfig() {
        int v3;
        ArrayList v1 = null;
        if(this.mActive != null) {
            int v2;
            for(v2 = 0; v2 < this.mActive.size(); ++v2) {
                Object v0 = this.mActive.get(v2);
                if(v0 != null && (((Fragment)v0).mRetainInstance)) {
                    if(v1 == null) {
                        v1 = new ArrayList();
                    }

                    v1.add(v0);
                    ((Fragment)v0).mRetaining = true;
                    if(((Fragment)v0).mTarget != null) {
                        v3 = ((Fragment)v0).mTarget.mIndex;
                    }
                    else {
                        v3 = -1;
                    }

                    ((Fragment)v0).mTargetIndex = v3;
                    if(!FragmentManagerImpl.DEBUG) {
                        goto label_31;
                    }

                    Log.v("FragmentManager", "retainNonConfig: keeping retained " + v0);
                }

            label_31:
            }
        }

        return v1;
    }

    public static int reverseTransit(int transit) {
        int v0 = 0;
        switch(transit) {
            case 4097: {
                v0 = 8194;
                break;
            }
            case 4099: {
                v0 = 4099;
                break;
            }
            case 8194: {
                v0 = 4097;
                break;
            }
        }

        return v0;
    }

    Parcelable saveAllState() {
        FragmentManagerState v5_1;
        Parcelable v5 = null;
        this.execPendingActions();
        if(FragmentManagerImpl.HONEYCOMB) {
            this.mStateSaved = true;
        }

        if(this.mActive != null && this.mActive.size() > 0) {
            int v0 = this.mActive.size();
            FragmentState[] v1 = new FragmentState[v0];
            int v7 = 0;
            int v8;
            for(v8 = 0; v8 < v0; ++v8) {
                Object v4 = this.mActive.get(v8);
                if(v4 != null) {
                    if(((Fragment)v4).mIndex < 0) {
                        this.throwException(new IllegalStateException("Failure saving state: active " + v4 + " has cleared index: " + ((Fragment)v4).mIndex));
                    }

                    v7 = 1;
                    FragmentState v6 = new FragmentState(((Fragment)v4));
                    v1[v8] = v6;
                    if(((Fragment)v4).mState <= 0 || v6.mSavedFragmentState != null) {
                        v6.mSavedFragmentState = ((Fragment)v4).mSavedFragmentState;
                    }
                    else {
                        v6.mSavedFragmentState = this.saveFragmentBasicState(((Fragment)v4));
                        if(((Fragment)v4).mTarget != null) {
                            if(((Fragment)v4).mTarget.mIndex < 0) {
                                this.throwException(new IllegalStateException("Failure saving state: " + v4 + " has target not in fragment manager: " + ((Fragment)v4).mTarget));
                            }

                            if(v6.mSavedFragmentState == null) {
                                v6.mSavedFragmentState = new Bundle();
                            }

                            this.putFragment(v6.mSavedFragmentState, "android:target_state", ((Fragment)v4).mTarget);
                            if(((Fragment)v4).mTargetRequestCode == 0) {
                                goto label_73;
                            }

                            v6.mSavedFragmentState.putInt("android:target_req_state", ((Fragment)v4).mTargetRequestCode);
                        }
                    }

                label_73:
                    if(!FragmentManagerImpl.DEBUG) {
                        goto label_86;
                    }

                    Log.v("FragmentManager", "Saved state of " + v4 + ": " + v6.mSavedFragmentState);
                }

            label_86:
            }

            if(v7 != 0) {
                goto label_98;
            }

            if(!FragmentManagerImpl.DEBUG) {
                goto label_11;
            }

            Log.v("FragmentManager", "saveAllState: no fragments!");
            goto label_11;
        label_98:
            int[] v2 = null;
            BackStackState[] v3 = null;
            if(this.mAdded != null) {
                v0 = this.mAdded.size();
                if(v0 > 0) {
                    v2 = new int[v0];
                    for(v8 = 0; v8 < v0; ++v8) {
                        v2[v8] = this.mAdded.get(v8).mIndex;
                        if(v2[v8] < 0) {
                            this.throwException(new IllegalStateException("Failure saving state: active " + this.mAdded.get(v8) + " has cleared index: " + v2[v8]));
                        }

                        if(FragmentManagerImpl.DEBUG) {
                            Log.v("FragmentManager", "saveAllState: adding fragment #" + v8 + ": " + this.mAdded.get(v8));
                        }
                    }
                }
            }

            if(this.mBackStack != null) {
                v0 = this.mBackStack.size();
                if(v0 > 0) {
                    v3 = new BackStackState[v0];
                    for(v8 = 0; v8 < v0; ++v8) {
                        v3[v8] = new BackStackState(this, this.mBackStack.get(v8));
                        if(FragmentManagerImpl.DEBUG) {
                            Log.v("FragmentManager", "saveAllState: adding back stack #" + v8 + ": " + this.mBackStack.get(v8));
                        }
                    }
                }
            }

            v5_1 = new FragmentManagerState();
            v5_1.mActive = v1;
            v5_1.mAdded = v2;
            v5_1.mBackStack = v3;
        }

    label_11:
        return ((Parcelable)v5_1);
    }

    Bundle saveFragmentBasicState(Fragment f) {
        Bundle v0 = null;
        if(this.mStateBundle == null) {
            this.mStateBundle = new Bundle();
        }

        f.performSaveInstanceState(this.mStateBundle);
        if(!this.mStateBundle.isEmpty()) {
            v0 = this.mStateBundle;
            this.mStateBundle = null;
        }

        if(f.mView != null) {
            this.saveFragmentViewState(f);
        }

        if(f.mSavedViewState != null) {
            if(v0 == null) {
                v0 = new Bundle();
            }

            v0.putSparseParcelableArray("android:view_state", f.mSavedViewState);
        }

        if(!f.mUserVisibleHint) {
            if(v0 == null) {
                v0 = new Bundle();
            }

            v0.putBoolean("android:user_visible_hint", f.mUserVisibleHint);
        }

        return v0;
    }

    void saveFragmentViewState(Fragment f) {
        if(f.mInnerView != null) {
            if(this.mStateArray == null) {
                this.mStateArray = new SparseArray();
            }
            else {
                this.mStateArray.clear();
            }

            f.mInnerView.saveHierarchyState(this.mStateArray);
            if(this.mStateArray.size() <= 0) {
                return;
            }

            f.mSavedViewState = this.mStateArray;
            this.mStateArray = null;
        }
    }

    public void setBackStackIndex(int index, BackStackRecord bse) {
        __monitor_enter(this);
        try {
            if(this.mBackStackIndices == null) {
                this.mBackStackIndices = new ArrayList();
            }

            int v0 = this.mBackStackIndices.size();
            if(index < v0) {
                if(FragmentManagerImpl.DEBUG) {
                    Log.v("FragmentManager", "Setting back stack index " + index + " to " + bse);
                }

                this.mBackStackIndices.set(index, bse);
            }
            else {
                while(v0 < index) {
                    this.mBackStackIndices.add(null);
                    if(this.mAvailBackStackIndices == null) {
                        this.mAvailBackStackIndices = new ArrayList();
                    }

                    if(FragmentManagerImpl.DEBUG) {
                        Log.v("FragmentManager", "Adding available back stack index " + v0);
                    }

                    this.mAvailBackStackIndices.add(Integer.valueOf(v0));
                    ++v0;
                }

                if(FragmentManagerImpl.DEBUG) {
                    Log.v("FragmentManager", "Adding back stack index " + index + " with " + bse);
                }

                this.mBackStackIndices.add(bse);
            }

            __monitor_exit(this);
            return;
        label_62:
            __monitor_exit(this);
        }
        catch(Throwable v1) {
            goto label_62;
        }

        throw v1;
    }

    public void showFragment(Fragment fragment, int transition, int transitionStyle) {
        if(FragmentManagerImpl.DEBUG) {
            Log.v("FragmentManager", "show: " + fragment);
        }

        if(fragment.mHidden) {
            fragment.mHidden = false;
            if(fragment.mView != null) {
                Animation v0 = this.loadAnimation(fragment, transition, true, transitionStyle);
                if(v0 != null) {
                    fragment.mView.startAnimation(v0);
                }

                fragment.mView.setVisibility(0);
            }

            if((fragment.mAdded) && (fragment.mHasMenu) && (fragment.mMenuVisible)) {
                this.mNeedMenuInvalidate = true;
            }

            fragment.onHiddenChanged(false);
        }
    }

    void startPendingDeferredFragments() {
        if(this.mActive != null) {
            int v1;
            for(v1 = 0; v1 < this.mActive.size(); ++v1) {
                Object v0 = this.mActive.get(v1);
                if(v0 != null) {
                    this.performPendingDeferredStart(((Fragment)v0));
                }
            }
        }
    }

    private void throwException(RuntimeException ex) {
        Log.e("FragmentManager", ex.getMessage());
        Log.e("FragmentManager", "Activity state:");
        PrintWriter v2 = new PrintWriter(new LogWriter("FragmentManager"));
        if(this.mActivity == null) {
            goto label_23;
        }

        try {
            this.mActivity.dump("  ", null, v2, new String[0]);
            goto label_17;
        }
        catch(Exception v0) {
            Log.e("FragmentManager", "Failed dumping state", ((Throwable)v0));
            goto label_17;
        }

        try {
        label_23:
            this.dump("  ", null, v2, new String[0]);
        }
        catch(Exception v0) {
            Log.e("FragmentManager", "Failed dumping state", ((Throwable)v0));
        }

    label_17:
        throw ex;
    }

    public String toString() {
        StringBuilder v0 = new StringBuilder(128);
        v0.append("FragmentManager{");
        v0.append(Integer.toHexString(System.identityHashCode(this)));
        v0.append(" in ");
        if(this.mParent != null) {
            DebugUtils.buildShortClassTag(this.mParent, v0);
        }
        else {
            DebugUtils.buildShortClassTag(this.mActivity, v0);
        }

        v0.append("}}");
        return v0.toString();
    }

    public static int transitToStyleIndex(int transit, boolean enter) {
        int v0 = -1;
        switch(transit) {
            case 4097: {
                if(!enter) {
                    goto label_6;
                }

                v0 = 1;
                goto label_2;
            label_6:
                v0 = 2;
                break;
            }
            case 4099: {
                if(!enter) {
                    goto label_16;
                }

                v0 = 5;
                goto label_2;
            label_16:
                v0 = 6;
                break;
            }
            case 8194: {
                if(!enter) {
                    goto label_11;
                }

                v0 = 3;
                goto label_2;
            label_11:
                v0 = 4;
                break;
            }
        }

    label_2:
        return v0;
    }
}

