// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.app;

import android.os.Bundle;
import android.support.v4.content.Loader;
import android.support.v4.content.Loader$OnLoadCompleteListener;
import android.support.v4.util.DebugUtils;
import android.support.v4.util.SparseArrayCompat;
import android.util.Log;
import java.io.FileDescriptor;
import java.io.PrintWriter;

class LoaderManagerImpl extends LoaderManager {
    final class LoaderInfo implements OnLoadCompleteListener {
        final Bundle mArgs;
        LoaderCallbacks mCallbacks;
        Object mData;
        boolean mDeliveredData;
        boolean mDestroyed;
        boolean mHaveData;
        final int mId;
        boolean mListenerRegistered;
        Loader mLoader;
        LoaderInfo mPendingLoader;
        boolean mReportNextStart;
        boolean mRetaining;
        boolean mRetainingStarted;
        boolean mStarted;

        void callOnLoadFinished(Loader arg5, Object data) {
            if(this.mCallbacks != null) {
                String v0 = null;
                if(LoaderManagerImpl.this.mActivity != null) {
                    v0 = LoaderManagerImpl.this.mActivity.mFragments.mNoTransactionsBecause;
                    LoaderManagerImpl.this.mActivity.mFragments.mNoTransactionsBecause = "onLoadFinished";
                }

                try {
                    if(LoaderManagerImpl.DEBUG) {
                        Log.v("LoaderManager", "  onLoadFinished in " + arg5 + ": " + arg5.dataToString(data));
                    }

                    this.mCallbacks.onLoadFinished(arg5, data);
                }
                catch(Throwable v1) {
                    if(LoaderManagerImpl.this.mActivity != null) {
                        LoaderManagerImpl.this.mActivity.mFragments.mNoTransactionsBecause = v0;
                    }

                    throw v1;
                }

                if(LoaderManagerImpl.this.mActivity != null) {
                    LoaderManagerImpl.this.mActivity.mFragments.mNoTransactionsBecause = v0;
                }

                this.mDeliveredData = true;
            }
        }

        void destroy() {
            LoaderCallbacks v6 = null;
            if(LoaderManagerImpl.DEBUG) {
                Log.v("LoaderManager", "  Destroying: " + this);
            }

            this.mDestroyed = true;
            boolean v1 = this.mDeliveredData;
            this.mDeliveredData = false;
            if(this.mCallbacks != null && this.mLoader != null && (this.mHaveData) && (v1)) {
                if(LoaderManagerImpl.DEBUG) {
                    Log.v("LoaderManager", "  Reseting: " + this);
                }

                String v0 = null;
                if(LoaderManagerImpl.this.mActivity != null) {
                    v0 = LoaderManagerImpl.this.mActivity.mFragments.mNoTransactionsBecause;
                    LoaderManagerImpl.this.mActivity.mFragments.mNoTransactionsBecause = "onLoaderReset";
                }

                try {
                    this.mCallbacks.onLoaderReset(this.mLoader);
                }
                catch(Throwable v2) {
                    if(LoaderManagerImpl.this.mActivity != null) {
                        LoaderManagerImpl.this.mActivity.mFragments.mNoTransactionsBecause = v0;
                    }

                    throw v2;
                }

                if(LoaderManagerImpl.this.mActivity == null) {
                    goto label_54;
                }

                LoaderManagerImpl.this.mActivity.mFragments.mNoTransactionsBecause = v0;
            }

        label_54:
            this.mCallbacks = v6;
            this.mData = v6;
            this.mHaveData = false;
            if(this.mLoader != null) {
                if(this.mListenerRegistered) {
                    this.mListenerRegistered = false;
                    this.mLoader.unregisterListener(((OnLoadCompleteListener)this));
                }

                this.mLoader.reset();
            }

            if(this.mPendingLoader != null) {
                this.mPendingLoader.destroy();
            }
        }

        public void dump(String prefix, FileDescriptor fd, PrintWriter writer, String[] args) {
            writer.print(prefix);
            writer.print("mId=");
            writer.print(this.mId);
            writer.print(" mArgs=");
            writer.println(this.mArgs);
            writer.print(prefix);
            writer.print("mCallbacks=");
            writer.println(this.mCallbacks);
            writer.print(prefix);
            writer.print("mLoader=");
            writer.println(this.mLoader);
            if(this.mLoader != null) {
                this.mLoader.dump(prefix + "  ", fd, writer, args);
            }

            if((this.mHaveData) || (this.mDeliveredData)) {
                writer.print(prefix);
                writer.print("mHaveData=");
                writer.print(this.mHaveData);
                writer.print("  mDeliveredData=");
                writer.println(this.mDeliveredData);
                writer.print(prefix);
                writer.print("mData=");
                writer.println(this.mData);
            }

            writer.print(prefix);
            writer.print("mStarted=");
            writer.print(this.mStarted);
            writer.print(" mReportNextStart=");
            writer.print(this.mReportNextStart);
            writer.print(" mDestroyed=");
            writer.println(this.mDestroyed);
            writer.print(prefix);
            writer.print("mRetaining=");
            writer.print(this.mRetaining);
            writer.print(" mRetainingStarted=");
            writer.print(this.mRetainingStarted);
            writer.print(" mListenerRegistered=");
            writer.println(this.mListenerRegistered);
            if(this.mPendingLoader != null) {
                writer.print(prefix);
                writer.println("Pending Loader ");
                writer.print(this.mPendingLoader);
                writer.println(":");
                this.mPendingLoader.dump(prefix + "  ", fd, writer, args);
            }
        }

        void finishRetain() {
            if(this.mRetaining) {
                if(LoaderManagerImpl.DEBUG) {
                    Log.v("LoaderManager", "  Finished Retaining: " + this);
                }

                this.mRetaining = false;
                if(this.mStarted == this.mRetainingStarted) {
                    goto label_19;
                }

                if(this.mStarted) {
                    goto label_19;
                }

                this.stop();
            }

        label_19:
            if((this.mStarted) && (this.mHaveData) && !this.mReportNextStart) {
                this.callOnLoadFinished(this.mLoader, this.mData);
            }
        }

        void reportStart() {
            if((this.mStarted) && (this.mReportNextStart)) {
                this.mReportNextStart = false;
                if(this.mHaveData) {
                    this.callOnLoadFinished(this.mLoader, this.mData);
                }
            }
        }

        void retain() {
            if(LoaderManagerImpl.DEBUG) {
                Log.v("LoaderManager", "  Retaining: " + this);
            }

            this.mRetaining = true;
            this.mRetainingStarted = this.mStarted;
            this.mStarted = false;
            this.mCallbacks = null;
        }

        void start() {
            if((this.mRetaining) && (this.mRetainingStarted)) {
                this.mStarted = true;
            }
            else if(!this.mStarted) {
                this.mStarted = true;
                if(LoaderManagerImpl.DEBUG) {
                    Log.v("LoaderManager", "  Starting: " + this);
                }

                if(this.mLoader == null && this.mCallbacks != null) {
                    this.mLoader = this.mCallbacks.onCreateLoader(this.mId, this.mArgs);
                }

                if(this.mLoader == null) {
                    return;
                }

                if((this.mLoader.getClass().isMemberClass()) && !Modifier.isStatic(this.mLoader.getClass().getModifiers())) {
                    throw new IllegalArgumentException("Object returned from onCreateLoader must not be a non-static inner member class: " + this.mLoader);
                }

                if(!this.mListenerRegistered) {
                    this.mLoader.registerListener(this.mId, ((OnLoadCompleteListener)this));
                    this.mListenerRegistered = true;
                }

                this.mLoader.startLoading();
            }
        }

        void stop() {
            if(LoaderManagerImpl.DEBUG) {
                Log.v("LoaderManager", "  Stopping: " + this);
            }

            this.mStarted = false;
            if(!this.mRetaining && this.mLoader != null && (this.mListenerRegistered)) {
                this.mListenerRegistered = false;
                this.mLoader.unregisterListener(((OnLoadCompleteListener)this));
                this.mLoader.stopLoading();
            }
        }

        public String toString() {
            StringBuilder v0 = new StringBuilder(64);
            v0.append("LoaderInfo{");
            v0.append(Integer.toHexString(System.identityHashCode(this)));
            v0.append(" #");
            v0.append(this.mId);
            v0.append(" : ");
            DebugUtils.buildShortClassTag(this.mLoader, v0);
            v0.append("}}");
            return v0.toString();
        }
    }

    static boolean DEBUG;
    FragmentActivity mActivity;
    final SparseArrayCompat mInactiveLoaders;
    final SparseArrayCompat mLoaders;
    boolean mRetaining;
    boolean mStarted;
    final String mWho;

    static  {
        LoaderManagerImpl.DEBUG = false;
    }

    LoaderManagerImpl(String who, FragmentActivity activity, boolean started) {
        super();
        this.mLoaders = new SparseArrayCompat();
        this.mInactiveLoaders = new SparseArrayCompat();
        this.mWho = who;
        this.mActivity = activity;
        this.mStarted = started;
    }

    void doDestroy() {
        if(!this.mRetaining) {
            if(LoaderManagerImpl.DEBUG) {
                Log.v("LoaderManager", "Destroying Active in " + this);
            }

            int v0;
            for(v0 = this.mLoaders.size() - 1; v0 >= 0; --v0) {
                this.mLoaders.valueAt(v0).destroy();
            }
        }

        if(LoaderManagerImpl.DEBUG) {
            Log.v("LoaderManager", "Destroying Inactive in " + this);
        }

        for(v0 = this.mInactiveLoaders.size() - 1; v0 >= 0; --v0) {
            this.mInactiveLoaders.valueAt(v0).destroy();
        }

        this.mInactiveLoaders.clear();
    }

    void doReportNextStart() {
        int v0;
        for(v0 = this.mLoaders.size() - 1; v0 >= 0; --v0) {
            this.mLoaders.valueAt(v0).mReportNextStart = true;
        }
    }

    void doReportStart() {
        int v0;
        for(v0 = this.mLoaders.size() - 1; v0 >= 0; --v0) {
            this.mLoaders.valueAt(v0).reportStart();
        }
    }

    void doRetain() {
        if(LoaderManagerImpl.DEBUG) {
            Log.v("LoaderManager", "Retaining in " + this);
        }

        if(!this.mStarted) {
            RuntimeException v0 = new RuntimeException("here");
            v0.fillInStackTrace();
            Log.w("LoaderManager", "Called doRetain when not started: " + this, ((Throwable)v0));
        }
        else {
            this.mRetaining = true;
            this.mStarted = false;
            int v1;
            for(v1 = this.mLoaders.size() - 1; v1 >= 0; --v1) {
                this.mLoaders.valueAt(v1).retain();
            }
        }
    }

    void doStart() {
        if(LoaderManagerImpl.DEBUG) {
            Log.v("LoaderManager", "Starting in " + this);
        }

        if(this.mStarted) {
            RuntimeException v0 = new RuntimeException("here");
            v0.fillInStackTrace();
            Log.w("LoaderManager", "Called doStart when already started: " + this, ((Throwable)v0));
        }
        else {
            this.mStarted = true;
            int v1;
            for(v1 = this.mLoaders.size() - 1; v1 >= 0; --v1) {
                this.mLoaders.valueAt(v1).start();
            }
        }
    }

    void doStop() {
        if(LoaderManagerImpl.DEBUG) {
            Log.v("LoaderManager", "Stopping in " + this);
        }

        if(!this.mStarted) {
            RuntimeException v0 = new RuntimeException("here");
            v0.fillInStackTrace();
            Log.w("LoaderManager", "Called doStop when not started: " + this, ((Throwable)v0));
        }
        else {
            int v1;
            for(v1 = this.mLoaders.size() - 1; v1 >= 0; --v1) {
                this.mLoaders.valueAt(v1).stop();
            }

            this.mStarted = false;
        }
    }

    public void dump(String prefix, FileDescriptor fd, PrintWriter writer, String[] args) {
        Object v2;
        String v1;
        if(this.mLoaders.size() > 0) {
            writer.print(prefix);
            writer.println("Active Loaders:");
            v1 = prefix + "    ";
            int v0;
            for(v0 = 0; v0 < this.mLoaders.size(); ++v0) {
                v2 = this.mLoaders.valueAt(v0);
                writer.print(prefix);
                writer.print("  #");
                writer.print(this.mLoaders.keyAt(v0));
                writer.print(": ");
                writer.println(((LoaderInfo)v2).toString());
                ((LoaderInfo)v2).dump(v1, fd, writer, args);
            }
        }

        if(this.mInactiveLoaders.size() > 0) {
            writer.print(prefix);
            writer.println("Inactive Loaders:");
            v1 = prefix + "    ";
            for(v0 = 0; v0 < this.mInactiveLoaders.size(); ++v0) {
                v2 = this.mInactiveLoaders.valueAt(v0);
                writer.print(prefix);
                writer.print("  #");
                writer.print(this.mInactiveLoaders.keyAt(v0));
                writer.print(": ");
                writer.println(((LoaderInfo)v2).toString());
                ((LoaderInfo)v2).dump(v1, fd, writer, args);
            }
        }
    }

    void finishRetain() {
        if(this.mRetaining) {
            if(LoaderManagerImpl.DEBUG) {
                Log.v("LoaderManager", "Finished Retaining in " + this);
            }

            this.mRetaining = false;
            int v0;
            for(v0 = this.mLoaders.size() - 1; v0 >= 0; --v0) {
                this.mLoaders.valueAt(v0).finishRetain();
            }
        }
    }

    public boolean hasRunningLoaders() {
        int v4;
        int v3 = 0;
        int v0 = this.mLoaders.size();
        int v1;
        for(v1 = 0; v1 < v0; ++v1) {
            Object v2 = this.mLoaders.valueAt(v1);
            if(!((LoaderInfo)v2).mStarted || (((LoaderInfo)v2).mDeliveredData)) {
                v4 = 0;
            }
            else {
                v4 = 1;
            }

            v3 |= v4;
        }

        return ((boolean)v3);
    }

    public String toString() {
        StringBuilder v0 = new StringBuilder(128);
        v0.append("LoaderManager{");
        v0.append(Integer.toHexString(System.identityHashCode(this)));
        v0.append(" in ");
        DebugUtils.buildShortClassTag(this.mActivity, v0);
        v0.append("}}");
        return v0.toString();
    }

    void updateActivity(FragmentActivity activity) {
        this.mActivity = activity;
    }
}

