// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.content;

import android.content.ContentProvider;
import android.content.ContentValues;
import android.content.Context;
import android.content.pm.ProviderInfo;
import android.content.res.XmlResourceParser;
import android.database.Cursor;
import android.database.MatrixCursor;
import android.net.Uri;
import android.os.Environment;
import android.os.ParcelFileDescriptor;
import android.text.TextUtils;
import android.webkit.MimeTypeMap;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.HashMap;
import org.xmlpull.v1.XmlPullParserException;

public class FileProvider extends ContentProvider {
    abstract interface PathStrategy {
        public abstract File getFileForUri(Uri arg0);
    }

    class SimplePathStrategy implements PathStrategy {
        private final String mAuthority;
        private final HashMap mRoots;

        public SimplePathStrategy(String authority) {
            super();
            this.mRoots = new HashMap();
            this.mAuthority = authority;
        }

        public void addRoot(String name, File root) {
            if(!TextUtils.isEmpty(((CharSequence)name))) {
                goto label_5;
            }

            throw new IllegalArgumentException("Name must not be empty");
            try {
            label_5:
                root = root.getCanonicalFile();
            }
            catch(IOException v0) {
                throw new IllegalArgumentException("Failed to resolve canonical path for " + root, ((Throwable)v0));
            }

            this.mRoots.put(name, root);
        }

        public File getFileForUri(Uri uri) {
            String v2 = uri.getEncodedPath();
            int v4 = v2.indexOf(47, 1);
            String v5 = Uri.decode(v2.substring(1, v4));
            v2 = Uri.decode(v2.substring(v4 + 1));
            Object v3 = this.mRoots.get(v5);
            if(v3 == null) {
                throw new IllegalArgumentException("Unable to find configured root for " + uri);
            }

            File v1 = new File(((File)v3), v2);
            try {
                v1 = v1.getCanonicalFile();
            }
            catch(IOException v0) {
                throw new IllegalArgumentException("Failed to resolve canonical path for " + v1);
            }

            if(!v1.getPath().startsWith(((File)v3).getPath())) {
                throw new SecurityException("Resolved path jumped beyond configured root");
            }

            return v1;
        }
    }

    private static final String[] COLUMNS;
    private static final File DEVICE_ROOT;
    private PathStrategy mStrategy;
    private static HashMap sCache;

    static  {
        FileProvider.COLUMNS = new String[]{"_display_name", "_size"};
        FileProvider.DEVICE_ROOT = new File("/");
        FileProvider.sCache = new HashMap();
    }

    public FileProvider() {
        super();
    }

    public void attachInfo(Context context, ProviderInfo info) {
        super.attachInfo(context, info);
        if(info.exported) {
            throw new SecurityException("Provider must not be exported");
        }

        if(!info.grantUriPermissions) {
            throw new SecurityException("Provider must grant uri permissions");
        }

        this.mStrategy = FileProvider.getPathStrategy(context, info.authority);
    }

    private static File buildPath(File base, String[] segments) {
        File v1;
        String[] v0 = segments;
        int v4 = v0.length;
        int v3 = 0;
        File v2;
        for(v2 = base; v3 < v4; v2 = v1) {
            String v5 = v0[v3];
            if(v5 != null) {
                v1 = new File(v2, v5);
            }
            else {
                v1 = v2;
            }

            ++v3;
        }

        return v2;
    }

    private static Object[] copyOf(Object[] original, int newLength) {
        Object[] v0 = new Object[newLength];
        System.arraycopy(original, 0, v0, 0, newLength);
        return v0;
    }

    private static String[] copyOf(String[] original, int newLength) {
        String[] v0 = new String[newLength];
        System.arraycopy(original, 0, v0, 0, newLength);
        return v0;
    }

    public int delete(Uri uri, String selection, String[] selectionArgs) {
        int v1;
        if(this.mStrategy.getFileForUri(uri).delete()) {
            v1 = 1;
        }
        else {
            v1 = 0;
        }

        return v1;
    }

    private static PathStrategy getPathStrategy(Context context, String authority) {
        PathStrategy v1_1;
        HashMap v3 = FileProvider.sCache;
        __monitor_enter(v3);
        try {
            Object v1 = FileProvider.sCache.get(authority);
            if(v1 == null) {
                try {
                    v1_1 = FileProvider.parsePathStrategy(context, authority);
                    goto label_6;
                }
                catch(XmlPullParserException v0) {
                    try {
                        throw new IllegalArgumentException("Failed to parse android.support.FILE_PROVIDER_PATHS meta-data", ((Throwable)v0));
                    label_6:
                        FileProvider.sCache.put(authority, v1_1);
                    label_8:
                        __monitor_exit(v3);
                        return ((PathStrategy)v1);
                    label_15:
                        __monitor_exit(v3);
                        goto label_16;
                    }
                    catch(Throwable v2) {
                        goto label_15;
                    }
                }
                catch(IOException v0_1) {
                    throw new IllegalArgumentException("Failed to parse android.support.FILE_PROVIDER_PATHS meta-data", ((Throwable)v0_1));
                }
            }

            goto label_8;
        }
        catch(Throwable v2) {
            goto label_15;
        }

    label_16:
        throw v2;
    }

    public String getType(Uri uri) {
        String v3;
        File v1 = this.mStrategy.getFileForUri(uri);
        int v2 = v1.getName().lastIndexOf(46);
        if(v2 >= 0) {
            v3 = MimeTypeMap.getSingleton().getMimeTypeFromExtension(v1.getName().substring(v2 + 1));
            if(v3 == null) {
                goto label_13;
            }
        }
        else {
        label_13:
            v3 = "application/octet-stream";
        }

        return v3;
    }

    public Uri insert(Uri uri, ContentValues values) {
        throw new UnsupportedOperationException("No external inserts");
    }

    private static int modeToMode(String mode) {
        int v0;
        if("r".equals(mode)) {
            v0 = 268435456;
        }
        else {
            if(!"w".equals(mode) && !"wt".equals(mode)) {
                if("wa".equals(mode)) {
                    v0 = 704643072;
                    goto label_4;
                }
                else if("rw".equals(mode)) {
                    v0 = 939524096;
                    goto label_4;
                }
                else if("rwt".equals(mode)) {
                    v0 = 1006632960;
                    goto label_4;
                }
                else {
                    throw new IllegalArgumentException("Invalid mode: " + mode);
                }
            }

            v0 = 738197504;
        }

    label_4:
        return v0;
    }

    public boolean onCreate() {
        return 1;
    }

    public ParcelFileDescriptor openFile(Uri uri, String mode) throws FileNotFoundException {
        return ParcelFileDescriptor.open(this.mStrategy.getFileForUri(uri), FileProvider.modeToMode(mode));
    }

    private static PathStrategy parsePathStrategy(Context context, String authority) throws IOException, XmlPullParserException {
        String v12 = null;
        SimplePathStrategy v4 = new SimplePathStrategy(authority);
        XmlResourceParser v0 = context.getPackageManager().resolveContentProvider(authority, 128).loadXmlMetaData(context.getPackageManager(), "android.support.FILE_PROVIDER_PATHS");
        if(v0 == null) {
            throw new IllegalArgumentException("Missing android.support.FILE_PROVIDER_PATHS meta-data");
        }

        while(true) {
            int v7 = v0.next();
            if(v7 == 1) {
                break;
            }

            if(v7 != 2) {
                continue;
            }

            String v5 = v0.getName();
            String v2 = v0.getAttributeValue(v12, "name");
            String v3 = v0.getAttributeValue(v12, "path");
            File v6 = null;
            if("root-path".equals(v5)) {
                v6 = FileProvider.buildPath(FileProvider.DEVICE_ROOT, new String[]{v3});
            }
            else if("files-path".equals(v5)) {
                v6 = FileProvider.buildPath(context.getFilesDir(), new String[]{v3});
            }
            else if("cache-path".equals(v5)) {
                v6 = FileProvider.buildPath(context.getCacheDir(), new String[]{v3});
            }
            else if("external-path".equals(v5)) {
                v6 = FileProvider.buildPath(Environment.getExternalStorageDirectory(), new String[]{v3});
            }

            if(v6 == null) {
                continue;
            }

            v4.addRoot(v2, v6);
        }

        return ((PathStrategy)v4);
    }

    public Cursor query(Uri uri, String[] projection, String selection, String[] selectionArgs, String sortOrder) {
        int v5;
        File v4 = this.mStrategy.getFileForUri(uri);
        if(projection == null) {
            projection = FileProvider.COLUMNS;
        }

        String[] v2 = new String[projection.length];
        Object[] v9 = new Object[projection.length];
        String[] v0 = projection;
        int v8 = v0.length;
        int v7 = 0;
        int v6;
        for(v6 = 0; v7 < v8; v6 = v5) {
            String v1 = v0[v7];
            if("_display_name".equals(v1)) {
                v2[v6] = "_display_name";
                v5 = v6 + 1;
                v9[v6] = v4.getName();
            }
            else if("_size".equals(v1)) {
                v2[v6] = "_size";
                v5 = v6 + 1;
                v9[v6] = Long.valueOf(v4.length());
            }
            else {
                v5 = v6;
            }

            ++v7;
        }

        v2 = FileProvider.copyOf(v2, v6);
        v9 = FileProvider.copyOf(v9, v6);
        MatrixCursor v3 = new MatrixCursor(v2, 1);
        v3.addRow(v9);
        return ((Cursor)v3);
    }

    public int update(Uri uri, ContentValues values, String selection, String[] selectionArgs) {
        throw new UnsupportedOperationException("No external updates");
    }
}

