// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.util;

public class SparseArrayCompat {
    private static final Object DELETED;
    private boolean mGarbage;
    private int[] mKeys;
    private int mSize;
    private Object[] mValues;

    static  {
        SparseArrayCompat.DELETED = new Object();
    }

    public SparseArrayCompat() {
        this(10);
    }

    public SparseArrayCompat(int initialCapacity) {
        super();
        this.mGarbage = false;
        initialCapacity = SparseArrayCompat.idealIntArraySize(initialCapacity);
        this.mKeys = new int[initialCapacity];
        this.mValues = new Object[initialCapacity];
        this.mSize = 0;
    }

    public void clear() {
        int v1 = this.mSize;
        Object[] v2 = this.mValues;
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            v2[v0] = null;
        }

        this.mSize = 0;
        this.mGarbage = false;
    }

    private void gc() {
        int v2 = this.mSize;
        int v3 = 0;
        int[] v1 = this.mKeys;
        Object[] v5 = this.mValues;
        int v0;
        for(v0 = 0; v0 < v2; ++v0) {
            Object v4 = v5[v0];
            if(v4 != SparseArrayCompat.DELETED) {
                if(v0 != v3) {
                    v1[v3] = v1[v0];
                    v5[v3] = v4;
                }

                ++v3;
            }
        }

        this.mGarbage = false;
        this.mSize = v3;
    }

    static int idealByteArraySize(int need) {
        int v0 = 4;
        while(v0 < 32) {
            if(need <= (1 << v0) - 12) {
                need = (1 << v0) - 12;
            }
            else {
                ++v0;
                continue;
            }

            break;
        }

        return need;
    }

    static int idealIntArraySize(int need) {
        return SparseArrayCompat.idealByteArraySize(need * 4) / 4;
    }

    public int keyAt(int index) {
        if(this.mGarbage) {
            this.gc();
        }

        return this.mKeys[index];
    }

    public int size() {
        if(this.mGarbage) {
            this.gc();
        }

        return this.mSize;
    }

    public Object valueAt(int index) {
        if(this.mGarbage) {
            this.gc();
        }

        return this.mValues[index];
    }
}

