// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.view;

import android.os.Build$VERSION;
import android.view.MotionEvent;

public class MotionEventCompat {
    class BaseMotionEventVersionImpl implements MotionEventVersionImpl {
        BaseMotionEventVersionImpl() {
            super();
        }

        public int findPointerIndex(MotionEvent event, int pointerId) {
            int v0;
            if(pointerId == 0) {
                v0 = 0;
            }
            else {
                v0 = -1;
            }

            return v0;
        }

        public int getPointerCount(MotionEvent event) {
            return 1;
        }

        public int getPointerId(MotionEvent event, int pointerIndex) {
            if(pointerIndex == 0) {
                return 0;
            }

            throw new IndexOutOfBoundsException("Pre-Eclair does not support multiple pointers");
        }

        public float getX(MotionEvent event, int pointerIndex) {
            if(pointerIndex == 0) {
                return event.getX();
            }

            throw new IndexOutOfBoundsException("Pre-Eclair does not support multiple pointers");
        }

        public float getY(MotionEvent event, int pointerIndex) {
            if(pointerIndex == 0) {
                return event.getY();
            }

            throw new IndexOutOfBoundsException("Pre-Eclair does not support multiple pointers");
        }
    }

    class EclairMotionEventVersionImpl implements MotionEventVersionImpl {
        EclairMotionEventVersionImpl() {
            super();
        }

        public int findPointerIndex(MotionEvent event, int pointerId) {
            return MotionEventCompatEclair.findPointerIndex(event, pointerId);
        }

        public int getPointerCount(MotionEvent event) {
            return MotionEventCompatEclair.getPointerCount(event);
        }

        public int getPointerId(MotionEvent event, int pointerIndex) {
            return MotionEventCompatEclair.getPointerId(event, pointerIndex);
        }

        public float getX(MotionEvent event, int pointerIndex) {
            return MotionEventCompatEclair.getX(event, pointerIndex);
        }

        public float getY(MotionEvent event, int pointerIndex) {
            return MotionEventCompatEclair.getY(event, pointerIndex);
        }
    }

    abstract interface MotionEventVersionImpl {
        public abstract int findPointerIndex(MotionEvent arg0, int arg1);

        public abstract int getPointerCount(MotionEvent arg0);

        public abstract int getPointerId(MotionEvent arg0, int arg1);

        public abstract float getX(MotionEvent arg0, int arg1);

        public abstract float getY(MotionEvent arg0, int arg1);
    }

    static final MotionEventVersionImpl IMPL;

    static  {
        if(Build$VERSION.SDK_INT >= 5) {
            MotionEventCompat.IMPL = new EclairMotionEventVersionImpl();
        }
        else {
            MotionEventCompat.IMPL = new BaseMotionEventVersionImpl();
        }
    }

    public static int findPointerIndex(MotionEvent event, int pointerId) {
        return MotionEventCompat.IMPL.findPointerIndex(event, pointerId);
    }

    public static int getActionIndex(MotionEvent event) {
        return (event.getAction() & 65280) >> 8;
    }

    public static int getActionMasked(MotionEvent event) {
        return event.getAction() & 255;
    }

    public static int getPointerCount(MotionEvent event) {
        return MotionEventCompat.IMPL.getPointerCount(event);
    }

    public static int getPointerId(MotionEvent event, int pointerIndex) {
        return MotionEventCompat.IMPL.getPointerId(event, pointerIndex);
    }

    public static float getX(MotionEvent event, int pointerIndex) {
        return MotionEventCompat.IMPL.getX(event, pointerIndex);
    }

    public static float getY(MotionEvent event, int pointerIndex) {
        return MotionEventCompat.IMPL.getY(event, pointerIndex);
    }
}

