// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.view;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.drawable.Drawable;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.view.View$OnClickListener;
import android.view.ViewConfiguration;

public class PagerTabStrip extends PagerTitleStrip {
    private boolean mDrawFullUnderline;
    private boolean mDrawFullUnderlineSet;
    private int mFullUnderlineHeight;
    private boolean mIgnoreTap;
    private int mIndicatorColor;
    private int mIndicatorHeight;
    private float mInitialMotionX;
    private float mInitialMotionY;
    private int mMinPaddingBottom;
    private int mMinStripHeight;
    private int mMinTextSpacing;
    private int mTabAlpha;
    private int mTabPadding;
    private final Paint mTabPaint;
    private final Rect mTempRect;
    private int mTouchSlop;

    public PagerTabStrip(Context context, AttributeSet attrs) {
        super(context, attrs);
        this.mTabPaint = new Paint();
        this.mTempRect = new Rect();
        this.mTabAlpha = 255;
        this.mDrawFullUnderline = false;
        this.mDrawFullUnderlineSet = false;
        this.mIndicatorColor = this.mTextColor;
        this.mTabPaint.setColor(this.mIndicatorColor);
        float v0 = context.getResources().getDisplayMetrics().density;
        this.mIndicatorHeight = ((int)(3f * v0 + 0.5f));
        this.mMinPaddingBottom = ((int)(6f * v0 + 0.5f));
        this.mMinTextSpacing = ((int)(64f * v0));
        this.mTabPadding = ((int)(16f * v0 + 0.5f));
        this.mFullUnderlineHeight = ((int)(1f * v0 + 0.5f));
        this.mMinStripHeight = ((int)(32f * v0 + 0.5f));
        this.mTouchSlop = ViewConfiguration.get(context).getScaledTouchSlop();
        this.setPadding(this.getPaddingLeft(), this.getPaddingTop(), this.getPaddingRight(), this.getPaddingBottom());
        this.setTextSpacing(this.getTextSpacing());
        this.setWillNotDraw(false);
        this.mPrevText.setFocusable(true);
        this.mPrevText.setOnClickListener(new View$OnClickListener() {
            public void onClick(View v) {
                PagerTabStrip.this.mPager.setCurrentItem(PagerTabStrip.this.mPager.getCurrentItem() - 1);
            }
        });
        this.mNextText.setFocusable(true);
        this.mNextText.setOnClickListener(new View$OnClickListener() {
            public void onClick(View v) {
                PagerTabStrip.this.mPager.setCurrentItem(PagerTabStrip.this.mPager.getCurrentItem() + 1);
            }
        });
        if(this.getBackground() == null) {
            this.mDrawFullUnderline = true;
        }
    }

    int getMinHeight() {
        return Math.max(super.getMinHeight(), this.mMinStripHeight);
    }

    protected void onDraw(Canvas canvas) {
        int v11 = 16777215;
        super.onDraw(canvas);
        int v7 = this.getHeight();
        int v8 = this.mCurrText.getLeft() - this.mTabPadding;
        int v9 = this.mCurrText.getRight() + this.mTabPadding;
        int v10 = v7 - this.mIndicatorHeight;
        this.mTabPaint.setColor(this.mTabAlpha << 24 | this.mIndicatorColor & v11);
        canvas.drawRect(((float)v8), ((float)v10), ((float)v9), ((float)v7), this.mTabPaint);
        if(this.mDrawFullUnderline) {
            this.mTabPaint.setColor(-16777216 | this.mIndicatorColor & v11);
            canvas.drawRect(((float)this.getPaddingLeft()), ((float)(v7 - this.mFullUnderlineHeight)), ((float)(this.getWidth() - this.getPaddingRight())), ((float)v7), this.mTabPaint);
        }
    }

    public boolean onTouchEvent(MotionEvent ev) {
        boolean v3 = false;
        int v0 = ev.getAction();
        if(v0 == 0 || !this.mIgnoreTap) {
            float v1 = ev.getX();
            float v2 = ev.getY();
            switch(v0) {
                case 0: {
                    this.mInitialMotionX = v1;
                    this.mInitialMotionY = v2;
                    this.mIgnoreTap = false;
                    break;
                }
                case 1: {
                    if(v1 >= (((float)(this.mCurrText.getLeft() - this.mTabPadding)))) {
                        goto label_42;
                    }

                    this.mPager.setCurrentItem(this.mPager.getCurrentItem() - 1);
                    goto label_10;
                label_42:
                    if(v1 <= (((float)(this.mCurrText.getRight() + this.mTabPadding)))) {
                        goto label_10;
                    }

                    this.mPager.setCurrentItem(this.mPager.getCurrentItem() + 1);
                    break;
                }
                case 2: {
                    if(Math.abs(v1 - this.mInitialMotionX) <= (((float)this.mTouchSlop)) && Math.abs(v2 - this.mInitialMotionY) <= (((float)this.mTouchSlop))) {
                        goto label_10;
                    }

                    this.mIgnoreTap = true;
                    break;
                }
            }

        label_10:
            v3 = true;
        }

        return v3;
    }

    public void setBackgroundColor(int color) {
        boolean v0;
        super.setBackgroundColor(color);
        if(!this.mDrawFullUnderlineSet) {
            if((-16777216 & color) == 0) {
                v0 = true;
            }
            else {
                v0 = false;
            }

            this.mDrawFullUnderline = v0;
        }
    }

    public void setBackgroundDrawable(Drawable d) {
        boolean v0;
        super.setBackgroundDrawable(d);
        if(!this.mDrawFullUnderlineSet) {
            if(d == null) {
                v0 = true;
            }
            else {
                v0 = false;
            }

            this.mDrawFullUnderline = v0;
        }
    }

    public void setBackgroundResource(int resId) {
        boolean v0;
        super.setBackgroundResource(resId);
        if(!this.mDrawFullUnderlineSet) {
            if(resId == 0) {
                v0 = true;
            }
            else {
                v0 = false;
            }

            this.mDrawFullUnderline = v0;
        }
    }

    public void setPadding(int left, int top, int right, int bottom) {
        if(bottom < this.mMinPaddingBottom) {
            bottom = this.mMinPaddingBottom;
        }

        super.setPadding(left, top, right, bottom);
    }

    public void setTextSpacing(int textSpacing) {
        if(textSpacing < this.mMinTextSpacing) {
            textSpacing = this.mMinTextSpacing;
        }

        super.setTextSpacing(textSpacing);
    }

    void updateTextPositions(int position, float positionOffset, boolean force) {
        Rect v2 = this.mTempRect;
        int v0 = this.getHeight();
        int v1 = this.mCurrText.getLeft() - this.mTabPadding;
        int v3 = this.mCurrText.getRight() + this.mTabPadding;
        int v4 = v0 - this.mIndicatorHeight;
        v2.set(v1, v4, v3, v0);
        super.updateTextPositions(position, positionOffset, force);
        this.mTabAlpha = ((int)(Math.abs(positionOffset - 0.5f) * 2f * 255f));
        v2.union(this.mCurrText.getLeft() - this.mTabPadding, v4, this.mCurrText.getRight() + this.mTabPadding, v0);
        this.invalidate(v2);
    }
}

