// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.view;

import android.content.Context;
import android.content.res.TypedArray;
import android.database.DataSetObserver;
import android.graphics.drawable.Drawable;
import android.os.Build$VERSION;
import android.text.TextUtils$TruncateAt;
import android.util.AttributeSet;
import android.view.View;
import android.view.View$MeasureSpec;
import android.view.ViewGroup;
import android.view.ViewParent;
import android.widget.TextView;

public class PagerTitleStrip extends ViewGroup implements Decor {
    class PageListener extends DataSetObserver implements OnAdapterChangeListener, OnPageChangeListener {
        private int mScrollState;

        PageListener(PagerTitleStrip x0, android.support.v4.view.PagerTitleStrip$1 x1) {
            super(x0);
        }

        private PageListener(PagerTitleStrip arg1) {
            PagerTitleStrip.this = arg1;
            super();
        }

        public void onAdapterChanged(PagerAdapter oldAdapter, PagerAdapter newAdapter) {
            PagerTitleStrip.this.updateAdapter(oldAdapter, newAdapter);
        }

        public void onChanged() {
            float v0 = 0f;
            PagerTitleStrip.this.updateText(PagerTitleStrip.this.mPager.getCurrentItem(), PagerTitleStrip.this.mPager.getAdapter());
            if(PagerTitleStrip.this.mLastKnownPositionOffset >= 0f) {
                v0 = PagerTitleStrip.this.mLastKnownPositionOffset;
            }

            PagerTitleStrip.this.updateTextPositions(PagerTitleStrip.this.mPager.getCurrentItem(), v0, true);
        }

        public void onPageScrollStateChanged(int state) {
            this.mScrollState = state;
        }

        public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {
            if(positionOffset > 0.5f) {
                ++position;
            }

            PagerTitleStrip.this.updateTextPositions(position, positionOffset, false);
        }

        public void onPageSelected(int position) {
            float v0 = 0f;
            if(this.mScrollState == 0) {
                PagerTitleStrip.this.updateText(PagerTitleStrip.this.mPager.getCurrentItem(), PagerTitleStrip.this.mPager.getAdapter());
                if(PagerTitleStrip.this.mLastKnownPositionOffset >= 0f) {
                    v0 = PagerTitleStrip.this.mLastKnownPositionOffset;
                }

                PagerTitleStrip.this.updateTextPositions(PagerTitleStrip.this.mPager.getCurrentItem(), v0, true);
            }
        }
    }

    abstract interface PagerTitleStripImpl {
        public abstract void setSingleLineAllCaps(TextView arg0);
    }

    class PagerTitleStripImplBase implements PagerTitleStripImpl {
        PagerTitleStripImplBase() {
            super();
        }

        public void setSingleLineAllCaps(TextView text) {
            text.setSingleLine();
        }
    }

    class PagerTitleStripImplIcs implements PagerTitleStripImpl {
        PagerTitleStripImplIcs() {
            super();
        }

        public void setSingleLineAllCaps(TextView text) {
            PagerTitleStripIcs.setSingleLineAllCaps(text);
        }
    }

    private static final int[] ATTRS;
    private static final PagerTitleStripImpl IMPL;
    private static final int[] TEXT_ATTRS;
    TextView mCurrText;
    private int mGravity;
    private int mLastKnownCurrentPage;
    private float mLastKnownPositionOffset;
    TextView mNextText;
    private int mNonPrimaryAlpha;
    private final PageListener mPageListener;
    ViewPager mPager;
    TextView mPrevText;
    private int mScaledTextSpacing;
    int mTextColor;
    private boolean mUpdatingPositions;
    private boolean mUpdatingText;
    private WeakReference mWatchingAdapter;

    static  {
        PagerTitleStrip.ATTRS = new int[]{16842804, 16842901, 16842904, 16842927};
        PagerTitleStrip.TEXT_ATTRS = new int[]{16843660};
        if(Build$VERSION.SDK_INT >= 14) {
            PagerTitleStrip.IMPL = new PagerTitleStripImplIcs();
        }
        else {
            PagerTitleStrip.IMPL = new PagerTitleStripImplBase();
        }
    }

    public PagerTitleStrip(Context context, AttributeSet attrs) {
        int v10 = 2;
        super(context, attrs);
        this.mLastKnownCurrentPage = -1;
        this.mLastKnownPositionOffset = -1f;
        this.mPageListener = new PageListener(this, null);
        TextView v7 = new TextView(context);
        this.mPrevText = v7;
        this.addView(((View)v7));
        v7 = new TextView(context);
        this.mCurrText = v7;
        this.addView(((View)v7));
        v7 = new TextView(context);
        this.mNextText = v7;
        this.addView(((View)v7));
        TypedArray v0 = context.obtainStyledAttributes(attrs, PagerTitleStrip.ATTRS);
        int v4 = v0.getResourceId(0, 0);
        if(v4 != 0) {
            this.mPrevText.setTextAppearance(context, v4);
            this.mCurrText.setTextAppearance(context, v4);
            this.mNextText.setTextAppearance(context, v4);
        }

        int v6 = v0.getDimensionPixelSize(1, 0);
        if(v6 != 0) {
            this.setTextSize(0, ((float)v6));
        }

        if(v0.hasValue(v10)) {
            int v5 = v0.getColor(v10, 0);
            this.mPrevText.setTextColor(v5);
            this.mCurrText.setTextColor(v5);
            this.mNextText.setTextColor(v5);
        }

        this.mGravity = v0.getInteger(3, 80);
        v0.recycle();
        this.mTextColor = this.mCurrText.getTextColors().getDefaultColor();
        this.setNonPrimaryAlpha(0.6f);
        this.mPrevText.setEllipsize(TextUtils$TruncateAt.END);
        this.mCurrText.setEllipsize(TextUtils$TruncateAt.END);
        this.mNextText.setEllipsize(TextUtils$TruncateAt.END);
        boolean v1 = false;
        if(v4 != 0) {
            TypedArray v3 = context.obtainStyledAttributes(v4, PagerTitleStrip.TEXT_ATTRS);
            v1 = v3.getBoolean(0, false);
            v3.recycle();
        }

        if(v1) {
            PagerTitleStrip.setSingleLineAllCaps(this.mPrevText);
            PagerTitleStrip.setSingleLineAllCaps(this.mCurrText);
            PagerTitleStrip.setSingleLineAllCaps(this.mNextText);
        }
        else {
            this.mPrevText.setSingleLine();
            this.mCurrText.setSingleLine();
            this.mNextText.setSingleLine();
        }

        this.mScaledTextSpacing = ((int)(16f * context.getResources().getDisplayMetrics().density));
    }

    static float access$100(PagerTitleStrip x0) {
        return x0.mLastKnownPositionOffset;
    }

    int getMinHeight() {
        int v1 = 0;
        Drawable v0 = this.getBackground();
        if(v0 != null) {
            v1 = v0.getIntrinsicHeight();
        }

        return v1;
    }

    public int getTextSpacing() {
        return this.mScaledTextSpacing;
    }

    protected void onAttachedToWindow() {
        PagerAdapter v3_1;
        super.onAttachedToWindow();
        ViewParent v2 = this.getParent();
        if(!(v2 instanceof ViewPager)) {
            throw new IllegalStateException("PagerTitleStrip must be a direct child of a ViewPager.");
        }

        PagerAdapter v0 = v2.getAdapter();
        v2.setInternalPageChangeListener(this.mPageListener);
        v2.setOnAdapterChangeListener(this.mPageListener);
        this.mPager = v2;
        if(this.mWatchingAdapter != null) {
            Object v3 = this.mWatchingAdapter.get();
        }
        else {
            v3_1 = null;
        }

        this.updateAdapter(v3_1, v0);
    }

    protected void onDetachedFromWindow() {
        PagerAdapter v1 = null;
        super.onDetachedFromWindow();
        if(this.mPager != null) {
            this.updateAdapter(this.mPager.getAdapter(), v1);
            this.mPager.setInternalPageChangeListener(((OnPageChangeListener)v1));
            this.mPager.setOnAdapterChangeListener(((OnAdapterChangeListener)v1));
            this.mPager = ((ViewPager)v1);
        }
    }

    protected void onLayout(boolean changed, int l, int t, int r, int b) {
        float v0 = 0f;
        if(this.mPager != null) {
            if(this.mLastKnownPositionOffset >= 0f) {
                v0 = this.mLastKnownPositionOffset;
            }

            this.updateTextPositions(this.mLastKnownCurrentPage, v0, true);
        }
    }

    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        int v8 = View$MeasureSpec.getMode(widthMeasureSpec);
        int v3 = View$MeasureSpec.getMode(heightMeasureSpec);
        int v9 = View$MeasureSpec.getSize(widthMeasureSpec);
        int v4 = View$MeasureSpec.getSize(heightMeasureSpec);
        if(v8 != 1073741824) {
            throw new IllegalStateException("Must measure with an exact width");
        }

        int v5 = this.getMinHeight();
        int v6 = this.getPaddingTop() + this.getPaddingBottom();
        int v2 = View$MeasureSpec.makeMeasureSpec(((int)((((float)v9)) * 0.8f)), -2147483648);
        int v1 = View$MeasureSpec.makeMeasureSpec(v4 - v6, -2147483648);
        this.mPrevText.measure(v2, v1);
        this.mCurrText.measure(v2, v1);
        this.mNextText.measure(v2, v1);
        if(v3 == 1073741824) {
            this.setMeasuredDimension(v9, v4);
        }
        else {
            this.setMeasuredDimension(v9, Math.max(v5, this.mCurrText.getMeasuredHeight() + v6));
        }
    }

    public void requestLayout() {
        if(!this.mUpdatingText) {
            super.requestLayout();
        }
    }

    public void setNonPrimaryAlpha(float alpha) {
        this.mNonPrimaryAlpha = (((int)(255f * alpha))) & 255;
        int v0 = this.mNonPrimaryAlpha << 24 | this.mTextColor & 16777215;
        this.mPrevText.setTextColor(v0);
        this.mNextText.setTextColor(v0);
    }

    private static void setSingleLineAllCaps(TextView text) {
        PagerTitleStrip.IMPL.setSingleLineAllCaps(text);
    }

    public void setTextSize(int unit, float size) {
        this.mPrevText.setTextSize(unit, size);
        this.mCurrText.setTextSize(unit, size);
        this.mNextText.setTextSize(unit, size);
    }

    public void setTextSpacing(int spacingPixels) {
        this.mScaledTextSpacing = spacingPixels;
        this.requestLayout();
    }

    void updateAdapter(PagerAdapter oldAdapter, PagerAdapter newAdapter) {
        if(oldAdapter != null) {
            oldAdapter.unregisterDataSetObserver(this.mPageListener);
            this.mWatchingAdapter = null;
        }

        if(newAdapter != null) {
            newAdapter.registerDataSetObserver(this.mPageListener);
            this.mWatchingAdapter = new WeakReference(newAdapter);
        }

        if(this.mPager != null) {
            this.mLastKnownCurrentPage = -1;
            this.mLastKnownPositionOffset = -1f;
            this.updateText(this.mPager.getCurrentItem(), newAdapter);
            this.requestLayout();
        }
    }

    void updateText(int currentItem, PagerAdapter adapter) {
        CharSequence v7;
        int v3;
        int v9 = -2147483648;
        if(adapter != null) {
            v3 = adapter.getCount();
        }
        else {
            v3 = 0;
        }

        this.mUpdatingText = true;
        CharSequence v4 = null;
        if(currentItem >= 1 && adapter != null) {
            v4 = adapter.getPageTitle(currentItem - 1);
        }

        this.mPrevText.setText(v4);
        TextView v8 = this.mCurrText;
        if(adapter == null || currentItem >= v3) {
            v7 = null;
        }
        else {
            v7 = adapter.getPageTitle(currentItem);
        }

        v8.setText(v7);
        v4 = null;
        if(currentItem + 1 < v3 && adapter != null) {
            v4 = adapter.getPageTitle(currentItem + 1);
        }

        this.mNextText.setText(v4);
        int v5 = this.getWidth() - this.getPaddingLeft() - this.getPaddingRight();
        int v0 = this.getHeight() - this.getPaddingTop() - this.getPaddingBottom();
        int v2 = View$MeasureSpec.makeMeasureSpec(((int)((((float)v5)) * 0.8f)), v9);
        int v1 = View$MeasureSpec.makeMeasureSpec(v0, v9);
        this.mPrevText.measure(v2, v1);
        this.mCurrText.measure(v2, v1);
        this.mNextText.measure(v2, v1);
        this.mLastKnownCurrentPage = currentItem;
        if(!this.mUpdatingPositions) {
            this.updateTextPositions(currentItem, this.mLastKnownPositionOffset, false);
        }

        this.mUpdatingText = false;
    }

    void updateTextPositions(int position, float positionOffset, boolean force) {
        int v24;
        int v16;
        int v34;
        if(position != this.mLastKnownCurrentPage) {
            this.updateText(position, this.mPager.getAdapter());
            goto label_14;
        }
        else if(force) {
        label_14:
            this.mUpdatingPositions = true;
            int v36 = this.mPrevText.getMeasuredWidth();
            int v18 = this.mCurrText.getMeasuredWidth();
            int v26 = this.mNextText.getMeasuredWidth();
            int v19 = v18 / 2;
            int v38 = this.getWidth();
            int v37 = this.getHeight();
            int v29 = this.getPaddingLeft();
            int v30 = this.getPaddingRight();
            int v31 = this.getPaddingTop();
            int v28 = this.getPaddingBottom();
            int v40 = v30 + v19;
            int v10 = v38 - (v29 + v19) - v40;
            float v14 = positionOffset + 0.5f;
            if(v14 > 1f) {
                --v14;
            }

            int v13 = v38 - v40 - (((int)((((float)v10)) * v14))) - v18 / 2;
            int v15 = v13 + v18;
            int v32 = this.mPrevText.getBaseline();
            int v11 = this.mCurrText.getBaseline();
            int v22 = this.mNextText.getBaseline();
            int v20 = Math.max(Math.max(v32, v11), v22);
            int v35 = v20 - v32;
            int v17 = v20 - v11;
            int v25 = v20 - v22;
            int v21 = Math.max(Math.max(v35 + this.mPrevText.getMeasuredHeight(), v17 + this.mCurrText.getMeasuredHeight()), v25 + this.mNextText.getMeasuredHeight());
            switch(this.mGravity & 112) {
                case 16: {
                    int v9 = (v37 - v31 - v28 - v21) / 2;
                    v34 = v9 + v35;
                    v16 = v9 + v17;
                    v24 = v9 + v25;
                    break;
                }
                case 80: {
                    int v8 = v37 - v28 - v21;
                    v34 = v8 + v35;
                    v16 = v8 + v17;
                    v24 = v8 + v25;
                    break;
                }
                default: {
                    v34 = v31 + v35;
                    v16 = v31 + v17;
                    v24 = v31 + v25;
                    break;
                }
            }

            this.mCurrText.layout(v13, v16, v15, this.mCurrText.getMeasuredHeight() + v16);
            int v33 = Math.min(v29, v13 - this.mScaledTextSpacing - v36);
            this.mPrevText.layout(v33, v34, v33 + v36, this.mPrevText.getMeasuredHeight() + v34);
            int v23 = Math.max(v38 - v30 - v26, this.mScaledTextSpacing + v15);
            this.mNextText.layout(v23, v24, v23 + v26, this.mNextText.getMeasuredHeight() + v24);
            this.mLastKnownPositionOffset = positionOffset;
            this.mUpdatingPositions = false;
        }
        else if(positionOffset == this.mLastKnownPositionOffset) {
        }
        else {
            goto label_14;
        }
    }
}

