// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.view;

import android.graphics.Paint;
import android.os.Build$VERSION;
import android.view.View;

public class ViewCompat {
    class BaseViewCompatImpl implements ViewCompatImpl {
        BaseViewCompatImpl() {
            super();
        }

        public boolean canScrollHorizontally(View v, int direction) {
            return 0;
        }

        long getFrameTime() {
            return 10;
        }

        public int getImportantForAccessibility(View view) {
            return 0;
        }

        public int getLayerType(View view) {
            return 0;
        }

        public int getLayoutDirection(View view) {
            return 0;
        }

        public int getOverScrollMode(View v) {
            return 2;
        }

        public void postInvalidateOnAnimation(View view) {
            view.postInvalidateDelayed(this.getFrameTime());
        }

        public void postInvalidateOnAnimation(View view, int left, int top, int right, int bottom) {
            view.postInvalidateDelayed(this.getFrameTime(), left, top, right, bottom);
        }

        public void postOnAnimation(View view, Runnable action) {
            view.postDelayed(action, this.getFrameTime());
        }

        public void setAccessibilityDelegate(View v, AccessibilityDelegateCompat delegate) {
        }

        public void setImportantForAccessibility(View view, int mode) {
        }

        public void setLayerPaint(View view, Paint p) {
        }

        public void setLayerType(View view, int layerType, Paint paint) {
        }
    }

    class GBViewCompatImpl extends BaseViewCompatImpl {
        GBViewCompatImpl() {
            super();
        }

        public int getOverScrollMode(View v) {
            return ViewCompatGingerbread.getOverScrollMode(v);
        }
    }

    class HCViewCompatImpl extends GBViewCompatImpl {
        HCViewCompatImpl() {
            super();
        }

        long getFrameTime() {
            return ViewCompatHC.getFrameTime();
        }

        public int getLayerType(View view) {
            return ViewCompatHC.getLayerType(view);
        }

        public void setLayerPaint(View view, Paint paint) {
            this.setLayerType(view, this.getLayerType(view), paint);
            view.invalidate();
        }

        public void setLayerType(View view, int layerType, Paint paint) {
            ViewCompatHC.setLayerType(view, layerType, paint);
        }
    }

    class ICSViewCompatImpl extends HCViewCompatImpl {
        ICSViewCompatImpl() {
            super();
        }

        public boolean canScrollHorizontally(View v, int direction) {
            return ViewCompatICS.canScrollHorizontally(v, direction);
        }

        public void setAccessibilityDelegate(View v, AccessibilityDelegateCompat delegate) {
            ViewCompatICS.setAccessibilityDelegate(v, delegate.getBridge());
        }
    }

    class JBViewCompatImpl extends ICSViewCompatImpl {
        JBViewCompatImpl() {
            super();
        }

        public int getImportantForAccessibility(View view) {
            return ViewCompatJB.getImportantForAccessibility(view);
        }

        public void postInvalidateOnAnimation(View view) {
            ViewCompatJB.postInvalidateOnAnimation(view);
        }

        public void postInvalidateOnAnimation(View view, int left, int top, int right, int bottom) {
            ViewCompatJB.postInvalidateOnAnimation(view, left, top, right, bottom);
        }

        public void postOnAnimation(View view, Runnable action) {
            ViewCompatJB.postOnAnimation(view, action);
        }

        public void setImportantForAccessibility(View view, int mode) {
            ViewCompatJB.setImportantForAccessibility(view, mode);
        }
    }

    class JbMr1ViewCompatImpl extends JBViewCompatImpl {
        JbMr1ViewCompatImpl() {
            super();
        }

        public int getLayoutDirection(View view) {
            return ViewCompatJellybeanMr1.getLayoutDirection(view);
        }

        public void setLayerPaint(View view, Paint paint) {
            ViewCompatJellybeanMr1.setLayerPaint(view, paint);
        }
    }

    abstract interface ViewCompatImpl {
        public abstract boolean canScrollHorizontally(View arg0, int arg1);

        public abstract int getImportantForAccessibility(View arg0);

        public abstract int getLayerType(View arg0);

        public abstract int getLayoutDirection(View arg0);

        public abstract int getOverScrollMode(View arg0);

        public abstract void postInvalidateOnAnimation(View arg0);

        public abstract void postInvalidateOnAnimation(View arg0, int arg1, int arg2, int arg3, int arg4);

        public abstract void postOnAnimation(View arg0, Runnable arg1);

        public abstract void setAccessibilityDelegate(View arg0, AccessibilityDelegateCompat arg1);

        public abstract void setImportantForAccessibility(View arg0, int arg1);

        public abstract void setLayerPaint(View arg0, Paint arg1);

        public abstract void setLayerType(View arg0, int arg1, Paint arg2);
    }

    static final ViewCompatImpl IMPL;

    static  {
        int v0 = Build$VERSION.SDK_INT;
        if(v0 >= 17) {
            ViewCompat.IMPL = new JbMr1ViewCompatImpl();
        }
        else if(v0 >= 16) {
            ViewCompat.IMPL = new JBViewCompatImpl();
        }
        else if(v0 >= 14) {
            ViewCompat.IMPL = new ICSViewCompatImpl();
        }
        else if(v0 >= 11) {
            ViewCompat.IMPL = new HCViewCompatImpl();
        }
        else if(v0 >= 9) {
            ViewCompat.IMPL = new GBViewCompatImpl();
        }
        else {
            ViewCompat.IMPL = new BaseViewCompatImpl();
        }
    }

    public static boolean canScrollHorizontally(View v, int direction) {
        return ViewCompat.IMPL.canScrollHorizontally(v, direction);
    }

    public static int getImportantForAccessibility(View view) {
        return ViewCompat.IMPL.getImportantForAccessibility(view);
    }

    public static int getLayerType(View view) {
        return ViewCompat.IMPL.getLayerType(view);
    }

    public static int getLayoutDirection(View view) {
        return ViewCompat.IMPL.getLayoutDirection(view);
    }

    public static int getOverScrollMode(View v) {
        return ViewCompat.IMPL.getOverScrollMode(v);
    }

    public static void postInvalidateOnAnimation(View view) {
        ViewCompat.IMPL.postInvalidateOnAnimation(view);
    }

    public static void postInvalidateOnAnimation(View view, int left, int top, int right, int bottom) {
        ViewCompat.IMPL.postInvalidateOnAnimation(view, left, top, right, bottom);
    }

    public static void postOnAnimation(View view, Runnable action) {
        ViewCompat.IMPL.postOnAnimation(view, action);
    }

    public static void setAccessibilityDelegate(View v, AccessibilityDelegateCompat delegate) {
        ViewCompat.IMPL.setAccessibilityDelegate(v, delegate);
    }

    public static void setImportantForAccessibility(View view, int mode) {
        ViewCompat.IMPL.setImportantForAccessibility(view, mode);
    }

    public static void setLayerPaint(View view, Paint paint) {
        ViewCompat.IMPL.setLayerPaint(view, paint);
    }

    public static void setLayerType(View view, int layerType, Paint paint) {
        ViewCompat.IMPL.setLayerType(view, layerType, paint);
    }
}

