// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.view;

import android.content.Context;
import android.content.res.Resources$NotFoundException;
import android.content.res.TypedArray;
import android.database.DataSetObserver;
import android.graphics.Canvas;
import android.graphics.Rect;
import android.graphics.drawable.Drawable;
import android.os.Build$VERSION;
import android.os.Parcel;
import android.os.Parcelable;
import android.os.Parcelable$Creator;
import android.support.v4.os.ParcelableCompat;
import android.support.v4.os.ParcelableCompatCreatorCallbacks;
import android.support.v4.widget.EdgeEffectCompat;
import android.util.AttributeSet;
import android.util.Log;
import android.view.FocusFinder;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.SoundEffectConstants;
import android.view.VelocityTracker;
import android.view.View;
import android.view.View$BaseSavedState;
import android.view.View$MeasureSpec;
import android.view.ViewConfiguration;
import android.view.ViewGroup;
import android.view.ViewGroup$LayoutParams;
import android.view.ViewParent;
import android.view.accessibility.AccessibilityEvent;
import android.view.animation.Interpolator;
import android.widget.Scroller;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class ViewPager extends ViewGroup {
    abstract interface Decor {
    }

    class ItemInfo {
        Object object;
        float offset;
        int position;
        boolean scrolling;
        float widthFactor;

        ItemInfo() {
            super();
        }
    }

    public class LayoutParams extends ViewGroup$LayoutParams {
        int childIndex;
        public int gravity;
        int position;

        public LayoutParams() {
            super(-1, -1);
            this.widthFactor = 0f;
        }

        public LayoutParams(Context context, AttributeSet attrs) {
            super(context, attrs);
            this.widthFactor = 0f;
            TypedArray v0 = context.obtainStyledAttributes(attrs, ViewPager.LAYOUT_ATTRS);
            this.gravity = v0.getInteger(0, 48);
            v0.recycle();
        }
    }

    class MyAccessibilityDelegate extends AccessibilityDelegateCompat {
        MyAccessibilityDelegate(ViewPager arg1) {
            ViewPager.this = arg1;
            super();
        }
    }

    abstract interface OnAdapterChangeListener {
        public abstract void onAdapterChanged(PagerAdapter arg0, PagerAdapter arg1);
    }

    public abstract interface OnPageChangeListener {
        public abstract void onPageScrollStateChanged(int arg0);

        public abstract void onPageScrolled(int arg0, float arg1, int arg2);

        public abstract void onPageSelected(int arg0);
    }

    public abstract interface PageTransformer {
        public abstract void transformPage(View arg0, float arg1);
    }

    class PagerObserver extends DataSetObserver {
        PagerObserver(ViewPager x0, android.support.v4.view.ViewPager$1 x1) {
            super(x0);
        }

        private PagerObserver(ViewPager arg1) {
            ViewPager.this = arg1;
            super();
        }

        public void onChanged() {
            ViewPager.this.dataSetChanged();
        }

        public void onInvalidated() {
            ViewPager.this.dataSetChanged();
        }
    }

    public class SavedState extends View$BaseSavedState {
        public static final Parcelable$Creator CREATOR;
        Parcelable adapterState;
        ClassLoader loader;
        int position;

        static  {
            SavedState.CREATOR = ParcelableCompat.newCreator(new ParcelableCompatCreatorCallbacks() {
                public SavedState createFromParcel(Parcel in, ClassLoader loader) {
                    return new SavedState(in, loader);
                }

                public Object createFromParcel(Parcel x0, ClassLoader x1) {
                    return this.createFromParcel(x0, x1);
                }

                public SavedState[] newArray(int size) {
                    return new SavedState[size];
                }

                public Object[] newArray(int x0) {
                    return this.newArray(x0);
                }
            });
        }

        public SavedState(Parcelable superState) {
            super(superState);
        }

        SavedState(Parcel in, ClassLoader loader) {
            super(in);
            if(loader == null) {
                loader = this.getClass().getClassLoader();
            }

            this.position = in.readInt();
            this.adapterState = in.readParcelable(loader);
            this.loader = loader;
        }

        public String toString() {
            return "FragmentPager.SavedState{" + Integer.toHexString(System.identityHashCode(this)) + " position=" + this.position + "}";
        }

        public void writeToParcel(Parcel out, int flags) {
            super.writeToParcel(out, flags);
            out.writeInt(this.position);
            out.writeParcelable(this.adapterState, flags);
        }
    }

    class ViewPositionComparator implements Comparator {
        ViewPositionComparator() {
            super();
        }

        public int compare(View lhs, View rhs) {
            int v2;
            ViewGroup$LayoutParams v0 = lhs.getLayoutParams();
            ViewGroup$LayoutParams v1 = rhs.getLayoutParams();
            if(((LayoutParams)v0).isDecor == ((LayoutParams)v1).isDecor) {
                v2 = ((LayoutParams)v0).position - ((LayoutParams)v1).position;
            }
            else if(((LayoutParams)v0).isDecor) {
                v2 = 1;
            }
            else {
                v2 = -1;
            }

            return v2;
        }

        public int compare(Object x0, Object x1) {
            return this.compare(((View)x0), ((View)x1));
        }
    }

    private static final Comparator COMPARATOR;
    private static final int[] LAYOUT_ATTRS;
    private int mActivePointerId;
    private PagerAdapter mAdapter;
    private OnAdapterChangeListener mAdapterChangeListener;
    private int mBottomPageBounds;
    private boolean mCalledSuper;
    private int mChildHeightMeasureSpec;
    private int mChildWidthMeasureSpec;
    private int mCloseEnough;
    private int mCurItem;
    private int mDecorChildCount;
    private int mDefaultGutterSize;
    private int mDrawingOrder;
    private ArrayList mDrawingOrderedChildren;
    private final Runnable mEndScrollRunnable;
    private int mExpectedAdapterCount;
    private boolean mFakeDragging;
    private boolean mFirstLayout;
    private float mFirstOffset;
    private int mFlingDistance;
    private int mGutterSize;
    private boolean mInLayout;
    private float mInitialMotionX;
    private float mInitialMotionY;
    private OnPageChangeListener mInternalPageChangeListener;
    private boolean mIsBeingDragged;
    private boolean mIsUnableToDrag;
    private final ArrayList mItems;
    private float mLastMotionX;
    private float mLastMotionY;
    private float mLastOffset;
    private EdgeEffectCompat mLeftEdge;
    private Drawable mMarginDrawable;
    private int mMaximumVelocity;
    private int mMinimumVelocity;
    private boolean mNeedCalculatePageOffsets;
    private PagerObserver mObserver;
    private int mOffscreenPageLimit;
    private OnPageChangeListener mOnPageChangeListener;
    private int mPageMargin;
    private PageTransformer mPageTransformer;
    private boolean mPopulatePending;
    private Parcelable mRestoredAdapterState;
    private ClassLoader mRestoredClassLoader;
    private int mRestoredCurItem;
    private EdgeEffectCompat mRightEdge;
    private int mScrollState;
    private Scroller mScroller;
    private boolean mScrollingCacheEnabled;
    private final ItemInfo mTempItem;
    private final Rect mTempRect;
    private int mTopPageBounds;
    private int mTouchSlop;
    private VelocityTracker mVelocityTracker;
    private static final Interpolator sInterpolator;
    private static final ViewPositionComparator sPositionComparator;

    static  {
        ViewPager.LAYOUT_ATTRS = new int[]{16842931};
        ViewPager.COMPARATOR = new Comparator() {
            public int compare(ItemInfo lhs, ItemInfo rhs) {
                return lhs.position - rhs.position;
            }

            public int compare(Object x0, Object x1) {
                return this.compare(((ItemInfo)x0), ((ItemInfo)x1));
            }
        };
        ViewPager.sInterpolator = new Interpolator() {
            public float getInterpolation(float t) {
                --t;
                return t * t * t * t * t + 1f;
            }
        };
        ViewPager.sPositionComparator = new ViewPositionComparator();
    }

    public ViewPager(Context context, AttributeSet attrs) {
        super(context, attrs);
        this.mItems = new ArrayList();
        this.mTempItem = new ItemInfo();
        this.mTempRect = new Rect();
        this.mRestoredCurItem = -1;
        this.mRestoredAdapterState = null;
        this.mRestoredClassLoader = null;
        this.mFirstOffset = -340282346638528860000000000000000000000f;
        this.mLastOffset = 340282346638528860000000000000000000000f;
        this.mOffscreenPageLimit = 1;
        this.mActivePointerId = -1;
        this.mFirstLayout = true;
        this.mNeedCalculatePageOffsets = false;
        this.mEndScrollRunnable = new Runnable() {
            public void run() {
                ViewPager.this.setScrollState(0);
                ViewPager.this.populate();
            }
        };
        this.mScrollState = 0;
        this.initViewPager();
    }

    static void access$000(ViewPager x0, int x1) {
        x0.setScrollState(x1);
    }

    static int[] access$400() {
        return ViewPager.LAYOUT_ATTRS;
    }

    public void addFocusables(ArrayList arg8, int direction, int focusableMode) {
        int v2 = arg8.size();
        int v1 = this.getDescendantFocusability();
        if(v1 != 393216) {
            int v3;
            for(v3 = 0; v3 < this.getChildCount(); ++v3) {
                View v0 = this.getChildAt(v3);
                if(v0.getVisibility() == 0) {
                    ItemInfo v4 = this.infoForChild(v0);
                    if(v4 != null && v4.position == this.mCurItem) {
                        v0.addFocusables(arg8, direction, focusableMode);
                    }
                }
            }
        }

        if((v1 != 262144 || v2 == arg8.size()) && (this.isFocusable()) && ((focusableMode & 1) != 1 || !this.isInTouchMode() || (this.isFocusableInTouchMode())) && arg8 != null) {
            arg8.add(this);
        }
    }

    ItemInfo addNewItem(int position, int index) {
        ItemInfo v0 = new ItemInfo();
        v0.position = position;
        v0.object = this.mAdapter.instantiateItem(((ViewGroup)this), position);
        v0.widthFactor = this.mAdapter.getPageWidth(position);
        if(index < 0 || index >= this.mItems.size()) {
            this.mItems.add(v0);
        }
        else {
            this.mItems.add(index, v0);
        }

        return v0;
    }

    public void addTouchables(ArrayList arg6) {
        int v1;
        for(v1 = 0; v1 < this.getChildCount(); ++v1) {
            View v0 = this.getChildAt(v1);
            if(v0.getVisibility() == 0) {
                ItemInfo v2 = this.infoForChild(v0);
                if(v2 != null && v2.position == this.mCurItem) {
                    v0.addTouchables(arg6);
                }
            }
        }
    }

    public void addView(View child, int index, ViewGroup$LayoutParams params) {
        if(!this.checkLayoutParams(params)) {
            params = this.generateLayoutParams(params);
        }

        ViewGroup$LayoutParams v0 = params;
        ((LayoutParams)v0).isDecor |= child instanceof Decor;
        if(this.mInLayout) {
            if(v0 != null && (((LayoutParams)v0).isDecor)) {
                throw new IllegalStateException("Cannot add pager decor view during layout");
            }

            ((LayoutParams)v0).needsMeasure = true;
            this.addViewInLayout(child, index, params);
        }
        else {
            super.addView(child, index, params);
        }
    }

    public boolean arrowScroll(int direction) {
        int v0;
        int v5;
        int v12 = 66;
        int v11 = 17;
        View v1 = this.findFocus();
        if((((ViewPager)v1)) == this) {
            v1 = null;
        }
        else if(v1 != null) {
            int v3 = 0;
            ViewParent v6 = v1.getParent();
            while((v6 instanceof ViewGroup)) {
                if((((ViewPager)v6)) == this) {
                    v3 = 1;
                }
                else {
                    v6 = v6.getParent();
                    continue;
                }

                break;
            }

            if(v3 != 0) {
                goto label_5;
            }

            StringBuilder v7 = new StringBuilder();
            v7.append(v1.getClass().getSimpleName());
            for(v6 = v1.getParent(); (v6 instanceof ViewGroup); v6 = v6.getParent()) {
                v7.append(" => ").append(v6.getClass().getSimpleName());
            }

            Log.e("ViewPager", "arrowScroll tried to find focus based on non-child current focused view " + v7.toString());
            v1 = null;
        }

    label_5:
        boolean v2 = false;
        View v4 = FocusFinder.getInstance().findNextFocus(((ViewGroup)this), v1, direction);
        if(v4 == null || v4 == v1) {
            if(direction != v11 && direction != 1) {
                if(direction != v12 && direction != 2) {
                    goto label_20;
                }

                v2 = this.pageRight();
                goto label_20;
            }

            v2 = this.pageLeft();
        }
        else if(direction == v11) {
            v5 = this.getChildRectInPagerCoordinates(this.mTempRect, v4).left;
            v0 = this.getChildRectInPagerCoordinates(this.mTempRect, v1).left;
            if(v1 != null && v5 >= v0) {
                v2 = this.pageLeft();
                goto label_20;
            }

            v2 = v4.requestFocus();
        }
        else {
            if(direction != v12) {
                goto label_20;
            }

            v5 = this.getChildRectInPagerCoordinates(this.mTempRect, v4).left;
            v0 = this.getChildRectInPagerCoordinates(this.mTempRect, v1).left;
            if(v1 != null && v5 <= v0) {
                v2 = this.pageRight();
                goto label_20;
            }

            v2 = v4.requestFocus();
        }

    label_20:
        if(v2) {
            this.playSoundEffect(SoundEffectConstants.getContantForFocusDirection(direction));
        }

        return v2;
    }

    private void calculatePageOffsets(ItemInfo curItem, int curIndex, ItemInfo oldCurInfo) {
        float v12;
        Object v3;
        int v9;
        float v7;
        int v5;
        float v6;
        int v1 = this.mAdapter.getCount();
        int v11 = this.getClientWidth();
        if(v11 > 0) {
            v6 = (((float)this.mPageMargin)) / (((float)v11));
        }
        else {
            v6 = 0f;
        }

        if(oldCurInfo != null) {
            int v8 = oldCurInfo.position;
            if(v8 < curItem.position) {
                v5 = 0;
                v7 = oldCurInfo.offset + oldCurInfo.widthFactor + v6;
                v9 = v8 + 1;
                while(v9 <= curItem.position) {
                    if(v5 >= this.mItems.size()) {
                        break;
                    }

                    v3 = this.mItems.get(v5);
                    while(v9 > ((ItemInfo)v3).position) {
                        if(v5 >= this.mItems.size() - 1) {
                            break;
                        }

                        ++v5;
                        v3 = this.mItems.get(v5);
                    }

                    while(v9 < ((ItemInfo)v3).position) {
                        v7 += this.mAdapter.getPageWidth(v9) + v6;
                        ++v9;
                    }

                    ((ItemInfo)v3).offset = v7;
                    v7 += ((ItemInfo)v3).widthFactor + v6;
                    ++v9;
                }
            }
            else {
                if(v8 <= curItem.position) {
                    goto label_90;
                }

                v5 = this.mItems.size() - 1;
                v7 = oldCurInfo.offset;
                for(v9 = v8 - 1; v9 >= curItem.position; --v9) {
                    if(v5 < 0) {
                        goto label_90;
                    }

                    v3 = this.mItems.get(v5);
                    while(v9 < ((ItemInfo)v3).position) {
                        if(v5 <= 0) {
                            break;
                        }

                        --v5;
                        v3 = this.mItems.get(v5);
                    }

                    while(v9 > ((ItemInfo)v3).position) {
                        v7 -= this.mAdapter.getPageWidth(v9) + v6;
                        --v9;
                    }

                    v7 -= ((ItemInfo)v3).widthFactor + v6;
                    ((ItemInfo)v3).offset = v7;
                }
            }
        }

    label_90:
        int v4 = this.mItems.size();
        v7 = curItem.offset;
        v9 = curItem.position - 1;
        if(curItem.position == 0) {
            v12 = curItem.offset;
        }
        else {
            v12 = -340282346638528860000000000000000000000f;
        }

        this.mFirstOffset = v12;
        if(curItem.position == v1 - 1) {
            v12 = curItem.offset + curItem.widthFactor - 1f;
        }
        else {
            v12 = 340282346638528860000000000000000000000f;
        }

        this.mLastOffset = v12;
        int v2 = curIndex - 1;
        while(v2 >= 0) {
            v3 = this.mItems.get(v2);
            while(v9 > ((ItemInfo)v3).position) {
                v7 -= this.mAdapter.getPageWidth(v9) + v6;
                --v9;
            }

            v7 -= ((ItemInfo)v3).widthFactor + v6;
            ((ItemInfo)v3).offset = v7;
            if(((ItemInfo)v3).position == 0) {
                this.mFirstOffset = v7;
            }

            --v2;
            --v9;
        }

        v7 = curItem.offset + curItem.widthFactor + v6;
        v9 = curItem.position + 1;
        v2 = curIndex + 1;
        while(v2 < v4) {
            v3 = this.mItems.get(v2);
            while(v9 < ((ItemInfo)v3).position) {
                v7 += this.mAdapter.getPageWidth(v9) + v6;
                ++v9;
            }

            if(((ItemInfo)v3).position == v1 - 1) {
                this.mLastOffset = ((ItemInfo)v3).widthFactor + v7 - 1f;
            }

            ((ItemInfo)v3).offset = v7;
            v7 += ((ItemInfo)v3).widthFactor + v6;
            ++v2;
            ++v9;
        }

        this.mNeedCalculatePageOffsets = false;
    }

    protected boolean canScroll(View v, boolean checkV, int dx, int x, int y) {
        boolean v0;
        if((v instanceof ViewGroup)) {
            View v7 = v;
            int v9 = v.getScrollX();
            int v10 = v.getScrollY();
            int v8 = ((ViewGroup)v7).getChildCount() - 1;
            while(true) {
                if(v8 >= 0) {
                    View v1 = ((ViewGroup)v7).getChildAt(v8);
                    if(x + v9 >= v1.getLeft() && x + v9 < v1.getRight() && y + v10 >= v1.getTop() && y + v10 < v1.getBottom() && (this.canScroll(v1, true, dx, x + v9 - v1.getLeft(), y + v10 - v1.getTop()))) {
                        v0 = true;
                        break;
                    }

                    --v8;
                    continue;
                }
                else {
                    goto label_36;
                }
            }
        }
        else {
        label_36:
            if((checkV) && (ViewCompat.canScrollHorizontally(v, -dx))) {
                v0 = true;
                goto label_33;
            }

            v0 = false;
        }

    label_33:
        return v0;
    }

    protected boolean checkLayoutParams(ViewGroup$LayoutParams p) {
        boolean v0;
        if(!(p instanceof LayoutParams) || !super.checkLayoutParams(p)) {
            v0 = false;
        }
        else {
            v0 = true;
        }

        return v0;
    }

    private void completeScroll(boolean postEvents) {
        int v2;
        if(this.mScrollState == 2) {
            v2 = 1;
        }
        else {
            v2 = 0;
        }

        if(v2 != 0) {
            this.setScrollingCacheEnabled(false);
            this.mScroller.abortAnimation();
            int v3 = this.getScrollX();
            int v4 = this.getScrollY();
            int v5 = this.mScroller.getCurrX();
            int v6 = this.mScroller.getCurrY();
            if(v3 == v5 && v4 == v6) {
                goto label_18;
            }

            this.scrollTo(v5, v6);
        }

    label_18:
        this.mPopulatePending = false;
        int v0;
        for(v0 = 0; v0 < this.mItems.size(); ++v0) {
            Object v1 = this.mItems.get(v0);
            if(((ItemInfo)v1).scrolling) {
                v2 = 1;
                ((ItemInfo)v1).scrolling = false;
            }
        }

        if(v2 != 0) {
            if(postEvents) {
                ViewCompat.postOnAnimation(((View)this), this.mEndScrollRunnable);
            }
            else {
                this.mEndScrollRunnable.run();
            }
        }
    }

    public void computeScroll() {
        if((this.mScroller.isFinished()) || !this.mScroller.computeScrollOffset()) {
            this.completeScroll(true);
        }
        else {
            int v0 = this.getScrollX();
            int v1 = this.getScrollY();
            int v2 = this.mScroller.getCurrX();
            int v3 = this.mScroller.getCurrY();
            if(v0 != v2 || v1 != v3) {
                this.scrollTo(v2, v3);
                if(!this.pageScrolled(v2)) {
                    this.mScroller.abortAnimation();
                    this.scrollTo(0, v3);
                }
            }

            ViewCompat.postInvalidateOnAnimation(((View)this));
        }
    }

    void dataSetChanged() {
        int v7;
        int v0 = this.mAdapter.getCount();
        this.mExpectedAdapterCount = v0;
        if(this.mItems.size() >= this.mOffscreenPageLimit * 2 + 1 || this.mItems.size() >= v0) {
            v7 = 0;
        }
        else {
            v7 = 1;
        }

        int v8 = this.mCurItem;
        int v5 = 0;
        int v3;
        for(v3 = 0; v3 < this.mItems.size(); ++v3) {
            Object v4 = this.mItems.get(v3);
            int v9 = this.mAdapter.getItemPosition(((ItemInfo)v4).object);
            if(v9 != -1) {
                if(v9 == -2) {
                    this.mItems.remove(v3);
                    --v3;
                    if(v5 == 0) {
                        this.mAdapter.startUpdate(((ViewGroup)this));
                        v5 = 1;
                    }

                    this.mAdapter.destroyItem(((ViewGroup)this), ((ItemInfo)v4).position, ((ItemInfo)v4).object);
                    v7 = 1;
                    if(this.mCurItem != ((ItemInfo)v4).position) {
                        goto label_28;
                    }

                    v8 = Math.max(0, Math.min(this.mCurItem, v0 - 1));
                    v7 = 1;
                }
                else {
                    if(((ItemInfo)v4).position == v9) {
                        goto label_28;
                    }

                    if(((ItemInfo)v4).position == this.mCurItem) {
                        v8 = v9;
                    }

                    ((ItemInfo)v4).position = v9;
                    v7 = 1;
                }
            }

        label_28:
        }

        if(v5 != 0) {
            this.mAdapter.finishUpdate(((ViewGroup)this));
        }

        Collections.sort(this.mItems, ViewPager.COMPARATOR);
        if(v7 != 0) {
            int v2 = this.getChildCount();
            for(v3 = 0; v3 < v2; ++v3) {
                ViewGroup$LayoutParams v6 = this.getChildAt(v3).getLayoutParams();
                if(!((LayoutParams)v6).isDecor) {
                    ((LayoutParams)v6).widthFactor = 0f;
                }
            }

            this.setCurrentItemInternal(v8, false, true);
            this.requestLayout();
        }
    }

    private int determineTargetPage(int currentPage, float pageOffset, int velocity, int deltaX) {
        int v2;
        float v3;
        if(Math.abs(deltaX) <= this.mFlingDistance || Math.abs(velocity) <= this.mMinimumVelocity) {
            if(currentPage >= this.mCurItem) {
                v3 = 0.4f;
            }
            else {
                v3 = 0.6f;
            }

            v2 = ((int)((((float)currentPage)) + pageOffset + v3));
        }
        else if(velocity > 0) {
            v2 = currentPage;
        }
        else {
            v2 = currentPage + 1;
        }

        if(this.mItems.size() > 0) {
            v2 = Math.max(this.mItems.get(0).position, Math.min(v2, this.mItems.get(this.mItems.size() - 1).position));
        }

        return v2;
    }

    public boolean dispatchKeyEvent(KeyEvent event) {
        boolean v0;
        if((super.dispatchKeyEvent(event)) || (this.executeKeyEvent(event))) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    public boolean dispatchPopulateAccessibilityEvent(AccessibilityEvent event) {
        boolean v4;
        int v1 = this.getChildCount();
        int v2;
        for(v2 = 0; v2 < v1; ++v2) {
            View v0 = this.getChildAt(v2);
            if(v0.getVisibility() == 0) {
                ItemInfo v3 = this.infoForChild(v0);
                if(v3 != null && v3.position == this.mCurItem && (v0.dispatchPopulateAccessibilityEvent(event))) {
                    v4 = true;
                    goto label_14;
                }
            }
        }

        v4 = false;
    label_14:
        return v4;
    }

    float distanceInfluenceForSnapDuration(float f) {
        return ((float)Math.sin(((double)(((float)((((double)(f - 0.5f))) * 0.471239))))));
    }

    public void draw(Canvas canvas) {
        int v4;
        int v0;
        int v3;
        super.draw(canvas);
        int v1 = 0;
        int v2 = ViewCompat.getOverScrollMode(((View)this));
        if(v2 != 0) {
            if(v2 == 1 && this.mAdapter != null && this.mAdapter.getCount() > 1) {
                goto label_11;
            }

            this.mLeftEdge.finish();
            this.mRightEdge.finish();
        }
        else {
        label_11:
            if(!this.mLeftEdge.isFinished()) {
                v3 = canvas.save();
                v0 = this.getHeight() - this.getPaddingTop() - this.getPaddingBottom();
                v4 = this.getWidth();
                canvas.rotate(270f);
                canvas.translate(((float)(-v0 + this.getPaddingTop())), this.mFirstOffset * (((float)v4)));
                this.mLeftEdge.setSize(v0, v4);
                v1 = 0 | this.mLeftEdge.draw(canvas);
                canvas.restoreToCount(v3);
            }

            if(this.mRightEdge.isFinished()) {
                goto label_65;
            }

            v3 = canvas.save();
            v4 = this.getWidth();
            v0 = this.getHeight() - this.getPaddingTop() - this.getPaddingBottom();
            canvas.rotate(90f);
            canvas.translate(((float)(-this.getPaddingTop())), -(this.mLastOffset + 1f) * (((float)v4)));
            this.mRightEdge.setSize(v0, v4);
            v1 |= this.mRightEdge.draw(canvas);
            canvas.restoreToCount(v3);
        }

    label_65:
        if(v1 != 0) {
            ViewCompat.postInvalidateOnAnimation(((View)this));
        }
    }

    protected void drawableStateChanged() {
        super.drawableStateChanged();
        Drawable v0 = this.mMarginDrawable;
        if(v0 != null && (v0.isStateful())) {
            v0.setState(this.getDrawableState());
        }
    }

    private void enableLayers(boolean enable) {
        int v2;
        int v0 = this.getChildCount();
        int v1;
        for(v1 = 0; v1 < v0; ++v1) {
            if(enable) {
                v2 = 2;
            }
            else {
                v2 = 0;
            }

            ViewCompat.setLayerType(this.getChildAt(v1), v2, null);
        }
    }

    private void endDrag() {
        this.mIsBeingDragged = false;
        this.mIsUnableToDrag = false;
        if(this.mVelocityTracker != null) {
            this.mVelocityTracker.recycle();
            this.mVelocityTracker = null;
        }
    }

    public boolean executeKeyEvent(KeyEvent event) {
        boolean v0 = false;
        if(event.getAction() == 0) {
            switch(event.getKeyCode()) {
                case 21: {
                    goto label_7;
                }
                case 22: {
                    goto label_10;
                }
                case 61: {
                    goto label_13;
                }
            }

            goto label_6;
        label_7:
            v0 = this.arrowScroll(17);
            goto label_6;
        label_10:
            v0 = this.arrowScroll(66);
            goto label_6;
        label_13:
            if(Build$VERSION.SDK_INT >= 11) {
                if(KeyEventCompat.hasNoModifiers(event)) {
                    v0 = this.arrowScroll(2);
                }
                else if(KeyEventCompat.hasModifiers(event, 1)) {
                    v0 = this.arrowScroll(1);
                }
            }
        }

    label_6:
        return v0;
    }

    protected ViewGroup$LayoutParams generateDefaultLayoutParams() {
        return new LayoutParams();
    }

    protected ViewGroup$LayoutParams generateLayoutParams(ViewGroup$LayoutParams p) {
        return this.generateDefaultLayoutParams();
    }

    public ViewGroup$LayoutParams generateLayoutParams(AttributeSet attrs) {
        return new LayoutParams(this.getContext(), attrs);
    }

    public PagerAdapter getAdapter() {
        return this.mAdapter;
    }

    protected int getChildDrawingOrder(int childCount, int i) {
        int v0;
        if(this.mDrawingOrder == 2) {
            v0 = childCount - 1 - i;
        }
        else {
            v0 = i;
        }

        return this.mDrawingOrderedChildren.get(v0).getLayoutParams().childIndex;
    }

    private Rect getChildRectInPagerCoordinates(Rect outRect, View child) {
        if(outRect == null) {
            outRect = new Rect();
        }

        if(child == null) {
            outRect.set(0, 0, 0, 0);
        }
        else {
            outRect.left = child.getLeft();
            outRect.right = child.getRight();
            outRect.top = child.getTop();
            outRect.bottom = child.getBottom();
            ViewParent v1 = child.getParent();
            while((v1 instanceof ViewGroup)) {
                if((((ViewPager)v1)) == this) {
                    break;
                }

                outRect.left += v1.getLeft();
                outRect.right += v1.getRight();
                outRect.top += v1.getTop();
                outRect.bottom += v1.getBottom();
                v1 = v1.getParent();
            }
        }

        return outRect;
    }

    private int getClientWidth() {
        return this.getMeasuredWidth() - this.getPaddingLeft() - this.getPaddingRight();
    }

    public int getCurrentItem() {
        return this.mCurItem;
    }

    ItemInfo infoForAnyChild(View child) {
        ViewParent v3;
        while(true) {
            ViewParent v0 = child.getParent();
            if((((ViewPager)v0)) != this) {
                if(v0 != null && ((v0 instanceof View))) {
                    v3 = v0;
                    continue;
                }

                break;
            }
            else {
                goto label_9;
            }
        }

        ItemInfo v1 = null;
        goto label_6;
    label_9:
        v1 = this.infoForChild(((View)v3));
    label_6:
        return v1;
    }

    ItemInfo infoForChild(View child) {
        int v0 = 0;
        while(true) {
            if(v0 < this.mItems.size()) {
                Object v1 = this.mItems.get(v0);
                if(!this.mAdapter.isViewFromObject(child, ((ItemInfo)v1).object)) {
                    ++v0;
                    continue;
                }
            }
            else {
                break;
            }

            goto label_10;
        }

        ItemInfo v1_1 = null;
    label_10:
        return v1_1;
    }

    private ItemInfo infoForCurrentScrollPosition() {
        Object v3_1;
        ItemInfo v2_1;
        float v11;
        float v8 = 0f;
        int v12 = this.getClientWidth();
        if(v12 > 0) {
            v11 = (((float)this.getScrollX())) / (((float)v12));
        }
        else {
            v11 = 0f;
        }

        if(v12 > 0) {
            v8 = (((float)this.mPageMargin)) / (((float)v12));
        }

        int v5 = -1;
        float v4 = 0f;
        float v6 = 0f;
        int v0 = 1;
        ItemInfo v3 = null;
        int v1 = 0;
        while(true) {
            if(v1 < this.mItems.size()) {
                Object v2 = this.mItems.get(v1);
                if(v0 == 0 && ((ItemInfo)v2).position != v5 + 1) {
                    v2_1 = this.mTempItem;
                    v2_1.offset = v4 + v6 + v8;
                    v2_1.position = v5 + 1;
                    v2_1.widthFactor = this.mAdapter.getPageWidth(v2_1.position);
                    --v1;
                }

                float v9 = v2_1.offset;
                float v7 = v9;
                float v10 = v2_1.widthFactor + v9 + v8;
                if(v0 == 0 && v11 < v7) {
                    goto label_51;
                }

                if(v11 >= v10 && v1 != this.mItems.size() - 1) {
                    v0 = 0;
                    v5 = v2_1.position;
                    v4 = v9;
                    v6 = v2_1.widthFactor;
                    v3_1 = v2_1;
                    ++v1;
                    continue;
                }

                break;
            }

            goto label_51;
        }

        v3_1 = v2_1;
    label_51:
        return v3;
    }

    ItemInfo infoForPosition(int position) {
        Object v1;
        int v0 = 0;
        while(true) {
            if(v0 < this.mItems.size()) {
                v1 = this.mItems.get(v0);
                if(((ItemInfo)v1).position != position) {
                    ++v0;
                    continue;
                }
            }
            else {
                break;
            }

            goto label_8;
        }

        ItemInfo v1_1 = null;
    label_8:
        return ((ItemInfo)v1);
    }

    void initViewPager() {
        this.setWillNotDraw(false);
        this.setDescendantFocusability(262144);
        this.setFocusable(true);
        Context v1 = this.getContext();
        this.mScroller = new Scroller(v1, ViewPager.sInterpolator);
        ViewConfiguration v0 = ViewConfiguration.get(v1);
        float v2 = v1.getResources().getDisplayMetrics().density;
        this.mTouchSlop = ViewConfigurationCompat.getScaledPagingTouchSlop(v0);
        this.mMinimumVelocity = ((int)(400f * v2));
        this.mMaximumVelocity = v0.getScaledMaximumFlingVelocity();
        this.mLeftEdge = new EdgeEffectCompat(v1);
        this.mRightEdge = new EdgeEffectCompat(v1);
        this.mFlingDistance = ((int)(25f * v2));
        this.mCloseEnough = ((int)(2f * v2));
        this.mDefaultGutterSize = ((int)(16f * v2));
        ViewCompat.setAccessibilityDelegate(((View)this), new MyAccessibilityDelegate(this));
        if(ViewCompat.getImportantForAccessibility(((View)this)) == 0) {
            ViewCompat.setImportantForAccessibility(((View)this), 1);
        }
    }

    private boolean isGutterDrag(float x, float dx) {
        boolean v0;
        if(x >= (((float)this.mGutterSize)) || dx <= 0f) {
            if(x > (((float)(this.getWidth() - this.mGutterSize))) && dx < 0f) {
            label_11:
                v0 = true;
                goto label_12;
            }

            v0 = false;
        }
        else {
            goto label_11;
        }

    label_12:
        return v0;
    }

    protected void onAttachedToWindow() {
        super.onAttachedToWindow();
        this.mFirstLayout = true;
    }

    protected void onDetachedFromWindow() {
        this.removeCallbacks(this.mEndScrollRunnable);
        super.onDetachedFromWindow();
    }

    protected void onDraw(Canvas canvas) {
        float v1;
        super.onDraw(canvas);
        if(this.mPageMargin > 0 && this.mMarginDrawable != null && this.mItems.size() > 0 && this.mAdapter != null) {
            int v10 = this.getScrollX();
            int v11 = this.getWidth();
            float v7 = (((float)this.mPageMargin)) / (((float)v11));
            int v5 = 0;
            Object v3 = this.mItems.get(0);
            float v8 = ((ItemInfo)v3).offset;
            int v4 = this.mItems.size();
            int v2 = ((ItemInfo)v3).position;
            int v6 = this.mItems.get(v4 - 1).position;
            int v9;
            for(v9 = v2; v9 < v6; ++v9) {
                while(v9 > ((ItemInfo)v3).position) {
                    if(v5 >= v4) {
                        break;
                    }

                    ++v5;
                    v3 = this.mItems.get(v5);
                }

                if(v9 == ((ItemInfo)v3).position) {
                    v1 = (((ItemInfo)v3).offset + ((ItemInfo)v3).widthFactor) * (((float)v11));
                    v8 = ((ItemInfo)v3).offset + ((ItemInfo)v3).widthFactor + v7;
                }
                else {
                    float v12 = this.mAdapter.getPageWidth(v9);
                    v1 = (v8 + v12) * (((float)v11));
                    v8 += v12 + v7;
                }

                if((((float)this.mPageMargin)) + v1 > (((float)v10))) {
                    this.mMarginDrawable.setBounds(((int)v1), this.mTopPageBounds, ((int)((((float)this.mPageMargin)) + v1 + 0.5f)), this.mBottomPageBounds);
                    this.mMarginDrawable.draw(canvas);
                }

                if(v1 <= (((float)(v10 + v11)))) {
                    goto label_101;
                }

                return;
            label_101:
            }
        }
    }

    public boolean onInterceptTouchEvent(MotionEvent ev) {
        float v0_1;
        boolean v0;
        int v6 = ev.getAction() & 255;
        if(v6 == 3 || v6 == 1) {
            this.mIsBeingDragged = false;
            this.mIsUnableToDrag = false;
            this.mActivePointerId = -1;
            if(this.mVelocityTracker != null) {
                this.mVelocityTracker.recycle();
                this.mVelocityTracker = null;
            }

            v0 = false;
        }
        else {
            if(v6 != 0) {
                if(this.mIsBeingDragged) {
                    v0 = true;
                    goto label_19;
                }
                else if(this.mIsUnableToDrag) {
                    v0 = false;
                    goto label_19;
                }
            }

            switch(v6) {
                case 0: {
                    v0_1 = ev.getX();
                    this.mInitialMotionX = v0_1;
                    this.mLastMotionX = v0_1;
                    v0_1 = ev.getY();
                    this.mInitialMotionY = v0_1;
                    this.mLastMotionY = v0_1;
                    this.mActivePointerId = MotionEventCompat.getPointerId(ev, 0);
                    this.mIsUnableToDrag = false;
                    this.mScroller.computeScrollOffset();
                    if(this.mScrollState == 2 && Math.abs(this.mScroller.getFinalX() - this.mScroller.getCurrX()) > this.mCloseEnough) {
                        this.mScroller.abortAnimation();
                        this.mPopulatePending = false;
                        this.populate();
                        this.mIsBeingDragged = true;
                        this.setScrollState(1);
                        goto label_30;
                    }

                    this.completeScroll(false);
                    this.mIsBeingDragged = false;
                    break;
                }
                case 2: {
                    int v7 = this.mActivePointerId;
                    if(v7 == -1) {
                        goto label_30;
                    }

                    int v9 = MotionEventCompat.findPointerIndex(ev, v7);
                    float v10 = MotionEventCompat.getX(ev, v9);
                    float v8 = v10 - this.mLastMotionX;
                    float v11 = Math.abs(v8);
                    float v12 = MotionEventCompat.getY(ev, v9);
                    float v13 = Math.abs(v12 - this.mInitialMotionY);
                    if(v8 != 0f && !this.isGutterDrag(this.mLastMotionX, v8) && (this.canScroll(this, false, ((int)v8), ((int)v10), ((int)v12)))) {
                        this.mLastMotionX = v10;
                        this.mLastMotionY = v12;
                        this.mIsUnableToDrag = true;
                        v0 = false;
                        goto label_19;
                    }

                    if(v11 <= (((float)this.mTouchSlop)) || 0.5f * v11 <= v13) {
                        if(v13 <= (((float)this.mTouchSlop))) {
                            goto label_89;
                        }

                        this.mIsUnableToDrag = true;
                    }
                    else {
                        this.mIsBeingDragged = true;
                        this.setScrollState(1);
                        if(v8 > 0f) {
                            v0_1 = this.mInitialMotionX + (((float)this.mTouchSlop));
                        }
                        else {
                            v0_1 = this.mInitialMotionX - (((float)this.mTouchSlop));
                        }

                        this.mLastMotionX = v0_1;
                        this.mLastMotionY = v12;
                        this.setScrollingCacheEnabled(true);
                    }

                label_89:
                    if(!this.mIsBeingDragged) {
                        goto label_30;
                    }

                    if(!this.performDrag(v10)) {
                        goto label_30;
                    }

                    ViewCompat.postInvalidateOnAnimation(((View)this));
                    break;
                }
                case 6: {
                    this.onSecondaryPointerUp(ev);
                    break;
                }
            }

        label_30:
            if(this.mVelocityTracker == null) {
                this.mVelocityTracker = VelocityTracker.obtain();
            }

            this.mVelocityTracker.addMovement(ev);
            v0 = this.mIsBeingDragged;
        }

    label_19:
        return v0;
    }

    protected void onLayout(boolean changed, int l, int t, int r, int b) {
        int v7;
        int v6;
        ViewGroup$LayoutParams v17;
        View v5;
        int v9 = this.getChildCount();
        int v24 = r - l;
        int v11 = b - t;
        int v19 = this.getPaddingLeft();
        int v21 = this.getPaddingTop();
        int v20 = this.getPaddingRight();
        int v18 = this.getPaddingBottom();
        int v22 = this.getScrollX();
        int v10 = 0;
        int v14;
        for(v14 = 0; v14 < v9; ++v14) {
            v5 = this.getChildAt(v14);
            if(v5.getVisibility() != 8) {
                v17 = v5.getLayoutParams();
                if(v17.isDecor) {
                    int v13 = v17.gravity & 7;
                    int v23 = v17.gravity & 112;
                    switch(v13) {
                        case 1: {
                            v6 = Math.max((v24 - v5.getMeasuredWidth()) / 2, v19);
                            break;
                        }
                        case 3: {
                            v6 = v19;
                            v19 += v5.getMeasuredWidth();
                            break;
                        }
                        case 5: {
                            v6 = v24 - v20 - v5.getMeasuredWidth();
                            v20 += v5.getMeasuredWidth();
                            break;
                        }
                        default: {
                            v6 = v19;
                            break;
                        }
                    }

                    switch(v23) {
                        case 16: {
                            v7 = Math.max((v11 - v5.getMeasuredHeight()) / 2, v21);
                            break;
                        }
                        case 48: {
                            v7 = v21;
                            v21 += v5.getMeasuredHeight();
                            break;
                        }
                        case 80: {
                            v7 = v11 - v18 - v5.getMeasuredHeight();
                            v18 += v5.getMeasuredHeight();
                            break;
                        }
                        default: {
                            v7 = v21;
                            break;
                        }
                    }

                    v6 += v22;
                    v5.layout(v6, v7, v5.getMeasuredWidth() + v6, v5.getMeasuredHeight() + v7);
                    ++v10;
                }
            }
        }

        int v8 = v24 - v19 - v20;
        for(v14 = 0; v14 < v9; ++v14) {
            v5 = this.getChildAt(v14);
            if(v5.getVisibility() != 8) {
                v17 = v5.getLayoutParams();
                if(!v17.isDecor) {
                    ItemInfo v15 = this.infoForChild(v5);
                    if(v15 != null) {
                        v6 = v19 + (((int)((((float)v8)) * v15.offset)));
                        v7 = v21;
                        if(v17.needsMeasure) {
                            v17.needsMeasure = false;
                            v5.measure(View$MeasureSpec.makeMeasureSpec(((int)((((float)v8)) * v17.widthFactor)), 1073741824), View$MeasureSpec.makeMeasureSpec(v11 - v21 - v18, 1073741824));
                        }

                        v5.layout(v6, v7, v5.getMeasuredWidth() + v6, v5.getMeasuredHeight() + v7);
                    }
                }
            }
        }

        this.mTopPageBounds = v21;
        this.mBottomPageBounds = v11 - v18;
        this.mDecorChildCount = v10;
        if(this.mFirstLayout) {
            this.scrollToItem(this.mCurItem, false, 0, false);
        }

        this.mFirstLayout = false;
    }

    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        int v6;
        int v7;
        ViewGroup$LayoutParams v13;
        View v3;
        this.setMeasuredDimension(ViewPager.getDefaultSize(0, widthMeasureSpec), ViewPager.getDefaultSize(0, heightMeasureSpec));
        int v15 = this.getMeasuredWidth();
        this.mGutterSize = Math.min(v15 / 10, this.mDefaultGutterSize);
        int v5 = v15 - this.getPaddingLeft() - this.getPaddingRight();
        int v4 = this.getMeasuredHeight() - this.getPaddingTop() - this.getPaddingBottom();
        int v16 = this.getChildCount();
        int v12;
        for(v12 = 0; v12 < v16; ++v12) {
            v3 = this.getChildAt(v12);
            if(v3.getVisibility() != 8) {
                v13 = v3.getLayoutParams();
                if(v13 != null && (((LayoutParams)v13).isDecor)) {
                    int v11 = ((LayoutParams)v13).gravity & 7;
                    int v17 = ((LayoutParams)v13).gravity & 112;
                    int v18 = -2147483648;
                    int v8 = -2147483648;
                    if(v17 == 48 || v17 == 80) {
                        v7 = 1;
                    }
                    else {
                        v7 = 0;
                    }

                    if(v11 == 3 || v11 == 5) {
                        v6 = 1;
                    }
                    else {
                        v6 = 0;
                    }

                    if(v7 != 0) {
                        v18 = 1073741824;
                    }
                    else if(v6 != 0) {
                        v8 = 1073741824;
                    }

                    int v19 = v5;
                    int v9 = v4;
                    if(((LayoutParams)v13).width != -2) {
                        v18 = 1073741824;
                        if(((LayoutParams)v13).width != -1) {
                            v19 = ((LayoutParams)v13).width;
                        }
                    }

                    if(((LayoutParams)v13).height != -2) {
                        v8 = 1073741824;
                        if(((LayoutParams)v13).height != -1) {
                            v9 = ((LayoutParams)v13).height;
                        }
                    }

                    v3.measure(View$MeasureSpec.makeMeasureSpec(v19, v18), View$MeasureSpec.makeMeasureSpec(v9, v8));
                    if(v7 == 0) {
                        goto label_122;
                    }

                    v4 -= v3.getMeasuredHeight();
                    goto label_113;
                label_122:
                    if(v6 == 0) {
                        goto label_113;
                    }

                    v5 -= v3.getMeasuredWidth();
                }
            }

        label_113:
        }

        this.mChildWidthMeasureSpec = View$MeasureSpec.makeMeasureSpec(v5, 1073741824);
        this.mChildHeightMeasureSpec = View$MeasureSpec.makeMeasureSpec(v4, 1073741824);
        this.mInLayout = true;
        this.populate();
        this.mInLayout = false;
        v16 = this.getChildCount();
        for(v12 = 0; v12 < v16; ++v12) {
            v3 = this.getChildAt(v12);
            if(v3.getVisibility() != 8) {
                v13 = v3.getLayoutParams();
                if(v13 != null && (((LayoutParams)v13).isDecor)) {
                    goto label_179;
                }

                v3.measure(View$MeasureSpec.makeMeasureSpec(((int)((((float)v5)) * ((LayoutParams)v13).widthFactor)), 1073741824), this.mChildHeightMeasureSpec);
            }

        label_179:
        }
    }

    protected void onPageScrolled(int position, float offset, int offsetPixels) {
        int v5;
        View v3;
        int v4;
        int v12;
        if(this.mDecorChildCount > 0) {
            v12 = this.getScrollX();
            int v10 = this.getPaddingLeft();
            int v11 = this.getPaddingRight();
            int v14 = this.getWidth();
            v4 = this.getChildCount();
            int v8;
            for(v8 = 0; v8 < v4; ++v8) {
                v3 = this.getChildAt(v8);
                ViewGroup$LayoutParams v9 = v3.getLayoutParams();
                if(((LayoutParams)v9).isDecor) {
                    switch(((LayoutParams)v9).gravity & 7) {
                        case 1: {
                            v5 = Math.max((v14 - v3.getMeasuredWidth()) / 2, v10);
                            break;
                        }
                        case 3: {
                            v5 = v10;
                            v10 += v3.getWidth();
                            break;
                        }
                        case 5: {
                            v5 = v14 - v11 - v3.getMeasuredWidth();
                            v11 += v3.getMeasuredWidth();
                            break;
                        }
                        default: {
                            v5 = v10;
                            break;
                        }
                    }

                    int v6 = v5 + v12 - v3.getLeft();
                    if(v6 != 0) {
                        v3.offsetLeftAndRight(v6);
                    }
                }
            }
        }

        if(this.mOnPageChangeListener != null) {
            this.mOnPageChangeListener.onPageScrolled(position, offset, offsetPixels);
        }

        if(this.mInternalPageChangeListener != null) {
            this.mInternalPageChangeListener.onPageScrolled(position, offset, offsetPixels);
        }

        if(this.mPageTransformer != null) {
            v12 = this.getScrollX();
            v4 = this.getChildCount();
            for(v8 = 0; v8 < v4; ++v8) {
                v3 = this.getChildAt(v8);
                if(!v3.getLayoutParams().isDecor) {
                    this.mPageTransformer.transformPage(v3, (((float)(v3.getLeft() - v12))) / (((float)this.getClientWidth())));
                }
            }
        }

        this.mCalledSuper = true;
    }

    protected boolean onRequestFocusInDescendants(int direction, Rect previouslyFocusedRect) {
        boolean v7;
        int v2;
        int v5;
        int v6;
        int v1 = this.getChildCount();
        if((direction & 2) != 0) {
            v6 = 0;
            v5 = 1;
            v2 = v1;
        }
        else {
            v6 = v1 - 1;
            v5 = -1;
            v2 = -1;
        }

        int v3;
        for(v3 = v6; v3 != v2; v3 += v5) {
            View v0 = this.getChildAt(v3);
            if(v0.getVisibility() == 0) {
                ItemInfo v4 = this.infoForChild(v0);
                if(v4 != null && v4.position == this.mCurItem && (v0.requestFocus(direction, previouslyFocusedRect))) {
                    v7 = true;
                    goto label_19;
                }
            }
        }

        v7 = false;
    label_19:
        return v7;
    }

    public void onRestoreInstanceState(Parcelable state) {
        if(!(state instanceof SavedState)) {
            super.onRestoreInstanceState(state);
        }
        else {
            Parcelable v0 = state;
            super.onRestoreInstanceState(((SavedState)v0).getSuperState());
            if(this.mAdapter != null) {
                this.mAdapter.restoreState(((SavedState)v0).adapterState, ((SavedState)v0).loader);
                this.setCurrentItemInternal(((SavedState)v0).position, false, true);
            }
            else {
                this.mRestoredCurItem = ((SavedState)v0).position;
                this.mRestoredAdapterState = ((SavedState)v0).adapterState;
                this.mRestoredClassLoader = ((SavedState)v0).loader;
            }
        }
    }

    public Parcelable onSaveInstanceState() {
        SavedState v0 = new SavedState(super.onSaveInstanceState());
        v0.position = this.mCurItem;
        if(this.mAdapter != null) {
            v0.adapterState = this.mAdapter.saveState();
        }

        return ((Parcelable)v0);
    }

    private void onSecondaryPointerUp(MotionEvent ev) {
        int v0;
        int v2 = MotionEventCompat.getActionIndex(ev);
        if(MotionEventCompat.getPointerId(ev, v2) == this.mActivePointerId) {
            if(v2 == 0) {
                v0 = 1;
            }
            else {
                v0 = 0;
            }

            this.mLastMotionX = MotionEventCompat.getX(ev, v0);
            this.mActivePointerId = MotionEventCompat.getPointerId(ev, v0);
            if(this.mVelocityTracker == null) {
                return;
            }

            this.mVelocityTracker.clear();
        }
    }

    protected void onSizeChanged(int w, int h, int oldw, int oldh) {
        super.onSizeChanged(w, h, oldw, oldh);
        if(w != oldw) {
            this.recomputeScrollPosition(w, oldw, this.mPageMargin, this.mPageMargin);
        }
    }

    public boolean onTouchEvent(MotionEvent ev) {
        float v23_1;
        boolean v23;
        if(this.mFakeDragging) {
            v23 = true;
        }
        else {
            if(ev.getAction() == 0 && ev.getEdgeFlags() != 0) {
                v23 = false;
                goto label_5;
            }

            if(this.mAdapter != null && this.mAdapter.getCount() != 0) {
                if(this.mVelocityTracker == null) {
                    this.mVelocityTracker = VelocityTracker.obtain();
                }

                this.mVelocityTracker.addMovement(ev);
                int v11 = 0;
                switch(ev.getAction() & 255) {
                    case 0: {
                        this.mScroller.abortAnimation();
                        this.mPopulatePending = false;
                        this.populate();
                        this.mIsBeingDragged = true;
                        this.setScrollState(1);
                        v23_1 = ev.getX();
                        this.mInitialMotionX = v23_1;
                        this.mLastMotionX = v23_1;
                        v23_1 = ev.getY();
                        this.mInitialMotionY = v23_1;
                        this.mLastMotionY = v23_1;
                        this.mActivePointerId = MotionEventCompat.getPointerId(ev, 0);
                        break;
                    }
                    case 1: {
                        if(!this.mIsBeingDragged) {
                            goto label_42;
                        }

                        VelocityTracker v17 = this.mVelocityTracker;
                        v17.computeCurrentVelocity(1000, ((float)this.mMaximumVelocity));
                        int v10 = ((int)VelocityTrackerCompat.getXVelocity(v17, this.mActivePointerId));
                        this.mPopulatePending = true;
                        int v18 = this.getClientWidth();
                        int v15 = this.getScrollX();
                        ItemInfo v8 = this.infoForCurrentScrollPosition();
                        this.setCurrentItemInternal(this.determineTargetPage(v8.position, ((((float)v15)) / (((float)v18)) - v8.offset) / v8.widthFactor, v10, ((int)(MotionEventCompat.getX(ev, MotionEventCompat.findPointerIndex(ev, this.mActivePointerId)) - this.mInitialMotionX))), true, true, v10);
                        this.mActivePointerId = -1;
                        this.endDrag();
                        v11 = this.mLeftEdge.onRelease() | this.mRightEdge.onRelease();
                        break;
                    }
                    case 2: {
                        if(!this.mIsBeingDragged) {
                            int v14 = MotionEventCompat.findPointerIndex(ev, this.mActivePointerId);
                            float v19 = MotionEventCompat.getX(ev, v14);
                            float v20 = Math.abs(v19 - this.mLastMotionX);
                            float v21 = MotionEventCompat.getY(ev, v14);
                            float v22 = Math.abs(v21 - this.mLastMotionY);
                            if(v20 > (((float)this.mTouchSlop)) && v20 > v22) {
                                this.mIsBeingDragged = true;
                                if(v19 - this.mInitialMotionX > 0f) {
                                    v23_1 = this.mInitialMotionX + (((float)this.mTouchSlop));
                                }
                                else {
                                    v23_1 = this.mInitialMotionX - (((float)this.mTouchSlop));
                                }

                                this.mLastMotionX = v23_1;
                                this.mLastMotionY = v21;
                                this.setScrollState(1);
                                this.setScrollingCacheEnabled(true);
                            }
                        }

                        if(!this.mIsBeingDragged) {
                            goto label_42;
                        }

                        v11 = 0 | this.performDrag(MotionEventCompat.getX(ev, MotionEventCompat.findPointerIndex(ev, this.mActivePointerId)));
                        break;
                    }
                    case 3: {
                        if(!this.mIsBeingDragged) {
                            goto label_42;
                        }

                        this.scrollToItem(this.mCurItem, true, 0, false);
                        this.mActivePointerId = -1;
                        this.endDrag();
                        v11 = this.mLeftEdge.onRelease() | this.mRightEdge.onRelease();
                        break;
                    }
                    case 5: {
                        int v9 = MotionEventCompat.getActionIndex(ev);
                        this.mLastMotionX = MotionEventCompat.getX(ev, v9);
                        this.mActivePointerId = MotionEventCompat.getPointerId(ev, v9);
                        break;
                    }
                    case 6: {
                        this.onSecondaryPointerUp(ev);
                        this.mLastMotionX = MotionEventCompat.getX(ev, MotionEventCompat.findPointerIndex(ev, this.mActivePointerId));
                        break;
                    }
                }

            label_42:
                if(v11 != 0) {
                    ViewCompat.postInvalidateOnAnimation(((View)this));
                }

                v23 = true;
                goto label_5;
            }

            v23 = false;
        }

    label_5:
        return v23;
    }

    boolean pageLeft() {
        boolean v0 = true;
        if(this.mCurItem > 0) {
            this.setCurrentItem(this.mCurItem - 1, true);
        }
        else {
            v0 = false;
        }

        return v0;
    }

    boolean pageRight() {
        boolean v0 = true;
        if(this.mAdapter == null || this.mCurItem >= this.mAdapter.getCount() - 1) {
            v0 = false;
        }
        else {
            this.setCurrentItem(this.mCurItem + 1, true);
        }

        return v0;
    }

    private boolean pageScrolled(int xpos) {
        boolean v7 = false;
        if(this.mItems.size() == 0) {
            this.mCalledSuper = false;
            this.onPageScrolled(0, 0f, 0);
            if(!this.mCalledSuper) {
                throw new IllegalStateException("onPageScrolled did not call superclass implementation");
            }
        }
        else {
            ItemInfo v1 = this.infoForCurrentScrollPosition();
            int v5 = this.getClientWidth();
            int v6 = v5 + this.mPageMargin;
            float v2 = (((float)this.mPageMargin)) / (((float)v5));
            int v0 = v1.position;
            float v4 = ((((float)xpos)) / (((float)v5)) - v1.offset) / (v1.widthFactor + v2);
            this.mCalledSuper = false;
            this.onPageScrolled(v0, v4, ((int)((((float)v6)) * v4)));
            if(!this.mCalledSuper) {
                throw new IllegalStateException("onPageScrolled did not call superclass implementation");
            }
            else {
                v7 = true;
            }
        }

        return v7;
    }

    private boolean performDrag(float x) {
        boolean v7 = false;
        float v2 = this.mLastMotionX - x;
        this.mLastMotionX = x;
        float v12 = (((float)this.getScrollX())) + v2;
        int v13 = this.getClientWidth();
        float v6 = (((float)v13)) * this.mFirstOffset;
        float v11 = (((float)v13)) * this.mLastOffset;
        int v5 = 1;
        int v10 = 1;
        Object v3 = this.mItems.get(0);
        Object v4 = this.mItems.get(this.mItems.size() - 1);
        if(((ItemInfo)v3).position != 0) {
            v5 = 0;
            v6 = ((ItemInfo)v3).offset * (((float)v13));
        }

        if(((ItemInfo)v4).position != this.mAdapter.getCount() - 1) {
            v10 = 0;
            v11 = ((ItemInfo)v4).offset * (((float)v13));
        }

        if(v12 < v6) {
            if(v5 != 0) {
                v7 = this.mLeftEdge.onPull(Math.abs(v6 - v12) / (((float)v13)));
            }

            v12 = v6;
        }
        else {
            if(v12 <= v11) {
                goto label_59;
            }

            if(v10 != 0) {
                v7 = this.mRightEdge.onPull(Math.abs(v12 - v11) / (((float)v13)));
            }

            v12 = v11;
        }

    label_59:
        this.mLastMotionX += v12 - (((float)(((int)v12))));
        this.scrollTo(((int)v12), this.getScrollY());
        this.pageScrolled(((int)v12));
        return v7;
    }

    void populate() {
        this.populate(this.mCurItem);
    }

    void populate(int newCurrentItem) {
        View v5;
        Object v26;
        ItemInfo v16_1;
        ItemInfo v8_1;
        Object v16;
        String v23;
        ItemInfo v20 = null;
        int v14 = 2;
        if(this.mCurItem != newCurrentItem) {
            if(this.mCurItem < newCurrentItem) {
                v14 = 66;
            }
            else {
                v14 = 17;
            }

            v20 = this.infoForPosition(this.mCurItem);
            this.mCurItem = newCurrentItem;
        }

        if(this.mAdapter == null) {
            this.sortChildDrawingOrder();
        }
        else if(this.mPopulatePending) {
            this.sortChildDrawingOrder();
        }
        else if(this.getWindowToken() != null) {
            this.mAdapter.startUpdate(this);
            int v21 = this.mOffscreenPageLimit;
            int v25 = Math.max(0, this.mCurItem - v21);
            int v4 = this.mAdapter.getCount();
            int v11 = Math.min(v4 - 1, this.mCurItem + v21);
            if(v4 != this.mExpectedAdapterCount) {
                try {
                    v23 = this.getResources().getResourceName(this.getId());
                }
                catch(Resources$NotFoundException v10) {
                    v23 = Integer.toHexString(this.getId());
                }

                throw new IllegalStateException("The application\'s PagerAdapter changed the adapter\'s contents without calling PagerAdapter#notifyDataSetChanged! Expected adapter item count: " + this.mExpectedAdapterCount + ", found: " + v4 + " Pager id: " + v23 + " Pager class: " + this.getClass() + " Problematic adapter: " + this.mAdapter.getClass());
            }
            else {
                Object v8 = null;
                int v7 = 0;
                while(v7 < this.mItems.size()) {
                    v16 = this.mItems.get(v7);
                    if(v16.position < this.mCurItem) {
                        ++v7;
                        continue;
                    }
                    else if(v16.position == this.mCurItem) {
                        v8 = v16;
                    }

                    break;
                }

                if(v8 == null && v4 > 0) {
                    v8_1 = this.addNewItem(this.mCurItem, v7);
                }

                if(v8_1 != null) {
                    float v12 = 0f;
                    int v17 = v7 - 1;
                    if(v17 >= 0) {
                        v16 = this.mItems.get(v17);
                    }
                    else {
                        v16 = null;
                    }

                    float v18 = 2f - v8_1.widthFactor + (((float)this.getPaddingLeft())) / (((float)this.getClientWidth()));
                    int v22;
                    for(v22 = this.mCurItem - 1; v22 >= 0; --v22) {
                        if(v12 < v18 || v22 >= v25) {
                            if(v16 != null && v22 == v16.position) {
                                v12 += v16.widthFactor;
                                --v17;
                                if(v17 >= 0) {
                                    v16 = this.mItems.get(v17);
                                    goto label_320;
                                }
                                else {
                                    v16 = null;
                                    goto label_320;
                                }
                            }

                            v12 += this.addNewItem(v22, v17 + 1).widthFactor;
                            ++v7;
                            if(v17 < 0) {
                                goto label_366;
                            }

                            v16 = this.mItems.get(v17);
                            goto label_320;
                        label_366:
                            v16 = null;
                        }
                        else if(v16 == null) {
                            goto label_183;
                        }
                        else if(v22 == v16.position && !v16.scrolling) {
                            this.mItems.remove(v17);
                            this.mAdapter.destroyItem(this, v22, v16.object);
                            --v17;
                            --v7;
                            if(v17 >= 0) {
                                v16 = this.mItems.get(v17);
                            }
                            else {
                                v16 = null;
                            }
                        }

                    label_320:
                    }

                label_183:
                    float v13 = v8_1.widthFactor;
                    v17 = v7 + 1;
                    if(v13 < 2f) {
                        if(v17 < this.mItems.size()) {
                            v16 = this.mItems.get(v17);
                        }
                        else {
                            v16 = null;
                        }

                        float v24 = (((float)this.getPaddingRight())) / (((float)this.getClientWidth())) + 2f;
                        for(v22 = this.mCurItem + 1; v22 < v4; ++v22) {
                            if(v13 < v24 || v22 <= v11) {
                                if(v16 != null && v22 == v16.position) {
                                    v13 += v16.widthFactor;
                                    ++v17;
                                    if(v17 < this.mItems.size()) {
                                        v16 = this.mItems.get(v17);
                                        goto label_411;
                                    }
                                    else {
                                        v16 = null;
                                        goto label_411;
                                    }
                                }

                                v16_1 = this.addNewItem(v22, v17);
                                ++v17;
                                v13 += v16_1.widthFactor;
                                if(v17 >= this.mItems.size()) {
                                    goto label_468;
                                }

                                v16 = this.mItems.get(v17);
                                goto label_411;
                            label_468:
                                v16 = null;
                            }
                            else if(v16 == null) {
                                goto label_222;
                            }
                            else if(v22 == v16.position && !v16.scrolling) {
                                this.mItems.remove(v17);
                                this.mAdapter.destroyItem(this, v22, v16.object);
                                if(v17 < this.mItems.size()) {
                                    v16 = this.mItems.get(v17);
                                }
                                else {
                                    v16 = null;
                                }
                            }

                        label_411:
                        }
                    }

                label_222:
                    this.calculatePageOffsets(v8_1, v7, v20);
                }

                PagerAdapter v27 = this.mAdapter;
                int v28 = this.mCurItem;
                if(v8_1 != null) {
                    v26 = v8_1.object;
                }
                else {
                    v26 = null;
                }

                v27.setPrimaryItem(this, v28, v26);
                this.mAdapter.finishUpdate(this);
                int v6 = this.getChildCount();
                int v15;
                for(v15 = 0; v15 < v6; ++v15) {
                    v5 = this.getChildAt(v15);
                    ViewGroup$LayoutParams v19 = v5.getLayoutParams();
                    v19.childIndex = v15;
                    if(!v19.isDecor && v19.widthFactor == 0f) {
                        v16_1 = this.infoForChild(v5);
                        if(v16_1 != null) {
                            v19.widthFactor = v16_1.widthFactor;
                            v19.position = v16_1.position;
                        }
                    }
                }

                this.sortChildDrawingOrder();
                if(!this.hasFocus()) {
                    return;
                }

                View v9 = this.findFocus();
                if(v9 != null) {
                    v16_1 = this.infoForAnyChild(v9);
                }
                else {
                    v16_1 = null;
                }

                if(v16_1 != null && v16_1.position == this.mCurItem) {
                    return;
                }

                for(v15 = 0; v15 < this.getChildCount(); ++v15) {
                    v5 = this.getChildAt(v15);
                    v16_1 = this.infoForChild(v5);
                    if(v16_1 != null && v16_1.position == this.mCurItem && (v5.requestFocus(v14))) {
                        return;
                    }
                }
            }
        }
    }

    private void recomputeScrollPosition(int width, int oldWidth, int margin, int oldMargin) {
        float v9;
        if(oldWidth <= 0 || (this.mItems.isEmpty())) {
            ItemInfo v6 = this.infoForPosition(this.mCurItem);
            if(v6 != null) {
                v9 = Math.min(v6.offset, this.mLastOffset);
            }
            else {
                v9 = 0f;
            }

            int v10 = ((int)((((float)(width - this.getPaddingLeft() - this.getPaddingRight()))) * v9));
            if(v10 == this.getScrollX()) {
                return;
            }

            this.completeScroll(false);
            this.scrollTo(v10, this.getScrollY());
        }
        else {
            int v1 = ((int)((((float)(width - this.getPaddingLeft() - this.getPaddingRight() + margin))) * ((((float)this.getScrollX())) / (((float)(oldWidth - this.getPaddingLeft() - this.getPaddingRight() + oldMargin))))));
            this.scrollTo(v1, this.getScrollY());
            if(!this.mScroller.isFinished()) {
                this.mScroller.startScroll(v1, 0, ((int)(this.infoForPosition(this.mCurItem).offset * (((float)width)))), 0, this.mScroller.getDuration() - this.mScroller.timePassed());
            }
        }
    }

    private void removeNonDecorViews() {
        int v1;
        for(v1 = 0; v1 < this.getChildCount(); ++v1) {
            if(!this.getChildAt(v1).getLayoutParams().isDecor) {
                this.removeViewAt(v1);
                --v1;
            }
        }
    }

    public void removeView(View view) {
        if(this.mInLayout) {
            this.removeViewInLayout(view);
        }
        else {
            super.removeView(view);
        }
    }

    private void scrollToItem(int item, boolean smoothScroll, int velocity, boolean dispatchSelected) {
        ItemInfo v0 = this.infoForPosition(item);
        int v1 = 0;
        if(v0 != null) {
            v1 = ((int)((((float)this.getClientWidth())) * Math.max(this.mFirstOffset, Math.min(v0.offset, this.mLastOffset))));
        }

        if(smoothScroll) {
            this.smoothScrollTo(v1, 0, velocity);
            if((dispatchSelected) && this.mOnPageChangeListener != null) {
                this.mOnPageChangeListener.onPageSelected(item);
            }

            if(!dispatchSelected) {
                return;
            }

            if(this.mInternalPageChangeListener == null) {
                return;
            }

            this.mInternalPageChangeListener.onPageSelected(item);
        }
        else {
            if((dispatchSelected) && this.mOnPageChangeListener != null) {
                this.mOnPageChangeListener.onPageSelected(item);
            }

            if((dispatchSelected) && this.mInternalPageChangeListener != null) {
                this.mInternalPageChangeListener.onPageSelected(item);
            }

            this.completeScroll(false);
            this.scrollTo(v1, 0);
        }
    }

    public void setAdapter(PagerAdapter adapter) {
        android.support.v4.view.ViewPager$1 v8 = null;
        if(this.mAdapter != null) {
            this.mAdapter.unregisterDataSetObserver(this.mObserver);
            this.mAdapter.startUpdate(((ViewGroup)this));
            int v0;
            for(v0 = 0; v0 < this.mItems.size(); ++v0) {
                Object v1 = this.mItems.get(v0);
                this.mAdapter.destroyItem(((ViewGroup)this), ((ItemInfo)v1).position, ((ItemInfo)v1).object);
            }

            this.mAdapter.finishUpdate(((ViewGroup)this));
            this.mItems.clear();
            this.removeNonDecorViews();
            this.mCurItem = 0;
            this.scrollTo(0, 0);
        }

        PagerAdapter v2 = this.mAdapter;
        this.mAdapter = adapter;
        this.mExpectedAdapterCount = 0;
        if(this.mAdapter != null) {
            if(this.mObserver == null) {
                this.mObserver = new PagerObserver(this, v8);
            }

            this.mAdapter.registerDataSetObserver(this.mObserver);
            this.mPopulatePending = false;
            boolean v3 = this.mFirstLayout;
            this.mFirstLayout = true;
            this.mExpectedAdapterCount = this.mAdapter.getCount();
            if(this.mRestoredCurItem < 0) {
                goto label_65;
            }

            this.mAdapter.restoreState(this.mRestoredAdapterState, this.mRestoredClassLoader);
            this.setCurrentItemInternal(this.mRestoredCurItem, false, true);
            this.mRestoredCurItem = -1;
            this.mRestoredAdapterState = ((Parcelable)v8);
            this.mRestoredClassLoader = ((ClassLoader)v8);
            goto label_59;
        label_65:
            if(v3) {
                goto label_68;
            }

            this.populate();
            goto label_59;
        label_68:
            this.requestLayout();
        }

    label_59:
        if(this.mAdapterChangeListener != null && v2 != adapter) {
            this.mAdapterChangeListener.onAdapterChanged(v2, adapter);
        }
    }

    public void setCurrentItem(int item) {
        boolean v0;
        this.mPopulatePending = false;
        if(!this.mFirstLayout) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        this.setCurrentItemInternal(item, v0, false);
    }

    public void setCurrentItem(int item, boolean smoothScroll) {
        this.mPopulatePending = false;
        this.setCurrentItemInternal(item, smoothScroll, false);
    }

    void setCurrentItemInternal(int item, boolean smoothScroll, boolean always) {
        this.setCurrentItemInternal(item, smoothScroll, always, 0);
    }

    void setCurrentItemInternal(int item, boolean smoothScroll, boolean always, int velocity) {
        boolean v0 = true;
        if(this.mAdapter == null || this.mAdapter.getCount() <= 0) {
            this.setScrollingCacheEnabled(false);
        }
        else {
            if(!always && this.mCurItem == item && this.mItems.size() != 0) {
                this.setScrollingCacheEnabled(false);
                return;
            }

            if(item < 0) {
                item = 0;
            }
            else if(item >= this.mAdapter.getCount()) {
                item = this.mAdapter.getCount() - 1;
            }

            int v2 = this.mOffscreenPageLimit;
            if(item > this.mCurItem + v2 || item < this.mCurItem - v2) {
                int v1;
                for(v1 = 0; v1 < this.mItems.size(); ++v1) {
                    this.mItems.get(v1).scrolling = true;
                }
            }

            if(this.mCurItem == item) {
                v0 = false;
            }

            if(!this.mFirstLayout) {
                goto label_61;
            }

            this.mCurItem = item;
            if((v0) && this.mOnPageChangeListener != null) {
                this.mOnPageChangeListener.onPageSelected(item);
            }

            if((v0) && this.mInternalPageChangeListener != null) {
                this.mInternalPageChangeListener.onPageSelected(item);
            }

            this.requestLayout();
            return;
        label_61:
            this.populate(item);
            this.scrollToItem(item, smoothScroll, velocity, v0);
        }
    }

    OnPageChangeListener setInternalPageChangeListener(OnPageChangeListener listener) {
        OnPageChangeListener v0 = this.mInternalPageChangeListener;
        this.mInternalPageChangeListener = listener;
        return v0;
    }

    void setOnAdapterChangeListener(OnAdapterChangeListener listener) {
        this.mAdapterChangeListener = listener;
    }

    public void setOnPageChangeListener(OnPageChangeListener listener) {
        this.mOnPageChangeListener = listener;
    }

    private void setScrollState(int newState) {
        boolean v0;
        if(this.mScrollState != newState) {
            this.mScrollState = newState;
            if(this.mPageTransformer != null) {
                if(newState != 0) {
                    v0 = true;
                }
                else {
                    v0 = false;
                }

                this.enableLayers(v0);
            }

            if(this.mOnPageChangeListener == null) {
                return;
            }

            this.mOnPageChangeListener.onPageScrollStateChanged(newState);
        }
    }

    private void setScrollingCacheEnabled(boolean enabled) {
        if(this.mScrollingCacheEnabled != enabled) {
            this.mScrollingCacheEnabled = enabled;
        }
    }

    void smoothScrollTo(int x, int y, int velocity) {
        int v6;
        if(this.getChildCount() == 0) {
            this.setScrollingCacheEnabled(false);
        }
        else {
            int v2 = this.getScrollX();
            int v3 = this.getScrollY();
            int v4 = x - v2;
            int v5 = y - v3;
            if(v4 == 0 && v5 == 0) {
                this.completeScroll(false);
                this.populate();
                this.setScrollState(0);
                return;
            }

            this.setScrollingCacheEnabled(true);
            this.setScrollState(2);
            int v12 = this.getClientWidth();
            int v9 = v12 / 2;
            float v7 = (((float)v9)) + (((float)v9)) * this.distanceInfluenceForSnapDuration(Math.min(1f, 1f * (((float)Math.abs(v4))) / (((float)v12))));
            velocity = Math.abs(velocity);
            if(velocity > 0) {
                v6 = Math.round(1000f * Math.abs(v7 / (((float)velocity)))) * 4;
            }
            else {
                v6 = ((int)((1f + (((float)Math.abs(v4))) / ((((float)this.mPageMargin)) + (((float)v12)) * this.mAdapter.getPageWidth(this.mCurItem))) * 100f));
            }

            this.mScroller.startScroll(v2, v3, v4, v5, Math.min(v6, 600));
            ViewCompat.postInvalidateOnAnimation(((View)this));
        }
    }

    private void sortChildDrawingOrder() {
        if(this.mDrawingOrder != 0) {
            if(this.mDrawingOrderedChildren == null) {
                this.mDrawingOrderedChildren = new ArrayList();
            }
            else {
                this.mDrawingOrderedChildren.clear();
            }

            int v1 = this.getChildCount();
            int v2;
            for(v2 = 0; v2 < v1; ++v2) {
                this.mDrawingOrderedChildren.add(this.getChildAt(v2));
            }

            Collections.sort(this.mDrawingOrderedChildren, ViewPager.sPositionComparator);
        }
    }

    protected boolean verifyDrawable(Drawable who) {
        boolean v0;
        if((super.verifyDrawable(who)) || who == this.mMarginDrawable) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }
}

