// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.widget;

import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.drawable.Drawable;
import android.os.Parcel;
import android.os.Parcelable;
import android.os.Parcelable$Creator;
import android.os.SystemClock;
import android.support.v4.view.AccessibilityDelegateCompat;
import android.support.v4.view.GravityCompat;
import android.support.v4.view.KeyEventCompat;
import android.support.v4.view.MotionEventCompat;
import android.support.v4.view.ViewCompat;
import android.support.v4.view.ViewGroupCompat;
import android.util.AttributeSet;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.View$BaseSavedState;
import android.view.View$MeasureSpec;
import android.view.ViewGroup;
import android.view.ViewGroup$LayoutParams;
import android.view.ViewGroup$MarginLayoutParams;

public class DrawerLayout extends ViewGroup {
    class AccessibilityDelegate extends AccessibilityDelegateCompat {
        private final Rect mTmpRect;

        AccessibilityDelegate(DrawerLayout arg2) {
            DrawerLayout.this = arg2;
            super();
            this.mTmpRect = new Rect();
        }
    }

    public abstract interface DrawerListener {
        public abstract void onDrawerClosed(View arg0);

        public abstract void onDrawerOpened(View arg0);

        public abstract void onDrawerSlide(View arg0, float arg1);

        public abstract void onDrawerStateChanged(int arg0);
    }

    public class LayoutParams extends ViewGroup$MarginLayoutParams {
        public int gravity;

        public LayoutParams(int width, int height) {
            super(width, height);
            this.gravity = 0;
        }

        public LayoutParams(Context c, AttributeSet attrs) {
            super(c, attrs);
            this.gravity = 0;
            TypedArray v0 = c.obtainStyledAttributes(attrs, DrawerLayout.LAYOUT_ATTRS);
            this.gravity = v0.getInt(0, 0);
            v0.recycle();
        }

        public LayoutParams(LayoutParams source) {
            super(((ViewGroup$MarginLayoutParams)source));
            this.gravity = 0;
            this.gravity = source.gravity;
        }

        public LayoutParams(ViewGroup$MarginLayoutParams source) {
            super(source);
            this.gravity = 0;
        }

        public LayoutParams(ViewGroup$LayoutParams source) {
            super(source);
            this.gravity = 0;
        }
    }

    public class SavedState extends View$BaseSavedState {
        public static final Parcelable$Creator CREATOR;
        int lockModeLeft;
        int lockModeRight;
        int openDrawerGravity;

        static  {
            SavedState.CREATOR = new Parcelable$Creator() {
                public SavedState createFromParcel(Parcel source) {
                    return new SavedState(source);
                }

                public Object createFromParcel(Parcel x0) {
                    return this.createFromParcel(x0);
                }

                public SavedState[] newArray(int size) {
                    return new SavedState[size];
                }

                public Object[] newArray(int x0) {
                    return this.newArray(x0);
                }
            };
        }

        public SavedState(Parcelable superState) {
            super(superState);
            this.openDrawerGravity = 0;
            this.lockModeLeft = 0;
            this.lockModeRight = 0;
        }

        public SavedState(Parcel in) {
            super(in);
            this.openDrawerGravity = 0;
            this.lockModeLeft = 0;
            this.lockModeRight = 0;
            this.openDrawerGravity = in.readInt();
        }

        public void writeToParcel(Parcel dest, int flags) {
            super.writeToParcel(dest, flags);
            dest.writeInt(this.openDrawerGravity);
        }
    }

    class ViewDragCallback extends Callback {
        private ViewDragHelper mDragger;
        private final int mGravity;
        private final Runnable mPeekRunnable;

        public ViewDragCallback(DrawerLayout arg2, int gravity) {
            DrawerLayout.this = arg2;
            super();
            this.mPeekRunnable = new Runnable() {
                public void run() {
                    this.this$1.peekDrawer();
                }
            };
            this.mGravity = gravity;
        }

        static void access$000(ViewDragCallback x0) {
            x0.peekDrawer();
        }

        public int clampViewPositionHorizontal(View child, int left, int dx) {
            int v1;
            if(DrawerLayout.this.checkDrawerViewGravity(child, 3)) {
                v1 = Math.max(-child.getWidth(), Math.min(left, 0));
            }
            else {
                int v0 = DrawerLayout.this.getWidth();
                v1 = Math.max(v0 - child.getWidth(), Math.min(left, v0));
            }

            return v1;
        }

        public int clampViewPositionVertical(View child, int top, int dy) {
            return child.getTop();
        }

        private void closeOtherDrawer() {
            int v0 = 3;
            if(this.mGravity == v0) {
                v0 = 5;
            }

            View v1 = DrawerLayout.this.findDrawerWithGravity(v0);
            if(v1 != null) {
                DrawerLayout.this.closeDrawer(v1);
            }
        }

        public int getViewHorizontalDragRange(View child) {
            return child.getWidth();
        }

        public void onEdgeDragStarted(int edgeFlags, int pointerId) {
            View v0;
            if((edgeFlags & 1) == 1) {
                v0 = DrawerLayout.this.findDrawerWithGravity(3);
            }
            else {
                v0 = DrawerLayout.this.findDrawerWithGravity(5);
            }

            if(v0 != null && DrawerLayout.this.getDrawerLockMode(v0) == 0) {
                this.mDragger.captureChildView(v0, pointerId);
            }
        }

        public boolean onEdgeLock(int edgeFlags) {
            return 0;
        }

        public void onEdgeTouched(int edgeFlags, int pointerId) {
            DrawerLayout.this.postDelayed(this.mPeekRunnable, 160);
        }

        public void onViewCaptured(View capturedChild, int activePointerId) {
            capturedChild.getLayoutParams().isPeeking = false;
            this.closeOtherDrawer();
        }

        public void onViewDragStateChanged(int state) {
            DrawerLayout.this.updateDrawerState(this.mGravity, state, this.mDragger.getCapturedView());
        }

        public void onViewPositionChanged(View changedView, int left, int top, int dx, int dy) {
            int v3;
            float v1;
            int v0 = changedView.getWidth();
            if(DrawerLayout.this.checkDrawerViewGravity(changedView, 3)) {
                v1 = (((float)(v0 + left))) / (((float)v0));
            }
            else {
                v1 = (((float)(DrawerLayout.this.getWidth() - left))) / (((float)v0));
            }

            DrawerLayout.this.setDrawerViewOffset(changedView, v1);
            if(v1 == 0f) {
                v3 = 4;
            }
            else {
                v3 = 0;
            }

            changedView.setVisibility(v3);
            DrawerLayout.this.invalidate();
        }

        public void onViewReleased(View releasedChild, float xvel, float yvel) {
            int v1;
            float v7 = 0.5f;
            float v2 = DrawerLayout.this.getDrawerViewOffset(releasedChild);
            int v0 = releasedChild.getWidth();
            if(DrawerLayout.this.checkDrawerViewGravity(releasedChild, 3)) {
                if(xvel <= 0f && (xvel != 0f || v2 <= v7)) {
                    v1 = -v0;
                    goto label_13;
                }

                v1 = 0;
            }
            else {
                int v3 = DrawerLayout.this.getWidth();
                if(xvel >= 0f && (xvel != 0f || v2 >= v7)) {
                    v1 = v3;
                    goto label_13;
                }

                v1 = v3 - v0;
            }

        label_13:
            this.mDragger.settleCapturedViewAt(v1, releasedChild.getTop());
            DrawerLayout.this.invalidate();
        }

        private void peekDrawer() {
            int v0;
            View v4;
            int v1;
            int v8 = 3;
            int v5 = 0;
            int v3 = this.mDragger.getEdgeSize();
            if(this.mGravity == v8) {
                v1 = 1;
            }
            else {
                v1 = 0;
            }

            if(v1 != 0) {
                v4 = DrawerLayout.this.findDrawerWithGravity(v8);
                if(v4 != null) {
                    v5 = -v4.getWidth();
                }

                v0 = v5 + v3;
            }
            else {
                v4 = DrawerLayout.this.findDrawerWithGravity(5);
                v0 = DrawerLayout.this.getWidth() - v3;
            }

            if(v4 != null) {
                if(v1 == 0 || v4.getLeft() >= v0) {
                    if(v1 == 0) {
                        if(v4.getLeft() > v0) {
                            goto label_22;
                        }

                        return;
                    }
                    else {
                        return;
                    }
                }

            label_22:
                if(DrawerLayout.this.getDrawerLockMode(v4) != 0) {
                    return;
                }

                ViewGroup$LayoutParams v2 = v4.getLayoutParams();
                this.mDragger.smoothSlideViewTo(v4, v0, v4.getTop());
                ((LayoutParams)v2).isPeeking = true;
                DrawerLayout.this.invalidate();
                this.closeOtherDrawer();
                DrawerLayout.this.cancelChildViewTouch();
            }
        }

        public void removeCallbacks() {
            DrawerLayout.this.removeCallbacks(this.mPeekRunnable);
        }

        public void setDragger(ViewDragHelper dragger) {
            this.mDragger = dragger;
        }

        public boolean tryCaptureView(View child, int pointerId) {
            boolean v0;
            if(!DrawerLayout.this.isDrawerView(child) || !DrawerLayout.this.checkDrawerViewGravity(child, this.mGravity) || DrawerLayout.this.getDrawerLockMode(child) != 0) {
                v0 = false;
            }
            else {
                v0 = true;
            }

            return v0;
        }
    }

    private static final int[] LAYOUT_ATTRS;
    private boolean mChildrenCanceledTouch;
    private boolean mDisallowInterceptRequested;
    private int mDrawerState;
    private boolean mFirstLayout;
    private boolean mInLayout;
    private float mInitialMotionX;
    private float mInitialMotionY;
    private final ViewDragCallback mLeftCallback;
    private final ViewDragHelper mLeftDragger;
    private DrawerListener mListener;
    private int mLockModeLeft;
    private int mLockModeRight;
    private int mMinDrawerMargin;
    private final ViewDragCallback mRightCallback;
    private final ViewDragHelper mRightDragger;
    private int mScrimColor;
    private float mScrimOpacity;
    private Paint mScrimPaint;
    private Drawable mShadowLeft;
    private Drawable mShadowRight;

    static  {
        DrawerLayout.LAYOUT_ATTRS = new int[]{16842931};
    }

    public DrawerLayout(Context context, AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public DrawerLayout(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        this.mScrimColor = -1728053248;
        this.mScrimPaint = new Paint();
        this.mFirstLayout = true;
        float v0 = this.getResources().getDisplayMetrics().density;
        this.mMinDrawerMargin = ((int)(64f * v0 + 0.5f));
        float v1 = 400f * v0;
        this.mLeftCallback = new ViewDragCallback(this, 3);
        this.mRightCallback = new ViewDragCallback(this, 5);
        this.mLeftDragger = ViewDragHelper.create(((ViewGroup)this), 0.5f, this.mLeftCallback);
        this.mLeftDragger.setEdgeTrackingEnabled(1);
        this.mLeftDragger.setMinVelocity(v1);
        this.mLeftCallback.setDragger(this.mLeftDragger);
        this.mRightDragger = ViewDragHelper.create(((ViewGroup)this), 0.5f, this.mRightCallback);
        this.mRightDragger.setEdgeTrackingEnabled(2);
        this.mRightDragger.setMinVelocity(v1);
        this.mRightCallback.setDragger(this.mRightDragger);
        this.setFocusableInTouchMode(true);
        ViewCompat.setAccessibilityDelegate(((View)this), new AccessibilityDelegate(this));
        ViewGroupCompat.setMotionEventSplittingEnabled(((ViewGroup)this), false);
    }

    static int[] access$100() {
        return DrawerLayout.LAYOUT_ATTRS;
    }

    void cancelChildViewTouch() {
        if(!this.mChildrenCanceledTouch) {
            long v0 = SystemClock.uptimeMillis();
            MotionEvent v8 = MotionEvent.obtain(v0, v0, 3, 0f, 0f, 0);
            int v9 = this.getChildCount();
            int v10;
            for(v10 = 0; v10 < v9; ++v10) {
                this.getChildAt(v10).dispatchTouchEvent(v8);
            }

            v8.recycle();
            this.mChildrenCanceledTouch = true;
        }
    }

    boolean checkDrawerViewGravity(View drawerView, int checkFor) {
        boolean v1;
        if((this.getDrawerViewGravity(drawerView) & checkFor) == checkFor) {
            v1 = true;
        }
        else {
            v1 = false;
        }

        return v1;
    }

    protected boolean checkLayoutParams(ViewGroup$LayoutParams p) {
        boolean v0;
        if(!(p instanceof LayoutParams) || !super.checkLayoutParams(p)) {
            v0 = false;
        }
        else {
            v0 = true;
        }

        return v0;
    }

    public void closeDrawer(View drawerView) {
        if(!this.isDrawerView(drawerView)) {
            throw new IllegalArgumentException("View " + drawerView + " is not a sliding drawer");
        }

        if(this.mFirstLayout) {
            ViewGroup$LayoutParams v0 = drawerView.getLayoutParams();
            ((LayoutParams)v0).onScreen = 0f;
            ((LayoutParams)v0).knownOpen = false;
        }
        else if(this.checkDrawerViewGravity(drawerView, 3)) {
            this.mLeftDragger.smoothSlideViewTo(drawerView, -drawerView.getWidth(), drawerView.getTop());
        }
        else {
            this.mRightDragger.smoothSlideViewTo(drawerView, this.getWidth(), drawerView.getTop());
        }

        this.invalidate();
    }

    public void closeDrawers() {
        this.closeDrawers(false);
    }

    void closeDrawers(boolean peekingOnly) {
        int v5 = 0;
        int v1 = this.getChildCount();
        int v3;
        for(v3 = 0; v3 < v1; ++v3) {
            View v0 = this.getChildAt(v3);
            ViewGroup$LayoutParams v4 = v0.getLayoutParams();
            if((this.isDrawerView(v0)) && (!peekingOnly || (((LayoutParams)v4).isPeeking))) {
                int v2 = v0.getWidth();
                if(this.checkDrawerViewGravity(v0, 3)) {
                    v5 |= this.mLeftDragger.smoothSlideViewTo(v0, -v2, v0.getTop());
                }
                else {
                    v5 |= this.mRightDragger.smoothSlideViewTo(v0, this.getWidth(), v0.getTop());
                }

                ((LayoutParams)v4).isPeeking = false;
            }
        }

        this.mLeftCallback.removeCallbacks();
        this.mRightCallback.removeCallbacks();
        if(v5 != 0) {
            this.invalidate();
        }
    }

    public void computeScroll() {
        int v0 = this.getChildCount();
        float v3 = 0f;
        int v1;
        for(v1 = 0; v1 < v0; ++v1) {
            v3 = Math.max(v3, this.getChildAt(v1).getLayoutParams().onScreen);
        }

        this.mScrimOpacity = v3;
        if((this.mLeftDragger.continueSettling(true) | this.mRightDragger.continueSettling(true)) != 0) {
            ViewCompat.postInvalidateOnAnimation(((View)this));
        }
    }

    void dispatchOnDrawerClosed(View drawerView) {
        ViewGroup$LayoutParams v0 = drawerView.getLayoutParams();
        if(((LayoutParams)v0).knownOpen) {
            ((LayoutParams)v0).knownOpen = false;
            if(this.mListener != null) {
                this.mListener.onDrawerClosed(drawerView);
            }

            this.sendAccessibilityEvent(32);
        }
    }

    void dispatchOnDrawerOpened(View drawerView) {
        ViewGroup$LayoutParams v0 = drawerView.getLayoutParams();
        if(!((LayoutParams)v0).knownOpen) {
            ((LayoutParams)v0).knownOpen = true;
            if(this.mListener != null) {
                this.mListener.onDrawerOpened(drawerView);
            }

            drawerView.sendAccessibilityEvent(32);
        }
    }

    void dispatchOnDrawerSlide(View drawerView, float slideOffset) {
        if(this.mListener != null) {
            this.mListener.onDrawerSlide(drawerView, slideOffset);
        }
    }

    protected boolean drawChild(Canvas canvas, View child, long drawingTime) {
        float v8;
        int v23;
        int v18 = this.getHeight();
        boolean v17 = this.isContentView(child);
        int v13 = 0;
        int v14 = this.getWidth();
        int v21 = canvas.save();
        if(v17) {
            int v10 = this.getChildCount();
            int v19;
            for(v19 = 0; v19 < v10; ++v19) {
                View v25 = this.getChildAt(v19);
                if(v25 != child && v25.getVisibility() == 0 && (DrawerLayout.hasOpaqueBackground(v25)) && (this.isDrawerView(v25)) && v25.getHeight() >= v18) {
                    if(this.checkDrawerViewGravity(v25, 3)) {
                        int v27 = v25.getRight();
                        if(v27 > v13) {
                            v13 = v27;
                        }
                    }
                    else {
                        int v26 = v25.getLeft();
                        if(v26 < v14) {
                            v14 = v26;
                        }
                    }
                }
            }

            canvas.clipRect(v13, 0, v14, this.getHeight());
        }

        boolean v22 = super.drawChild(canvas, child, drawingTime);
        canvas.restoreToCount(v21);
        if(this.mScrimOpacity <= 0f || !v17) {
            if(this.mShadowLeft != null && (this.checkDrawerViewGravity(child, 3))) {
                v23 = this.mShadowLeft.getIntrinsicWidth();
                int v12 = child.getRight();
                v8 = Math.max(0f, Math.min((((float)v12)) / (((float)this.mLeftDragger.getEdgeSize())), 1f));
                this.mShadowLeft.setBounds(v12, child.getTop(), v12 + v23, child.getBottom());
                this.mShadowLeft.setAlpha(((int)(255f * v8)));
                this.mShadowLeft.draw(canvas);
                goto label_88;
            }

            if(this.mShadowRight == null) {
                goto label_88;
            }

            if(!this.checkDrawerViewGravity(child, 5)) {
                goto label_88;
            }

            v23 = this.mShadowRight.getIntrinsicWidth();
            int v11 = child.getLeft();
            v8 = Math.max(0f, Math.min((((float)(this.getWidth() - v11))) / (((float)this.mRightDragger.getEdgeSize())), 1f));
            this.mShadowRight.setBounds(v11 - v23, child.getTop(), v11, child.getBottom());
            this.mShadowRight.setAlpha(((int)(255f * v8)));
            this.mShadowRight.draw(canvas);
        }
        else {
            this.mScrimPaint.setColor((((int)((((float)((this.mScrimColor & -16777216) >>> 24))) * this.mScrimOpacity))) << 24 | this.mScrimColor & 16777215);
            canvas.drawRect(((float)v13), 0f, ((float)v14), ((float)this.getHeight()), this.mScrimPaint);
        }

    label_88:
        return v22;
    }

    View findDrawerWithGravity(int gravity) {
        View v0;
        int v1 = this.getChildCount();
        int v3 = 0;
        while(true) {
            if(v3 < v1) {
                v0 = this.getChildAt(v3);
                if((this.getDrawerViewGravity(v0) & 7) != (gravity & 7)) {
                    ++v3;
                    continue;
                }
            }
            else {
                break;
            }

            goto label_8;
        }

        v0 = null;
    label_8:
        return v0;
    }

    View findOpenDrawer() {
        View v0;
        int v1 = this.getChildCount();
        int v2 = 0;
        while(true) {
            if(v2 < v1) {
                v0 = this.getChildAt(v2);
                if(!v0.getLayoutParams().knownOpen) {
                    ++v2;
                    continue;
                }
            }
            else {
                break;
            }

            goto label_7;
        }

        v0 = null;
    label_7:
        return v0;
    }

    private View findVisibleDrawer() {
        View v0;
        int v1 = this.getChildCount();
        int v2;
        for(v2 = 0; v2 < v1; ++v2) {
            v0 = this.getChildAt(v2);
            if((this.isDrawerView(v0)) && (this.isDrawerVisible(v0))) {
                goto label_8;
            }
        }

        v0 = null;
    label_8:
        return v0;
    }

    protected ViewGroup$LayoutParams generateDefaultLayoutParams() {
        return new LayoutParams(-1, -1);
    }

    public ViewGroup$LayoutParams generateLayoutParams(AttributeSet attrs) {
        return new LayoutParams(this.getContext(), attrs);
    }

    protected ViewGroup$LayoutParams generateLayoutParams(ViewGroup$LayoutParams p) {
        LayoutParams v0;
        if((p instanceof LayoutParams)) {
            v0 = new LayoutParams(((LayoutParams)p));
        }
        else if((p instanceof ViewGroup$MarginLayoutParams)) {
            v0 = new LayoutParams(((ViewGroup$MarginLayoutParams)p));
        }
        else {
            v0 = new LayoutParams(p);
        }

        return ((ViewGroup$LayoutParams)v0);
    }

    public int getDrawerLockMode(View drawerView) {
        int v1;
        int v0 = this.getDrawerViewGravity(drawerView);
        if(v0 == 3) {
            v1 = this.mLockModeLeft;
        }
        else if(v0 == 5) {
            v1 = this.mLockModeRight;
        }
        else {
            v1 = 0;
        }

        return v1;
    }

    int getDrawerViewGravity(View drawerView) {
        return GravityCompat.getAbsoluteGravity(drawerView.getLayoutParams().gravity, ViewCompat.getLayoutDirection(drawerView));
    }

    float getDrawerViewOffset(View drawerView) {
        return drawerView.getLayoutParams().onScreen;
    }

    static String gravityToString(int gravity) {
        String v0;
        if((gravity & 3) == 3) {
            v0 = "LEFT";
        }
        else if((gravity & 5) == 5) {
            v0 = "RIGHT";
        }
        else {
            v0 = Integer.toHexString(gravity);
        }

        return v0;
    }

    private static boolean hasOpaqueBackground(View v) {
        boolean v1 = false;
        Drawable v0 = v.getBackground();
        if(v0 != null && v0.getOpacity() == -1) {
            v1 = true;
        }

        return v1;
    }

    private boolean hasPeekingDrawer() {
        boolean v3;
        int v0 = this.getChildCount();
        int v1 = 0;
        while(true) {
            if(v1 >= v0) {
                break;
            }
            else if(this.getChildAt(v1).getLayoutParams().isPeeking) {
                v3 = true;
            }
            else {
                ++v1;
                continue;
            }

            goto label_8;
        }

        v3 = false;
    label_8:
        return v3;
    }

    private boolean hasVisibleDrawer() {
        boolean v0;
        if(this.findVisibleDrawer() != null) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    boolean isContentView(View child) {
        boolean v0;
        if(child.getLayoutParams().gravity == 0) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    boolean isDrawerView(View child) {
        boolean v2;
        if((GravityCompat.getAbsoluteGravity(child.getLayoutParams().gravity, ViewCompat.getLayoutDirection(child)) & 7) != 0) {
            v2 = true;
        }
        else {
            v2 = false;
        }

        return v2;
    }

    public boolean isDrawerVisible(View drawer) {
        boolean v0;
        if(!this.isDrawerView(drawer)) {
            throw new IllegalArgumentException("View " + drawer + " is not a drawer");
        }

        if(drawer.getLayoutParams().onScreen > 0f) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    protected void onAttachedToWindow() {
        super.onAttachedToWindow();
        this.mFirstLayout = true;
    }

    protected void onDetachedFromWindow() {
        super.onDetachedFromWindow();
        this.mFirstLayout = true;
    }

    public boolean onInterceptTouchEvent(MotionEvent ev) {
        boolean v5 = false;
        int v0 = MotionEventCompat.getActionMasked(ev);
        int v1 = this.mLeftDragger.shouldInterceptTouchEvent(ev) | this.mRightDragger.shouldInterceptTouchEvent(ev);
        int v2 = 0;
        switch(v0) {
            case 0: {
                float v3 = ev.getX();
                float v4 = ev.getY();
                this.mInitialMotionX = v3;
                this.mInitialMotionY = v4;
                if(this.mScrimOpacity > 0f && (this.isContentView(this.mLeftDragger.findTopChildUnder(((int)v3), ((int)v4))))) {
                    v2 = 1;
                }

                this.mDisallowInterceptRequested = false;
                this.mChildrenCanceledTouch = false;
                break;
            }
            case 2: {
                if(!this.mLeftDragger.checkTouchSlop(3)) {
                    goto label_10;
                }

                this.mLeftCallback.removeCallbacks();
                this.mRightCallback.removeCallbacks();
                break;
            }
            case 1: 
            case 3: {
                this.closeDrawers(true);
                this.mDisallowInterceptRequested = false;
                this.mChildrenCanceledTouch = false;
                break;
            }
        }

    label_10:
        if(v1 != 0 || v2 != 0 || (this.hasPeekingDrawer()) || (this.mChildrenCanceledTouch)) {
            v5 = true;
        }

        return v5;
    }

    public boolean onKeyDown(int keyCode, KeyEvent event) {
        boolean v0;
        if(keyCode != 4 || !this.hasVisibleDrawer()) {
            v0 = super.onKeyDown(keyCode, event);
        }
        else {
            KeyEventCompat.startTracking(event);
            v0 = true;
        }

        return v0;
    }

    public boolean onKeyUp(int keyCode, KeyEvent event) {
        boolean v1;
        if(keyCode == 4) {
            View v0 = this.findVisibleDrawer();
            if(v0 != null && this.getDrawerLockMode(v0) == 0) {
                this.closeDrawers();
            }

            if(v0 == null) {
                goto label_10;
            }

            v1 = true;
            goto label_9;
        label_10:
            v1 = false;
        }
        else {
            v1 = super.onKeyUp(keyCode, event);
        }

    label_9:
        return v1;
    }

    protected void onLayout(boolean changed, int l, int t, int r, int b) {
        int v6;
        int v3;
        this.mInLayout = true;
        int v1 = this.getChildCount();
        int v7;
        for(v7 = 0; v7 < v1; ++v7) {
            View v0 = this.getChildAt(v7);
            if(v0.getVisibility() != 8) {
                ViewGroup$LayoutParams v8 = v0.getLayoutParams();
                if(this.isContentView(v0)) {
                    v0.layout(((LayoutParams)v8).leftMargin, ((LayoutParams)v8).topMargin, ((LayoutParams)v8).leftMargin + v0.getMeasuredWidth(), ((LayoutParams)v8).topMargin + v0.getMeasuredHeight());
                }
                else {
                    int v5 = v0.getMeasuredWidth();
                    int v2 = v0.getMeasuredHeight();
                    if(this.checkDrawerViewGravity(v0, 3)) {
                        v3 = -v5 + (((int)((((float)v5)) * ((LayoutParams)v8).onScreen)));
                    }
                    else {
                        v3 = r - l - (((int)((((float)v5)) * ((LayoutParams)v8).onScreen)));
                    }

                    switch(((LayoutParams)v8).gravity & 112) {
                        case 16: {
                            v6 = b - t;
                            int v4 = (v6 - v2) / 2;
                            if(v4 < ((LayoutParams)v8).topMargin) {
                                v4 = ((LayoutParams)v8).topMargin;
                            }
                            else if(v4 + v2 > v6 - ((LayoutParams)v8).bottomMargin) {
                                v4 = v6 - ((LayoutParams)v8).bottomMargin - v2;
                            }

                            v0.layout(v3, v4, v3 + v5, v4 + v2);
                            break;
                        }
                        case 80: {
                            v6 = b - t;
                            v0.layout(v3, v6 - ((LayoutParams)v8).bottomMargin - v0.getMeasuredHeight(), v3 + v5, v6 - ((LayoutParams)v8).bottomMargin);
                            break;
                        }
                        default: {
                            v0.layout(v3, ((LayoutParams)v8).topMargin, v3 + v5, v2);
                            break;
                        }
                    }

                    if(((LayoutParams)v8).onScreen != 0f) {
                        goto label_9;
                    }

                    v0.setVisibility(4);
                }
            }

        label_9:
        }

        this.mInLayout = false;
        this.mFirstLayout = false;
    }

    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        View v3;
        int v15 = View$MeasureSpec.getMode(widthMeasureSpec);
        int v11 = View$MeasureSpec.getMode(heightMeasureSpec);
        int v16 = View$MeasureSpec.getSize(widthMeasureSpec);
        int v12 = View$MeasureSpec.getSize(heightMeasureSpec);
        if(v15 == 1073741824 && v11 == 1073741824) {
            this.setMeasuredDimension(v16, v12);
            int v4 = this.getChildCount();
            int v13 = 0;
            while(true) {
                if(v13 < v4) {
                    v3 = this.getChildAt(v13);
                    if(v3.getVisibility() != 8) {
                        ViewGroup$LayoutParams v14 = v3.getLayoutParams();
                        if(this.isContentView(v3)) {
                            v3.measure(View$MeasureSpec.makeMeasureSpec(v16 - ((LayoutParams)v14).leftMargin - ((LayoutParams)v14).rightMargin, 1073741824), View$MeasureSpec.makeMeasureSpec(v12 - ((LayoutParams)v14).topMargin - ((LayoutParams)v14).bottomMargin, 1073741824));
                        }
                        else if(this.isDrawerView(v3)) {
                            int v5 = this.getDrawerViewGravity(v3) & 7;
                            if((0 & v5) != 0) {
                                throw new IllegalStateException("Child drawer has absolute gravity " + DrawerLayout.gravityToString(v5) + " but this " + "DrawerLayout" + " already has a " + "drawer view along that edge");
                            }
                            else {
                                v3.measure(DrawerLayout.getChildMeasureSpec(widthMeasureSpec, this.mMinDrawerMargin + ((LayoutParams)v14).leftMargin + ((LayoutParams)v14).rightMargin, ((LayoutParams)v14).width), DrawerLayout.getChildMeasureSpec(heightMeasureSpec, ((LayoutParams)v14).topMargin + ((LayoutParams)v14).bottomMargin, ((LayoutParams)v14).height));
                            }
                        }
                        else {
                            break;
                        }
                    }

                    ++v13;
                    continue;
                }
                else {
                    return;
                }
            }

            throw new IllegalStateException("Child " + v3 + " at index " + v13 + " does not have a valid layout_gravity - must be Gravity.LEFT, " + "Gravity.RIGHT or Gravity.NO_GRAVITY");
            return;
        }

        throw new IllegalArgumentException("DrawerLayout must be measured with MeasureSpec.EXACTLY.");
    }

    protected void onRestoreInstanceState(Parcelable state) {
        Parcelable v0 = state;
        super.onRestoreInstanceState(((SavedState)v0).getSuperState());
        if(((SavedState)v0).openDrawerGravity != 0) {
            View v1 = this.findDrawerWithGravity(((SavedState)v0).openDrawerGravity);
            if(v1 != null) {
                this.openDrawer(v1);
            }
        }

        this.setDrawerLockMode(((SavedState)v0).lockModeLeft, 3);
        this.setDrawerLockMode(((SavedState)v0).lockModeRight, 5);
    }

    protected Parcelable onSaveInstanceState() {
        SavedState v4 = new SavedState(super.onSaveInstanceState());
        int v1 = this.getChildCount();
        int v2;
        for(v2 = 0; v2 < v1; ++v2) {
            View v0 = this.getChildAt(v2);
            if(this.isDrawerView(v0)) {
                ViewGroup$LayoutParams v3 = v0.getLayoutParams();
                if(((LayoutParams)v3).knownOpen) {
                    v4.openDrawerGravity = ((LayoutParams)v3).gravity;
                    goto label_15;
                }
            }
        }

    label_15:
        v4.lockModeLeft = this.mLockModeLeft;
        v4.lockModeRight = this.mLockModeRight;
        return ((Parcelable)v4);
    }

    public boolean onTouchEvent(MotionEvent ev) {
        float v9;
        float v8;
        this.mLeftDragger.processTouchEvent(ev);
        this.mRightDragger.processTouchEvent(ev);
        switch(ev.getAction() & 255) {
            case 0: {
                v8 = ev.getX();
                v9 = ev.getY();
                this.mInitialMotionX = v8;
                this.mInitialMotionY = v9;
                this.mDisallowInterceptRequested = false;
                this.mChildrenCanceledTouch = false;
                break;
            }
            case 1: {
                v8 = ev.getX();
                v9 = ev.getY();
                boolean v4 = true;
                View v6 = this.mLeftDragger.findTopChildUnder(((int)v8), ((int)v9));
                if(v6 != null && (this.isContentView(v6))) {
                    float v1 = v8 - this.mInitialMotionX;
                    float v2 = v9 - this.mInitialMotionY;
                    int v5 = this.mLeftDragger.getTouchSlop();
                    if(v1 * v1 + v2 * v2 < (((float)(v5 * v5)))) {
                        View v3 = this.findOpenDrawer();
                        if(v3 != null) {
                            if(this.getDrawerLockMode(v3) == 2) {
                                v4 = true;
                            }
                            else {
                                v4 = false;
                            }
                        }
                    }
                }

                this.closeDrawers(v4);
                this.mDisallowInterceptRequested = false;
                break;
            }
            case 3: {
                this.closeDrawers(true);
                this.mDisallowInterceptRequested = false;
                this.mChildrenCanceledTouch = false;
                break;
            }
        }

        return 1;
    }

    public void openDrawer(View drawerView) {
        if(!this.isDrawerView(drawerView)) {
            throw new IllegalArgumentException("View " + drawerView + " is not a sliding drawer");
        }

        if(this.mFirstLayout) {
            ViewGroup$LayoutParams v0 = drawerView.getLayoutParams();
            ((LayoutParams)v0).onScreen = 1f;
            ((LayoutParams)v0).knownOpen = true;
        }
        else if(this.checkDrawerViewGravity(drawerView, 3)) {
            this.mLeftDragger.smoothSlideViewTo(drawerView, 0, drawerView.getTop());
        }
        else {
            this.mRightDragger.smoothSlideViewTo(drawerView, this.getWidth() - drawerView.getWidth(), drawerView.getTop());
        }

        this.invalidate();
    }

    public void requestDisallowInterceptTouchEvent(boolean disallowIntercept) {
        if(!this.mLeftDragger.isEdgeTouched(1) && !this.mRightDragger.isEdgeTouched(2)) {
            super.requestDisallowInterceptTouchEvent(disallowIntercept);
        }

        this.mDisallowInterceptRequested = disallowIntercept;
        if(disallowIntercept) {
            this.closeDrawers(true);
        }
    }

    public void requestLayout() {
        if(!this.mInLayout) {
            super.requestLayout();
        }
    }

    public void setDrawerLockMode(int lockMode, int edgeGravity) {
        ViewDragHelper v1;
        int v5 = 3;
        int v0 = GravityCompat.getAbsoluteGravity(edgeGravity, ViewCompat.getLayoutDirection(((View)this)));
        if(v0 == v5) {
            this.mLockModeLeft = lockMode;
        }
        else if(v0 == 5) {
            this.mLockModeRight = lockMode;
        }

        if(lockMode != 0) {
            if(v0 == v5) {
                v1 = this.mLeftDragger;
            }
            else {
                v1 = this.mRightDragger;
            }

            v1.cancel();
        }

        switch(lockMode) {
            case 1: {
                View v2 = this.findDrawerWithGravity(v0);
                if(v2 == null) {
                    return;
                }

                this.closeDrawer(v2);
                break;
            }
            case 2: {
                View v3 = this.findDrawerWithGravity(v0);
                if(v3 == null) {
                    return;
                }

                this.openDrawer(v3);
                break;
            }
        }
    }

    void setDrawerViewOffset(View drawerView, float slideOffset) {
        ViewGroup$LayoutParams v0 = drawerView.getLayoutParams();
        if(slideOffset != ((LayoutParams)v0).onScreen) {
            ((LayoutParams)v0).onScreen = slideOffset;
            this.dispatchOnDrawerSlide(drawerView, slideOffset);
        }
    }

    void updateDrawerState(int forGravity, int activeState, View activeDrawer) {
        int v3;
        int v6 = 2;
        int v0 = this.mLeftDragger.getViewDragState();
        int v2 = this.mRightDragger.getViewDragState();
        if(v0 == 1 || v2 == 1) {
            v3 = 1;
        }
        else {
            if(v0 != v6 && v2 != v6) {
                v3 = 0;
                goto label_9;
            }

            v3 = 2;
        }

    label_9:
        if(activeDrawer != null && activeState == 0) {
            ViewGroup$LayoutParams v1 = activeDrawer.getLayoutParams();
            if(((LayoutParams)v1).onScreen == 0f) {
                this.dispatchOnDrawerClosed(activeDrawer);
            }
            else if(((LayoutParams)v1).onScreen == 1f) {
                this.dispatchOnDrawerOpened(activeDrawer);
            }
        }

        if(v3 != this.mDrawerState) {
            this.mDrawerState = v3;
            if(this.mListener != null) {
                this.mListener.onDrawerStateChanged(v3);
            }
        }
    }
}

