// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.widget;

import android.content.Context;
import android.os.Build$VERSION;
import android.view.animation.Interpolator;
import android.widget.Scroller;

public class ScrollerCompat {
    abstract interface ScrollerCompatImpl {
        public abstract void abortAnimation(Object arg0);

        public abstract boolean computeScrollOffset(Object arg0);

        public abstract Object createScroller(Context arg0, Interpolator arg1);

        public abstract int getCurrX(Object arg0);

        public abstract int getCurrY(Object arg0);

        public abstract int getFinalX(Object arg0);

        public abstract int getFinalY(Object arg0);

        public abstract boolean isFinished(Object arg0);

        public abstract void startScroll(Object arg0, int arg1, int arg2, int arg3, int arg4, int arg5);
    }

    class ScrollerCompatImplBase implements ScrollerCompatImpl {
        ScrollerCompatImplBase() {
            super();
        }

        public void abortAnimation(Object scroller) {
            ((Scroller)scroller).abortAnimation();
        }

        public boolean computeScrollOffset(Object scroller) {
            return ((Scroller)scroller).computeScrollOffset();
        }

        public Object createScroller(Context context, Interpolator interpolator) {
            Scroller v0;
            if(interpolator != null) {
                v0 = new Scroller(context, interpolator);
            }
            else {
                v0 = new Scroller(context);
            }

            return v0;
        }

        public int getCurrX(Object scroller) {
            return ((Scroller)scroller).getCurrX();
        }

        public int getCurrY(Object scroller) {
            return ((Scroller)scroller).getCurrY();
        }

        public int getFinalX(Object scroller) {
            return ((Scroller)scroller).getFinalX();
        }

        public int getFinalY(Object scroller) {
            return ((Scroller)scroller).getFinalY();
        }

        public boolean isFinished(Object scroller) {
            return ((Scroller)scroller).isFinished();
        }

        public void startScroll(Object scroller, int startX, int startY, int dx, int dy, int duration) {
            scroller.startScroll(startX, startY, dx, dy, duration);
        }
    }

    class ScrollerCompatImplGingerbread implements ScrollerCompatImpl {
        ScrollerCompatImplGingerbread() {
            super();
        }

        public void abortAnimation(Object scroller) {
            ScrollerCompatGingerbread.abortAnimation(scroller);
        }

        public boolean computeScrollOffset(Object scroller) {
            return ScrollerCompatGingerbread.computeScrollOffset(scroller);
        }

        public Object createScroller(Context context, Interpolator interpolator) {
            return ScrollerCompatGingerbread.createScroller(context, interpolator);
        }

        public int getCurrX(Object scroller) {
            return ScrollerCompatGingerbread.getCurrX(scroller);
        }

        public int getCurrY(Object scroller) {
            return ScrollerCompatGingerbread.getCurrY(scroller);
        }

        public int getFinalX(Object scroller) {
            return ScrollerCompatGingerbread.getFinalX(scroller);
        }

        public int getFinalY(Object scroller) {
            return ScrollerCompatGingerbread.getFinalY(scroller);
        }

        public boolean isFinished(Object scroller) {
            return ScrollerCompatGingerbread.isFinished(scroller);
        }

        public void startScroll(Object scroller, int startX, int startY, int dx, int dy, int duration) {
            ScrollerCompatGingerbread.startScroll(scroller, startX, startY, dx, dy, duration);
        }
    }

    class ScrollerCompatImplIcs extends ScrollerCompatImplGingerbread {
        ScrollerCompatImplIcs() {
            super();
        }
    }

    static final ScrollerCompatImpl IMPL;
    Object mScroller;

    static  {
        int v0 = Build$VERSION.SDK_INT;
        if(v0 >= 14) {
            ScrollerCompat.IMPL = new ScrollerCompatImplIcs();
        }
        else if(v0 >= 9) {
            ScrollerCompat.IMPL = new ScrollerCompatImplGingerbread();
        }
        else {
            ScrollerCompat.IMPL = new ScrollerCompatImplBase();
        }
    }

    ScrollerCompat(Context context, Interpolator interpolator) {
        super();
        this.mScroller = ScrollerCompat.IMPL.createScroller(context, interpolator);
    }

    public void abortAnimation() {
        ScrollerCompat.IMPL.abortAnimation(this.mScroller);
    }

    public boolean computeScrollOffset() {
        return ScrollerCompat.IMPL.computeScrollOffset(this.mScroller);
    }

    public static ScrollerCompat create(Context context, Interpolator interpolator) {
        return new ScrollerCompat(context, interpolator);
    }

    public int getCurrX() {
        return ScrollerCompat.IMPL.getCurrX(this.mScroller);
    }

    public int getCurrY() {
        return ScrollerCompat.IMPL.getCurrY(this.mScroller);
    }

    public int getFinalX() {
        return ScrollerCompat.IMPL.getFinalX(this.mScroller);
    }

    public int getFinalY() {
        return ScrollerCompat.IMPL.getFinalY(this.mScroller);
    }

    public boolean isFinished() {
        return ScrollerCompat.IMPL.isFinished(this.mScroller);
    }

    public void startScroll(int startX, int startY, int dx, int dy, int duration) {
        ScrollerCompat.IMPL.startScroll(this.mScroller, startX, startY, dx, dy, duration);
    }
}

