// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package android.support.v4.widget;

import android.content.Context;
import android.support.v4.view.MotionEventCompat;
import android.support.v4.view.VelocityTrackerCompat;
import android.view.MotionEvent;
import android.view.VelocityTracker;
import android.view.View;
import android.view.ViewConfiguration;
import android.view.ViewGroup;
import android.view.animation.Interpolator;
import java.util.Arrays;

public class ViewDragHelper {
    public abstract class Callback {
        public Callback() {
            super();
        }

        public int clampViewPositionHorizontal(View child, int left, int dx) {
            return 0;
        }

        public int clampViewPositionVertical(View child, int top, int dy) {
            return 0;
        }

        public int getOrderedChildIndex(int index) {
            return index;
        }

        public int getViewHorizontalDragRange(View child) {
            return 0;
        }

        public int getViewVerticalDragRange(View child) {
            return 0;
        }

        public void onEdgeDragStarted(int edgeFlags, int pointerId) {
        }

        public boolean onEdgeLock(int edgeFlags) {
            return 0;
        }

        public void onEdgeTouched(int edgeFlags, int pointerId) {
        }

        public void onViewCaptured(View capturedChild, int activePointerId) {
        }

        public void onViewDragStateChanged(int state) {
        }

        public void onViewPositionChanged(View changedView, int left, int top, int dx, int dy) {
        }

        public void onViewReleased(View releasedChild, float xvel, float yvel) {
        }

        public abstract boolean tryCaptureView(View arg0, int arg1);
    }

    private int mActivePointerId;
    private final Callback mCallback;
    private View mCapturedView;
    private int mDragState;
    private int[] mEdgeDragsInProgress;
    private int[] mEdgeDragsLocked;
    private int mEdgeSize;
    private int[] mInitialEdgesTouched;
    private float[] mInitialMotionX;
    private float[] mInitialMotionY;
    private float[] mLastMotionX;
    private float[] mLastMotionY;
    private float mMaxVelocity;
    private float mMinVelocity;
    private final ViewGroup mParentView;
    private int mPointersDown;
    private boolean mReleaseInProgress;
    private ScrollerCompat mScroller;
    private final Runnable mSetIdleRunnable;
    private int mTouchSlop;
    private int mTrackingEdges;
    private VelocityTracker mVelocityTracker;
    private static final Interpolator sInterpolator;

    static  {
        ViewDragHelper.sInterpolator = new Interpolator() {
            public float getInterpolation(float t) {
                --t;
                return t * t * t * t * t + 1f;
            }
        };
    }

    private ViewDragHelper(Context context, ViewGroup forParent, Callback cb) {
        super();
        this.mActivePointerId = -1;
        this.mSetIdleRunnable = new Runnable() {
            public void run() {
                ViewDragHelper.this.setDragState(0);
            }
        };
        if(forParent == null) {
            throw new IllegalArgumentException("Parent view may not be null");
        }

        if(cb == null) {
            throw new IllegalArgumentException("Callback may not be null");
        }

        this.mParentView = forParent;
        this.mCallback = cb;
        ViewConfiguration v1 = ViewConfiguration.get(context);
        this.mEdgeSize = ((int)(20f * context.getResources().getDisplayMetrics().density + 0.5f));
        this.mTouchSlop = v1.getScaledTouchSlop();
        this.mMaxVelocity = ((float)v1.getScaledMaximumFlingVelocity());
        this.mMinVelocity = ((float)v1.getScaledMinimumFlingVelocity());
        this.mScroller = ScrollerCompat.create(context, ViewDragHelper.sInterpolator);
    }

    public void abort() {
        this.cancel();
        if(this.mDragState == 2) {
            int v6 = this.mScroller.getCurrX();
            int v7 = this.mScroller.getCurrY();
            this.mScroller.abortAnimation();
            int v2 = this.mScroller.getCurrX();
            int v3 = this.mScroller.getCurrY();
            this.mCallback.onViewPositionChanged(this.mCapturedView, v2, v3, v2 - v6, v3 - v7);
        }

        this.setDragState(0);
    }

    public void cancel() {
        this.mActivePointerId = -1;
        this.clearMotionHistory();
        if(this.mVelocityTracker != null) {
            this.mVelocityTracker.recycle();
            this.mVelocityTracker = null;
        }
    }

    public void captureChildView(View childView, int activePointerId) {
        if(childView.getParent() != this.mParentView) {
            throw new IllegalArgumentException("captureChildView: parameter must be a descendant of the ViewDragHelper\'s tracked parent view (" + this.mParentView + ")");
        }

        this.mCapturedView = childView;
        this.mActivePointerId = activePointerId;
        this.mCallback.onViewCaptured(childView, activePointerId);
        this.setDragState(1);
    }

    private boolean checkNewEdgeDrag(float delta, float odelta, int pointerId, int edge) {
        boolean v2 = false;
        float v0 = Math.abs(delta);
        float v1 = Math.abs(odelta);
        if((this.mInitialEdgesTouched[pointerId] & edge) == edge && (this.mTrackingEdges & edge) != 0 && (this.mEdgeDragsLocked[pointerId] & edge) != edge && (this.mEdgeDragsInProgress[pointerId] & edge) != edge && (v0 > (((float)this.mTouchSlop)) || v1 > (((float)this.mTouchSlop)))) {
            if(v0 < 0.5f * v1 && (this.mCallback.onEdgeLock(edge))) {
                this.mEdgeDragsLocked[pointerId] |= edge;
                goto label_24;
            }

            if((this.mEdgeDragsInProgress[pointerId] & edge) != 0) {
                goto label_24;
            }

            if(v0 <= (((float)this.mTouchSlop))) {
                goto label_24;
            }

            v2 = true;
        }

    label_24:
        return v2;
    }

    public boolean checkTouchSlop(int directions) {
        boolean v2;
        int v0 = this.mInitialMotionX.length;
        int v1 = 0;
        while(true) {
            if(v1 >= v0) {
                break;
            }
            else if(this.checkTouchSlop(directions, v1)) {
                v2 = true;
            }
            else {
                ++v1;
                continue;
            }

            goto label_7;
        }

        v2 = false;
    label_7:
        return v2;
    }

    private boolean checkTouchSlop(View child, float dx, float dy) {
        int v1;
        int v0;
        boolean v2 = true;
        if(child == null) {
            v2 = false;
        }
        else {
            if(this.mCallback.getViewHorizontalDragRange(child) > 0) {
                v0 = 1;
            }
            else {
                v0 = 0;
            }

            if(this.mCallback.getViewVerticalDragRange(child) > 0) {
                v1 = 1;
            }
            else {
                v1 = 0;
            }

            if(v0 != 0 && v1 != 0) {
                if(dx * dx + dy * dy <= (((float)(this.mTouchSlop * this.mTouchSlop)))) {
                    v2 = false;
                    goto label_4;
                }
                else {
                    goto label_4;
                }
            }

            if(v0 == 0) {
                goto label_36;
            }

            if(Math.abs(dx) > (((float)this.mTouchSlop))) {
                goto label_4;
            }

            v2 = false;
            goto label_4;
        label_36:
            if(v1 == 0) {
                goto label_43;
            }

            if(Math.abs(dy) > (((float)this.mTouchSlop))) {
                goto label_4;
            }

            v2 = false;
            goto label_4;
        label_43:
            v2 = false;
        }

    label_4:
        return v2;
    }

    public boolean checkTouchSlop(int directions, int pointerId) {
        int v1;
        int v0;
        boolean v4 = true;
        if(!this.isPointerDown(pointerId)) {
            v4 = false;
        }
        else {
            if((directions & 1) == 1) {
                v0 = 1;
            }
            else {
                v0 = 0;
            }

            if((directions & 2) == 2) {
                v1 = 1;
            }
            else {
                v1 = 0;
            }

            float v2 = this.mLastMotionX[pointerId] - this.mInitialMotionX[pointerId];
            float v3 = this.mLastMotionY[pointerId] - this.mInitialMotionY[pointerId];
            if(v0 != 0 && v1 != 0) {
                if(v2 * v2 + v3 * v3 <= (((float)(this.mTouchSlop * this.mTouchSlop)))) {
                    v4 = false;
                    goto label_5;
                }
                else {
                    goto label_5;
                }
            }

            if(v0 == 0) {
                goto label_46;
            }

            if(Math.abs(v2) > (((float)this.mTouchSlop))) {
                goto label_5;
            }

            v4 = false;
            goto label_5;
        label_46:
            if(v1 == 0) {
                goto label_53;
            }

            if(Math.abs(v3) > (((float)this.mTouchSlop))) {
                goto label_5;
            }

            v4 = false;
            goto label_5;
        label_53:
            v4 = false;
        }

    label_5:
        return v4;
    }

    private float clampMag(float value, float absMin, float absMax) {
        float v0 = Math.abs(value);
        if(v0 < absMin) {
            absMax = 0f;
        }
        else if(v0 <= absMax) {
            absMax = value;
        }
        else if(value <= 0f) {
            absMax = -absMax;
        }

        return absMax;
    }

    private int clampMag(int value, int absMin, int absMax) {
        int v0 = Math.abs(value);
        if(v0 < absMin) {
            absMax = 0;
        }
        else if(v0 <= absMax) {
            absMax = value;
        }
        else if(value <= 0) {
            absMax = -absMax;
        }

        return absMax;
    }

    private void clearMotionHistory() {
        if(this.mInitialMotionX != null) {
            Arrays.fill(this.mInitialMotionX, 0f);
            Arrays.fill(this.mInitialMotionY, 0f);
            Arrays.fill(this.mLastMotionX, 0f);
            Arrays.fill(this.mLastMotionY, 0f);
            Arrays.fill(this.mInitialEdgesTouched, 0);
            Arrays.fill(this.mEdgeDragsInProgress, 0);
            Arrays.fill(this.mEdgeDragsLocked, 0);
            this.mPointersDown = 0;
        }
    }

    private void clearMotionHistory(int pointerId) {
        if(this.mInitialMotionX != null) {
            this.mInitialMotionX[pointerId] = 0f;
            this.mInitialMotionY[pointerId] = 0f;
            this.mLastMotionX[pointerId] = 0f;
            this.mLastMotionY[pointerId] = 0f;
            this.mInitialEdgesTouched[pointerId] = 0;
            this.mEdgeDragsInProgress[pointerId] = 0;
            this.mEdgeDragsLocked[pointerId] = 0;
            this.mPointersDown &= 1 << pointerId ^ -1;
        }
    }

    private int computeAxisDuration(int delta, int velocity, int motionRange) {
        int v2;
        int v6;
        float v9 = 1f;
        if(delta == 0) {
            v6 = 0;
        }
        else {
            int v5 = this.mParentView.getWidth();
            int v3 = v5 / 2;
            float v0 = (((float)v3)) + (((float)v3)) * this.distanceInfluenceForSnapDuration(Math.min(v9, (((float)Math.abs(delta))) / (((float)v5))));
            velocity = Math.abs(velocity);
            if(velocity > 0) {
                v2 = Math.round(1000f * Math.abs(v0 / (((float)velocity)))) * 4;
            }
            else {
                v2 = ((int)(((((float)Math.abs(delta))) / (((float)motionRange)) + v9) * 256f));
            }

            v6 = Math.min(v2, 600);
        }

        return v6;
    }

    private int computeSettleDuration(View child, int dx, int dy, int xvel, int yvel) {
        float v11;
        float v9;
        xvel = this.clampMag(xvel, ((int)this.mMinVelocity), ((int)this.mMaxVelocity));
        yvel = this.clampMag(yvel, ((int)this.mMinVelocity), ((int)this.mMaxVelocity));
        int v2 = Math.abs(dx);
        int v3 = Math.abs(dy);
        int v4 = Math.abs(xvel);
        int v5 = Math.abs(yvel);
        int v7 = v4 + v5;
        int v6 = v2 + v3;
        if(xvel != 0) {
            v9 = (((float)v4)) / (((float)v7));
        }
        else {
            v9 = (((float)v2)) / (((float)v6));
        }

        if(yvel != 0) {
            v11 = (((float)v5)) / (((float)v7));
        }
        else {
            v11 = (((float)v3)) / (((float)v6));
        }

        return ((int)((((float)this.computeAxisDuration(dx, xvel, this.mCallback.getViewHorizontalDragRange(child)))) * v9 + (((float)this.computeAxisDuration(dy, yvel, this.mCallback.getViewVerticalDragRange(child)))) * v11));
    }

    public boolean continueSettling(boolean deferCallbacks) {
        boolean v0;
        int v8 = 2;
        if(this.mDragState == v8) {
            boolean v6 = this.mScroller.computeScrollOffset();
            int v2 = this.mScroller.getCurrX();
            int v3 = this.mScroller.getCurrY();
            int v4 = v2 - this.mCapturedView.getLeft();
            int v5 = v3 - this.mCapturedView.getTop();
            if(v4 != 0) {
                this.mCapturedView.offsetLeftAndRight(v4);
            }

            if(v5 != 0) {
                this.mCapturedView.offsetTopAndBottom(v5);
            }

            if(v4 != 0 || v5 != 0) {
                this.mCallback.onViewPositionChanged(this.mCapturedView, v2, v3, v4, v5);
            }

            if((v6) && v2 == this.mScroller.getFinalX() && v3 == this.mScroller.getFinalY()) {
                this.mScroller.abortAnimation();
                v6 = this.mScroller.isFinished();
            }

            if(v6) {
                goto label_43;
            }

            if(!deferCallbacks) {
                goto label_47;
            }

            this.mParentView.post(this.mSetIdleRunnable);
            goto label_43;
        label_47:
            this.setDragState(0);
        }

    label_43:
        if(this.mDragState == v8) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    public static ViewDragHelper create(ViewGroup forParent, float sensitivity, Callback cb) {
        ViewDragHelper v0 = ViewDragHelper.create(forParent, cb);
        v0.mTouchSlop = ((int)((((float)v0.mTouchSlop)) * (1f / sensitivity)));
        return v0;
    }

    public static ViewDragHelper create(ViewGroup forParent, Callback cb) {
        return new ViewDragHelper(forParent.getContext(), forParent, cb);
    }

    private void dispatchViewReleased(float xvel, float yvel) {
        this.mReleaseInProgress = true;
        this.mCallback.onViewReleased(this.mCapturedView, xvel, yvel);
        this.mReleaseInProgress = false;
        if(this.mDragState == 1) {
            this.setDragState(0);
        }
    }

    private float distanceInfluenceForSnapDuration(float f) {
        return ((float)Math.sin(((double)(((float)((((double)(f - 0.5f))) * 0.471239))))));
    }

    private void dragTo(int left, int top, int dx, int dy) {
        int v2 = left;
        int v3 = top;
        int v6 = this.mCapturedView.getLeft();
        int v7 = this.mCapturedView.getTop();
        if(dx != 0) {
            v2 = this.mCallback.clampViewPositionHorizontal(this.mCapturedView, left, dx);
            this.mCapturedView.offsetLeftAndRight(v2 - v6);
        }

        if(dy != 0) {
            v3 = this.mCallback.clampViewPositionVertical(this.mCapturedView, top, dy);
            this.mCapturedView.offsetTopAndBottom(v3 - v7);
        }

        if(dx != 0 || dy != 0) {
            this.mCallback.onViewPositionChanged(this.mCapturedView, v2, v3, v2 - v6, v3 - v7);
        }
    }

    private void ensureMotionHistorySizeForId(int pointerId) {
        if(this.mInitialMotionX == null || this.mInitialMotionX.length <= pointerId) {
            float[] v3 = new float[pointerId + 1];
            float[] v4 = new float[pointerId + 1];
            float[] v5 = new float[pointerId + 1];
            float[] v6 = new float[pointerId + 1];
            int[] v2 = new int[pointerId + 1];
            int[] v0 = new int[pointerId + 1];
            int[] v1 = new int[pointerId + 1];
            if(this.mInitialMotionX != null) {
                System.arraycopy(this.mInitialMotionX, 0, v3, 0, this.mInitialMotionX.length);
                System.arraycopy(this.mInitialMotionY, 0, v4, 0, this.mInitialMotionY.length);
                System.arraycopy(this.mLastMotionX, 0, v5, 0, this.mLastMotionX.length);
                System.arraycopy(this.mLastMotionY, 0, v6, 0, this.mLastMotionY.length);
                System.arraycopy(this.mInitialEdgesTouched, 0, v2, 0, this.mInitialEdgesTouched.length);
                System.arraycopy(this.mEdgeDragsInProgress, 0, v0, 0, this.mEdgeDragsInProgress.length);
                System.arraycopy(this.mEdgeDragsLocked, 0, v1, 0, this.mEdgeDragsLocked.length);
            }

            this.mInitialMotionX = v3;
            this.mInitialMotionY = v4;
            this.mLastMotionX = v5;
            this.mLastMotionY = v6;
            this.mInitialEdgesTouched = v2;
            this.mEdgeDragsInProgress = v0;
            this.mEdgeDragsLocked = v1;
        }
    }

    public View findTopChildUnder(int x, int y) {
        View v0;
        int v2;
        for(v2 = this.mParentView.getChildCount() - 1; v2 >= 0; --v2) {
            v0 = this.mParentView.getChildAt(this.mCallback.getOrderedChildIndex(v2));
            if(x >= v0.getLeft() && x < v0.getRight() && y >= v0.getTop() && y < v0.getBottom()) {
                goto label_16;
            }
        }

        v0 = null;
    label_16:
        return v0;
    }

    private boolean forceSettleCapturedViewAt(int finalLeft, int finalTop, int xvel, int yvel) {
        boolean v0 = false;
        int v10 = this.mCapturedView.getLeft();
        int v6 = this.mCapturedView.getTop();
        int v2 = finalLeft - v10;
        int v3 = finalTop - v6;
        if(v2 != 0 || v3 != 0) {
            this.mScroller.startScroll(v10, v6, v2, v3, this.computeSettleDuration(this.mCapturedView, v2, v3, xvel, yvel));
            this.setDragState(2);
            v0 = true;
        }
        else {
            this.mScroller.abortAnimation();
            this.setDragState(0);
        }

        return v0;
    }

    public View getCapturedView() {
        return this.mCapturedView;
    }

    public int getEdgeSize() {
        return this.mEdgeSize;
    }

    private int getEdgesTouched(int x, int y) {
        int v0 = 0;
        if(x < this.mParentView.getLeft() + this.mEdgeSize) {
            v0 = 1;
        }

        if(y < this.mParentView.getTop() + this.mEdgeSize) {
            v0 |= 4;
        }

        if(x > this.mParentView.getRight() - this.mEdgeSize) {
            v0 |= 2;
        }

        if(y > this.mParentView.getBottom() - this.mEdgeSize) {
            v0 |= 8;
        }

        return v0;
    }

    public int getTouchSlop() {
        return this.mTouchSlop;
    }

    public int getViewDragState() {
        return this.mDragState;
    }

    public boolean isCapturedViewUnder(int x, int y) {
        return this.isViewUnder(this.mCapturedView, x, y);
    }

    public boolean isEdgeTouched(int edges) {
        boolean v2;
        int v0 = this.mInitialEdgesTouched.length;
        int v1 = 0;
        while(true) {
            if(v1 >= v0) {
                break;
            }
            else if(this.isEdgeTouched(edges, v1)) {
                v2 = true;
            }
            else {
                ++v1;
                continue;
            }

            goto label_7;
        }

        v2 = false;
    label_7:
        return v2;
    }

    public boolean isEdgeTouched(int edges, int pointerId) {
        boolean v0;
        if(!this.isPointerDown(pointerId) || (this.mInitialEdgesTouched[pointerId] & edges) == 0) {
            v0 = false;
        }
        else {
            v0 = true;
        }

        return v0;
    }

    public boolean isPointerDown(int pointerId) {
        boolean v0 = true;
        if((this.mPointersDown & 1 << pointerId) == 0) {
            v0 = false;
        }

        return v0;
    }

    public boolean isViewUnder(View view, int x, int y) {
        boolean v0 = false;
        if(view != null && x >= view.getLeft() && x < view.getRight() && y >= view.getTop() && y < view.getBottom()) {
            v0 = true;
        }

        return v0;
    }

    public void processTouchEvent(MotionEvent ev) {
        int v14;
        int v7;
        View v16;
        int v15;
        float v18;
        float v17;
        int v3 = MotionEventCompat.getActionMasked(ev);
        int v4 = MotionEventCompat.getActionIndex(ev);
        if(v3 == 0) {
            this.cancel();
        }

        if(this.mVelocityTracker == null) {
            this.mVelocityTracker = VelocityTracker.obtain();
        }

        this.mVelocityTracker.addMovement(ev);
        switch(v3) {
            case 0: {
                v17 = ev.getX();
                v18 = ev.getY();
                v15 = MotionEventCompat.getPointerId(ev, 0);
                v16 = this.findTopChildUnder(((int)v17), ((int)v18));
                this.saveInitialMotion(v17, v18, v15);
                this.tryCaptureViewForDrag(v16, v15);
                v7 = this.mInitialEdgesTouched[v15];
                if((this.mTrackingEdges & v7) == 0) {
                    return;
                }

                this.mCallback.onEdgeTouched(this.mTrackingEdges & v7, v15);
                break;
            }
            case 1: {
                if(this.mDragState == 1) {
                    this.releaseViewForPointerUp();
                }

                this.cancel();
                break;
            }
            case 2: {
                if(this.mDragState != 1) {
                    goto label_181;
                }

                int v12 = MotionEventCompat.findPointerIndex(ev, this.mActivePointerId);
                v17 = MotionEventCompat.getX(ev, v12);
                v18 = MotionEventCompat.getY(ev, v12);
                int v10 = ((int)(v17 - this.mLastMotionX[this.mActivePointerId]));
                int v11 = ((int)(v18 - this.mLastMotionY[this.mActivePointerId]));
                this.dragTo(this.mCapturedView.getLeft() + v10, this.mCapturedView.getTop() + v11, v10, v11);
                this.saveLastMotion(ev);
                return;
            label_181:
                v14 = MotionEventCompat.getPointerCount(ev);
                v8 = 0;
                while(v8 < v14) {
                    v15 = MotionEventCompat.getPointerId(ev, v8);
                    v17 = MotionEventCompat.getX(ev, v8);
                    v18 = MotionEventCompat.getY(ev, v8);
                    float v5 = v17 - this.mInitialMotionX[v15];
                    float v6 = v18 - this.mInitialMotionY[v15];
                    this.reportNewEdgeDrags(v5, v6, v15);
                    if(this.mDragState == 1) {
                        break;
                    }

                    v16 = this.findTopChildUnder(((int)v17), ((int)v18));
                    if((this.checkTouchSlop(v16, v5, v6)) && (this.tryCaptureViewForDrag(v16, v15))) {
                        break;
                    }

                    ++v8;
                }

                this.saveLastMotion(ev);
                break;
            }
            case 3: {
                if(this.mDragState == 1) {
                    this.dispatchViewReleased(0f, 0f);
                }

                this.cancel();
                break;
            }
            case 5: {
                v15 = MotionEventCompat.getPointerId(ev, v4);
                v17 = MotionEventCompat.getX(ev, v4);
                v18 = MotionEventCompat.getY(ev, v4);
                this.saveInitialMotion(v17, v18, v15);
                if(this.mDragState != 0) {
                    goto label_110;
                }

                this.tryCaptureViewForDrag(this.findTopChildUnder(((int)v17), ((int)v18)), v15);
                v7 = this.mInitialEdgesTouched[v15];
                if((this.mTrackingEdges & v7) == 0) {
                    return;
                }

                this.mCallback.onEdgeTouched(this.mTrackingEdges & v7, v15);
                return;
            label_110:
                if(!this.isCapturedViewUnder(((int)v17), ((int)v18))) {
                    return;
                }

                this.tryCaptureViewForDrag(this.mCapturedView, v15);
                break;
            }
            case 6: {
                v15 = MotionEventCompat.getPointerId(ev, v4);
                if(this.mDragState == 1 && v15 == this.mActivePointerId) {
                    int v13 = -1;
                    v14 = MotionEventCompat.getPointerCount(ev);
                    int v8;
                    for(v8 = 0; v8 < v14; ++v8) {
                        int v9 = MotionEventCompat.getPointerId(ev, v8);
                        if(v9 != this.mActivePointerId && this.findTopChildUnder(((int)MotionEventCompat.getX(ev, v8)), ((int)MotionEventCompat.getY(ev, v8))) == this.mCapturedView && (this.tryCaptureViewForDrag(this.mCapturedView, v9))) {
                            v13 = this.mActivePointerId;
                            goto label_287;
                        }
                    }

                label_287:
                    if(v13 != -1) {
                        goto label_291;
                    }

                    this.releaseViewForPointerUp();
                }

            label_291:
                this.clearMotionHistory(v15);
                break;
            }
        }
    }

    private void releaseViewForPointerUp() {
        this.mVelocityTracker.computeCurrentVelocity(1000, this.mMaxVelocity);
        this.dispatchViewReleased(this.clampMag(VelocityTrackerCompat.getXVelocity(this.mVelocityTracker, this.mActivePointerId), this.mMinVelocity, this.mMaxVelocity), this.clampMag(VelocityTrackerCompat.getYVelocity(this.mVelocityTracker, this.mActivePointerId), this.mMinVelocity, this.mMaxVelocity));
    }

    private void reportNewEdgeDrags(float dx, float dy, int pointerId) {
        int v0 = 0;
        if(this.checkNewEdgeDrag(dx, dy, pointerId, 1)) {
            v0 = 1;
        }

        if(this.checkNewEdgeDrag(dy, dx, pointerId, 4)) {
            v0 |= 4;
        }

        if(this.checkNewEdgeDrag(dx, dy, pointerId, 2)) {
            v0 |= 2;
        }

        if(this.checkNewEdgeDrag(dy, dx, pointerId, 8)) {
            v0 |= 8;
        }

        if(v0 != 0) {
            this.mEdgeDragsInProgress[pointerId] |= v0;
            this.mCallback.onEdgeDragStarted(v0, pointerId);
        }
    }

    private void saveInitialMotion(float x, float y, int pointerId) {
        this.ensureMotionHistorySizeForId(pointerId);
        float[] v0 = this.mInitialMotionX;
        this.mLastMotionX[pointerId] = x;
        v0[pointerId] = x;
        v0 = this.mInitialMotionY;
        this.mLastMotionY[pointerId] = y;
        v0[pointerId] = y;
        this.mInitialEdgesTouched[pointerId] = this.getEdgesTouched(((int)x), ((int)y));
        this.mPointersDown |= 1 << pointerId;
    }

    private void saveLastMotion(MotionEvent ev) {
        int v1 = MotionEventCompat.getPointerCount(ev);
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            int v2 = MotionEventCompat.getPointerId(ev, v0);
            float v3 = MotionEventCompat.getX(ev, v0);
            float v4 = MotionEventCompat.getY(ev, v0);
            this.mLastMotionX[v2] = v3;
            this.mLastMotionY[v2] = v4;
        }
    }

    void setDragState(int state) {
        if(this.mDragState != state) {
            this.mDragState = state;
            this.mCallback.onViewDragStateChanged(state);
            if(state == 0) {
                this.mCapturedView = null;
            }
        }
    }

    public void setEdgeTrackingEnabled(int edgeFlags) {
        this.mTrackingEdges = edgeFlags;
    }

    public void setMinVelocity(float minVel) {
        this.mMinVelocity = minVel;
    }

    public boolean settleCapturedViewAt(int finalLeft, int finalTop) {
        if(!this.mReleaseInProgress) {
            throw new IllegalStateException("Cannot settleCapturedViewAt outside of a call to Callback#onViewReleased");
        }

        return this.forceSettleCapturedViewAt(finalLeft, finalTop, ((int)VelocityTrackerCompat.getXVelocity(this.mVelocityTracker, this.mActivePointerId)), ((int)VelocityTrackerCompat.getYVelocity(this.mVelocityTracker, this.mActivePointerId)));
    }

    public boolean shouldInterceptTouchEvent(MotionEvent ev) {
        boolean v11;
        View v8;
        int v4;
        float v10;
        float v9;
        int v7;
        int v0 = MotionEventCompat.getActionMasked(ev);
        int v1 = MotionEventCompat.getActionIndex(ev);
        if(v0 == 0) {
            this.cancel();
        }

        if(this.mVelocityTracker == null) {
            this.mVelocityTracker = VelocityTracker.obtain();
        }

        this.mVelocityTracker.addMovement(ev);
        switch(v0) {
            case 0: {
                v9 = ev.getX();
                v10 = ev.getY();
                v7 = MotionEventCompat.getPointerId(ev, 0);
                this.saveInitialMotion(v9, v10, v7);
                v8 = this.findTopChildUnder(((int)v9), ((int)v10));
                if(v8 == this.mCapturedView && this.mDragState == 2) {
                    this.tryCaptureViewForDrag(v8, v7);
                }

                v4 = this.mInitialEdgesTouched[v7];
                if((this.mTrackingEdges & v4) == 0) {
                    goto label_11;
                }

                this.mCallback.onEdgeTouched(this.mTrackingEdges & v4, v7);
                break;
            }
            case 2: {
                int v6 = MotionEventCompat.getPointerCount(ev);
                int v5 = 0;
                while(v5 < v6) {
                    v7 = MotionEventCompat.getPointerId(ev, v5);
                    v9 = MotionEventCompat.getX(ev, v5);
                    v10 = MotionEventCompat.getY(ev, v5);
                    float v2 = v9 - this.mInitialMotionX[v7];
                    float v3 = v10 - this.mInitialMotionY[v7];
                    this.reportNewEdgeDrags(v2, v3, v7);
                    if(this.mDragState == 1) {
                        break;
                    }

                    v8 = this.findTopChildUnder(((int)v9), ((int)v10));
                    if(v8 != null && (this.checkTouchSlop(v8, v2, v3)) && (this.tryCaptureViewForDrag(v8, v7))) {
                        break;
                    }

                    ++v5;
                }

                this.saveLastMotion(ev);
                break;
            }
            case 1: 
            case 3: {
                this.cancel();
                break;
            }
            case 5: {
                v7 = MotionEventCompat.getPointerId(ev, v1);
                v9 = MotionEventCompat.getX(ev, v1);
                v10 = MotionEventCompat.getY(ev, v1);
                this.saveInitialMotion(v9, v10, v7);
                if(this.mDragState != 0) {
                    goto label_56;
                }

                v4 = this.mInitialEdgesTouched[v7];
                if((this.mTrackingEdges & v4) == 0) {
                    goto label_11;
                }

                this.mCallback.onEdgeTouched(this.mTrackingEdges & v4, v7);
                goto label_11;
            label_56:
                if(this.mDragState != 2) {
                    goto label_11;
                }

                v8 = this.findTopChildUnder(((int)v9), ((int)v10));
                if(v8 != this.mCapturedView) {
                    goto label_11;
                }

                this.tryCaptureViewForDrag(v8, v7);
                break;
            }
            case 6: {
                this.clearMotionHistory(MotionEventCompat.getPointerId(ev, v1));
                break;
            }
        }

    label_11:
        if(this.mDragState == 1) {
            v11 = true;
        }
        else {
            v11 = false;
        }

        return v11;
    }

    public boolean smoothSlideViewTo(View child, int finalLeft, int finalTop) {
        this.mCapturedView = child;
        this.mActivePointerId = -1;
        return this.forceSettleCapturedViewAt(finalLeft, finalTop, 0, 0);
    }

    boolean tryCaptureViewForDrag(View toCapture, int pointerId) {
        boolean v0 = true;
        if(toCapture != this.mCapturedView || this.mActivePointerId != pointerId) {
            if(toCapture != null && (this.mCallback.tryCaptureView(toCapture, pointerId))) {
                this.mActivePointerId = pointerId;
                this.captureChildView(toCapture, pointerId);
                goto label_5;
            }

            v0 = false;
        }

    label_5:
        return v0;
    }
}

