// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.google.gson;

import com.google.gson.internal.ConstructorConstructor;
import com.google.gson.internal.Excluder;
import com.google.gson.internal.bind.ArrayTypeAdapter;
import com.google.gson.internal.bind.CollectionTypeAdapterFactory;
import com.google.gson.internal.bind.DateTypeAdapter;
import com.google.gson.internal.bind.MapTypeAdapterFactory;
import com.google.gson.internal.bind.ObjectTypeAdapter;
import com.google.gson.internal.bind.ReflectiveTypeAdapterFactory;
import com.google.gson.internal.bind.SqlDateTypeAdapter;
import com.google.gson.internal.bind.TimeTypeAdapter;
import com.google.gson.internal.bind.TypeAdapters;
import com.google.gson.reflect.TypeToken;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonToken;
import com.google.gson.stream.JsonWriter;
import com.google.gson.stream.MalformedJsonException;
import java.io.EOFException;
import java.io.IOException;
import java.io.Reader;
import java.io.StringReader;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public final class Gson {
    class FutureTypeAdapter extends TypeAdapter {
        private TypeAdapter delegate;

        FutureTypeAdapter() {
            super();
        }

        public Object read(JsonReader in) throws IOException {
            if(this.delegate == null) {
                throw new IllegalStateException();
            }

            return this.delegate.read(in);
        }

        public void setDelegate(TypeAdapter arg2) {
            if(this.delegate != null) {
                throw new AssertionError();
            }

            this.delegate = arg2;
        }

        public void write(JsonWriter out, Object arg3) throws IOException {
            if(this.delegate == null) {
                throw new IllegalStateException();
            }

            this.delegate.write(out, arg3);
        }
    }

    private final ThreadLocal calls;
    private final ConstructorConstructor constructorConstructor;
    final JsonDeserializationContext deserializationContext;
    private final List factories;
    private final boolean generateNonExecutableJson;
    private final boolean htmlSafe;
    private final boolean prettyPrinting;
    final JsonSerializationContext serializationContext;
    private final boolean serializeNulls;
    private final Map typeTokenCache;

    public Gson() {
        this(Excluder.DEFAULT, FieldNamingPolicy.IDENTITY, Collections.emptyMap(), false, false, false, true, false, false, LongSerializationPolicy.DEFAULT, Collections.emptyList());
    }

    Gson(Excluder excluder, FieldNamingStrategy fieldNamingPolicy, Map arg7, boolean serializeNulls, boolean complexMapKeySerialization, boolean generateNonExecutableGson, boolean htmlSafe, boolean prettyPrinting, boolean serializeSpecialFloatingPointValues, LongSerializationPolicy longSerializationPolicy, List arg15) {
        super();
        this.calls = new ThreadLocal() {
            protected Object initialValue() {
                return this.initialValue();
            }

            protected Map initialValue() {
                return new HashMap();
            }
        };
        this.typeTokenCache = Collections.synchronizedMap(new HashMap());
        this.deserializationContext = new JsonDeserializationContext() {
        };
        this.serializationContext = new JsonSerializationContext() {
        };
        this.constructorConstructor = new ConstructorConstructor(arg7);
        this.serializeNulls = serializeNulls;
        this.generateNonExecutableJson = generateNonExecutableGson;
        this.htmlSafe = htmlSafe;
        this.prettyPrinting = prettyPrinting;
        ArrayList v0 = new ArrayList();
        ((List)v0).add(TypeAdapters.JSON_ELEMENT_FACTORY);
        ((List)v0).add(ObjectTypeAdapter.FACTORY);
        ((List)v0).addAll(((Collection)arg15));
        ((List)v0).add(TypeAdapters.STRING_FACTORY);
        ((List)v0).add(TypeAdapters.INTEGER_FACTORY);
        ((List)v0).add(TypeAdapters.BOOLEAN_FACTORY);
        ((List)v0).add(TypeAdapters.BYTE_FACTORY);
        ((List)v0).add(TypeAdapters.SHORT_FACTORY);
        ((List)v0).add(TypeAdapters.newFactory(Long.TYPE, Long.class, this.longAdapter(longSerializationPolicy)));
        ((List)v0).add(TypeAdapters.newFactory(Double.TYPE, Double.class, this.doubleAdapter(serializeSpecialFloatingPointValues)));
        ((List)v0).add(TypeAdapters.newFactory(Float.TYPE, Float.class, this.floatAdapter(serializeSpecialFloatingPointValues)));
        ((List)v0).add(TypeAdapters.NUMBER_FACTORY);
        ((List)v0).add(TypeAdapters.CHARACTER_FACTORY);
        ((List)v0).add(TypeAdapters.STRING_BUILDER_FACTORY);
        ((List)v0).add(TypeAdapters.STRING_BUFFER_FACTORY);
        ((List)v0).add(TypeAdapters.newFactory(BigDecimal.class, TypeAdapters.BIG_DECIMAL));
        ((List)v0).add(TypeAdapters.newFactory(BigInteger.class, TypeAdapters.BIG_INTEGER));
        ((List)v0).add(TypeAdapters.URL_FACTORY);
        ((List)v0).add(TypeAdapters.URI_FACTORY);
        ((List)v0).add(TypeAdapters.UUID_FACTORY);
        ((List)v0).add(TypeAdapters.LOCALE_FACTORY);
        ((List)v0).add(TypeAdapters.INET_ADDRESS_FACTORY);
        ((List)v0).add(TypeAdapters.BIT_SET_FACTORY);
        ((List)v0).add(DateTypeAdapter.FACTORY);
        ((List)v0).add(TypeAdapters.CALENDAR_FACTORY);
        ((List)v0).add(TimeTypeAdapter.FACTORY);
        ((List)v0).add(SqlDateTypeAdapter.FACTORY);
        ((List)v0).add(TypeAdapters.TIMESTAMP_FACTORY);
        ((List)v0).add(ArrayTypeAdapter.FACTORY);
        ((List)v0).add(TypeAdapters.ENUM_FACTORY);
        ((List)v0).add(TypeAdapters.CLASS_FACTORY);
        ((List)v0).add(excluder);
        ((List)v0).add(new CollectionTypeAdapterFactory(this.constructorConstructor));
        ((List)v0).add(new MapTypeAdapterFactory(this.constructorConstructor, complexMapKeySerialization));
        ((List)v0).add(new ReflectiveTypeAdapterFactory(this.constructorConstructor, fieldNamingPolicy, excluder));
        this.factories = Collections.unmodifiableList(((List)v0));
    }

    static void access$000(Gson x0, double x1) {
        x0.checkValidFloatingPoint(x1);
    }

    private static void assertFullConsumption(Object obj, JsonReader reader) {
        if(obj != null) {
            try {
                if(reader.peek() != JsonToken.END_DOCUMENT) {
                    throw new JsonIOException("JSON document was not fully consumed.");
                }
            }
            catch(IOException v0) {
                throw new JsonIOException(((Throwable)v0));
            }
            catch(MalformedJsonException v0_1) {
                throw new JsonSyntaxException(((Throwable)v0_1));
            }
        }
    }

    private void checkValidFloatingPoint(double value) {
        if(!Double.isNaN(value) && !Double.isInfinite(value)) {
            return;
        }

        throw new IllegalArgumentException(value + " is not a valid double value as per JSON specification. To override this" + " behavior, use GsonBuilder.serializeSpecialDoubleValues() method.");
    }

    private TypeAdapter doubleAdapter(boolean serializeSpecialFloatingPointValues) {
        com.google.gson.Gson$4 v0_1;
        if(serializeSpecialFloatingPointValues) {
            TypeAdapter v0 = TypeAdapters.DOUBLE;
        }
        else {
            v0_1 = new TypeAdapter() {
                public Double read(JsonReader in) throws IOException {
                    Double v0;
                    if(in.peek() == JsonToken.NULL) {
                        in.nextNull();
                        v0 = null;
                    }
                    else {
                        v0 = Double.valueOf(in.nextDouble());
                    }

                    return v0;
                }

                public Object read(JsonReader x0) throws IOException {
                    return this.read(x0);
                }

                public void write(JsonWriter out, Number value) throws IOException {
                    if(value == null) {
                        out.nullValue();
                    }
                    else {
                        Gson.this.checkValidFloatingPoint(value.doubleValue());
                        out.value(value);
                    }
                }

                public void write(JsonWriter x0, Object x1) throws IOException {
                    this.write(x0, ((Number)x1));
                }
            };
        }

        return ((TypeAdapter)v0_1);
    }

    private TypeAdapter floatAdapter(boolean serializeSpecialFloatingPointValues) {
        com.google.gson.Gson$5 v0_1;
        if(serializeSpecialFloatingPointValues) {
            TypeAdapter v0 = TypeAdapters.FLOAT;
        }
        else {
            v0_1 = new TypeAdapter() {
                public Float read(JsonReader in) throws IOException {
                    Float v0;
                    if(in.peek() == JsonToken.NULL) {
                        in.nextNull();
                        v0 = null;
                    }
                    else {
                        v0 = Float.valueOf(((float)in.nextDouble()));
                    }

                    return v0;
                }

                public Object read(JsonReader x0) throws IOException {
                    return this.read(x0);
                }

                public void write(JsonWriter out, Number value) throws IOException {
                    if(value == null) {
                        out.nullValue();
                    }
                    else {
                        Gson.this.checkValidFloatingPoint(((double)value.floatValue()));
                        out.value(value);
                    }
                }

                public void write(JsonWriter x0, Object x1) throws IOException {
                    this.write(x0, ((Number)x1));
                }
            };
        }

        return ((TypeAdapter)v0_1);
    }

    public Object fromJson(String json, Type typeOfT) throws JsonSyntaxException {
        Object v1;
        if(json == null) {
            v1 = null;
        }
        else {
            v1 = this.fromJson(new StringReader(json), typeOfT);
        }

        return v1;
    }

    public Object fromJson(JsonReader reader, Type typeOfT) throws JsonIOException, JsonSyntaxException {
        Object v4_1;
        boolean v2 = reader.isLenient();
        reader.setLenient(true);
        try {
            reader.peek();
            v4_1 = this.getAdapter(TypeToken.get(typeOfT)).read(reader);
        }
        catch(Throwable v4) {
        }
        catch(IOException v0) {
        }
        catch(IllegalStateException v0_1) {
            try {
                throw new JsonSyntaxException(((Throwable)v0_1));
                throw new JsonSyntaxException(((Throwable)v0));
            }
            catch(Throwable v4) {
            label_19:
                reader.setLenient(v2);
                throw v4;
            }
        }
        catch(EOFException v0_2) {
            if(0 == 0) {
                goto label_16;
            }

            v4_1 = null;
            reader.setLenient(v2);
            goto label_10;
            try {
            label_16:
                throw new JsonSyntaxException(((Throwable)v0_2));
            }
            catch(Throwable v4) {
                goto label_19;
            }
        }

        reader.setLenient(v2);
    label_10:
        return v4_1;
    }

    public Object fromJson(Reader json, Type typeOfT) throws JsonIOException, JsonSyntaxException {
        JsonReader v0 = new JsonReader(json);
        Object v1 = this.fromJson(v0, typeOfT);
        Gson.assertFullConsumption(v1, v0);
        return v1;
    }

    public TypeAdapter getAdapter(TypeToken arg11) {
        TypeAdapter v0_1;
        TypeAdapter v2;
        Object v6;
        Object v0 = this.typeTokenCache.get(arg11);
        if(v0 == null) {
            v6 = this.calls.get();
            Object v5 = ((Map)v6).get(arg11);
            if(v5 != null) {
                v0 = v5;
            }
            else {
                FutureTypeAdapter v1 = new FutureTypeAdapter();
                ((Map)v6).put(arg11, v1);
                try {
                    Iterator v4 = this.factories.iterator();
                    do {
                        if(v4.hasNext()) {
                            v2 = v4.next().create(this, arg11);
                            if(v2 == null) {
                                continue;
                            }

                            break;
                        }
                        else {
                            goto label_25;
                        }
                    }
                    while(true);

                    v1.setDelegate(v2);
                    this.typeTokenCache.put(arg11, v2);
                }
                catch(Throwable v7) {
                    goto label_33;
                }

                ((Map)v6).remove(arg11);
                v0_1 = v2;
                goto label_3;
                try {
                label_25:
                    throw new IllegalArgumentException("GSON cannot handle " + arg11);
                }
                catch(Throwable v7) {
                    goto label_33;
                }
            }
        }

    label_3:
        return v0_1;
    label_33:
        ((Map)v6).remove(arg11);
        throw v7;
    }

    public TypeAdapter getAdapter(Class arg2) {
        return this.getAdapter(TypeToken.get(arg2));
    }

    public TypeAdapter getDelegateAdapter(TypeAdapterFactory skipPast, TypeToken arg9) {
        TypeAdapter v0;
        int v3 = 0;
        Iterator v2 = this.factories.iterator();
        do {
        label_3:
            if(!v2.hasNext()) {
                goto label_13;
            }

            Object v1 = v2.next();
            if(v3 != 0) {
                goto label_10;
            }

            if((((TypeAdapterFactory)v1)) != skipPast) {
                goto label_3;
            }

            v3 = 1;
            goto label_3;
        label_10:
            v0 = ((TypeAdapterFactory)v1).create(this, arg9);
        }
        while(v0 == null);

        return v0;
    label_13:
        throw new IllegalArgumentException("GSON cannot serialize " + arg9);
    }

    private TypeAdapter longAdapter(LongSerializationPolicy longSerializationPolicy) {
        TypeAdapter v0;
        if(longSerializationPolicy == LongSerializationPolicy.DEFAULT) {
            v0 = TypeAdapters.LONG;
        }
        else {
            com.google.gson.Gson$6 v0_1 = new TypeAdapter() {
                public Number read(JsonReader in) throws IOException {
                    Number v0;
                    if(in.peek() == JsonToken.NULL) {
                        in.nextNull();
                        v0 = null;
                    }
                    else {
                        Long v0_1 = Long.valueOf(in.nextLong());
                    }

                    return v0;
                }

                public Object read(JsonReader x0) throws IOException {
                    return this.read(x0);
                }

                public void write(JsonWriter out, Number value) throws IOException {
                    if(value == null) {
                        out.nullValue();
                    }
                    else {
                        out.value(value.toString());
                    }
                }

                public void write(JsonWriter x0, Object x1) throws IOException {
                    this.write(x0, ((Number)x1));
                }
            };
        }

        return v0;
    }

    public String toString() {
        return "{" + "serializeNulls:" + this.serializeNulls + "factories:" + this.factories + ",instanceCreators:" + this.constructorConstructor + "}";
    }
}

