// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.google.gson;

import com.google.gson.internal.$Gson$Preconditions;
import com.google.gson.internal.LazilyParsedNumber;
import java.math.BigInteger;

public final class JsonPrimitive extends JsonElement {
    private static final Class[] PRIMITIVE_TYPES;
    private Object value;

    static  {
        JsonPrimitive.PRIMITIVE_TYPES = new Class[]{Integer.TYPE, Long.TYPE, Short.TYPE, Float.TYPE, Double.TYPE, Byte.TYPE, Boolean.TYPE, Character.TYPE, Integer.class, Long.class, Short.class, Float.class, Double.class, Byte.class, Boolean.class, Character.class};
    }

    public JsonPrimitive(Boolean bool) {
        super();
        this.setValue(bool);
    }

    public JsonPrimitive(Number number) {
        super();
        this.setValue(number);
    }

    public JsonPrimitive(String string) {
        super();
        this.setValue(string);
    }

    public boolean equals(Object obj) {
        boolean v5 = true;
        boolean v6 = false;
        if(this != (((JsonPrimitive)obj))) {
            if(obj != null && this.getClass() == obj.getClass()) {
                Object v4 = obj;
                if(this.value != null) {
                    if((JsonPrimitive.isIntegral(this)) && (JsonPrimitive.isIntegral(((JsonPrimitive)v4)))) {
                        if(this.getAsNumber().longValue() != ((JsonPrimitive)v4).getAsNumber().longValue()) {
                            v5 = false;
                            goto label_3;
                        }
                        else {
                            goto label_3;
                        }
                    }

                    if(((this.value instanceof Number)) && ((((JsonPrimitive)v4).value instanceof Number))) {
                        double v0 = this.getAsNumber().doubleValue();
                        double v2 = ((JsonPrimitive)v4).getAsNumber().doubleValue();
                        if(v0 == v2 || (Double.isNaN(v0)) && (Double.isNaN(v2))) {
                            v6 = true;
                        }

                        v5 = v6;
                        goto label_3;
                    }

                    v5 = this.value.equals(((JsonPrimitive)v4).value);
                    goto label_3;
                }
                else if(((JsonPrimitive)v4).value != null) {
                    v5 = false;
                    goto label_3;
                }
                else {
                    goto label_3;
                }
            }

            v5 = false;
        }

    label_3:
        return v5;
    }

    public boolean getAsBoolean() {
        boolean v0;
        if(this.isBoolean()) {
            v0 = this.getAsBooleanWrapper().booleanValue();
        }
        else {
            v0 = Boolean.parseBoolean(this.getAsString());
        }

        return v0;
    }

    Boolean getAsBooleanWrapper() {
        return this.value;
    }

    public double getAsDouble() {
        double v0;
        if(this.isNumber()) {
            v0 = this.getAsNumber().doubleValue();
        }
        else {
            v0 = Double.parseDouble(this.getAsString());
        }

        return v0;
    }

    public int getAsInt() {
        int v0;
        if(this.isNumber()) {
            v0 = this.getAsNumber().intValue();
        }
        else {
            v0 = Integer.parseInt(this.getAsString());
        }

        return v0;
    }

    public long getAsLong() {
        long v0;
        if(this.isNumber()) {
            v0 = this.getAsNumber().longValue();
        }
        else {
            v0 = Long.parseLong(this.getAsString());
        }

        return v0;
    }

    public Number getAsNumber() {
        LazilyParsedNumber v0;
        if((this.value instanceof String)) {
            v0 = new LazilyParsedNumber(this.value);
        }
        else {
            Object v0_1 = this.value;
        }

        return ((Number)v0);
    }

    public String getAsString() {
        String v0;
        if(this.isNumber()) {
            v0 = this.getAsNumber().toString();
        }
        else if(this.isBoolean()) {
            v0 = this.getAsBooleanWrapper().toString();
        }
        else {
            Object v0_1 = this.value;
        }

        return v0;
    }

    public int hashCode() {
        long v0;
        int v2;
        int v4 = 32;
        if(this.value == null) {
            v2 = 31;
        }
        else if(JsonPrimitive.isIntegral(this)) {
            v0 = this.getAsNumber().longValue();
            v2 = ((int)(v0 >>> v4 ^ v0));
        }
        else if((this.value instanceof Number)) {
            v0 = Double.doubleToLongBits(this.getAsNumber().doubleValue());
            v2 = ((int)(v0 >>> v4 ^ v0));
        }
        else {
            v2 = this.value.hashCode();
        }

        return v2;
    }

    public boolean isBoolean() {
        return this.value instanceof Boolean;
    }

    private static boolean isIntegral(JsonPrimitive primitive) {
        boolean v1 = false;
        if((primitive.value instanceof Number)) {
            Object v0 = primitive.value;
            if(!(v0 instanceof BigInteger) && !(v0 instanceof Long) && !(v0 instanceof Integer) && !(v0 instanceof Short) && !(v0 instanceof Byte)) {
                goto label_16;
            }

            v1 = true;
        }

    label_16:
        return v1;
    }

    public boolean isNumber() {
        return this.value instanceof Number;
    }

    private static boolean isPrimitiveOrString(Object target) {
        boolean v5 = true;
        if(!(target instanceof String)) {
            Class v1 = target.getClass();
            Class[] v0 = JsonPrimitive.PRIMITIVE_TYPES;
            int v3 = v0.length;
            int v2 = 0;
            while(true) {
                if(v2 >= v3) {
                    break;
                }
                else if(!v0[v2].isAssignableFrom(v1)) {
                    ++v2;
                    continue;
                }

                goto label_3;
            }

            v5 = false;
        }

    label_3:
        return v5;
    }

    public boolean isString() {
        return this.value instanceof String;
    }

    void setValue(Object primitive) {
        boolean v1;
        if((primitive instanceof Character)) {
            this.value = String.valueOf(((Character)primitive).charValue());
        }
        else {
            if(((primitive instanceof Number)) || (JsonPrimitive.isPrimitiveOrString(primitive))) {
                v1 = true;
            }
            else {
                v1 = false;
            }

            $Gson$Preconditions.checkArgument(v1);
            this.value = primitive;
        }
    }
}

