// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.google.gson.internal;

import com.google.gson.FieldAttributes;
import com.google.gson.Gson;
import com.google.gson.TypeAdapter;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.annotations.Expose;
import com.google.gson.annotations.Since;
import com.google.gson.annotations.Until;
import com.google.gson.reflect.TypeToken;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public final class Excluder implements TypeAdapterFactory, Cloneable {
    private List deserializationStrategies;
    private int modifiers;
    private boolean requireExpose;
    private List serializationStrategies;
    private boolean serializeInnerClasses;
    private double version;

    static  {
        Excluder.DEFAULT = new Excluder();
    }

    public Excluder() {
        super();
        this.version = -1;
        this.modifiers = 136;
        this.serializeInnerClasses = true;
        this.serializationStrategies = Collections.emptyList();
        this.deserializationStrategies = Collections.emptyList();
    }

    protected Excluder clone() {
        try {
            return super.clone();
        }
        catch(CloneNotSupportedException v0) {
            throw new AssertionError();
        }
    }

    protected Object clone() throws CloneNotSupportedException {
        return this.clone();
    }

    public TypeAdapter create(Gson gson, TypeToken arg9) {
        TypeAdapter v0;
        Class v6 = arg9.getRawType();
        boolean v3 = this.excludeClass(v6, true);
        boolean v2 = this.excludeClass(v6, false);
        if((v3) || (v2)) {
            com.google.gson.internal.Excluder$1 v0_1 = new TypeAdapter() {
                private TypeAdapter delegate;

                private TypeAdapter delegate() {
                    TypeAdapter v0 = this.delegate;
                    if(v0 == null) {
                        v0 = this.val$gson.getDelegateAdapter(Excluder.this, this.val$type);
                        this.delegate = v0;
                    }

                    return v0;
                }

                public Object read(JsonReader in) throws IOException {
                    Object v0;
                    if(this.val$skipDeserialize) {
                        in.skipValue();
                        v0 = null;
                    }
                    else {
                        v0 = this.delegate().read(in);
                    }

                    return v0;
                }

                public void write(JsonWriter out, Object arg3) throws IOException {
                    if(this.val$skipSerialize) {
                        out.nullValue();
                    }
                    else {
                        this.delegate().write(out, arg3);
                    }
                }
            };
        }
        else {
            v0 = null;
        }

        return v0;
    }

    public boolean excludeClass(Class arg9, boolean serialize) {
        boolean v3;
        List v2;
        if(this.version == -1 || (this.isValidVersion(arg9.getAnnotation(Since.class), arg9.getAnnotation(Until.class)))) {
            if(!this.serializeInnerClasses && (this.isInnerClass(arg9))) {
                v3 = true;
                goto label_11;
            }

            if(!this.isAnonymousOrLocal(arg9)) {
                goto label_22;
            }

            v3 = true;
            goto label_11;
        label_22:
            if(serialize) {
                v2 = this.serializationStrategies;
            }
            else {
                v2 = this.deserializationStrategies;
            }

            Iterator v1 = v2.iterator();
            do {
                if(!v1.hasNext()) {
                    goto label_34;
                }
            }
            while(!v1.next().shouldSkipClass(arg9));

            v3 = true;
            goto label_11;
        label_34:
            v3 = false;
        }
        else {
            v3 = true;
        }

    label_11:
        return v3;
    }

    public boolean excludeField(Field field, boolean serialize) {
        List v4;
        boolean v5;
        if((this.modifiers & field.getModifiers()) != 0) {
            v5 = true;
        }
        else {
            if(this.version != -1 && !this.isValidVersion(field.getAnnotation(Since.class), field.getAnnotation(Until.class))) {
                v5 = true;
                goto label_6;
            }

            if(!field.isSynthetic()) {
                goto label_22;
            }

            v5 = true;
            goto label_6;
        label_22:
            if(this.requireExpose) {
                Annotation v0 = field.getAnnotation(Expose.class);
                if(v0 != null) {
                    if(!serialize) {
                        if(!((Expose)v0).deserialize()) {
                            goto label_30;
                        }

                        goto label_34;
                    }
                    else if(((Expose)v0).serialize()) {
                        goto label_34;
                    }
                }

            label_30:
                v5 = true;
                goto label_6;
            }

        label_34:
            if(!this.serializeInnerClasses && (this.isInnerClass(field.getType()))) {
                v5 = true;
                goto label_6;
            }

            if(!this.isAnonymousOrLocal(field.getType())) {
                goto label_46;
            }

            v5 = true;
            goto label_6;
        label_46:
            if(serialize) {
                v4 = this.serializationStrategies;
            }
            else {
                v4 = this.deserializationStrategies;
            }

            if(!v4.isEmpty()) {
                FieldAttributes v2 = new FieldAttributes(field);
                Iterator v3 = v4.iterator();
                do {
                    if(v3.hasNext()) {
                        if(!v3.next().shouldSkipField(v2)) {
                            continue;
                        }

                        break;
                    }

                    goto label_61;
                }
                while(true);

                v5 = true;
                goto label_6;
            }

        label_61:
            v5 = false;
        }

    label_6:
        return v5;
    }

    private boolean isAnonymousOrLocal(Class arg2) {
        boolean v0;
        if(!Enum.class.isAssignableFrom(arg2)) {
            if(!arg2.isAnonymousClass() && !arg2.isLocalClass()) {
                goto label_9;
            }

            v0 = true;
        }
        else {
        label_9:
            v0 = false;
        }

        return v0;
    }

    private boolean isInnerClass(Class arg2) {
        boolean v0;
        if(!arg2.isMemberClass() || (this.isStatic(arg2))) {
            v0 = false;
        }
        else {
            v0 = true;
        }

        return v0;
    }

    private boolean isStatic(Class arg2) {
        boolean v0;
        if((arg2.getModifiers() & 8) != 0) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    private boolean isValidSince(Since annotation) {
        boolean v2;
        if(annotation == null || annotation.value() <= this.version) {
            v2 = true;
        }
        else {
            v2 = false;
        }

        return v2;
    }

    private boolean isValidUntil(Until annotation) {
        boolean v2;
        if(annotation == null || annotation.value() > this.version) {
            v2 = true;
        }
        else {
            v2 = false;
        }

        return v2;
    }

    private boolean isValidVersion(Since since, Until until) {
        boolean v0;
        if(!this.isValidSince(since) || !this.isValidUntil(until)) {
            v0 = false;
        }
        else {
            v0 = true;
        }

        return v0;
    }
}

