// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.google.gson.internal.bind;

import com.google.gson.Gson;
import com.google.gson.JsonSyntaxException;
import com.google.gson.TypeAdapter;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonToken;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;

public final class DateTypeAdapter extends TypeAdapter {
    private final DateFormat enUsFormat;
    private final DateFormat iso8601Format;
    private final DateFormat localFormat;

    static  {
        DateTypeAdapter.FACTORY = new TypeAdapterFactory() {
            public TypeAdapter create(Gson gson, TypeToken arg4) {
                DateTypeAdapter v0;
                if(arg4.getRawType() == Date.class) {
                    v0 = new DateTypeAdapter();
                }
                else {
                    TypeAdapter v0_1 = null;
                }

                return ((TypeAdapter)v0);
            }
        };
    }

    public DateTypeAdapter() {
        super();
        this.enUsFormat = DateFormat.getDateTimeInstance(2, 2, Locale.US);
        this.localFormat = DateFormat.getDateTimeInstance(2, 2);
        this.iso8601Format = DateTypeAdapter.buildIso8601Format();
    }

    private static DateFormat buildIso8601Format() {
        SimpleDateFormat v0 = new SimpleDateFormat("yyyy-MM-dd\'T\'HH:mm:ss\'Z\'", Locale.US);
        ((DateFormat)v0).setTimeZone(TimeZone.getTimeZone("UTC"));
        return ((DateFormat)v0);
    }

    private Date deserializeToDate(String json) {
        Date v1_2;
        __monitor_enter(this);
        try {
            v1_2 = this.localFormat.parse(json);
        }
        catch(Throwable v1) {
        }
        catch(ParseException v1_1) {
            try {
                v1_2 = this.enUsFormat.parse(json);
            }
            catch(Throwable v1) {
            }
            catch(ParseException v1_1) {
                try {
                    v1_2 = this.iso8601Format.parse(json);
                }
                catch(Throwable v1) {
                }
                catch(ParseException v0) {
                    try {
                        throw new JsonSyntaxException(json, ((Throwable)v0));
                    }
                    catch(Throwable v1) {
                        __monitor_exit(this);
                        throw v1;
                    }
                }
            }
        }

        __monitor_exit(this);
        return v1_2;
    }

    public Object read(JsonReader x0) throws IOException {
        return this.read(x0);
    }

    public Date read(JsonReader in) throws IOException {
        Date v0;
        if(in.peek() == JsonToken.NULL) {
            in.nextNull();
            v0 = null;
        }
        else {
            v0 = this.deserializeToDate(in.nextString());
        }

        return v0;
    }

    public void write(JsonWriter x0, Object x1) throws IOException {
        this.write(x0, ((Date)x1));
    }

    public void write(JsonWriter out, Date value) throws IOException {
        __monitor_enter(this);
        if(value == null) {
            try {
                out.nullValue();
                goto label_3;
            label_5:
                out.value(this.enUsFormat.format(value));
            }
            catch(Throwable v1) {
                __monitor_exit(this);
                throw v1;
            }
        }
        else {
            goto label_5;
        }

    label_3:
        __monitor_exit(this);
    }
}

