// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.google.gson.internal.bind;

import com.google.gson.JsonArray;
import com.google.gson.JsonNull;
import com.google.gson.JsonObject;
import com.google.gson.JsonPrimitive;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonToken;
import java.io.IOException;
import java.io.Reader;
import java.util.Iterator;
import java.util.List;
import java.util.Map$Entry;

public final class JsonTreeReader extends JsonReader {
    private static final Object SENTINEL_CLOSED;
    private static final Reader UNREADABLE_READER;
    private final List stack;

    static  {
        JsonTreeReader.UNREADABLE_READER = new Reader() {
            public void close() throws IOException {
                throw new AssertionError();
            }

            public int read(char[] buffer, int offset, int count) throws IOException {
                throw new AssertionError();
            }
        };
        JsonTreeReader.SENTINEL_CLOSED = new Object();
    }

    public void beginArray() throws IOException {
        this.expect(JsonToken.BEGIN_ARRAY);
        this.stack.add(this.peekStack().iterator());
    }

    public void beginObject() throws IOException {
        this.expect(JsonToken.BEGIN_OBJECT);
        this.stack.add(this.peekStack().entrySet().iterator());
    }

    public void close() throws IOException {
        this.stack.clear();
        this.stack.add(JsonTreeReader.SENTINEL_CLOSED);
    }

    public void endArray() throws IOException {
        this.expect(JsonToken.END_ARRAY);
        this.popStack();
        this.popStack();
    }

    public void endObject() throws IOException {
        this.expect(JsonToken.END_OBJECT);
        this.popStack();
        this.popStack();
    }

    private void expect(JsonToken expected) throws IOException {
        if(this.peek() != expected) {
            throw new IllegalStateException("Expected " + expected + " but was " + this.peek());
        }
    }

    public boolean hasNext() throws IOException {
        boolean v1;
        JsonToken v0 = this.peek();
        if(v0 == JsonToken.END_OBJECT || v0 == JsonToken.END_ARRAY) {
            v1 = false;
        }
        else {
            v1 = true;
        }

        return v1;
    }

    public boolean nextBoolean() throws IOException {
        this.expect(JsonToken.BOOLEAN);
        return this.popStack().getAsBoolean();
    }

    public double nextDouble() throws IOException {
        JsonToken v2 = this.peek();
        if(v2 != JsonToken.NUMBER && v2 != JsonToken.STRING) {
            throw new IllegalStateException("Expected " + JsonToken.NUMBER + " but was " + v2);
        }

        double v0 = this.peekStack().getAsDouble();
        if(!this.isLenient() && ((Double.isNaN(v0)) || (Double.isInfinite(v0)))) {
            throw new NumberFormatException("JSON forbids NaN and infinities: " + v0);
        }

        this.popStack();
        return v0;
    }

    public int nextInt() throws IOException {
        JsonToken v1 = this.peek();
        if(v1 != JsonToken.NUMBER && v1 != JsonToken.STRING) {
            throw new IllegalStateException("Expected " + JsonToken.NUMBER + " but was " + v1);
        }

        int v0 = this.peekStack().getAsInt();
        this.popStack();
        return v0;
    }

    public long nextLong() throws IOException {
        JsonToken v2 = this.peek();
        if(v2 != JsonToken.NUMBER && v2 != JsonToken.STRING) {
            throw new IllegalStateException("Expected " + JsonToken.NUMBER + " but was " + v2);
        }

        long v0 = this.peekStack().getAsLong();
        this.popStack();
        return v0;
    }

    public String nextName() throws IOException {
        this.expect(JsonToken.NAME);
        Object v0 = this.peekStack().next();
        this.stack.add(((Map$Entry)v0).getValue());
        return ((Map$Entry)v0).getKey();
    }

    public void nextNull() throws IOException {
        this.expect(JsonToken.NULL);
        this.popStack();
    }

    public String nextString() throws IOException {
        JsonToken v0 = this.peek();
        if(v0 != JsonToken.STRING && v0 != JsonToken.NUMBER) {
            throw new IllegalStateException("Expected " + JsonToken.STRING + " but was " + v0);
        }

        return this.popStack().getAsString();
    }

    public JsonToken peek() throws IOException {
        JsonToken v4;
        if(this.stack.isEmpty()) {
            v4 = JsonToken.END_DOCUMENT;
        }
        else {
            Object v2 = this.peekStack();
            if((v2 instanceof Iterator)) {
                boolean v0 = this.stack.get(this.stack.size() - 2) instanceof JsonObject;
                Object v1 = v2;
                if(((Iterator)v1).hasNext()) {
                    if(v0) {
                        v4 = JsonToken.NAME;
                    }
                    else {
                        this.stack.add(((Iterator)v1).next());
                        v4 = this.peek();
                    }
                }
                else if(v0) {
                    v4 = JsonToken.END_OBJECT;
                }
                else {
                    v4 = JsonToken.END_ARRAY;
                }
            }
            else if((v2 instanceof JsonObject)) {
                v4 = JsonToken.BEGIN_OBJECT;
            }
            else if((v2 instanceof JsonArray)) {
                v4 = JsonToken.BEGIN_ARRAY;
            }
            else if((v2 instanceof JsonPrimitive)) {
                Object v3 = v2;
                if(((JsonPrimitive)v3).isString()) {
                    v4 = JsonToken.STRING;
                }
                else if(((JsonPrimitive)v3).isBoolean()) {
                    v4 = JsonToken.BOOLEAN;
                }
                else if(((JsonPrimitive)v3).isNumber()) {
                    v4 = JsonToken.NUMBER;
                }
                else {
                    throw new AssertionError();
                }
            }
            else if((v2 instanceof JsonNull)) {
                v4 = JsonToken.NULL;
            }
            else {
                goto label_59;
            }
        }

        return v4;
    label_59:
        if(v2 == JsonTreeReader.SENTINEL_CLOSED) {
            throw new IllegalStateException("JsonReader is closed");
        }

        throw new AssertionError();
    }

    private Object peekStack() {
        return this.stack.get(this.stack.size() - 1);
    }

    private Object popStack() {
        return this.stack.remove(this.stack.size() - 1);
    }

    public void promoteNameToValue() throws IOException {
        this.expect(JsonToken.NAME);
        Object v0 = this.peekStack().next();
        this.stack.add(((Map$Entry)v0).getValue());
        this.stack.add(new JsonPrimitive(((Map$Entry)v0).getKey()));
    }

    public void skipValue() throws IOException {
        if(this.peek() == JsonToken.NAME) {
            this.nextName();
        }
        else {
            this.popStack();
        }
    }

    public String toString() {
        return this.getClass().getSimpleName();
    }
}

