// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.google.gson.internal.bind;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonNull;
import com.google.gson.JsonObject;
import com.google.gson.JsonPrimitive;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.List;

public final class JsonTreeWriter extends JsonWriter {
    private static final JsonPrimitive SENTINEL_CLOSED;
    private static final Writer UNWRITABLE_WRITER;
    private String pendingName;
    private JsonElement product;
    private final List stack;

    static  {
        JsonTreeWriter.UNWRITABLE_WRITER = new Writer() {
            public void close() throws IOException {
                throw new AssertionError();
            }

            public void flush() throws IOException {
                throw new AssertionError();
            }

            public void write(char[] buffer, int offset, int counter) {
                throw new AssertionError();
            }
        };
        JsonTreeWriter.SENTINEL_CLOSED = new JsonPrimitive("closed");
    }

    public JsonTreeWriter() {
        super(JsonTreeWriter.UNWRITABLE_WRITER);
        this.stack = new ArrayList();
        this.product = JsonNull.INSTANCE;
    }

    public JsonWriter beginArray() throws IOException {
        JsonArray v0 = new JsonArray();
        this.put(((JsonElement)v0));
        this.stack.add(v0);
        return this;
    }

    public JsonWriter beginObject() throws IOException {
        JsonObject v0 = new JsonObject();
        this.put(((JsonElement)v0));
        this.stack.add(v0);
        return this;
    }

    public void close() throws IOException {
        if(!this.stack.isEmpty()) {
            throw new IOException("Incomplete document");
        }

        this.stack.add(JsonTreeWriter.SENTINEL_CLOSED);
    }

    public JsonWriter endArray() throws IOException {
        if(!this.stack.isEmpty() && this.pendingName == null) {
            if((this.peek() instanceof JsonArray)) {
                this.stack.remove(this.stack.size() - 1);
                return this;
            }
            else {
                throw new IllegalStateException();
            }
        }

        throw new IllegalStateException();
    }

    public JsonWriter endObject() throws IOException {
        if(!this.stack.isEmpty() && this.pendingName == null) {
            if((this.peek() instanceof JsonObject)) {
                this.stack.remove(this.stack.size() - 1);
                return this;
            }
            else {
                throw new IllegalStateException();
            }
        }

        throw new IllegalStateException();
    }

    public void flush() throws IOException {
    }

    public JsonElement get() {
        if(!this.stack.isEmpty()) {
            throw new IllegalStateException("Expected one JSON element but was " + this.stack);
        }

        return this.product;
    }

    public JsonWriter name(String name) throws IOException {
        if(!this.stack.isEmpty() && this.pendingName == null) {
            if((this.peek() instanceof JsonObject)) {
                this.pendingName = name;
                return this;
            }
            else {
                throw new IllegalStateException();
            }
        }

        throw new IllegalStateException();
    }

    public JsonWriter nullValue() throws IOException {
        this.put(JsonNull.INSTANCE);
        return this;
    }

    private JsonElement peek() {
        return this.stack.get(this.stack.size() - 1);
    }

    private void put(JsonElement value) {
        if(this.pendingName != null) {
            if(!value.isJsonNull() || (this.getSerializeNulls())) {
                this.peek().add(this.pendingName, value);
            }

            this.pendingName = null;
        }
        else {
            if(!this.stack.isEmpty()) {
                goto label_17;
            }

            this.product = value;
            return;
        label_17:
            JsonElement v0 = this.peek();
            if(!(v0 instanceof JsonArray)) {
                goto label_22;
            }

            ((JsonArray)v0).add(value);
        }

        return;
    label_22:
        throw new IllegalStateException();
    }

    public JsonWriter value(long value) throws IOException {
        this.put(new JsonPrimitive(Long.valueOf(value)));
        return this;
    }

    public JsonWriter value(Number value) throws IOException {
        JsonWriter v5;
        if(value == null) {
            v5 = this.nullValue();
        }
        else {
            if(!this.isLenient()) {
                double v0 = value.doubleValue();
                if(!Double.isNaN(v0) && !Double.isInfinite(v0)) {
                    goto label_17;
                }

                throw new IllegalArgumentException("JSON forbids NaN and infinities: " + value);
            }

        label_17:
            this.put(new JsonPrimitive(value));
        }

        return ((JsonTreeWriter)v5);
    }

    public JsonWriter value(String value) throws IOException {
        JsonWriter v1;
        if(value == null) {
            v1 = this.nullValue();
        }
        else {
            this.put(new JsonPrimitive(value));
        }

        return ((JsonTreeWriter)v1);
    }

    public JsonWriter value(boolean value) throws IOException {
        this.put(new JsonPrimitive(Boolean.valueOf(value)));
        return this;
    }
}

