// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.google.gson.internal.bind;

import com.google.gson.Gson;
import com.google.gson.JsonElement;
import com.google.gson.JsonPrimitive;
import com.google.gson.JsonSyntaxException;
import com.google.gson.TypeAdapter;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.internal.$Gson$Types;
import com.google.gson.internal.ConstructorConstructor;
import com.google.gson.internal.JsonReaderInternalAccess;
import com.google.gson.internal.ObjectConstructor;
import com.google.gson.internal.Streams;
import com.google.gson.reflect.TypeToken;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonToken;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map$Entry;

public final class MapTypeAdapterFactory implements TypeAdapterFactory {
    final class Adapter extends TypeAdapter {
        private final ObjectConstructor constructor;
        private final TypeAdapter keyTypeAdapter;
        private final TypeAdapter valueTypeAdapter;

        public Adapter(MapTypeAdapterFactory arg2, Gson context, Type keyType, TypeAdapter arg5, Type valueType, TypeAdapter arg7, ObjectConstructor arg8) {
            MapTypeAdapterFactory.this = arg2;
            super();
            this.keyTypeAdapter = new TypeAdapterRuntimeTypeWrapper(context, arg5, keyType);
            this.valueTypeAdapter = new TypeAdapterRuntimeTypeWrapper(context, arg7, valueType);
            this.constructor = arg8;
        }

        private String keyToString(JsonElement keyElement) {
            String v1;
            if(keyElement.isJsonPrimitive()) {
                JsonPrimitive v0 = keyElement.getAsJsonPrimitive();
                if(v0.isNumber()) {
                    v1 = String.valueOf(v0.getAsNumber());
                }
                else if(v0.isBoolean()) {
                    v1 = Boolean.toString(v0.getAsBoolean());
                }
                else if(v0.isString()) {
                    v1 = v0.getAsString();
                }
                else {
                    throw new AssertionError();
                }
            }
            else if(keyElement.isJsonNull()) {
                v1 = "null";
            }
            else {
                goto label_23;
            }

            return v1;
        label_23:
            throw new AssertionError();
        }

        public Object read(JsonReader x0) throws IOException {
            return this.read(x0);
        }

        public Map read(JsonReader in) throws IOException {
            Object v0;
            Object v1_1;
            JsonToken v2 = in.peek();
            if(v2 == JsonToken.NULL) {
                in.nextNull();
                Map v1 = null;
            }
            else {
                v1_1 = this.constructor.construct();
                if(v2 == JsonToken.BEGIN_ARRAY) {
                    in.beginArray();
                    while(true) {
                        if(in.hasNext()) {
                            in.beginArray();
                            v0 = this.keyTypeAdapter.read(in);
                            if(((Map)v1_1).put(v0, this.valueTypeAdapter.read(in)) != null) {
                                throw new JsonSyntaxException("duplicate key: " + v0);
                            }
                            else {
                                in.endArray();
                                continue;
                            }
                        }
                        else {
                            break;
                        }

                        goto label_5;
                    }

                    in.endArray();
                }
                else {
                    in.beginObject();
                    do {
                        if(in.hasNext()) {
                            JsonReaderInternalAccess.INSTANCE.promoteNameToValue(in);
                            v0 = this.keyTypeAdapter.read(in);
                            if(((Map)v1_1).put(v0, this.valueTypeAdapter.read(in)) == null) {
                                continue;
                            }

                            break;
                        }
                        else {
                            goto label_49;
                        }
                    }
                    while(true);

                    throw new JsonSyntaxException("duplicate key: " + v0);
                label_49:
                    in.endObject();
                }
            }

        label_5:
            return ((Map)v1_1);
        }

        public void write(JsonWriter x0, Object x1) throws IOException {
            this.write(x0, ((Map)x1));
        }

        public void write(JsonWriter out, Map arg11) throws IOException {
            int v7;
            Object v0;
            Iterator v3;
            if(arg11 == null) {
                out.nullValue();
            }
            else if(!MapTypeAdapterFactory.this.complexMapKeySerialization) {
                out.beginObject();
                v3 = arg11.entrySet().iterator();
                while(v3.hasNext()) {
                    v0 = v3.next();
                    out.name(String.valueOf(((Map$Entry)v0).getKey()));
                    this.valueTypeAdapter.write(out, ((Map$Entry)v0).getValue());
                }

                out.endObject();
            }
            else {
                int v1 = 0;
                ArrayList v5 = new ArrayList(arg11.size());
                ArrayList v6 = new ArrayList(arg11.size());
                v3 = arg11.entrySet().iterator();
                while(v3.hasNext()) {
                    v0 = v3.next();
                    JsonElement v4 = this.keyTypeAdapter.toJsonTree(((Map$Entry)v0).getKey());
                    ((List)v5).add(v4);
                    ((List)v6).add(((Map$Entry)v0).getValue());
                    if((v4.isJsonArray()) || (v4.isJsonObject())) {
                        v7 = 1;
                    }
                    else {
                        v7 = 0;
                    }

                    v1 |= v7;
                }

                if(v1 == 0) {
                    goto label_62;
                }

                out.beginArray();
                int v2 = 0;
                goto label_49;
            label_62:
                out.beginObject();
                for(v2 = 0; v2 < ((List)v5).size(); ++v2) {
                    out.name(this.keyToString(((List)v5).get(v2)));
                    this.valueTypeAdapter.write(out, ((List)v6).get(v2));
                }

                out.endObject();
                return;
            label_49:
                while(v2 < ((List)v5).size()) {
                    out.beginArray();
                    Streams.write(((List)v5).get(v2), out);
                    this.valueTypeAdapter.write(out, ((List)v6).get(v2));
                    out.endArray();
                    ++v2;
                }

                out.endArray();
            }
        }
    }

    private final boolean complexMapKeySerialization;
    private final ConstructorConstructor constructorConstructor;

    public MapTypeAdapterFactory(ConstructorConstructor constructorConstructor, boolean complexMapKeySerialization) {
        super();
        this.constructorConstructor = constructorConstructor;
        this.complexMapKeySerialization = complexMapKeySerialization;
    }

    static boolean access$000(MapTypeAdapterFactory x0) {
        return x0.complexMapKeySerialization;
    }

    public TypeAdapter create(Gson gson, TypeToken arg14) {
        TypeAdapter v0;
        Type v11 = arg14.getType();
        if(!Map.class.isAssignableFrom(arg14.getRawType())) {
            v0 = null;
        }
        else {
            Type[] v8 = $Gson$Types.getMapKeyAndValueTypes(v11, $Gson$Types.getRawType(v11));
            Adapter v0_1 = new Adapter(this, gson, v8[0], this.getKeyAdapter(gson, v8[0]), v8[1], gson.getAdapter(TypeToken.get(v8[1])), this.constructorConstructor.get(arg14));
        }

        return v0;
    }

    private TypeAdapter getKeyAdapter(Gson context, Type keyType) {
        TypeAdapter v0;
        if(keyType == Boolean.TYPE || keyType == Boolean.class) {
            v0 = TypeAdapters.BOOLEAN_AS_STRING;
        }
        else {
            v0 = context.getAdapter(TypeToken.get(keyType));
        }

        return v0;
    }
}

