// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.google.gson.internal.bind;

import com.google.gson.FieldNamingStrategy;
import com.google.gson.Gson;
import com.google.gson.JsonSyntaxException;
import com.google.gson.TypeAdapter;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.annotations.SerializedName;
import com.google.gson.internal.$Gson$Types;
import com.google.gson.internal.ConstructorConstructor;
import com.google.gson.internal.Excluder;
import com.google.gson.internal.ObjectConstructor;
import com.google.gson.reflect.TypeToken;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonToken;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;

public final class ReflectiveTypeAdapterFactory implements TypeAdapterFactory {
    public final class Adapter extends TypeAdapter {
        private final Map boundFields;
        private final ObjectConstructor constructor;

        Adapter(ReflectiveTypeAdapterFactory x0, ObjectConstructor x1, Map x2, com.google.gson.internal.bind.ReflectiveTypeAdapterFactory$1 x3) {
            super(x0, x1, x2);
        }

        private Adapter(ReflectiveTypeAdapterFactory arg1, ObjectConstructor arg2, Map arg3) {
            ReflectiveTypeAdapterFactory.this = arg1;
            super();
            this.constructor = arg2;
            this.boundFields = arg3;
        }

        public Object read(JsonReader in) throws IOException {
            Object v2;
            if(in.peek() == JsonToken.NULL) {
                in.nextNull();
                v2 = null;
            }
            else {
                v2 = this.constructor.construct();
                try {
                    in.beginObject();
                    while(in.hasNext()) {
                        Object v1 = this.boundFields.get(in.nextName());
                        if(v1 != null && (((BoundField)v1).deserialized)) {
                            ((BoundField)v1).read(in, v2);
                            continue;
                        }

                        in.skipValue();
                    }
                }
                catch(IllegalStateException v0) {
                    goto label_21;
                }
                catch(IllegalAccessException v0_1) {
                    goto label_26;
                }

                in.endObject();
            }

            return v2;
        label_21:
            throw new JsonSyntaxException(((Throwable)v0));
        label_26:
            throw new AssertionError(v0_1);
        }

        public void write(JsonWriter out, Object arg6) throws IOException {
            if(arg6 == null) {
                out.nullValue();
            }
            else {
                out.beginObject();
                try {
                    Iterator v2 = this.boundFields.values().iterator();
                    while(v2.hasNext()) {
                        Object v0 = v2.next();
                        if(!((BoundField)v0).serialized) {
                            continue;
                        }

                        out.name(((BoundField)v0).name);
                        ((BoundField)v0).write(out, arg6);
                    }
                }
                catch(IllegalAccessException v1) {
                    goto label_18;
                }

                out.endObject();
            }

            return;
        label_18:
            throw new AssertionError();
        }
    }

    abstract class BoundField {
        final boolean serialized;

        protected BoundField(String name, boolean serialized, boolean deserialized) {
            super();
            this.name = name;
            this.serialized = serialized;
            this.deserialized = deserialized;
        }

        abstract void read(JsonReader arg0, Object arg1) throws IOException, IllegalAccessException;

        abstract void write(JsonWriter arg0, Object arg1) throws IOException, IllegalAccessException;
    }

    private final ConstructorConstructor constructorConstructor;
    private final Excluder excluder;
    private final FieldNamingStrategy fieldNamingPolicy;

    public ReflectiveTypeAdapterFactory(ConstructorConstructor constructorConstructor, FieldNamingStrategy fieldNamingPolicy, Excluder excluder) {
        super();
        this.constructorConstructor = constructorConstructor;
        this.fieldNamingPolicy = fieldNamingPolicy;
        this.excluder = excluder;
    }

    public TypeAdapter create(Gson gson, TypeToken arg7) {
        TypeAdapter v2 = null;
        Class v1 = arg7.getRawType();
        if(Object.class.isAssignableFrom(v1)) {
            Adapter v2_1 = new Adapter(this, this.constructorConstructor.get(arg7), this.getBoundFields(gson, arg7, v1), ((com.google.gson.internal.bind.ReflectiveTypeAdapterFactory$1)v2));
        }

        return v2;
    }

    private BoundField createBoundField(Gson context, Field field, String name, TypeToken arg13, boolean serialize, boolean deserialize) {
        return new BoundField() {
            final TypeAdapter typeAdapter;

            void read(JsonReader reader, Object value) throws IOException, IllegalAccessException {
                Object v0 = this.typeAdapter.read(reader);
                if(v0 != null || !this.val$isPrimitive) {
                    this.val$field.set(value, v0);
                }
            }

            void write(JsonWriter writer, Object value) throws IOException, IllegalAccessException {
                new TypeAdapterRuntimeTypeWrapper(this.val$context, this.typeAdapter, this.val$fieldType.getType()).write(writer, this.val$field.get(value));
            }
        };
    }

    public boolean excludeField(Field f, boolean serialize) {
        boolean v0;
        if((this.excluder.excludeClass(f.getType(), serialize)) || (this.excluder.excludeField(f, serialize))) {
            v0 = false;
        }
        else {
            v0 = true;
        }

        return v0;
    }

    private Map getBoundFields(Gson context, TypeToken arg19, Class arg20) {
        LinkedHashMap v16 = new LinkedHashMap();
        if(!arg20.isInterface()) {
            Type v10 = arg19.getType();
            while(arg20 != Object.class) {
                Field[] v8 = arg20.getDeclaredFields();
                int v14 = v8.length;
                int v13;
                for(v13 = 0; v13 < v14; ++v13) {
                    Field v3 = v8[v13];
                    boolean v6 = this.excludeField(v3, true);
                    boolean v7 = this.excludeField(v3, false);
                    if((v6) || (v7)) {
                        v3.setAccessible(true);
                        BoundField v9 = this.createBoundField(context, v3, this.getFieldName(v3), TypeToken.get($Gson$Types.resolve(arg19.getType(), arg20, v3.getGenericType())), v6, v7);
                        Object v15 = v16.put(v9.name, v9);
                        if(v15 != null) {
                            throw new IllegalArgumentException(v10 + " declares multiple JSON fields named " + ((BoundField)v15).name);
                        }
                    }
                }

                arg19 = TypeToken.get($Gson$Types.resolve(arg19.getType(), arg20, arg20.getGenericSuperclass()));
                arg20 = arg19.getRawType();
            }
        }

        return ((Map)v16);
    }

    private String getFieldName(Field f) {
        String v1;
        Annotation v0 = f.getAnnotation(SerializedName.class);
        if(v0 == null) {
            v1 = this.fieldNamingPolicy.translateName(f);
        }
        else {
            v1 = ((SerializedName)v0).value();
        }

        return v1;
    }
}

