// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.google.gson.stream;

import com.google.gson.internal.JsonReaderInternalAccess;
import com.google.gson.internal.bind.JsonTreeReader;
import java.io.Closeable;
import java.io.EOFException;
import java.io.IOException;
import java.io.Reader;

public class JsonReader implements Closeable {
    private static final char[] NON_EXECUTE_PREFIX;
    private final char[] buffer;
    private int bufferStartColumn;
    private int bufferStartLine;
    private final Reader in;
    private boolean lenient;
    private int limit;
    private String name;
    private int pos;
    private boolean skipping;
    private JsonScope[] stack;
    private int stackSize;
    private final StringPool stringPool;
    private JsonToken token;
    private String value;
    private int valueLength;
    private int valuePos;

    static  {
        JsonReader.NON_EXECUTE_PREFIX = ")]}\'\n".toCharArray();
        JsonReaderInternalAccess.INSTANCE = new JsonReaderInternalAccess() {
            public void promoteNameToValue(JsonReader reader) throws IOException {
                if((reader instanceof JsonTreeReader)) {
                    ((JsonTreeReader)reader).promoteNameToValue();
                }
                else {
                    reader.peek();
                    if(reader.token != JsonToken.NAME) {
                        throw new IllegalStateException("Expected a name but was " + reader.peek() + " " + " at line " + reader.getLineNumber() + " column " + reader.getColumnNumber());
                    }
                    else {
                        reader.value = reader.name;
                        reader.name = null;
                        reader.token = JsonToken.STRING;
                    }
                }
            }
        };
    }

    public JsonReader(Reader in) {
        super();
        this.stringPool = new StringPool();
        this.lenient = false;
        this.buffer = new char[1024];
        this.pos = 0;
        this.limit = 0;
        this.bufferStartLine = 1;
        this.bufferStartColumn = 1;
        this.stack = new JsonScope[32];
        this.stackSize = 0;
        this.push(JsonScope.EMPTY_DOCUMENT);
        this.skipping = false;
        if(in == null) {
            throw new NullPointerException("in == null");
        }

        this.in = in;
    }

    static JsonToken access$000(JsonReader x0) {
        return x0.token;
    }

    static JsonToken access$002(JsonReader x0, JsonToken x1) {
        x0.token = x1;
        return x1;
    }

    static int access$100(JsonReader x0) {
        return x0.getLineNumber();
    }

    static int access$200(JsonReader x0) {
        return x0.getColumnNumber();
    }

    static String access$302(JsonReader x0, String x1) {
        x0.value = x1;
        return x1;
    }

    static String access$400(JsonReader x0) {
        return x0.name;
    }

    static String access$402(JsonReader x0, String x1) {
        x0.name = x1;
        return x1;
    }

    private JsonToken advance() throws IOException {
        this.peek();
        JsonToken v0 = this.token;
        this.token = null;
        this.value = null;
        this.name = null;
        return v0;
    }

    public void beginArray() throws IOException {
        this.expect(JsonToken.BEGIN_ARRAY);
    }

    public void beginObject() throws IOException {
        this.expect(JsonToken.BEGIN_OBJECT);
    }

    private void checkLenient() throws IOException {
        if(!this.lenient) {
            throw this.syntaxError("Use JsonReader.setLenient(true) to accept malformed JSON");
        }
    }

    public void close() throws IOException {
        this.value = null;
        this.token = null;
        this.stack[0] = JsonScope.CLOSED;
        this.stackSize = 1;
        this.in.close();
    }

    private void consumeNonExecutePrefix() throws IOException {
        this.nextNonWhitespace(true);
        --this.pos;
        if(this.pos + JsonReader.NON_EXECUTE_PREFIX.length <= this.limit || (this.fillBuffer(JsonReader.NON_EXECUTE_PREFIX.length))) {
            int v0 = 0;
            while(true) {
                if(v0 >= JsonReader.NON_EXECUTE_PREFIX.length) {
                    break;
                }
                else if(this.buffer[this.pos + v0] == JsonReader.NON_EXECUTE_PREFIX[v0]) {
                    ++v0;
                    continue;
                }

                return;
            }

            this.pos += JsonReader.NON_EXECUTE_PREFIX.length;
        }
    }

    private JsonToken decodeLiteral() throws IOException {
        JsonToken v0;
        int v7 = 85;
        int v6 = 69;
        int v5 = 4;
        int v4 = 108;
        int v3 = 76;
        if(this.valuePos == -1) {
            v0 = JsonToken.STRING;
        }
        else {
            if(this.valueLength == v5 && (110 == this.buffer[this.valuePos] || 78 == this.buffer[this.valuePos]) && (117 == this.buffer[this.valuePos + 1] || v7 == this.buffer[this.valuePos + 1]) && (v4 == this.buffer[this.valuePos + 2] || v3 == this.buffer[this.valuePos + 2]) && (v4 == this.buffer[this.valuePos + 3] || v3 == this.buffer[this.valuePos + 3])) {
                this.value = "null";
                v0 = JsonToken.NULL;
                goto label_9;
            }

            if(this.valueLength == v5 && (116 == this.buffer[this.valuePos] || 84 == this.buffer[this.valuePos]) && (114 == this.buffer[this.valuePos + 1] || 82 == this.buffer[this.valuePos + 1]) && (117 == this.buffer[this.valuePos + 2] || v7 == this.buffer[this.valuePos + 2]) && (101 == this.buffer[this.valuePos + 3] || v6 == this.buffer[this.valuePos + 3])) {
                this.value = "true";
                v0 = JsonToken.BOOLEAN;
                goto label_9;
            }

            if(this.valueLength == 5 && (102 == this.buffer[this.valuePos] || 70 == this.buffer[this.valuePos]) && (97 == this.buffer[this.valuePos + 1] || 65 == this.buffer[this.valuePos + 1]) && (v4 == this.buffer[this.valuePos + 2] || v3 == this.buffer[this.valuePos + 2]) && (115 == this.buffer[this.valuePos + 3] || 83 == this.buffer[this.valuePos + 3]) && (101 == this.buffer[this.valuePos + 4] || v6 == this.buffer[this.valuePos + 4])) {
                this.value = "false";
                v0 = JsonToken.BOOLEAN;
                goto label_9;
            }

            this.value = this.stringPool.get(this.buffer, this.valuePos, this.valueLength);
            v0 = this.decodeNumber(this.buffer, this.valuePos, this.valueLength);
        }

    label_9:
        return v0;
    }

    private JsonToken decodeNumber(char[] chars, int offset, int length) {
        JsonToken v2;
        int v5 = 45;
        int v4 = 57;
        int v3 = 48;
        int v1 = offset;
        int v0 = chars[v1];
        if(v0 == v5) {
            ++v1;
            v0 = chars[v1];
        }

        if(v0 == v3) {
            ++v1;
            v0 = chars[v1];
            goto label_11;
        }
        else {
            if(v0 >= 49 && v0 <= v4) {
                ++v1;
                v0 = chars[v1];
                while(true) {
                    if(v0 < v3) {
                        break;
                    }
                    else if(v0 <= v4) {
                        ++v1;
                        v0 = chars[v1];
                        continue;
                    }
                    else {
                        break;
                    }
                }

            label_11:
                if(v0 == 46) {
                    ++v1;
                    v0 = chars[v1];
                    while(v0 >= v3) {
                        if(v0 > v4) {
                            break;
                        }

                        ++v1;
                        v0 = chars[v1];
                    }
                }

                if(v0 == 101 || v0 == 69) {
                    ++v1;
                    v0 = chars[v1];
                    if(v0 == 43 || v0 == v5) {
                        ++v1;
                        v0 = chars[v1];
                    }

                    if(v0 >= v3 && v0 <= v4) {
                        ++v1;
                        v0 = chars[v1];
                        while(true) {
                            if(v0 < v3) {
                                goto label_54;
                            }
                            else if(v0 <= v4) {
                                ++v1;
                                v0 = chars[v1];
                                continue;
                            }
                            else {
                                goto label_54;
                            }
                        }
                    }

                    goto label_52;
                }

            label_54:
                if(v1 == offset + length) {
                    v2 = JsonToken.NUMBER;
                    goto label_31;
                }
                else {
                    v2 = JsonToken.STRING;
                    goto label_31;
                }

            label_52:
                v2 = JsonToken.STRING;
                goto label_31;
            }

            v2 = JsonToken.STRING;
        }

    label_31:
        return v2;
    }

    public void endArray() throws IOException {
        this.expect(JsonToken.END_ARRAY);
    }

    public void endObject() throws IOException {
        this.expect(JsonToken.END_OBJECT);
    }

    private void expect(JsonToken expected) throws IOException {
        this.peek();
        if(this.token != expected) {
            throw new IllegalStateException("Expected " + expected + " but was " + this.peek() + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        this.advance();
    }

    private boolean fillBuffer(int minimum) throws IOException {
        boolean v6 = true;
        char[] v0 = this.buffer;
        int v3 = this.bufferStartLine;
        int v1 = this.bufferStartColumn;
        int v2 = 0;
        int v4 = this.pos;
        while(v2 < v4) {
            if(v0[v2] == 10) {
                ++v3;
                v1 = 1;
            }
            else {
                ++v1;
            }

            ++v2;
        }

        this.bufferStartLine = v3;
        this.bufferStartColumn = v1;
        if(this.limit != this.pos) {
            this.limit -= this.pos;
            System.arraycopy(v0, this.pos, v0, 0, this.limit);
        }
        else {
            this.limit = 0;
        }

        this.pos = 0;
        do {
            int v5 = this.in.read(v0, this.limit, v0.length - this.limit);
            if(v5 != -1) {
                this.limit += v5;
                if(this.bufferStartLine == 1 && this.bufferStartColumn == 1 && this.limit > 0 && v0[0] == 65279) {
                    ++this.pos;
                    --this.bufferStartColumn;
                }

                if(this.limit < minimum) {
                    continue;
                }
            }
            else {
                break;
            }

            goto label_58;
        }
        while(true);

        v6 = false;
    label_58:
        return v6;
    }

    private int getColumnNumber() {
        int v1 = this.bufferStartColumn;
        int v0;
        for(v0 = 0; v0 < this.pos; ++v0) {
            if(this.buffer[v0] == 10) {
                v1 = 1;
            }
            else {
                ++v1;
            }
        }

        return v1;
    }

    private int getLineNumber() {
        int v1 = this.bufferStartLine;
        int v0;
        for(v0 = 0; v0 < this.pos; ++v0) {
            if(this.buffer[v0] == 10) {
                ++v1;
            }
        }

        return v1;
    }

    public boolean hasNext() throws IOException {
        boolean v0;
        this.peek();
        if(this.token == JsonToken.END_OBJECT || this.token == JsonToken.END_ARRAY) {
            v0 = false;
        }
        else {
            v0 = true;
        }

        return v0;
    }

    public final boolean isLenient() {
        return this.lenient;
    }

    public boolean nextBoolean() throws IOException {
        boolean v0;
        this.peek();
        if(this.token != JsonToken.BOOLEAN) {
            throw new IllegalStateException("Expected a boolean but was " + this.token + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        if(this.value == "true") {
            v0 = true;
        }
        else {
            v0 = false;
        }

        this.advance();
        return v0;
    }

    public double nextDouble() throws IOException {
        this.peek();
        if(this.token != JsonToken.STRING && this.token != JsonToken.NUMBER) {
            throw new IllegalStateException("Expected a double but was " + this.token + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        double v0 = Double.parseDouble(this.value);
        if(v0 >= 1 && (this.value.startsWith("0"))) {
            throw new MalformedJsonException("JSON forbids octal prefixes: " + this.value + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        if(!this.lenient && ((Double.isNaN(v0)) || (Double.isInfinite(v0)))) {
            throw new MalformedJsonException("JSON forbids NaN and infinities: " + this.value + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        this.advance();
        return v0;
    }

    private JsonToken nextInArray(boolean firstElement) throws IOException {
        JsonToken v0;
        if(firstElement) {
            this.stack[this.stackSize - 1] = JsonScope.NONEMPTY_ARRAY;
            goto label_7;
        }
        else {
            switch(this.nextNonWhitespace(true)) {
                case 44: {
                    goto label_7;
                }
                case 59: {
                    goto label_25;
                }
                case 93: {
                    goto label_19;
                }
            }

            throw this.syntaxError("Unterminated array");
        label_19:
            --this.stackSize;
            v0 = JsonToken.END_ARRAY;
            this.token = v0;
            goto label_13;
        label_25:
            this.checkLenient();
        label_7:
            switch(this.nextNonWhitespace(true)) {
                case 44: 
                case 59: {
                    goto label_34;
                }
                case 93: {
                    goto label_27;
                }
            }

            --this.pos;
            v0 = this.nextValue();
            goto label_13;
        label_27:
            if(firstElement) {
                --this.stackSize;
                v0 = JsonToken.END_ARRAY;
                this.token = v0;
            }
            else {
            label_34:
                this.checkLenient();
                --this.pos;
                this.value = "null";
                v0 = JsonToken.NULL;
                this.token = v0;
            }
        }

    label_13:
        return v0;
    }

    private JsonToken nextInObject(boolean firstElement) throws IOException {
        JsonToken v1;
        if(firstElement) {
            switch(this.nextNonWhitespace(true)) {
                case 125: {
                    --this.stackSize;
                    v1 = JsonToken.END_OBJECT;
                    this.token = v1;
                    goto label_27;
                label_28:
                    switch(this.nextNonWhitespace(true)) {
                        case 44: 
                        case 59: {
                            goto label_7;
                        }
                        case 125: {
                            goto label_33;
                        }
                    }

                    throw this.syntaxError("Unterminated object");
                label_33:
                    --this.stackSize;
                    v1 = JsonToken.END_OBJECT;
                    this.token = v1;
                    goto label_27;
                label_7:
                    int v0 = this.nextNonWhitespace(true);
                    switch(v0) {
                        case 34: {
                            goto label_40;
                        }
                        case 39: {
                            goto label_39;
                        }
                    }

                    this.checkLenient();
                    --this.pos;
                    this.name = this.nextLiteral(false);
                    if(this.name.length() == 0) {
                        throw this.syntaxError("Expected name");
                    label_39:
                        this.checkLenient();
                    label_40:
                        this.name = this.nextString(((char)v0));
                        goto label_43;
                    }
                    else {
                    label_43:
                        this.stack[this.stackSize - 1] = JsonScope.DANGLING_NAME;
                        v1 = JsonToken.NAME;
                        this.token = v1;
                    }

                    goto label_27;
                }
                default: {
                    --this.pos;
                    goto label_7;
                }
            }
        }
        else {
            goto label_28;
        }

    label_27:
        return v1;
    }

    public int nextInt() throws IOException {
        int v3;
        this.peek();
        if(this.token != JsonToken.STRING && this.token != JsonToken.NUMBER) {
            throw new IllegalStateException("Expected an int but was " + this.token + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        try {
            v3 = Integer.parseInt(this.value);
        }
        catch(NumberFormatException v2) {
            double v0 = Double.parseDouble(this.value);
            v3 = ((int)v0);
            if((((double)v3)) == v0) {
                goto label_25;
            }

            throw new NumberFormatException("Expected an int but was " + this.value + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

    label_25:
        if((((long)v3)) >= 1 && (this.value.startsWith("0"))) {
            throw new MalformedJsonException("JSON forbids octal prefixes: " + this.value + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        this.advance();
        return v3;
    }

    private String nextLiteral(boolean assignOffsetsOnly) throws IOException {
        String v2;
        StringBuilder v0 = null;
        this.valuePos = -1;
        this.valueLength = 0;
        int v1 = 0;
        while(true) {
            if(this.pos + v1 < this.limit) {
                switch(this.buffer[this.pos + v1]) {
                    case 35: 
                    case 47: 
                    case 59: 
                    case 61: 
                    case 92: {
                        goto label_17;
                    }
                    case 9: 
                    case 10: 
                    case 12: 
                    case 13: 
                    case 32: 
                    case 44: 
                    case 58: 
                    case 91: 
                    case 93: 
                    case 123: 
                    case 125: {
                        goto label_18;
                    }
                }

                ++v1;
                continue;
            }
            else if(v1 < this.buffer.length) {
                if(this.fillBuffer(v1 + 1)) {
                    continue;
                }

                this.buffer[this.limit] = '\u0000';
            }
            else {
                if(v0 == null) {
                    v0 = new StringBuilder();
                }

                v0.append(this.buffer, this.pos, v1);
                this.valueLength += v1;
                this.pos += v1;
                v1 = 0;
                if(this.fillBuffer(1)) {
                    continue;
                }
            }

            goto label_18;
        }

    label_17:
        this.checkLenient();
    label_18:
        if((assignOffsetsOnly) && v0 == null) {
            this.valuePos = this.pos;
            v2 = null;
        }
        else if(this.skipping) {
            v2 = "skipped!";
        }
        else if(v0 == null) {
            v2 = this.stringPool.get(this.buffer, this.pos, v1);
        }
        else {
            v0.append(this.buffer, this.pos, v1);
            v2 = v0.toString();
        }

        this.valueLength += v1;
        this.pos += v1;
        return v2;
    }

    public long nextLong() throws IOException {
        long v3;
        this.peek();
        if(this.token != JsonToken.STRING && this.token != JsonToken.NUMBER) {
            throw new IllegalStateException("Expected a long but was " + this.token + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        try {
            v3 = Long.parseLong(this.value);
        }
        catch(NumberFormatException v2) {
            double v0 = Double.parseDouble(this.value);
            v3 = ((long)v0);
            if((((double)v3)) == v0) {
                goto label_25;
            }

            throw new NumberFormatException("Expected a long but was " + this.value + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

    label_25:
        if(v3 >= 1 && (this.value.startsWith("0"))) {
            throw new MalformedJsonException("JSON forbids octal prefixes: " + this.value + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        this.advance();
        return v3;
    }

    public String nextName() throws IOException {
        this.peek();
        if(this.token != JsonToken.NAME) {
            throw new IllegalStateException("Expected a name but was " + this.peek() + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        String v0 = this.name;
        this.advance();
        return v0;
    }

    private int nextNonWhitespace(boolean throwOnEof) throws IOException {
        int v5;
        int v1;
        char[] v0 = this.buffer;
        int v4 = this.pos;
        int v3 = this.limit;
        while(true) {
            if(v4 == v3) {
                this.pos = v4;
                if(this.fillBuffer(1)) {
                    v4 = this.pos;
                    v3 = this.limit;
                    goto label_23;
                }
                else if(throwOnEof) {
                    throw new EOFException("End of input at line " + this.getLineNumber() + " column " + this.getColumnNumber());
                }
                else {
                    v1 = -1;
                }
            }
            else {
            label_23:
                v5 = v4 + 1;
                v1 = v0[v4];
                switch(v1) {
                    case 9: 
                    case 10: 
                    case 13: 
                    case 32: {
                        goto label_29;
                    }
                    case 35: {
                        goto label_70;
                    }
                    case 47: {
                        goto label_31;
                    }
                }

                this.pos = v5;
                goto label_28;
            label_70:
                this.pos = v5;
                this.checkLenient();
                this.skipToEndOfLine();
                v4 = this.pos;
                v3 = this.limit;
                continue;
            label_31:
                this.pos = v5;
                if(v5 == v3) {
                    --this.pos;
                    boolean v2 = this.fillBuffer(2);
                    ++this.pos;
                    if(!v2) {
                        goto label_28;
                    }
                }

                this.checkLenient();
                switch(v0[this.pos]) {
                    case 42: {
                        goto label_50;
                    }
                    case 47: {
                        goto label_63;
                    }
                }
            }

        label_28:
            return v1;
        label_50:
            ++this.pos;
            if(!this.skipTo("*/")) {
                throw this.syntaxError("Unterminated comment");
            }

            v4 = this.pos + 2;
            v3 = this.limit;
            continue;
        label_63:
            ++this.pos;
            this.skipToEndOfLine();
            v4 = this.pos;
            v3 = this.limit;
            continue;
        label_29:
            v4 = v5;
        }
    }

    public void nextNull() throws IOException {
        this.peek();
        if(this.token != JsonToken.NULL) {
            throw new IllegalStateException("Expected null but was " + this.token + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        this.advance();
    }

    public String nextString() throws IOException {
        this.peek();
        if(this.token != JsonToken.STRING && this.token != JsonToken.NUMBER) {
            throw new IllegalStateException("Expected a string but was " + this.peek() + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        }

        String v0 = this.value;
        this.advance();
        return v0;
    }

    private String nextString(char quote) throws IOException {
        String v7;
        char[] v0 = this.buffer;
        StringBuilder v1 = null;
        do {
            int v4 = this.pos;
            int v3 = this.limit;
            int v6 = v4;
            int v5;
            for(v5 = v4; v5 < v3; v5 = v4) {
                v4 = v5 + 1;
                int v2 = v0[v5];
                if(v2 == quote) {
                    this.pos = v4;
                    if(this.skipping) {
                        v7 = "skipped!";
                    }
                    else if(v1 == null) {
                        v7 = this.stringPool.get(v0, v6, v4 - v6 - 1);
                    }
                    else {
                        v1.append(v0, v6, v4 - v6 - 1);
                        v7 = v1.toString();
                    }

                    return v7;
                }

                if(v2 == 92) {
                    this.pos = v4;
                    if(v1 == null) {
                        v1 = new StringBuilder();
                    }

                    v1.append(v0, v6, v4 - v6 - 1);
                    v1.append(this.readEscapeCharacter());
                    v4 = this.pos;
                    v3 = this.limit;
                    v6 = v4;
                }
            }

            if(v1 == null) {
                v1 = new StringBuilder();
            }

            v1.append(v0, v6, v5 - v6);
            this.pos = v5;
        }
        while(this.fillBuffer(1));

        throw this.syntaxError("Unterminated string");
    }

    private JsonToken nextValue() throws IOException {
        int v0 = this.nextNonWhitespace(true);
        switch(v0) {
            case 34: {
                goto label_19;
            }
            case 39: {
                goto label_18;
            }
            case 91: {
                goto label_13;
            }
            case 123: {
                goto label_8;
            }
        }

        --this.pos;
        JsonToken v1 = this.readLiteral();
        goto label_7;
    label_18:
        this.checkLenient();
    label_19:
        this.value = this.nextString(((char)v0));
        v1 = JsonToken.STRING;
        this.token = v1;
        goto label_7;
    label_8:
        this.push(JsonScope.EMPTY_OBJECT);
        v1 = JsonToken.BEGIN_OBJECT;
        this.token = v1;
        goto label_7;
    label_13:
        this.push(JsonScope.EMPTY_ARRAY);
        v1 = JsonToken.BEGIN_ARRAY;
        this.token = v1;
    label_7:
        return v1;
    }

    private JsonToken objectValue() throws IOException {
        switch(this.nextNonWhitespace(true)) {
            case 58: {
                break;
            }
            case 61: {
                this.checkLenient();
                if(this.pos >= this.limit && !this.fillBuffer(1)) {
                    goto label_20;
                }

                if(this.buffer[this.pos] != 62) {
                    goto label_20;
                }

                ++this.pos;
                break;
            }
            default: {
                throw this.syntaxError("Expected \':\'");
            }
        }

    label_20:
        this.stack[this.stackSize - 1] = JsonScope.NONEMPTY_OBJECT;
        return this.nextValue();
    }

    public JsonToken peek() throws IOException {
        JsonToken v1;
        if(this.token != null) {
            v1 = this.token;
        }
        else {
            switch(com.google.gson.stream.JsonReader$2.$SwitchMap$com$google$gson$stream$JsonScope[this.stack[this.stackSize - 1].ordinal()]) {
                case 1: {
                    goto label_16;
                }
                case 2: {
                    goto label_49;
                }
                case 3: {
                    goto label_51;
                }
                case 4: {
                    goto label_53;
                }
                case 5: {
                    goto label_55;
                }
                case 6: {
                    goto label_57;
                }
                case 7: {
                    goto label_59;
                }
                case 8: {
                    goto label_74;
                }
            }

            throw new AssertionError();
        label_53:
            v1 = this.nextInObject(true);
            goto label_5;
        label_55:
            v1 = this.objectValue();
            goto label_5;
        label_49:
            v1 = this.nextInArray(true);
            goto label_5;
        label_51:
            v1 = this.nextInArray(false);
            goto label_5;
        label_57:
            v1 = this.nextInObject(false);
            goto label_5;
        label_16:
            if(this.lenient) {
                this.consumeNonExecutePrefix();
            }

            this.stack[this.stackSize - 1] = JsonScope.NONEMPTY_DOCUMENT;
            v1 = this.nextValue();
            if(this.lenient) {
                goto label_5;
            }

            if(this.token == JsonToken.BEGIN_ARRAY) {
                goto label_5;
            }

            if(this.token == JsonToken.BEGIN_OBJECT) {
                goto label_5;
            }

            throw new IOException("Expected JSON document to start with \'[\' or \'{\' but was " + this.token + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
        label_74:
            throw new IllegalStateException("JsonReader is closed");
        label_59:
            if(this.nextNonWhitespace(false) != -1) {
                goto label_64;
            }

            v1 = JsonToken.END_DOCUMENT;
            goto label_5;
        label_64:
            --this.pos;
            if(!this.lenient) {
                throw this.syntaxError("Expected EOF");
            }

            v1 = this.nextValue();
        }

    label_5:
        return v1;
    }

    private void push(JsonScope newTop) {
        if(this.stackSize == this.stack.length) {
            JsonScope[] v0 = new JsonScope[this.stackSize * 2];
            System.arraycopy(this.stack, 0, v0, 0, this.stackSize);
            this.stack = v0;
        }

        JsonScope[] v1 = this.stack;
        int v2 = this.stackSize;
        this.stackSize = v2 + 1;
        v1[v2] = newTop;
    }

    private char readEscapeCharacter() throws IOException {
        char v4;
        int v10 = 4;
        if(this.pos == this.limit && !this.fillBuffer(1)) {
            throw this.syntaxError("Unterminated escape sequence");
        }

        char[] v5 = this.buffer;
        int v6 = this.pos;
        this.pos = v6 + 1;
        char v2 = v5[v6];
        switch(v2) {
            case 98: {
                v4 = '\b';
                break;
            }
            case 102: {
                v4 = '\f';
                break;
            }
            case 110: {
                v4 = '\n';
                break;
            }
            case 114: {
                v4 = '\r';
                break;
            }
            case 116: {
                v4 = '\t';
                break;
            }
            case 117: {
                if(this.pos + 4 > this.limit && !this.fillBuffer(v10)) {
                    throw this.syntaxError("Unterminated escape sequence");
                }

                v4 = '\u0000';
                int v3 = this.pos;
                int v1 = v3 + 4;
                while(true) {
                    if(v3 >= v1) {
                        goto label_73;
                    }

                    int v0 = this.buffer[v3];
                    v4 = ((char)(v4 << 4));
                    if(v0 < 48 || v0 > 57) {
                        if(v0 >= 97 && v0 <= 102) {
                            v4 = ((char)(v0 - 87 + v4));
                            goto label_42;
                        }

                        if(v0 >= 65 && v0 <= 70) {
                            v4 = ((char)(v0 - 55 + v4));
                            goto label_42;
                        }

                        break;
                    }
                    else {
                        v4 = ((char)(v0 - 48 + v4));
                    }

                label_42:
                    ++v3;
                }

                throw new NumberFormatException("\\u" + this.stringPool.get(this.buffer, this.pos, v10));
            label_73:
                this.pos += 4;
                break;
            }
            default: {
                v4 = v2;
                break;
            }
        }

        return v4;
    }

    private JsonToken readLiteral() throws IOException {
        this.value = this.nextLiteral(true);
        if(this.valueLength == 0) {
            throw this.syntaxError("Expected literal value");
        }

        this.token = this.decodeLiteral();
        if(this.token == JsonToken.STRING) {
            this.checkLenient();
        }

        return this.token;
    }

    public final void setLenient(boolean lenient) {
        this.lenient = lenient;
    }

    private boolean skipTo(String toFind) throws IOException {
        boolean v1;
        int v0;
        while(true) {
        label_0:
            if(this.pos + toFind.length() <= this.limit || (this.fillBuffer(toFind.length()))) {
                v0 = 0;
                while(true) {
                label_9:
                    if(v0 >= toFind.length()) {
                        goto label_23;
                    }
                    else if(this.buffer[this.pos + v0] != toFind.charAt(v0)) {
                        ++this.pos;
                        goto label_0;
                    }
                    else {
                        goto label_21;
                    }
                }
            }
            else {
                v1 = false;
            }

            goto label_24;
        }

    label_21:
        ++v0;
        goto label_9;
    label_23:
        v1 = true;
    label_24:
        return v1;
    }

    private void skipToEndOfLine() throws IOException {
        do {
            if(this.pos >= this.limit && !this.fillBuffer(1)) {
                return;
            }

            char[] v1 = this.buffer;
            int v2 = this.pos;
            this.pos = v2 + 1;
            int v0 = v1[v2];
        }
        while(v0 != 13 && v0 != 10);
    }

    public void skipValue() throws IOException {
        this.skipping = true;
        int v0 = 0;
        try {
            do {
            label_4:
                JsonToken v1 = this.advance();
                if(v1 == JsonToken.BEGIN_ARRAY) {
                    goto label_9;
                }
                else if(v1 != JsonToken.BEGIN_OBJECT) {
                    if(v1 != JsonToken.END_ARRAY && v1 != JsonToken.END_OBJECT) {
                        goto label_10;
                    }

                    break;
                }
                else {
                    goto label_9;
                }
            }
            while(true);
        }
        catch(Throwable v2) {
            this.skipping = false;
            throw v2;
        }

        --v0;
        goto label_10;
    label_9:
        ++v0;
    label_10:
        if(v0 != 0) {
            goto label_4;
        }

        this.skipping = false;
    }

    private IOException syntaxError(String message) throws IOException {
        throw new MalformedJsonException(message + " at line " + this.getLineNumber() + " column " + this.getColumnNumber());
    }

    public String toString() {
        return this.getClass().getSimpleName() + " at line " + this.getLineNumber() + " column " + this.getColumnNumber();
    }
}

