// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.hk515.activity.specially;

import android.content.Context;
import android.graphics.Point;
import android.graphics.Rect;
import android.os.Handler;
import android.util.AttributeSet;
import android.util.SparseIntArray;
import android.util.TypedValue;
import android.view.Display;
import android.view.MotionEvent;
import android.view.View;
import android.view.View$MeasureSpec;
import android.view.View$OnClickListener;
import android.view.View$OnLongClickListener;
import android.view.View$OnTouchListener;
import android.view.ViewGroup;
import android.view.animation.AccelerateDecelerateInterpolator;
import android.view.animation.Animation;
import android.view.animation.AnimationSet;
import android.view.animation.RotateAnimation;
import android.view.animation.ScaleAnimation;
import android.view.animation.TranslateAnimation;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

public class DragDropGrid extends ViewGroup implements View$OnLongClickListener, View$OnTouchListener {
    class ItemPosition {
        public int pageIndex;

        public ItemPosition(DragDropGrid arg1, int pageIndex, int itemIndex) {
            DragDropGrid.this = arg1;
            super();
            this.pageIndex = pageIndex;
            this.itemIndex = itemIndex;
        }
    }

    private static int ANIMATION_DURATION;
    private static int EGDE_DETECTION_MARGIN;
    private PagedDragDropGridAdapter adapter;
    private int biggestChildHeight;
    private int biggestChildWidth;
    private int columnWidthSize;
    private int computedColumnCount;
    private int computedRowCount;
    private PagedContainer container;
    private DeleteDropZoneView deleteZone;
    private int dragged;
    private Timer edgeScrollTimer;
    private final Handler edgeTimerHandler;
    private int gridPageHeight;
    private int gridPageWidth;
    private int initialX;
    private int initialY;
    private int lastTarget;
    private int lastTouchX;
    private int lastTouchY;
    private boolean movingView;
    private SparseIntArray newPositions;
    private View$OnClickListener onClickListener;
    private int rowHeightSize;
    private boolean wasOnEdgeJustNow;

    static  {
        DragDropGrid.ANIMATION_DURATION = 250;
        DragDropGrid.EGDE_DETECTION_MARGIN = 35;
    }

    public DragDropGrid(Context context) {
        super(context);
        this.onClickListener = null;
        this.newPositions = new SparseIntArray();
        this.gridPageWidth = 0;
        this.dragged = -1;
        this.lastTarget = -1;
        this.wasOnEdgeJustNow = false;
        this.edgeTimerHandler = new Handler();
        this.init();
    }

    public DragDropGrid(Context context, AttributeSet attrs) {
        super(context, attrs);
        this.onClickListener = null;
        this.newPositions = new SparseIntArray();
        this.gridPageWidth = 0;
        this.dragged = -1;
        this.lastTarget = -1;
        this.wasOnEdgeJustNow = false;
        this.edgeTimerHandler = new Handler();
        this.init();
    }

    public DragDropGrid(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        this.onClickListener = null;
        this.newPositions = new SparseIntArray();
        this.gridPageWidth = 0;
        this.dragged = -1;
        this.lastTarget = -1;
        this.wasOnEdgeJustNow = false;
        this.edgeTimerHandler = new Handler();
        this.init();
    }

    private boolean aViewIsDragged() {
        return this.weWereMovingDraggedBetweenPages();
    }

    static boolean access$0(DragDropGrid arg1) {
        return arg1.wasOnEdgeJustNow;
    }

    static void access$1(DragDropGrid arg0, boolean arg1) {
        arg0.wasOnEdgeJustNow = arg1;
    }

    static Handler access$2(DragDropGrid arg1) {
        return arg1.edgeTimerHandler;
    }

    static void access$3(DragDropGrid arg0) {
        arg0.hideDeleteView();
    }

    static void access$4(DragDropGrid arg0, boolean arg1, boolean arg2) {
        arg0.scroll(arg1, arg2);
    }

    static void access$5(DragDropGrid arg0) {
        arg0.cancelAnimations();
    }

    static void access$6(DragDropGrid arg0) {
        arg0.animateMoveAllItems();
    }

    static void access$7(DragDropGrid arg0) {
        arg0.animateDragged();
    }

    static void access$8(DragDropGrid arg0) {
        arg0.popDeleteView();
    }

    private int acknowledgeHeightSize(int heightMode, int heightSize, Display display) {
        if(heightMode == 0) {
            heightSize = display.getHeight();
        }

        this.gridPageHeight = heightSize;
        return heightSize;
    }

    private int acknowledgeWidthSize(int widthMode, int widthSize, Display display) {
        if(widthMode == 0) {
            widthSize = display.getWidth();
        }

        this.gridPageWidth = widthSize;
        return widthSize;
    }

    private void adaptChildrenMeasuresToViewSize(int widthSize, int heightSize) {
        int v4 = -1;
        int v3 = -2147483648;
        if(this.adapter.columnCount() == v4 || this.adapter.rowCount() == v4) {
            this.measureChildren(0, 0);
        }
        else {
            this.measureChildren(View$MeasureSpec.makeMeasureSpec(widthSize / this.adapter.columnCount(), v3), View$MeasureSpec.makeMeasureSpec(heightSize / this.adapter.rowCount(), v3));
        }
    }

    private void addChildViews() {
        int v1;
        for(v1 = 0; v1 < this.adapter.pageCount(); ++v1) {
            int v0;
            for(v0 = 0; v0 < this.adapter.itemCountInPage(v1); ++v0) {
                this.addView(this.adapter.view(v1, v0));
            }
        }

        this.deleteZone.bringToFront();
    }

    private void addReorderedChildrenToParent(List arg5) {
        List v0 = this.reeorderView(arg5);
        this.newPositions.clear();
        Iterator v2 = v0.iterator();
        while(v2.hasNext()) {
            Object v1 = v2.next();
            if(v1 == null) {
                continue;
            }

            this.addView(((View)v1));
        }

        this.deleteZone.bringToFront();
    }

    private void animateDeleteDragged() {
        ScaleAnimation v0 = new ScaleAnimation(1.4f, 0f, 1.4f, 0f, ((float)(this.biggestChildWidth / 2)), ((float)(this.biggestChildHeight / 2)));
        v0.setDuration(200);
        v0.setFillAfter(true);
        v0.setFillEnabled(true);
        this.getDraggedView().clearAnimation();
        this.getDraggedView().startAnimation(((Animation)v0));
    }

    private void animateDragged() {
        ScaleAnimation v0 = new ScaleAnimation(1f, 1.4f, 1f, 1.4f, ((float)(this.biggestChildWidth / 2)), ((float)(this.biggestChildHeight / 2)));
        v0.setDuration(200);
        v0.setFillAfter(true);
        v0.setFillEnabled(true);
        if(this.aViewIsDragged()) {
            View v7 = this.getDraggedView();
            v7.clearAnimation();
            v7.startAnimation(((Animation)v0));
        }
    }

    private void animateGap(int targetLocationInGrid) {
        int v5 = this.currentViewAtPosition(targetLocationInGrid);
        if(v5 != this.dragged) {
            View v4 = this.getChildView(v5);
            Point v3 = this.getCoorForIndex(v5);
            this.animateMoveToNewPosition(v4, this.computeTranslationStartDeltaRelativeToRealViewPosition(targetLocationInGrid, v5, v3), this.computeTranslationEndDeltaRelativeToRealViewPosition(v3, this.getCoorForIndex(this.newPositions.get(this.dragged, this.dragged))));
            this.saveNewPositions(targetLocationInGrid, v5);
        }
    }

    private void animateMoveAllItems() {
        Animation v3 = this.createFastRotateAnimation();
        int v2 = this.getItemViewCount() - 2;
        int v1;
        for(v1 = 0; v1 < this.getItemViewCount(); ++v1) {
            View v0 = this.getChildAt(v1);
            if(v1 != 0 && v1 != v2) {
                v0.startAnimation(v3);
            }
        }
    }

    private void animateMoveToNewPosition(View targetView, Point oldOffset, Point newOffset) {
        AnimationSet v1 = new AnimationSet(true);
        Animation v0 = this.createFastRotateAnimation();
        TranslateAnimation v2 = this.createTranslateAnimation(oldOffset, newOffset);
        v1.addAnimation(v0);
        v1.addAnimation(((Animation)v2));
        targetView.clearAnimation();
        targetView.startAnimation(((Animation)v1));
    }

    private void animateOnTheEdge() {
        View v7 = this.getDraggedView();
        ScaleAnimation v0 = new ScaleAnimation(0.667f, 1.5f, 0.667f, 1.5f, ((float)(v7.getMeasuredWidth() * 3 / 4)), ((float)(v7.getMeasuredHeight() * 3 / 4)));
        v0.setDuration(200);
        v0.setRepeatMode(2);
        v0.setRepeatCount(-1);
        v7.clearAnimation();
        v7.startAnimation(((Animation)v0));
    }

    private void bringDraggedToFront() {
        this.getChildAt(this.dragged).bringToFront();
        this.deleteZone.bringToFront();
    }

    private boolean canScrollToEitherSide(boolean onRightEdge, boolean onLeftEdge) {
        boolean v0;
        if(!onLeftEdge || !this.container.canScrollToPreviousPage()) {
            if((onRightEdge) && (this.container.canScrollToNextPage())) {
            label_10:
                v0 = true;
                goto label_9;
            }

            v0 = false;
        }
        else {
            goto label_10;
        }

    label_9:
        return v0;
    }

    private void cancelAnimations() {
        int v1;
        for(v1 = 0; v1 < this.getItemViewCount() - 2; ++v1) {
            this.getChildAt(v1).clearAnimation();
        }
    }

    private void cancelEdgeTimer() {
        if(this.edgeScrollTimer != null) {
            this.edgeScrollTimer.cancel();
            this.edgeScrollTimer = null;
        }
    }

    private boolean childHasMoved(int position) {
        boolean v0;
        if(position != -1) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    private List cleanUnorderedChildren() {
        List v0 = this.saveChildren();
        this.removeItemChildren(v0);
        return v0;
    }

    private void computeColumnsAndRowsSizes(int widthSize, int heightSize) {
        this.columnWidthSize = widthSize / this.computedColumnCount;
        this.rowHeightSize = heightSize / this.computedRowCount;
    }

    private int computeDropZoneVerticalBottom() {
        int v1;
        if(this.adapter.deleteDropZoneLocation() == 1) {
            v1 = this.deleteZone.getMeasuredHeight();
        }
        else {
            v1 = this.gridPageHeight - this.deleteZone.getMeasuredHeight() + this.gridPageHeight;
        }

        return v1;
    }

    private int computeDropZoneVerticalLocation() {
        int v1;
        if(this.adapter.deleteDropZoneLocation() == 1) {
            v1 = 0;
        }
        else {
            v1 = this.gridPageHeight - this.deleteZone.getMeasuredHeight();
        }

        return v1;
    }

    private void computeGridMatrixSize(int widthSize, int heightSize) {
        int v1 = -1;
        if(this.adapter.columnCount() != v1 && this.adapter.rowCount() != v1) {
            this.computedColumnCount = this.adapter.columnCount();
            this.computedRowCount = this.adapter.rowCount();
        }
        else if(this.biggestChildWidth > 0 && this.biggestChildHeight > 0) {
            this.computedColumnCount = widthSize / this.biggestChildWidth;
            this.computedRowCount = heightSize / this.biggestChildHeight;
        }

        if(this.computedColumnCount == 0) {
            this.computedColumnCount = 1;
        }

        if(this.computedRowCount == 0) {
            this.computedRowCount = 1;
        }
    }

    private int computePageEdgeXCoor(View child) {
        int v0 = this.lastTouchX - child.getMeasuredWidth() / 2;
        if(this.onRightEdgeOfScreen(this.lastTouchX)) {
            v0 -= this.gridPageWidth;
        }
        else if(this.onLeftEdgeOfScreen(this.lastTouchX)) {
            v0 += this.gridPageWidth;
        }

        return v0;
    }

    private Point computeTranslationEndDeltaRelativeToRealViewPosition(Point oldXY, Point newXY) {
        return new Point(newXY.x - oldXY.x, newXY.y - oldXY.y);
    }

    private Point computeTranslationStartDeltaRelativeToRealViewPosition(int targetLocation, int viewAtPosition, Point oldXY) {
        Point v0;
        if(this.viewWasAlreadyMoved(targetLocation, viewAtPosition)) {
            v0 = this.computeTranslationEndDeltaRelativeToRealViewPosition(oldXY, this.getCoorForIndex(targetLocation));
        }
        else {
            v0 = new Point(0, 0);
        }

        return v0;
    }

    private void createDeleteZone() {
        this.deleteZone = new DeleteDropZoneView(this.getContext());
        this.addView(this.deleteZone);
    }

    private Animation createFastRotateAnimation() {
        RotateAnimation v0 = new RotateAnimation(-2f, 2f, 1, 0.5f, 1, 0.5f);
        ((Animation)v0).setRepeatMode(2);
        ((Animation)v0).setRepeatCount(-1);
        ((Animation)v0).setDuration(60);
        ((Animation)v0).setInterpolator(new AccelerateDecelerateInterpolator());
        return ((Animation)v0);
    }

    private TranslateAnimation createTranslateAnimation(Point oldOffset, Point newOffset) {
        TranslateAnimation v0 = new TranslateAnimation(0, ((float)oldOffset.x), 0, ((float)newOffset.x), 0, ((float)oldOffset.y), 0, ((float)newOffset.y));
        v0.setDuration(((long)DragDropGrid.ANIMATION_DURATION));
        v0.setFillEnabled(true);
        v0.setFillAfter(true);
        v0.setInterpolator(new AccelerateDecelerateInterpolator());
        return v0;
    }

    private int currentPage() {
        return this.container.currentPage();
    }

    private int currentViewAtPosition(int targetLocation) {
        int v2 = targetLocation;
        int v0 = 0;
        while(v0 < this.newPositions.size()) {
            if(this.newPositions.valueAt(v0) == targetLocation) {
                v2 = this.newPositions.keyAt(v0);
            }
            else {
                ++v0;
                continue;
            }

            break;
        }

        return v2;
    }

    private void ensureThereIsNoArtifact() {
        this.invalidate();
    }

    private int findTheIndexLastElementInNextPage() {
        int v0 = this.currentPage();
        int v2 = 0;
        int v1;
        for(v1 = 0; v1 <= v0 + 1; ++v1) {
            v2 += this.adapter.itemCountInPage(v1);
        }

        return v2;
    }

    private int findTheIndexOfFirstElementInCurrentPage() {
        int v0 = this.currentPage();
        int v2 = 0;
        int v1;
        for(v1 = 0; v1 < v0; ++v1) {
            v2 += this.adapter.itemCountInPage(v1);
        }

        return v2;
    }

    private View getChildView(int index) {
        View v0;
        if(!this.weWereMovingDraggedBetweenPages() || index < this.dragged) {
            v0 = this.getChildAt(index);
        }
        else {
            v0 = this.getChildAt(index - 1);
        }

        return v0;
    }

    private int getColumnOfCoordinate(int x, int page) {
        int v0 = 0;
        int v3 = page * this.gridPageWidth;
        int v2 = 1;
        while(v2 <= this.computedColumnCount) {
            if(x < this.columnWidthSize * v2 + v3) {
                break;
            }

            ++v0;
            ++v2;
        }

        return v0;
    }

    private Point getCoorForIndex(int index) {
        ItemPosition v1 = this.itemInformationAtPosition(index);
        int v2 = v1.itemIndex / this.computedColumnCount;
        return new Point(this.currentPage() * this.gridPageWidth + this.columnWidthSize * (v1.itemIndex - this.computedColumnCount * v2), this.rowHeightSize * v2);
    }

    private View getDraggedView() {
        return this.getChildAt(this.getChildCount() - 2);
    }

    private int getItemViewCount() {
        return this.getChildCount() - 1;
    }

    private float getPixelFromDip(int size) {
        return TypedValue.applyDimension(1, ((float)size), this.getResources().getDisplayMetrics());
    }

    private int getRowOfCoordinate(int y) {
        int v1 = 0;
        int v0 = 1;
        while(v0 <= this.computedRowCount) {
            if(y < this.rowHeightSize * v0) {
                break;
            }

            ++v1;
            ++v0;
        }

        return v1;
    }

    private int getTargetAtCoor(int x, int y) {
        int v1 = this.currentPage();
        return this.positionOfItem(v1, this.getColumnOfCoordinate(x, v1) + this.computedColumnCount * this.getRowOfCoordinate(y));
    }

    private void hideDeleteView() {
        this.deleteZone.setVisibility(4);
    }

    private void init() {
        if((this.isInEditMode()) && this.adapter == null) {
            this.useEditModeAdapter();
        }

        this.setOnTouchListener(((View$OnTouchListener)this));
        this.setOnLongClickListener(((View$OnLongClickListener)this));
        this.createDeleteZone();
    }

    private boolean isPointInsideView(float x, float y, View view) {
        boolean v0;
        int[] v6 = new int[2];
        view.getLocationOnScreen(v6);
        if(this.pointIsInsideViewBounds(x, y, view, v6[0], v6[1])) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    private ItemPosition itemInformationAtPosition(int position) {
        ItemPosition v4;
        int v0 = 0;
        int v2;
        for(v2 = 0; v2 < this.adapter.pageCount(); ++v2) {
            int v3 = this.adapter.itemCountInPage(v2);
            int v1 = 0;
            while(true) {
                if(v1 >= v3) {
                    break;
                }
                else if(v0 == position) {
                    v4 = new ItemPosition(this, v2, v1);
                }
                else {
                    ++v0;
                    ++v1;
                    continue;
                }

                goto label_6;
            }
        }

        v4 = null;
    label_6:
        return v4;
    }

    private boolean lastTouchOnEdge() {
        boolean v0;
        if((this.onRightEdgeOfScreen(this.lastTouchX)) || (this.onLeftEdgeOfScreen(this.lastTouchX))) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    private void layoutAChild(int pageWidth, int page, int col, int row, int childIndex) {
        int v3;
        int v1;
        int v2 = this.positionOfItem(page, childIndex);
        View v0 = this.getChildAt(v2);
        if(v2 != this.dragged || !this.lastTouchOnEdge()) {
            v1 = page * pageWidth + this.columnWidthSize * col + (this.columnWidthSize - v0.getMeasuredWidth()) / 2;
            v3 = this.rowHeightSize * row + (this.rowHeightSize - v0.getMeasuredHeight()) / 2;
        }
        else {
            v1 = this.computePageEdgeXCoor(v0);
            v3 = this.lastTouchY - v0.getMeasuredHeight() / 2;
        }

        v0.layout(v1, v3, v0.getMeasuredWidth() + v1, v0.getMeasuredHeight() + v3);
    }

    private void layoutPage(int pageWidth, int page) {
        int v3 = 0;
        int v4 = 0;
        int v5;
        for(v5 = 0; v5 < this.adapter.itemCountInPage(page); ++v5) {
            this.layoutAChild(pageWidth, page, v3, v4, v5);
            ++v3;
            if(v3 == this.computedColumnCount) {
                v3 = 0;
                ++v4;
            }
        }
    }

    private void manageChildrenReordering() {
        if(this.touchUpInDeleteZoneDrop(this.lastTouchX, this.lastTouchY)) {
            this.animateDeleteDragged();
            this.reorderChildrenWhenDraggedIsDeleted();
        }
        else {
            this.reorderChildren();
        }
    }

    private void manageDeleteZoneHover(int x, int y) {
        Rect v0 = new Rect();
        this.deleteZone.getHitRect(v0);
        if(v0.intersect(x, y, x + 1, y + 1)) {
            this.deleteZone.highlight();
        }
        else {
            this.deleteZone.smother();
        }
    }

    private void manageEdgeCoordinates(int x) {
        boolean v1 = this.onRightEdgeOfScreen(x);
        boolean v0 = this.onLeftEdgeOfScreen(x);
        if(!this.canScrollToEitherSide(v1, v0)) {
            if(this.wasOnEdgeJustNow) {
                this.stopAnimateOnTheEdge();
            }

            this.wasOnEdgeJustNow = false;
            this.cancelEdgeTimer();
        }
        else if(!this.wasOnEdgeJustNow) {
            this.startEdgeDelayTimer(v1, v0);
            this.wasOnEdgeJustNow = true;
        }
    }

    private void manageSwapPosition(int x, int y) {
        int v0 = this.getTargetAtCoor(x, y);
        if((this.childHasMoved(v0)) && v0 != this.lastTarget) {
            this.animateGap(v0);
            this.lastTarget = v0;
        }
    }

    private void moveDraggedToNextPage() {
        List v5 = this.reeorderView(this.cleanUnorderedChildren());
        int v1 = this.newPositions.get(this.dragged, this.dragged);
        Object v2 = v5.get(v1);
        v5.remove(v1);
        this.reorderAndAddViews(v5, ((View)v2), this.findTheIndexLastElementInNextPage() - 1);
    }

    private void moveDraggedToPreviousPage() {
        List v5 = this.reeorderView(this.cleanUnorderedChildren());
        int v1 = this.newPositions.get(this.dragged, this.dragged);
        Object v2 = v5.get(v1);
        v5.remove(v1);
        this.reorderAndAddViews(v5, ((View)v2), this.findTheIndexOfFirstElementInCurrentPage() - 1);
    }

    private void moveDraggedView(int x, int y) {
        View v0 = this.getDraggedView();
        int v4 = v0.getMeasuredWidth();
        int v1 = v0.getMeasuredHeight();
        int v2 = x - v4 / 2;
        int v3 = y - v1 / 2;
        v0.layout(v2, v3, v2 + v4, v3 + v1);
    }

    public boolean onInterceptTouchEvent(MotionEvent event) {
        return this.onTouch(null, event);
    }

    protected void onLayout(boolean changed, int l, int t, int r, int b) {
        int v1 = (l + r) / this.adapter.pageCount();
        int v0;
        for(v0 = 0; v0 < this.adapter.pageCount(); ++v0) {
            this.layoutPage(v1, v0);
        }

        if(this.weWereMovingDraggedBetweenPages()) {
            this.bringDraggedToFront();
        }
    }

    private boolean onLeftEdgeOfScreen(int x) {
        boolean v3;
        int v1 = x - this.container.currentPage() * this.gridPageWidth;
        if(x <= 0 || v1 > DragDropGrid.EGDE_DETECTION_MARGIN) {
            v3 = false;
        }
        else {
            v3 = true;
        }

        return v3;
    }

    public boolean onLongClick(View v) {
        boolean v0 = true;
        if(this.positionForView(v) != -1) {
            this.container.disableScroll();
            this.movingView = true;
            this.dragged = this.positionForView(v);
            this.bringDraggedToFront();
            this.animateMoveAllItems();
            this.animateDragged();
            this.popDeleteView();
        }
        else {
            v0 = false;
        }

        return v0;
    }

    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        int v3 = View$MeasureSpec.getMode(widthMeasureSpec);
        int v1 = View$MeasureSpec.getMode(heightMeasureSpec);
        int v4 = View$MeasureSpec.getSize(widthMeasureSpec);
        int v2 = View$MeasureSpec.getSize(heightMeasureSpec);
        Display v0 = this.getContext().getSystemService("window").getDefaultDisplay();
        v4 = this.acknowledgeWidthSize(v3, v4, v0);
        v2 = this.acknowledgeHeightSize(v1, v2, v0);
        this.adaptChildrenMeasuresToViewSize(v4, v2);
        this.searchBiggestChildMeasures();
        this.computeGridMatrixSize(v4, v2);
        this.computeColumnsAndRowsSizes(v4, v2);
        this.measureChild(this.deleteZone, View$MeasureSpec.makeMeasureSpec(this.gridPageWidth, 1073741824), View$MeasureSpec.makeMeasureSpec(((int)this.getPixelFromDip(40)), 1073741824));
        this.setMeasuredDimension(this.adapter.pageCount() * v4, v2);
    }

    private boolean onRightEdgeOfScreen(int x) {
        boolean v3;
        int v2 = this.gridPageWidth * this.container.currentPage() + this.gridPageWidth;
        int v1 = v2 - x;
        if(x <= v2 - DragDropGrid.EGDE_DETECTION_MARGIN || v1 >= DragDropGrid.EGDE_DETECTION_MARGIN) {
            v3 = false;
        }
        else {
            v3 = true;
        }

        return v3;
    }

    public boolean onTouch(View v, MotionEvent event) {
        boolean v1;
        switch(event.getAction() & 255) {
            case 0: {
                this.touchDown(event);
                break;
            }
            case 1: {
                this.touchUp(event);
                break;
            }
            case 2: {
                this.touchMove(event);
                break;
            }
        }

        if(this.aViewIsDragged()) {
            v1 = true;
        }
        else {
            v1 = false;
        }

        return v1;
    }

    private boolean pointIsInsideViewBounds(float x, float y, View view, int viewX, int viewY) {
        boolean v0;
        if(x <= (((float)viewX)) || x >= (((float)(view.getWidth() + viewX))) || y <= (((float)viewY)) || y >= (((float)(view.getHeight() + viewY)))) {
            v0 = false;
        }
        else {
            v0 = true;
        }

        return v0;
    }

    private void popDeleteView() {
        if(this.adapter.showRemoveDropZone()) {
            this.showDeleteView();
        }
    }

    private int positionForView(View v) {
        int v1 = 0;
        while(true) {
            if(v1 >= this.getItemViewCount()) {
                break;
            }
            else if(!this.isPointInsideView(((float)this.initialX), ((float)this.initialY), this.getChildView(v1))) {
                ++v1;
                continue;
            }

            goto label_4;
        }

        v1 = -1;
    label_4:
        return v1;
    }

    private int positionOfItem(int pageIndex, int childIndex) {
        int v4;
        int v0 = 0;
        int v2;
        for(v2 = 0; v2 < this.adapter.pageCount(); ++v2) {
            int v3 = this.adapter.itemCountInPage(v2);
            int v1;
            for(v1 = 0; v1 < v3; ++v1) {
                if(pageIndex == v2 && childIndex == v1) {
                    v4 = v0;
                    goto label_6;
                }

                ++v0;
            }
        }

        v4 = -1;
    label_6:
        return v4;
    }

    private List reeorderView(List arg6) {
        View[] v2 = new View[arg6.size()];
        int v0;
        for(v0 = 0; v0 < arg6.size(); ++v0) {
            int v1 = this.newPositions.get(v0, -1);
            if(this.childHasMoved(v1)) {
                v2[v1] = arg6.get(v0);
            }
            else {
                v2[v0] = arg6.get(v0);
            }
        }

        return new ArrayList(Arrays.asList(((Object[])v2)));
    }

    private void removeItemChildren(List arg4) {
        Iterator v1 = arg4.iterator();
        while(v1.hasNext()) {
            this.removeView(v1.next());
        }
    }

    private void reorderAndAddViews(List arg4, View draggedView, int indexOfDraggedOnNewPage) {
        arg4.add(indexOfDraggedOnNewPage, draggedView);
        this.newPositions.clear();
        Iterator v1 = arg4.iterator();
        while(v1.hasNext()) {
            Object v0 = v1.next();
            if(v0 == null) {
                continue;
            }

            this.addView(((View)v0));
        }

        this.deleteZone.bringToFront();
    }

    private void reorderChildren() {
        this.addReorderedChildrenToParent(this.cleanUnorderedChildren());
    }

    private void reorderChildrenWhenDraggedIsDeleted() {
        Integer v1 = Integer.valueOf(this.newPositions.get(this.dragged, this.dragged));
        this.addReorderedChildrenToParent(this.cleanUnorderedChildren());
        this.tellAdapterDraggedIsDeleted(v1);
        this.removeViewAt(v1.intValue());
        this.requestLayout();
    }

    private List saveChildren() {
        View v0;
        ArrayList v1 = new ArrayList();
        int v2;
        for(v2 = 0; v2 < this.getItemViewCount(); ++v2) {
            if(v2 == this.dragged) {
                v0 = this.getDraggedView();
            }
            else {
                v0 = this.getChildView(v2);
            }

            v0.clearAnimation();
            ((List)v1).add(v0);
        }

        return ((List)v1);
    }

    private void saveNewPositions(int targetLocation, int viewAtPosition) {
        this.newPositions.put(viewAtPosition, this.newPositions.get(this.dragged, this.dragged));
        this.newPositions.put(this.dragged, targetLocation);
        this.tellAdapterToSwapDraggedWithTarget(this.newPositions.get(this.dragged, this.dragged), this.newPositions.get(viewAtPosition, viewAtPosition));
    }

    private void scheduleScroll(boolean onRightEdge, boolean onLeftEdge) {
        this.edgeScrollTimer.schedule(new TimerTask() {
            static DragDropGrid access$0(com.hk515.activity.specially.DragDropGrid$2 arg1) {
                return arg1.this$0;
            }

            public void run() {
                if(DragDropGrid.this.wasOnEdgeJustNow) {
                    DragDropGrid.access$1(DragDropGrid.this, false);
                    DragDropGrid.this.edgeTimerHandler.post(new Runnable() {
                        public void run() {
                            com.hk515.activity.specially.DragDropGrid$2.access$0(this.this$1).hideDeleteView();
                            com.hk515.activity.specially.DragDropGrid$2.access$0(this.this$1).scroll(this.val$onRightEdge, this.val$onLeftEdge);
                            com.hk515.activity.specially.DragDropGrid$2.access$0(this.this$1).cancelAnimations();
                            com.hk515.activity.specially.DragDropGrid$2.access$0(this.this$1).animateMoveAllItems();
                            com.hk515.activity.specially.DragDropGrid$2.access$0(this.this$1).animateDragged();
                            com.hk515.activity.specially.DragDropGrid$2.access$0(this.this$1).popDeleteView();
                        }
                    });
                }
            }
        }, 1000);
    }

    private void scroll(boolean onRightEdge, boolean onLeftEdge) {
        this.cancelEdgeTimer();
        if((onLeftEdge) && (this.container.canScrollToPreviousPage())) {
            this.scrollToPreviousPage();
        }
        else if((onRightEdge) && (this.container.canScrollToNextPage())) {
            this.scrollToNextPage();
        }

        this.wasOnEdgeJustNow = false;
    }

    private void scrollToNextPage() {
        this.tellAdapterToMoveItemToNextPage(this.dragged);
        this.moveDraggedToNextPage();
        this.container.scrollRight();
        int v0 = this.currentPage();
        this.dragged = this.positionOfItem(v0, this.adapter.itemCountInPage(v0) - 1);
        this.stopAnimateOnTheEdge();
    }

    private void scrollToPreviousPage() {
        this.tellAdapterToMoveItemToPreviousPage(this.dragged);
        this.moveDraggedToPreviousPage();
        this.container.scrollLeft();
        int v0 = this.currentPage();
        this.dragged = this.positionOfItem(v0, this.adapter.itemCountInPage(v0) - 1);
        this.stopAnimateOnTheEdge();
    }

    private void searchBiggestChildMeasures() {
        this.biggestChildWidth = 0;
        this.biggestChildHeight = 0;
        int v1;
        for(v1 = 0; v1 < this.getItemViewCount(); ++v1) {
            View v0 = this.getChildAt(v1);
            if(this.biggestChildHeight < v0.getMeasuredHeight()) {
                this.biggestChildHeight = v0.getMeasuredHeight();
            }

            if(this.biggestChildWidth < v0.getMeasuredWidth()) {
                this.biggestChildWidth = v0.getMeasuredWidth();
            }
        }
    }

    public void setAdapter(PagedDragDropGridAdapter adapter) {
        this.adapter = adapter;
        this.addChildViews();
    }

    public void setContainer(PagedDragDropGrid container) {
        this.container = ((PagedContainer)container);
    }

    public void setOnClickListener(View$OnClickListener l) {
        this.onClickListener = l;
    }

    private void showDeleteView() {
        this.deleteZone.setVisibility(0);
        int v1 = this.currentPage() * this.deleteZone.getMeasuredWidth();
        this.deleteZone.layout(v1, this.computeDropZoneVerticalLocation(), this.gridPageWidth + v1, this.computeDropZoneVerticalBottom());
    }

    private void startEdgeDelayTimer(boolean onRightEdge, boolean onLeftEdge) {
        if(this.canScrollToEitherSide(onRightEdge, onLeftEdge)) {
            this.animateOnTheEdge();
            if(this.edgeScrollTimer == null) {
                this.edgeScrollTimer = new Timer();
                this.scheduleScroll(onRightEdge, onLeftEdge);
            }
        }
    }

    private void stopAnimateOnTheEdge() {
        this.getDraggedView().clearAnimation();
        this.animateDragged();
    }

    private void tellAdapterDraggedIsDeleted(Integer newDraggedPosition) {
        ItemPosition v0 = this.itemInformationAtPosition(newDraggedPosition.intValue());
        this.adapter.deleteItem(v0.pageIndex, v0.itemIndex);
    }

    private void tellAdapterToMoveItemToNextPage(int itemIndex) {
        ItemPosition v0 = this.itemInformationAtPosition(itemIndex);
        this.adapter.moveItemToNextPage(v0.pageIndex, v0.itemIndex);
    }

    private void tellAdapterToMoveItemToPreviousPage(int itemIndex) {
        ItemPosition v0 = this.itemInformationAtPosition(itemIndex);
        this.adapter.moveItemToPreviousPage(v0.pageIndex, v0.itemIndex);
    }

    private void tellAdapterToSwapDraggedWithTarget(int dragged, int target) {
        ItemPosition v0 = this.itemInformationAtPosition(dragged);
        ItemPosition v1 = this.itemInformationAtPosition(target);
        if(v0 != null && v1 != null) {
            this.adapter.swapItems(v0.pageIndex, v0.itemIndex, v1.itemIndex);
        }
    }

    private void touchDown(MotionEvent event) {
        this.initialX = ((int)event.getRawX());
        this.initialY = ((int)event.getRawY());
        this.lastTouchX = (((int)event.getRawX())) + this.currentPage() * this.gridPageWidth;
        this.lastTouchY = ((int)event.getRawY());
    }

    private void touchMove(MotionEvent event) {
        if((this.movingView) && (this.aViewIsDragged())) {
            this.lastTouchX = ((int)event.getX());
            this.lastTouchY = ((int)event.getY());
            int v1 = this.getTargetAtCoor(this.lastTouchX, this.lastTouchY);
            int v0 = this.adapter.itemCountInPage(this.currentPage());
            this.ensureThereIsNoArtifact();
            this.moveDraggedView(this.lastTouchX, this.lastTouchY);
            if(v1 > 0 && v1 < v0 - 1) {
                this.manageSwapPosition(this.lastTouchX, this.lastTouchY);
            }

            this.manageEdgeCoordinates(this.lastTouchX);
            this.manageDeleteZoneHover(this.lastTouchX, this.lastTouchY);
        }
    }

    private void touchUp(MotionEvent event) {
        int v2 = -1;
        if(this.aViewIsDragged()) {
            this.cancelAnimations();
            this.manageChildrenReordering();
            this.hideDeleteView();
            this.cancelEdgeTimer();
            this.movingView = false;
            this.dragged = v2;
            this.lastTarget = v2;
            this.container.enableScroll();
        }
        else if(this.onClickListener != null) {
            View v0 = this.getChildAt(this.getTargetAtCoor(((int)event.getX()), ((int)event.getY())));
            if(v0 != null) {
                this.onClickListener.onClick(v0);
            }
        }
    }

    private boolean touchUpInDeleteZoneDrop(int x, int y) {
        boolean v1;
        Rect v0 = new Rect();
        this.deleteZone.getHitRect(v0);
        if(v0.intersect(x, y, x + 1, y + 1)) {
            this.deleteZone.smother();
            v1 = true;
        }
        else {
            v1 = false;
        }

        return v1;
    }

    private void useEditModeAdapter() {
        this.adapter = new PagedDragDropGridAdapter() {
            public int columnCount() {
                return 0;
            }

            public int deleteDropZoneLocation() {
                return 2;
            }

            public void deleteItem(int pageIndex, int itemIndex) {
            }

            public int itemCountInPage(int page) {
                return 0;
            }

            public void moveItemToNextPage(int pageIndex, int itemIndex) {
            }

            public void moveItemToPreviousPage(int pageIndex, int itemIndex) {
            }

            public int pageCount() {
                return -1;
            }

            public int rowCount() {
                return -1;
            }

            public boolean showRemoveDropZone() {
                return 1;
            }

            public void swapItems(int pageIndex, int itemIndexA, int itemIndexB) {
            }

            public View view(int page, int index) {
                return null;
            }
        };
    }

    private boolean viewWasAlreadyMoved(int targetLocation, int viewAtPosition) {
        boolean v0;
        if(viewAtPosition != targetLocation) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    private boolean weWereMovingDraggedBetweenPages() {
        boolean v0;
        if(this.dragged != -1) {
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }
}

