// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.hk515.activity.specially;

import android.content.Context;
import android.util.AttributeSet;
import android.view.GestureDetector;
import android.view.GestureDetector$OnGestureListener;
import android.view.MotionEvent;
import android.view.View;
import android.view.View$OnClickListener;
import android.view.View$OnTouchListener;
import android.widget.HorizontalScrollView;

public class PagedDragDropGrid extends HorizontalScrollView implements GestureDetector$OnGestureListener, PagedContainer {
    private int activePage;
    private boolean activePageRestored;
    private PagedDragDropGridAdapter adapter;
    private GestureDetector gestureScanner;
    private DragDropGrid grid;
    private View$OnClickListener listener;
    private OnPageChangedListener pageChangedListener;

    public PagedDragDropGrid(Context context, AttributeSet attrs) {
        super(context, attrs);
        this.activePage = 0;
        this.activePageRestored = false;
        this.initPagedScroll();
        this.initGrid();
    }

    public PagedDragDropGrid(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        this.activePage = 0;
        this.activePageRestored = false;
        this.initPagedScroll();
        this.initGrid();
    }

    static GestureDetector access$0(PagedDragDropGrid arg1) {
        return arg1.gestureScanner;
    }

    public boolean canScrollToNextPage() {
        boolean v1;
        if(this.activePage + 1 < this.adapter.pageCount()) {
            v1 = true;
        }
        else {
            v1 = false;
        }

        return v1;
    }

    public boolean canScrollToPreviousPage() {
        boolean v1;
        if(this.activePage - 1 >= 0) {
            v1 = true;
        }
        else {
            v1 = false;
        }

        return v1;
    }

    public int currentPage() {
        return this.activePage;
    }

    public void disableScroll() {
        this.requestDisallowInterceptTouchEvent(true);
    }

    public void enableScroll() {
        this.requestDisallowInterceptTouchEvent(false);
    }

    private void initGrid() {
        this.grid = new DragDropGrid(this.getContext());
        this.addView(this.grid);
    }

    public void initPagedScroll() {
        this.setScrollBarStyle(0);
        if(!this.isInEditMode()) {
            this.gestureScanner = new GestureDetector(this.getContext(), ((GestureDetector$OnGestureListener)this));
        }

        this.setOnTouchListener(new View$OnTouchListener() {
            public boolean onTouch(View v, MotionEvent event) {
                boolean v3 = PagedDragDropGrid.this.gestureScanner.onTouchEvent(event);
                if(!v3 && (event.getAction() == 1 || event.getAction() == 3)) {
                    int v2 = PagedDragDropGrid.this.getScrollX();
                    int v0 = v.getMeasuredWidth();
                    PagedDragDropGrid.this.scrollToPage((v0 / 2 + v2) / v0);
                    v3 = true;
                }

                return v3;
            }
        });
    }

    public boolean onDown(MotionEvent arg0) {
        return 0;
    }

    public boolean onFling(MotionEvent evt1, MotionEvent evt2, float velocityX, float velocityY) {
        boolean v0 = true;
        if(velocityX < -500f) {
            this.scrollRight();
        }
        else if(velocityX > 500f) {
            this.scrollLeft();
        }
        else {
            v0 = false;
        }

        return v0;
    }

    protected void onLayout(boolean changed, int l, int t, int r, int b) {
        super.onLayout(changed, l, t, r, b);
        if(this.activePageRestored) {
            this.activePageRestored = false;
            this.scrollToRestoredPage();
        }
    }

    public boolean onLongClick(View v) {
        return this.grid.onLongClick(v);
    }

    public void onLongPress(MotionEvent arg0) {
    }

    public boolean onScroll(MotionEvent arg0, MotionEvent arg1, float arg2, float arg3) {
        return 0;
    }

    public void onShowPress(MotionEvent arg0) {
    }

    public boolean onSingleTapUp(MotionEvent arg0) {
        return 0;
    }

    public void restoreCurrentPage(int currentPage) {
        this.activePage = currentPage;
        this.activePageRestored = true;
    }

    public void scrollLeft() {
        int v0 = this.activePage - 1;
        if(this.canScrollToPreviousPage()) {
            this.scrollToPage(v0);
        }
    }

    public void scrollRight() {
        int v0 = this.activePage + 1;
        if(this.canScrollToNextPage()) {
            this.scrollToPage(v0);
        }
    }

    public void scrollToPage(int page) {
        this.activePage = page;
        this.smoothScrollTo(page * this.getMeasuredWidth(), 0);
        this.pageChangedListener.onPageChanged(this, page);
    }

    private void scrollToRestoredPage() {
        this.scrollToPage(this.activePage);
    }

    public void setAdapter(PagedDragDropGridAdapter adapter) {
        this.adapter = adapter;
        this.grid.setAdapter(adapter);
        this.grid.setContainer(this);
    }

    public void setClickListener(View$OnClickListener l) {
        this.listener = l;
        this.grid.setOnClickListener(l);
    }

    public void setOnPageChangedListener(OnPageChangedListener listener) {
        this.pageChangedListener = listener;
    }
}

