// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.hk515.common;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.util.AttributeSet;
import android.view.View;
import java.util.Observable;
import java.util.Observer;

public class ImageZoomView extends View implements Observer {
    private float mAspectQuotient;
    private Bitmap mBitmap;
    private final Paint mPaint;
    private final Rect mRectDst;
    private final Rect mRectSrc;
    private ZoomState mState;

    public ImageZoomView(Context context, AttributeSet attrs) {
        super(context, attrs);
        this.mPaint = new Paint(2);
        this.mRectSrc = new Rect();
        this.mRectDst = new Rect();
    }

    private void calculateAspectQuotient() {
        if(this.mBitmap != null) {
            this.mAspectQuotient = (((float)this.mBitmap.getWidth())) / (((float)this.mBitmap.getHeight())) / ((((float)this.getWidth())) / (((float)this.getHeight())));
        }
    }

    protected void onDraw(Canvas canvas) {
        float v12 = 2f;
        if(this.mBitmap != null && this.mState != null) {
            int v5 = this.getWidth();
            int v4 = this.getHeight();
            int v1 = this.mBitmap.getWidth();
            int v0 = this.mBitmap.getHeight();
            float v2 = this.mState.getPanX();
            float v3 = this.mState.getPanY();
            float v6 = this.mState.getZoomX(this.mAspectQuotient) * (((float)v5)) / (((float)v1));
            float v7 = this.mState.getZoomY(this.mAspectQuotient) * (((float)v4)) / (((float)v0));
            this.mRectSrc.left = ((int)((((float)v1)) * v2 - (((float)v5)) / (v6 * v12)));
            this.mRectSrc.top = ((int)((((float)v0)) * v3 - (((float)v4)) / (v7 * v12)));
            this.mRectSrc.right = ((int)((((float)this.mRectSrc.left)) + (((float)v5)) / v6));
            this.mRectSrc.bottom = ((int)((((float)this.mRectSrc.top)) + (((float)v4)) / v7));
            this.mRectDst.left = this.getLeft();
            this.mRectDst.top = this.getTop();
            this.mRectDst.right = this.getRight();
            this.mRectDst.bottom = this.getBottom();
            if(this.mRectSrc.left < 0) {
                this.mRectDst.left = ((int)((((float)this.mRectDst.left)) + (((float)(-this.mRectSrc.left))) * v6));
                this.mRectSrc.left = 0;
            }

            if(this.mRectSrc.right > v1) {
                this.mRectDst.right = ((int)((((float)this.mRectDst.right)) - (((float)(this.mRectSrc.right - v1))) * v6));
                this.mRectSrc.right = v1;
            }

            if(this.mRectSrc.top < 0) {
                this.mRectDst.top = ((int)((((float)this.mRectDst.top)) + (((float)(-this.mRectSrc.top))) * v7));
                this.mRectSrc.top = 0;
            }

            if(this.mRectSrc.bottom > v0) {
                this.mRectDst.bottom = ((int)((((float)this.mRectDst.bottom)) - (((float)(this.mRectSrc.bottom - v0))) * v7));
                this.mRectSrc.bottom = v0;
            }

            canvas.drawBitmap(this.mBitmap, this.mRectSrc, this.mRectDst, this.mPaint);
        }
    }

    protected void onLayout(boolean changed, int left, int top, int right, int bottom) {
        super.onLayout(changed, left, top, right, bottom);
        this.calculateAspectQuotient();
    }

    public void setImage(Bitmap bitmap) {
        this.mBitmap = bitmap;
        this.calculateAspectQuotient();
        this.invalidate();
    }

    public void setZoomState(ZoomState state) {
        if(this.mState != null) {
            this.mState.deleteObserver(((Observer)this));
        }

        this.mState = state;
        this.mState.addObserver(((Observer)this));
        this.invalidate();
    }

    public void update(Observable observable, Object data) {
        this.invalidate();
    }
}

