// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.hk515.common;

import android.content.Context;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.view.View$OnClickListener;
import android.view.ViewTreeObserver$OnGlobalLayoutListener;
import android.view.animation.DecelerateInterpolator;
import android.widget.AbsListView;
import android.widget.AbsListView$OnScrollListener;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.Scroller;
import android.widget.TextView;

public class MyListView extends ListView implements AbsListView$OnScrollListener {
    public abstract interface IXListViewListener {
        public abstract void onLoadMore();

        public abstract void onRefresh();
    }

    public abstract interface OnXScrollListener extends AbsListView$OnScrollListener {
        public abstract void onXScrolling(View arg0);
    }

    private boolean mEnablePullLoad;
    private boolean mEnablePullRefresh;
    public MyListViewFooter mFooterView;
    private TextView mHeaderTimeView;
    public MyListViewHeader mHeaderView;
    private RelativeLayout mHeaderViewContent;
    private int mHeaderViewHeight;
    private boolean mIsFooterReady;
    private float mLastY;
    private IXListViewListener mListViewListener;
    private boolean mPullLoading;
    private boolean mPullRefreshing;
    private int mScrollBack;
    private AbsListView$OnScrollListener mScrollListener;
    private Scroller mScroller;
    private int mTotalItemCount;

    public MyListView(Context context, AttributeSet attrs) {
        super(context, attrs);
        this.mLastY = -1f;
        this.mEnablePullRefresh = true;
        this.mPullRefreshing = false;
        this.mIsFooterReady = false;
        this.initWithContext(context);
    }

    public MyListView(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        this.mLastY = -1f;
        this.mEnablePullRefresh = true;
        this.mPullRefreshing = false;
        this.mIsFooterReady = false;
        this.initWithContext(context);
    }

    static RelativeLayout access$0(MyListView arg1) {
        return arg1.mHeaderViewContent;
    }

    static void access$1(MyListView arg0, int arg1) {
        arg0.mHeaderViewHeight = arg1;
    }

    static void access$2(MyListView arg0) {
        arg0.startLoadMore();
    }

    public void computeScroll() {
        if(this.mScroller.computeScrollOffset()) {
            if(this.mScrollBack == 0) {
                this.mHeaderView.setVisiableHeight(this.mScroller.getCurrY());
            }
            else {
                this.mFooterView.setBottomMargin(this.mScroller.getCurrY());
            }

            this.postInvalidate();
            this.invokeOnScrolling();
        }

        super.computeScroll();
    }

    private void initWithContext(Context context) {
        this.mScroller = new Scroller(context, new DecelerateInterpolator());
        super.setOnScrollListener(((AbsListView$OnScrollListener)this));
        this.mHeaderView = new MyListViewHeader(context);
        this.mHeaderViewContent = this.mHeaderView.findViewById(2131296392);
        this.mHeaderTimeView = this.mHeaderView.findViewById(2131296395);
        this.addHeaderView(this.mHeaderView);
        this.mFooterView = new MyListViewFooter(context);
        this.mHeaderView.getViewTreeObserver().addOnGlobalLayoutListener(new ViewTreeObserver$OnGlobalLayoutListener() {
            public void onGlobalLayout() {
                MyListView.access$1(MyListView.this, MyListView.this.mHeaderViewContent.getHeight());
                MyListView.this.getViewTreeObserver().removeGlobalOnLayoutListener(((ViewTreeObserver$OnGlobalLayoutListener)this));
            }
        });
    }

    private void invokeOnScrolling() {
        if((this.mScrollListener instanceof OnXScrollListener)) {
            this.mScrollListener.onXScrolling(((View)this));
        }
    }

    public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
        this.mTotalItemCount = totalItemCount;
        if(this.mScrollListener != null) {
            this.mScrollListener.onScroll(view, firstVisibleItem, visibleItemCount, totalItemCount);
        }
    }

    public void onScrollStateChanged(AbsListView view, int scrollState) {
        if(this.mScrollListener != null) {
            this.mScrollListener.onScrollStateChanged(view, scrollState);
        }
    }

    public boolean onTouchEvent(MotionEvent ev) {
        float v4 = 1.8f;
        float v2 = -1f;
        if(this.mLastY == v2) {
            this.mLastY = ev.getRawY();
        }

        switch(ev.getAction()) {
            case 0: {
                this.mLastY = ev.getRawY();
                break;
            }
            case 2: {
                float v0 = ev.getRawY() - this.mLastY;
                this.mLastY = ev.getRawY();
                if(this.getFirstVisiblePosition() == 0 && (this.mHeaderView.getVisiableHeight() > 0 || v0 > 0f)) {
                    this.updateHeaderHeight(v0 / v4);
                    this.invokeOnScrolling();
                    goto label_28;
                }

                if(this.getLastVisiblePosition() != this.mTotalItemCount - 1) {
                    goto label_28;
                }

                if(this.mFooterView.getBottomMargin() <= 0 && v0 >= 0f) {
                    goto label_28;
                }

                this.updateFooterHeight(-v0 / v4);
                break;
            }
            default: {
                this.mLastY = v2;
                if(this.getFirstVisiblePosition() != 0) {
                    goto label_60;
                }

                if((this.mEnablePullRefresh) && this.mHeaderView.getVisiableHeight() > this.mHeaderViewHeight) {
                    this.mPullRefreshing = true;
                    this.mHeaderView.setState(2);
                    if(this.mListViewListener != null) {
                        this.mListViewListener.onRefresh();
                    }
                }

                this.resetHeaderHeight();
                goto label_28;
            label_60:
                if(this.getLastVisiblePosition() != this.mTotalItemCount - 1) {
                    goto label_28;
                }

                if((this.mEnablePullLoad) && this.mFooterView.getBottomMargin() > 50) {
                    this.startLoadMore();
                }

                this.resetFooterHeight();
                break;
            }
        }

    label_28:
        return super.onTouchEvent(ev);
    }

    private void resetFooterHeight() {
        int v2 = this.mFooterView.getBottomMargin();
        if(v2 > 0) {
            this.mScrollBack = 1;
            this.mScroller.startScroll(0, v2, 0, -v2, 400);
            this.invalidate();
        }
    }

    private void resetHeaderHeight() {
        int v2 = this.mHeaderView.getVisiableHeight();
        if(v2 != 0 && (!this.mPullRefreshing || v2 > this.mHeaderViewHeight)) {
            int v6 = 0;
            if((this.mPullRefreshing) && v2 > this.mHeaderViewHeight) {
                v6 = this.mHeaderViewHeight;
            }

            this.mScrollBack = 0;
            this.mScroller.startScroll(0, v2, 0, v6 - v2, 400);
            this.invalidate();
        }
    }

    public void setAdapter(ListAdapter adapter) {
        if(!this.mIsFooterReady) {
            this.mIsFooterReady = true;
            this.addFooterView(this.mFooterView);
        }

        if(adapter.getCount() <= 0) {
            this.mFooterView.hide();
            this.mFooterView.setOnClickListener(null);
        }

        super.setAdapter(adapter);
    }

    public void setOnScrollListener(AbsListView$OnScrollListener l) {
        this.mScrollListener = l;
    }

    public void setPullLoadEnable(boolean enable) {
        this.mEnablePullLoad = enable;
        if(!this.mEnablePullLoad) {
            this.mFooterView.hide();
            this.mFooterView.setOnClickListener(null);
        }
        else {
            this.mPullLoading = false;
            this.mFooterView.show();
            this.mFooterView.setState(0);
            this.mFooterView.setOnClickListener(new View$OnClickListener() {
                public void onClick(View v) {
                    MyListView.this.startLoadMore();
                }
            });
        }
    }

    public void setRefreshTime(String time) {
        this.mHeaderTimeView.setText(((CharSequence)time));
    }

    public void setXListViewListener(IXListViewListener l) {
        this.mListViewListener = l;
    }

    private void startLoadMore() {
        this.mPullLoading = true;
        this.mFooterView.setState(2);
        if(this.mListViewListener != null) {
            this.mListViewListener.onLoadMore();
        }
    }

    public void stopLoadMore() {
        if(this.mPullLoading) {
            this.mPullLoading = false;
            this.mFooterView.setState(0);
        }
    }

    public void stopRefresh() {
        if(this.mPullRefreshing) {
            this.mPullRefreshing = false;
            this.resetHeaderHeight();
        }
    }

    private void updateFooterHeight(float delta) {
        int v0 = this.mFooterView.getBottomMargin() + (((int)delta));
        if((this.mEnablePullLoad) && !this.mPullLoading) {
            if(v0 > 50) {
                this.mFooterView.setState(1);
            }
            else {
                this.mFooterView.setState(0);
            }
        }

        this.mFooterView.setBottomMargin(v0);
    }

    private void updateHeaderHeight(float delta) {
        this.mHeaderView.setVisiableHeight((((int)delta)) + this.mHeaderView.getVisiableHeight());
        if((this.mEnablePullRefresh) && !this.mPullRefreshing) {
            if(this.mHeaderView.getVisiableHeight() > this.mHeaderViewHeight) {
                this.mHeaderView.setState(1);
            }
            else {
                this.mHeaderView.setState(0);
            }
        }

        this.setSelection(0);
    }
}

