// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package com.hk515.common;

import com.hk515.entity.JsonResultInfo;
import com.hk515.entity.ReturnInfo;
import java.io.IOException;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpRequestBase;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONException;
import org.json.JSONObject;

public abstract class RestClientBase {
    protected DefaultHttpClient httpClient;
    protected String serviceUri;

    public RestClientBase(String serviceUri) {
        super();
        this.httpClient = new DefaultHttpClient();
        this.httpClient.getParams().setIntParameter("http.socket.timeout", 20000);
        this.httpClient.getParams().setIntParameter("http.connection.timeout", 20000);
        this.serviceUri = serviceUri;
    }

    public abstract void buildRequestHeader(HttpRequestBase arg0);

    public ReturnInfo buildReturnInfo(String jsonstr) {
        ReturnInfo v2 = new ReturnInfo();
        try {
            JSONObject v1 = new JSONObject(jsonstr);
            v2.setReturnCode(v1.getString("ReturnCode"));
            try {
                v2.setReturnData(v1.getJSONObject("ReturnData"));
            }
            catch(Exception v0_1) {
                v2.setReturnData(null);
            }

            v2.setReturnMessage(v1.getString("ReturnMessage"));
            v2.setSuccess(v1.getBoolean("IsSuccess"));
        }
        catch(JSONException v0) {
            v0.printStackTrace();
        }

        return v2;
    }

    protected String generateFullMethodUri(String methodUrl) {
        return String.valueOf(this.serviceUri) + methodUrl;
    }

    public JsonResultInfo getJsonResultInfo(String methodUri) throws IOException {
        return this.getRequestResultReturnInfo(new HttpGet(this.generateFullMethodUri(methodUri)));
    }

    public JsonResultInfo getJsonResultInfoUsePost(String methodUri, String postData) throws IOException {
        return this.getJsonResultInfoUsePost(methodUri, new StringEntity(postData, "utf-8"));
    }

    public JsonResultInfo getJsonResultInfoUsePost(String methodUri, StringEntity postEntity) throws IOException {
        HttpPost v0 = new HttpPost(this.generateFullMethodUri(methodUri));
        if(postEntity != null) {
            v0.setEntity(((HttpEntity)postEntity));
        }

        return this.getRequestResultReturnInfo(((HttpRequestBase)v0));
    }

    protected JsonResultInfo getRequestResultReturnInfo(HttpRequestBase requestBase) throws IOException {
        this.buildRequestHeader(requestBase);
        HttpResponse v2 = this.httpClient.execute(((HttpUriRequest)requestBase));
        int v0 = v2.getStatusLine().getStatusCode();
        JsonResultInfo v1 = new JsonResultInfo();
        v1.setReturnInfo(this.buildReturnInfo(ClientHelper.getResponseString(v2)));
        v1.setStateCode(v0);
        return v1;
    }

    protected String getRequestResultStr(HttpRequestBase requestBase) throws IOException {
        this.buildRequestHeader(requestBase);
        return ClientHelper.getResponseString(this.httpClient.execute(((HttpUriRequest)requestBase)));
    }

    public String getString(String methodUri) throws IOException {
        return this.getRequestResultStr(new HttpGet(this.generateFullMethodUri(methodUri)));
    }

    public String getStringUsePost(String methodUri, String postData) throws IOException {
        return this.getStringUsePost(methodUri, new StringEntity(postData, "utf-8"));
    }

    public String getStringUsePost(String methodUri, StringEntity postEntity) throws IOException {
        HttpPost v0 = new HttpPost(this.generateFullMethodUri(methodUri));
        if(postEntity != null) {
            v0.setEntity(((HttpEntity)postEntity));
        }

        return this.getRequestResultStr(((HttpRequestBase)v0));
    }
}

