// Decompiled by JEB v1.4.201311020 - http://www.android-decompiler.com

package org.json;

import java.util.ArrayList;
import java.util.Collection;

public class JSONArray {
    private ArrayList myArrayList;

    public JSONArray(String arg2) throws JSONException {
        this(new JSONTokener(arg2));
    }

    public JSONArray() {
        super();
        this.myArrayList = new ArrayList();
    }

    public JSONArray(Collection arg2) {
        ArrayList v0;
        super();
        if(arg2 == null) {
            v0 = new ArrayList();
        }
        else {
            v0 = new ArrayList(arg2);
        }

        this.myArrayList = v0;
    }

    public JSONArray(Object arg4) throws JSONException {
        this();
        if(arg4.getClass().isArray()) {
            int v1 = Array.getLength(arg4);
            int v0;
            for(v0 = 0; v0 < v1; ++v0) {
                this.put(Array.get(arg4, v0));
            }

            return;
        }

        throw new JSONException("JSONArray initial value should be a string or collection or array.");
    }

    public JSONArray(JSONTokener arg4) throws JSONException {
        int v2 = 93;
        this();
        if(arg4.nextClean() != 91) {
            throw arg4.syntaxError("A JSONArray text must start with \'[\'");
        }

        if(arg4.nextClean() != v2) {
            arg4.back();
            while(true) {
                if(arg4.nextClean() == 44) {
                    arg4.back();
                    this.myArrayList.add(null);
                }
                else {
                    arg4.back();
                    this.myArrayList.add(arg4.nextValue());
                }

                switch(arg4.nextClean()) {
                    case 44: 
                    case 59: {
                        goto label_29;
                    }
                    case 93: {
                        return;
                    }
                }

                throw arg4.syntaxError("Expected a \',\' or \']\'");
            label_29:
                if(arg4.nextClean() == v2) {
                    return;
                }

                arg4.back();
            }
        }
    }

    public Object get(int arg4) throws JSONException {
        Object v0 = this.opt(arg4);
        if(v0 == null) {
            throw new JSONException("JSONArray[" + arg4 + "] not found.");
        }

        return v0;
    }

    public double getDouble(int arg4) throws JSONException {
        double v0_2;
        Object v0 = this.get(arg4);
        try {
            if((v0 instanceof Number)) {
                v0_2 = ((Number)v0).doubleValue();
            }
            else {
                v0_2 = Double.valueOf(((String)v0)).doubleValue();
            }

            return v0_2;
        }
        catch(Exception v0_1) {
            throw new JSONException("JSONArray[" + arg4 + "] is not a number.");
        }
    }

    public int getInt(int arg3) throws JSONException {
        int v0_1;
        Object v0 = this.get(arg3);
        if((v0 instanceof Number)) {
            v0_1 = ((Number)v0).intValue();
        }
        else {
            v0_1 = ((int)this.getDouble(arg3));
        }

        return v0_1;
    }

    public JSONArray getJSONArray(int arg4) throws JSONException {
        Object v0 = this.get(arg4);
        if((v0 instanceof JSONArray)) {
            return ((JSONArray)v0);
        }

        throw new JSONException("JSONArray[" + arg4 + "] is not a JSONArray.");
    }

    public JSONObject getJSONObject(int arg4) throws JSONException {
        Object v0 = this.get(arg4);
        if((v0 instanceof JSONObject)) {
            return ((JSONObject)v0);
        }

        throw new JSONException("JSONArray[" + arg4 + "] is not a JSONObject.");
    }

    public String getString(int arg2) throws JSONException {
        return this.get(arg2).toString();
    }

    public String join(String arg5) throws JSONException {
        int v1 = this.length();
        StringBuffer v2 = new StringBuffer();
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            if(v0 > 0) {
                v2.append(arg5);
            }

            v2.append(JSONObject.valueToString(this.myArrayList.get(v0)));
        }

        return v2.toString();
    }

    public int length() {
        return this.myArrayList.size();
    }

    public Object opt(int arg2) {
        Object v0;
        if(arg2 < 0 || arg2 >= this.length()) {
            v0 = null;
        }
        else {
            v0 = this.myArrayList.get(arg2);
        }

        return v0;
    }

    public String optString(int arg2) {
        return this.optString(arg2, "");
    }

    public String optString(int arg2, String arg3) {
        Object v0 = this.opt(arg2);
        if(v0 != null) {
            arg3 = v0.toString();
        }

        return arg3;
    }

    public JSONArray put(Object arg2) {
        this.myArrayList.add(arg2);
        return this;
    }

    public JSONArray put(int arg2) {
        this.put(new Integer(arg2));
        return this;
    }

    public String toString() {
        String v0_1;
        try {
            v0_1 = '[' + this.join(",") + ']';
        }
        catch(Exception v0) {
            v0_1 = null;
        }

        return v0_1;
    }
}

